define([
    "jquery",
    "marionette",
    "jqueryui"
], function (
    $,
    Marionette
) {
    var SidebarRegion = Marionette.Region.extend({

        // Global Data for Region animations
        bodyElement: $("#conceptBody"),
        headerElement: $(".concept-header"),
        bodyHeaderElement: $("#conceptBody, .concept-header"),
        animateDuration: 600,
        animateOptions: {duration: this.animateDuration, queue: false},

        attachHtml: function (view) {
            this.$el.html(view.el).animate({"left": "50px"}, this.animateOptions).show();
            this.bodyHeaderElement.animate({
                left: "350px",
                width: $("body").width() - 350
            }, this.animateOptions);
        },

        onDestroyAnimation: function () {
            /*
            Keeping this as manual method instead of event call cause event is unable to handle our custom use case of
            only running this animation in case same view is being destroyed. Method is called from the controller on toggle view.
            */
            var elementWidth = this.el.offsetWidth;
            this.$el.animate({"left": "-"+elementWidth+"px"}, this.animateOptions);
            this.bodyHeaderElement.animate({
                left: "0",
                width: "100%"
            }, this.animateOptions);
        }
    });

    return SidebarRegion;
});