// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Answer, Model;
    Model = require("tep/utils/model");
    return Answer = (function(_super) {
      __extends(Answer, _super);

      function Answer(data, common) {
        var _ref;
        this.common = common;
        this.isCurrentUser = __bind(this.isCurrentUser, this);
        this._toggleLikeStatus = __bind(this._toggleLikeStatus, this);
        this._handleLikeStatus = __bind(this._handleLikeStatus, this);
        this.toggleLike = __bind(this.toggleLike, this);
        this.toggleAnswerHistory = __bind(this.toggleAnswerHistory, this);
        this.loadLikeStatus = __bind(this.loadLikeStatus, this);
        this.setStatuses = __bind(this.setStatuses, this);
        Answer.__super__.constructor.call(this, data);
        if ((_ref = this.get("display_name")) === "" || _ref === null) {
          this.set("display_name", this.get("first_name"));
        }
        this.setStatuses(data);
      }

      Answer.prototype.setStatuses = function(data) {
        this.set("likes", data.num_likes);
        this.set("liked_by_user", data.liked_by_user);
        return this.set("comments", data.comments);
      };

      Answer.prototype.loadLikeStatus = function() {
        return $.ajax({
          url: "/api/v1/wave/dstrat/submission/like/status",
          type: "POST",
          dataType: "json",
          data: JSON.stringify({
            course_instance_id: this.common.get("course_instance_id"),
            cohort: window.cohort_id,
            assignment: this.common.get("tei"),
            wave: "",
            type: "te",
            subtype: this.common.get("type"),
            team: "",
            student: this.get("user_id")
          }),
          success: this._handleLikeStatus
        });
      };

      Answer.prototype.toggleAnswerHistory = function() {
        var disp, metric;
        metric = {
          user_id: this.get("user_id")
        };
        disp = this.get("display_history") != null ? this.get("display_history") : "hide";
        metric.display_history = disp === "hide" ? "show" : "hide";
        this.set("display_history", metric.display_history);
        return this.dispatchEvent("SharedAnswer.MetricRequest", {
          bubbles: true,
          metric: metric,
          category: "show_hide_answer_history"
        });
      };

      Answer.prototype.toggleLike = function() {
        var current_tei_id,
          _this = this;
        if (this.isCurrentUser()) {
          return;
        }
        this._toggleLikeStatus();
        current_tei_id = "";
        if (this.common.get("calledFromBeforeAndAfter")) {
          current_tei_id = this.common.get("beforeAndAfterId");
        }
        return $.ajax({
          url: "/api/v1/wave/dstrat/submission/like",
          type: "POST",
          dataType: "json",
          data: JSON.stringify({
            course_instance_id: this.common.get("course_instance_id"),
            cohort: window.cohort_id,
            assignment: this.common.get("tei"),
            current_tei_id: current_tei_id,
            wave: "",
            type: "te",
            subtype: this.common.get("type"),
            team: "",
            student: this.get("user_id")
          }),
          success: function(data) {
            var metric, user_id;
            metric = {};
            user_id = _this.get("user_id");
            if (data.status) {
              metric.like_user_id = user_id;
            } else {
              metric.unlike_user_id = user_id;
            }
            return _this.dispatchEvent("SharedAnswer.MetricRequest", {
              bubbles: true,
              metric: metric,
              category: "like_user_response"
            });
          }
        });
      };

      Answer.prototype._handleLikeStatus = function(data) {
        this.set("likes", data.number);
        return this.set("liked_by_user", data.status);
      };

      Answer.prototype._toggleLikeStatus = function() {
        var liked, number;
        liked = this.get("liked_by_user");
        number = this.get("likes");
        this.set("likes", liked ? number - 1 : number + 1);
        return this.set("liked_by_user", !liked);
      };

      Answer.prototype.isCurrentUser = function() {
        return this.common.get("current_user") === this.get("user_id");
      };

      return Answer;

    })(Model);
  });

}).call(this);
