// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var BarChart, TEP, Utils, d3;
    d3 = require('common/js/vendor/d3_v3.2.8');
    TEP = require('tep/tep');
    Utils = require('tep/utils/utils');
    /*
    # BarChart
    Generates a bar chart
    */

    return BarChart = (function(_super) {
      var FONT, X_AXIS_TICK_LABEL_HEIGHT_WITH_PADDING, X_AXIS_TICK_PADDING;

      __extends(BarChart, _super);

      FONT = "12px sans-serif";

      X_AXIS_TICK_PADDING = 10;

      X_AXIS_TICK_LABEL_HEIGHT_WITH_PADDING = 13;

      function BarChart($dom, config, data) {
        var xAxisLabelPadding, yAxisLabelPadding;
        this.$dom = $dom;
        this.config = config != null ? config : {};
        if (data == null) {
          data = null;
        }
        this.calculateAdditionalBottomMargin = __bind(this.calculateAdditionalBottomMargin, this);
        this.handleData = __bind(this.handleData, this);
        this.customizeYAxis = __bind(this.customizeYAxis, this);
        this.initConfig = __bind(this.initConfig, this);
        this.initConfig();
        this.totalWidth = this.config.width + this.config.margin.left + this.config.margin.right + this.config.label.width;
        this.totalHeight = this.config.height + this.config.margin.top + this.config.margin.bottom + this.config.margin.additionalBottomMargin + this.config.label.width;
        this.svg = d3.select(this.$dom.get(0)).append("svg").attr({
          width: this.totalWidth,
          height: this.totalHeight,
          role: "img",
          "aria-label": "Bar Chart"
        }).append("g").attr("transform", "translate(" + (this.config.margin.left + this.config.label.width) + "," + (this.config.margin.top + 1) + ")");
        this.x = d3.scale.ordinal().rangeRoundBands([0, this.config.width], 0.5, 0.25);
        this.y = d3.scale.linear().range([this.config.height, 0]);
        this.xAxis = d3.svg.axis().scale(this.x).orient('bottom').tickSize(0).tickPadding((this.config.margin.bottom - 12 + this.config.margin.additionalBottomMargin) / 2);
        this.yAxis = d3.svg.axis().scale(this.y).orient('right').tickSize(this.config.width + this.config.margin.right);
        this.gy = this.svg.append("g").attr("class", "y axis").call(this.yAxis).call(this.customizeYAxis);
        this.gx = this.svg.append("g").attr("class", "x axis").attr("transform", "translate(0," + this.config.height + ")").call(this.xAxis);
        xAxisLabelPadding = 6;
        yAxisLabelPadding = 8;
        this.svg.append('text').attr('class', 'axis-label').attr('text-anchor', 'middle').attr('x', this.config.width / 2).attr('y', this.config.height + this.config.margin.top + this.config.margin.bottom + xAxisLabelPadding + this.config.margin.additionalBottomMargin + this.config.label.width / 2).text(this.config.label.xAxis);
        this.svg.append('g').attr('transform', 'translate(' + -(this.config.margin.left + yAxisLabelPadding) + ',' + (this.config.height / 2) + ")").append('text').attr('class', 'axis-label').attr('text-anchor', 'middle').attr('transform', 'rotate(-90)').text(this.config.label.yAxis);
        this.border = this.svg.append('rect').attr('rx', 4).attr('ry', 4).attr('width', this.config.width + this.config.margin.left + this.config.margin.right).attr('x', -this.config.margin.left).attr('height', this.config.height + this.config.margin.top + this.config.margin.bottom + this.config.margin.additionalBottomMargin).attr('y', -this.config.margin.top).attr('class', 'border');
        if (data != null) {
          this.handleData(data);
        }
      }

      /*
      ## Configuration values
      A configuration object can be sent to the constructor.  Available keys are:
      * width - width of the SVG, minus axis label spacing
      * xAxisTickLabels - list of X-Axis tick labels
      * height - height of the SVG, minus axis label spacing
      * margin - margin
        * top - defaults to 0
        * right - defaults to 0
        * bottom - defaults to 40px
        * left - defaults to 40px
        * additionalBottomMargin - defaults to 0
      * label
        * width - space allowed for labels. Defaults to 30px
        * xAxis - string label for x-axis
        * yAxis - string label for y-axis
      */


      BarChart.prototype.initConfig = function() {
        var _base, _base1, _base10, _base11, _base12, _base2, _base3, _base4, _base5, _base6, _base7, _base8, _base9;
        if ((_base = this.config).width == null) {
          _base.width = 200;
        }
        if ((_base1 = this.config).height == null) {
          _base1.height = 200;
        }
        if ((_base2 = this.config).xAxisTickLabels == null) {
          _base2.xAxisTickLabels = [];
        }
        if ((_base3 = this.config).margin == null) {
          _base3.margin = {};
        }
        if ((_base4 = this.config.margin).top == null) {
          _base4.top = 0;
        }
        if ((_base5 = this.config.margin).right == null) {
          _base5.right = 0;
        }
        if ((_base6 = this.config.margin).bottom == null) {
          _base6.bottom = 40;
        }
        if ((_base7 = this.config.margin).left == null) {
          _base7.left = 40;
        }
        if ((_base8 = this.config.margin).additionalBottomMargin == null) {
          _base8.additionalBottomMargin = 0;
        }
        if ((_base9 = this.config).label == null) {
          _base9.label = {};
        }
        if ((_base10 = this.config.label).width == null) {
          _base10.width = 30;
        }
        if ((_base11 = this.config.label).xAxis == null) {
          _base11.xAxis = '';
        }
        if ((_base12 = this.config.label).yAxis == null) {
          _base12.yAxis = '';
        }
        this.config.width = this.config.width - this.config.margin.left - this.config.margin.right;
        this.config.height = this.config.height - this.config.margin.top - this.config.margin.bottom - this.config.margin.additionalBottomMargin;
        this.config.barClassFn = this.defaultClass;
        if (this.config.xAxisTickLabels.length > 0) {
          return this.config.margin.additionalBottomMargin = this.calculateAdditionalBottomMargin(this.config.xAxisTickLabels);
        }
      };

      BarChart.prototype.customizeYAxis = function(g) {
        var firstTick, ftc;
        firstTick = g.select('.tick');
        ftc = firstTick.attr('class').split(' ');
        if (__indexOf.call(ftc, 'axis-zero') < 0) {
          ftc.push('axis-zero');
        }
        firstTick.attr('class', ftc.join(' '));
        g.selectAll('line').attr('x1', -this.config.margin.left);
        return g.selectAll('text').attr('x', -4).attr('opacity', function(d, i) {
          if (i === 0) {
            return 0;
          } else {
            return 1;
          }
        }).attr('style', 'text-anchor: end');
      };

      BarChart.prototype.defaultClass = function() {
        return 'bar';
      };

      BarChart.prototype.defaultDataValue = function() {
        return 1;
      };

      BarChart.prototype.handleData = function(allData) {
        var d, maxWidth, zebra, _i, _len,
          _this = this;
        this.x.domain(allData.map(function(d) {
          return d.label;
        }));
        this.y.domain([
          0, d3.max(allData, function(d) {
            return (+d.value) * 1.05;
          })
        ]);
        this.gy.call(this.yAxis);
        this.gy.call(this.customizeYAxis);
        this.gx.call(this.xAxis);
        maxWidth = 0;
        for (_i = 0, _len = allData.length; _i < _len; _i++) {
          d = allData[_i];
          maxWidth = Math.max(maxWidth, Utils.measureText(d, FONT));
        }
        this.gx.selectAll('.tick text').attr('y', function(d, i) {
          if (maxWidth < _this.x.rangeBand() * 2) {
            return (_this.config.margin.bottom - 12) / 2;
          } else {
            return (_this.config.margin.bottom - 12) / 2 + Math.pow(-1, i % 2) * 8;
          }
        });
        this.bars = this.svg.selectAll('.bar').data(allData).enter();
        zebra = this.bars.insert('g', ':first-child').attr('class', function(d, i) {
          return 'zebra' + (i === 0 ? ' axis-zero' : '');
        }).attr('transform', function(d) {
          return 'translate(' + (_this.x(d.label) - _this.x.rangeBand() * 0.5) + ',0)';
        });
        zebra.append('rect').attr('class', function(d, i) {
          if (i % 2) {
            return 'even';
          } else {
            return 'odd';
          }
        }).attr('width', this.x.rangeBand() * 2).attr('height', this.config.height + this.config.margin.top + this.config.margin.bottom + this.config.margin.additionalBottomMargin);
        zebra.append('line').attr('x1', 1).attr('x2', 1).attr('y2', this.config.height + this.config.margin.top);
        this.barG = this.bars.append('g').attr('class', this.config.barClassFn).attr('transform', function(d) {
          return 'translate(' + _this.x(d.label) + ', ' + _this.y(d.value) + ')';
        });
        return this.barG.append('rect').attr('width', this.x.rangeBand()).attr('height', function(d) {
          return _this.config.height - _this.y(d.value);
        });
      };

      BarChart.prototype.calculateAdditionalBottomMargin = function(labels) {
        var additionalNumberOfLines, defaultNumberOfLines, labelContainerWidth, totalNumberOfLines, wordWrapLineCounter;
        wordWrapLineCounter = function(text, maxWidth) {
          var line, lineText, numberOfLines, word, words;
          words = text.split(/\s+/).reverse();
          line = [];
          lineText = '';
          numberOfLines = 1;
          while ((word = words.pop())) {
            line.push(word);
            lineText = line.join(' ');
            if (Utils.measureText(lineText, FONT) > maxWidth) {
              line.pop();
              lineText = line.join(' ');
              line = [word];
              numberOfLines += 1;
            }
          }
          return numberOfLines;
        };
        defaultNumberOfLines = 2;
        labelContainerWidth = this.opts.optionWidth - X_AXIS_TICK_PADDING;
        totalNumberOfLines = labels.map(function(label) {
          return wordWrapLineCounter(label, labelContainerWidth);
        }).reduce(function(a, b) {
          return Math.max(a, b);
        });
        additionalNumberOfLines = totalNumberOfLines - defaultNumberOfLines;
        return additionalNumberOfLines * X_AXIS_TICK_LABEL_HEIGHT_WITH_PADDING;
      };

      return BarChart;

    })(TEP.EventDispatcher);
  });

}).call(this);
