// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Comment, Model, Utils;
    Model = require('tep/utils/model');
    Utils = require('tep/utils/utils');
    return Comment = (function(_super) {
      __extends(Comment, _super);

      function Comment(data) {
        this._handleLikeStatus = __bind(this._handleLikeStatus, this);
        this.toggleLike = __bind(this.toggleLike, this);
        this.isCurrentUser = __bind(this.isCurrentUser, this);
        Comment.__super__.constructor.call(this, data);
      }

      Comment.prototype.isCurrentUser = function() {
        return parseInt(window.user_id) === parseInt(this.get('author_id'));
      };

      Comment.prototype.toggleLike = function(conversation_id) {
        var current_tei_id;
        if (this.isCurrentUser()) {
          return;
        }
        this._handleLikeStatus();
        current_tei_id = null;
        if (this.get('calledFromBeforeAndAfter')) {
          current_tei_id = this.get("beforeAndAfterId");
        }
        return $.ajax({
          url: Utils.normalizeUrl("/conversation/" + conversation_id + "/comment/like", "POST"),
          type: "POST",
          dataType: "json",
          data: JSON.stringify({
            comment_id: this.get('id'),
            cohort: window.cohort_id,
            current_tei_id: current_tei_id
          })
        });
      };

      Comment.prototype._handleLikeStatus = function() {
        var liked, m, number;
        liked = this.get("liked_by_user");
        number = this.get("likes");
        this.set("likes", liked ? number - 1 : number + 1);
        this.set("liked_by_user", !liked);
        m = {};
        if (liked) {
          m.like_user_id = this.get('author_id');
        } else {
          m.unlike_user_id = this.get('author_id');
        }
        return this.dispatchEvent('Conversation.MetricRequest', {
          bubbles: true,
          metric: m,
          category: "like_user_comment"
        });
      };

      return Comment;

    })(Model);
  });

}).call(this);
