// MORE INFO about this boilerplate block in file: webpack_transition_info.md
(function (root, factory) {
    // If CommonJS (Webpack) define npm dependencies.
    if (typeof exports === 'object' && typeof module !== 'undefined') {
        factory(
            require('jquery'),
            require('jquery.cookie')
        );
    // If AMD is loading this file (Require.JS) define same dependencies just for Require.JS.
    // Based on configure-require configuration.
    } else if (typeof define === 'function' && define.amd) {
        define([
            'jquery',
            'jquery_cookie'
        ], factory);
    // If loaded in regular script tag.
    } else {
        factory(root.jQuery);
    }
}(typeof self !== 'undefined' ? self : this, function ($) {

// Place all npm dependencies here as well, so in future we delete the boilerplate up and uncomment this down
// so ideally everything JUST WORKS.

// import $ from 'jquery';
// import 'jquery.cookie';

/* ------------------------------------------------------------ */

function csrfSafeMethod(method) {
    // these HTTP methods do not require CSRF protection
    return (/^(GET|HEAD|OPTIONS|TRACE)$/.test(method));
}
function sameOrigin(url) {
    // test that a given url is a same-origin URL
    // url could be relative or scheme relative or absolute
    var host = document.location.host; // host + port
    var protocol = document.location.protocol;
    var sr_origin = '//' + host;
    var origin = protocol + sr_origin;
    // Allow absolute or scheme relative URLs to same origin
    return (url == origin || url.slice(0, origin.length + 1) == origin + '/') ||
        (url == sr_origin || url.slice(0, sr_origin.length + 1) == sr_origin + '/') ||
        // or any other URL that isn't scheme relative or absolute i.e relative.
        !(/^(\/\/|http:|https:).*/.test(url));
}
$.ajaxSetup({
    beforeSend: function(xhr, settings) {
        if (!csrfSafeMethod(settings.type) && sameOrigin(settings.url)) {
            // Send the token to same-origin, relative URLs only.
            // Send the token only if the method warrants CSRF protection
            // Using the CSRFToken value acquired earlier
            xhr.setRequestHeader("X-CSRFToken", $.cookie(window.globals.csrfCookieName));
        }
    }
});

/* ------------------------------------------------------------ */

}));
