// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, DropBar, EventDispatcher, TEProxy, slot_names, tmpl;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    $ = require('jquery');
    tmpl = require('text!./drop_bar.html');
    TEProxy = require('tep/lib/te/proxy');
    slot_names = [
      {
        label: 'Drill Down',
        "class": 'drill-down'
      }, {
        label: 'Step Back',
        "class": 'step-back'
      }, {
        label: 'Related',
        "class": 'related'
      }
    ];
    return DropBar = (function(_super) {
      __extends(DropBar, _super);

      function DropBar(sourceData, slot) {
        var input, tei, _i, _len, _ref;
        this.sourceData = sourceData;
        this.onSidebarSearchChange = __bind(this.onSidebarSearchChange, this);
        this.close = __bind(this.close, this);
        this.open = __bind(this.open, this);
        this.toggleDisplay = __bind(this.toggleDisplay, this);
        this.view = __bind(this.view, this);
        this.onTEIReady = __bind(this.onTEIReady, this);
        this.id = sourceData.id;
        this._view = $(tmpl);
        this._view.find('.drop-bar-title').addClass(slot_names[slot]["class"]).text(sourceData.display_name);
        if (sourceData.sub_title) {
          this._view.find('.drop-bar-sub-title').addClass(slot_names[slot]["class"]).text(sourceData.sub_title);
        }
        this._view.find('.accordion-toggle').on('click', this.toggleDisplay);
        this.teis = [];
        this._view.find('.drop-bar-content').hide();
        _ref = this.sourceData.teaching_element_instances;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          input = _ref[_i];
          tei = new TEProxy(this._view.find('.drop-bar-content'), input.id, false);
          tei.addEventListener('ready', this.onTEIReady);
          tei.onDataLoad(input);
          this.teis.push(tei);
        }
      }

      DropBar.prototype.onTEIReady = function(evt, teProxy) {
        var dropBarTeiView;
        dropBarTeiView = teProxy.view();
        teProxy.te.addEventListener(EventDispatcher.INITIAL_SEARCH_RESULT_FOUND, this.open);
        return this._view.find('.drop-bar-content').append(dropBarTeiView);
      };

      DropBar.prototype.view = function() {
        return this._view;
      };

      DropBar.prototype.toggleDisplay = function() {
        return this.dispatchEvent((this._view.hasClass('open') ? 'requestClose' : 'requestOpen'), {});
      };

      DropBar.prototype.open = function() {
        var tei, _i, _len, _ref,
          _this = this;
        this._view.addClass('open');
        _ref = this.teis;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tei = _ref[_i];
          tei.te.unlock();
          tei.te.end();
        }
        this._view.find('.drop-bar-content').css('visibility', 'hidden');
        return this._view.find('.drop-bar-content').slideDown("fast", "linear", function() {
          return _this._view.find('.drop-bar-content').css('visibility', 'visible');
        });
      };

      DropBar.prototype.close = function() {
        this._view.find('.drop-bar-content').css('visibility', 'hidden');
        this._view.find('.drop-bar-content').slideUp();
        return this._view.removeClass('open');
      };

      /*
      onSidebarSearchChange()
      --------------------------
      Event handler for when sidebar search input box is changed.
      This handler was configured in platform.coffee inside the shedProxy method.
      */


      DropBar.prototype.onSidebarSearchChange = function(searchPhrase) {
        var tei, _i, _len, _ref, _results;
        if (searchPhrase) {
          _ref = this.teis;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            tei = _ref[_i];
            TEP.addHighlights(this.view(), searchPhrase);
            if (this.view().find('mark[data-markjs]').length) {
              _results.push(this.open());
            } else {
              _results.push(void 0);
            }
          }
          return _results;
        }
      };

      return DropBar;

    })(EventDispatcher);
  });

}).call(this);
