// Generated by CoffeeScript 1.6.3
(function() {
  define([], function() {
    var _cancelFns, _changeEvts, _isFullscreen, _isIOS, _requestFns, _states;
    _requestFns = ['requestFullScreen', 'webkitRequestFullscreen', 'mozRequestFullScreen'];
    _cancelFns = ['cancelFullscreen', 'webkitCancelFullScreen', 'mozCancelFullScreen'];
    _changeEvts = ['fullscreenchange', 'webkitfullscreenchange', 'mozfullscreenchange'];
    _states = ['fullScreen', 'webkitIsFullScreen', 'mozFullScreen'];
    _isIOS = navigator.userAgent.match(/iPad|iPod|iPhone/g);
    _isFullscreen = false;
    return {
      fullscreenEnabled: function() {
        return !!(document.cancelFullscreen || document.webkitCancelFullScreen || document.mozCancelFullScreen);
      },
      isFullScreen: function() {
        var state, _i, _len;
        for (_i = 0, _len = _states.length; _i < _len; _i++) {
          state = _states[_i];
          if (document[state] != null) {
            return document[state];
          }
        }
        return false;
      },
      requestFullScreen: function(elem) {
        var fn, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _requestFns.length; _i < _len; _i++) {
          fn = _requestFns[_i];
          if (!!elem[fn]) {
            _results.push(elem[fn].call(elem));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      },
      cancelFullScreen: function() {
        var fn, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _cancelFns.length; _i < _len; _i++) {
          fn = _cancelFns[_i];
          if (!!document[fn]) {
            _results.push(document[fn].call(document));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      },
      bind: function(callback) {
        var evt, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _changeEvts.length; _i < _len; _i++) {
          evt = _changeEvts[_i];
          _results.push(document.addEventListener(evt, callback));
        }
        return _results;
      },
      unbind: function(callback) {
        var evt, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _changeEvts.length; _i < _len; _i++) {
          evt = _changeEvts[_i];
          _results.push(document.removeEventListener(evt, callback));
        }
        return _results;
      },
      _api_fullscreen_request: function(elem) {
        var fn, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _requestFns.length; _i < _len; _i++) {
          fn = _requestFns[_i];
          if (!!elem[fn]) {
            _results.push(elem[fn].call(elem));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      },
      _api_fullscreen_cancel: function() {
        var fn, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = _cancelFns.length; _i < _len; _i++) {
          fn = _cancelFns[_i];
          if (!!document[fn]) {
            _results.push(document[fn].call(document));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      },
      _api_enabled: function() {
        return !!(document.cancelFullscreen || document.webkitCancelFullScreen || document.mozCancelFullScreen);
      }
    };
  });

}).call(this);
