// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, EventDispatcher, GraphObject, GraphObjectView, defaults;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    GraphObjectView = require('./graph_object_view');
    $ = require('jquery');
    /*
    GraphObject
    ===========
    */

    defaults = {
      svgType: 'g',
      selectable: true
    };
    return GraphObject = (function(_super) {
      __extends(GraphObject, _super);

      function GraphObject(conf) {
        this.eventPassthrough = __bind(this.eventPassthrough, this);
        this.exportData = __bind(this.exportData, this);
        this.setScale = __bind(this.setScale, this);
        this.getScale = __bind(this.getScale, this);
        this.setRotation = __bind(this.setRotation, this);
        this.getRotation = __bind(this.getRotation, this);
        this.setReferencePoint = __bind(this.setReferencePoint, this);
        this.getReferencePoint = __bind(this.getReferencePoint, this);
        this.registerSvgObject = __bind(this.registerSvgObject, this);
        this.buildView = __bind(this.buildView, this);
        this["export"] = __bind(this["export"], this);
        this.clearView = __bind(this.clearView, this);
        this.setColor = __bind(this.setColor, this);
        this.scale = __bind(this.scale, this);
        this.rotate = __bind(this.rotate, this);
        this.translate = __bind(this.translate, this);
        this.name = __bind(this.name, this);
        var config;
        config = $.extend(true, {}, defaults, conf);
        this.svgType = config.svgType;
        this.selectable = config.selectable;
        this.view = this.buildView();
        this.view.addEventListener('GraphObject.Selected', this.eventPassthrough);
        this.view.addEventListener('GraphObject.Deselected', this.eventPassthrough);
      }

      /*
      API
      ===
      
      name()
      ------
      Returns the object type.
      */


      GraphObject.prototype.name = function() {
        return this._name;
      };

      /*
      translate(delta)
      ----------------
      Moves the object from its current position by the specified delta.
      Delta should be defined in { x: 0, y: 0 } format.
      */


      GraphObject.prototype.translate = function(delta) {
        var pt;
        pt = this.getReferencePoint();
        return this.setReferencePoint({
          x: pt.x + delta.x,
          y: pt.y + delta.y
        });
      };

      /*
      rotate(theta)
      -------------
      Rotates the object by theta radians.
      */


      GraphObject.prototype.rotate = function(theta) {
        return this.setRotation(this.getRotation() + theta);
      };

      /*
      scale(factor)
      ------------
      Scales the object by the provided multiplicitive factor.
      */


      GraphObject.prototype.scale = function(factor) {
        return this.setScale(this.getScale() * factor);
      };

      /*
      setColor(color)
      ---------------
      Sets the color of the object. Note that the passed value should be
      a ColorModel object, not a color id.
      */


      GraphObject.prototype.setColor = function(color) {
        var _ref, _ref1;
        this.color = color;
        if ((_ref = this.view) != null) {
          _ref.removeColorTag();
        }
        return (_ref1 = this.view) != null ? _ref1.setColorTag(this.color.getTag()) : void 0;
      };

      /*
      clearView()
      -----------
      Removes the object from the dom.
      */


      GraphObject.prototype.clearView = function() {
        var _ref;
        return (_ref = this.view) != null ? _ref.clear() : void 0;
      };

      /*
      export()
      --------
      Constructs the export data for the object.
      */


      GraphObject.prototype["export"] = function() {
        var e;
        return e = {
          color: this.color.id,
          type: this.name(),
          data: this.exportData()
        };
      };

      /*
      Subclass Overrides
      ==================
      The following methods are required for subclasses to override.
      */


      GraphObject.prototype.buildView = function() {};

      GraphObject.prototype.registerSvgObject = function(obj, config) {};

      GraphObject.prototype.getReferencePoint = function() {};

      GraphObject.prototype.setReferencePoint = function(pt) {};

      GraphObject.prototype.getRotation = function() {};

      GraphObject.prototype.setRotation = function(theta) {};

      GraphObject.prototype.getScale = function() {};

      GraphObject.prototype.setScale = function(scale) {};

      GraphObject.prototype.exportData = function() {
        return {};
      };

      /*
      Events
      ======
      GraphObject.Selected
      --------------------
      Fired when the object is hovered over, if the object is configured as selectable.
      
      GraphObject.Deselected
      ----------------------
      Fired when the object is no longer hovered, if the object is configured as selectable.
      */


      GraphObject.prototype.eventPassthrough = function(evt, data) {
        if (this.selectable) {
          this.view.hover(evt === 'GraphObject.Selected');
          return this.dispatchEvent(evt, data);
        }
      };

      return GraphObject;

    })(EventDispatcher);
  });

}).call(this);
