// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, BaseView, View, tmpl, uuid;
    $ = require('jquery');
    BaseView = require('tep/utils/view');
    tmpl = require('text!../templates/inline.html');
    uuid = require('uuid');
    require('bootstrap');
    return View = (function(_super) {
      __extends(View, _super);

      function View(model) {
        this.onHidden = __bind(this.onHidden, this);
        this.show = __bind(this.show, this);
        this.onConversationChange = __bind(this.onConversationChange, this);
        this.handleDirtyComment = __bind(this.handleDirtyComment, this);
        this.setUpObjectAnswer = __bind(this.setUpObjectAnswer, this);
        this.onChange = __bind(this.onChange, this);
        this._resetForm = __bind(this._resetForm, this);
        this.onCommentAccepted = __bind(this.onCommentAccepted, this);
        this.onFieldClicked = __bind(this.onFieldClicked, this);
        this.onFieldChange = __bind(this.onFieldChange, this);
        this.onSubmitRequest = __bind(this.onSubmitRequest, this);
        var newId;
        View.__super__.constructor.call(this, tmpl);
        this.showHideHistory = "hide";
        newId = 'conversation_' + uuid.v4();
        this.$el.find('.inline-conversation-comment-field').attr('id', newId);
        this.$el.find('#inline-conversation-comment-form label').attr('for', newId);
        this.$el.find(".close-dark").bind('click', this.hide);
        this.$el.find(".cancel").bind('click', this.hide);
        this.$el.find("#conversation-submit").bind('click', this.onSubmitRequest);
        this.$el.find("#conversation-submit").prop('disabled', true);
        this.$el.find(".inline-conversation-comment-field").bind('keyup', this.onFieldChange);
        this.$el.find(".inline-conversation-comment-field").bind('click', this.onFieldClicked);
        model.addEventListener('Model.Change', this.onChange);
        model.addEventListener('Conversation.CommentAccepted', this.onCommentAccepted);
        model.addEventListener('Conversation.ConversationChanged', this.onConversationChange);
      }

      View.prototype.onSubmitRequest = function(jqevt) {
        this.$el.find("#conversation-submit").prop('disabled', true);
        this.$el.find(".inline-conversation-comment-field").prop('disabled', true);
        return this.dispatchEvent('Conversation.AddCommentRequest', {
          comment: this.$el.find(".inline-conversation-comment-field").val(),
          bubbles: true
        });
      };

      View.prototype.onFieldChange = function(jqevt) {
        return this.$el.find("#conversation-submit").prop('disabled', this.$el.find(".inline-conversation-comment-field").val().trim() === "");
      };

      View.prototype.onFieldClicked = function(jqevt) {
        return this.$el.find(".inline-conversation-comment-field").tooltip("destroy");
      };

      View.prototype.onCommentAccepted = function(evt, data) {
        this._resetForm();
        return this.$el.find(".inline-conversation-comments").scrollTop(this.$el.find(".inline-conversation-comments")[0].scrollHeight);
      };

      View.prototype._resetForm = function() {
        this.$el.find("#conversation-submit").prop('disabled', true);
        return this.$el.find(".inline-conversation-comment-field").prop('disabled', false).val('');
      };

      View.prototype.onChange = function(evt, data) {
        switch (data.path) {
          case "title":
            return this.$el.find(".modal-title").text(data.value);
          case "preamble":
            this.$el.find(".modal-preamble").html(data.value);
            if (this.$el.find('.previous_answer_show_hide_history')) {
              this.$el.find(".previous_answer_history_container .previous_answer_show_hide_history").bind('click', this.setUpObjectAnswer);
              return this.setUpObjectAnswer(null);
            }
        }
      };

      View.prototype.setUpObjectAnswer = function(evt) {
        var answer_history_elem, answer_history_link, label;
        answer_history_link = this.$el.find('.previous_answer_history_container .previous_answer_show_hide_history');
        answer_history_elem = this.$el.find('.previous_answer_history_container .previous_answer_history');
        if (this.showHideHistory === "show") {
          label = "Hide Answer History";
          answer_history_elem.css('display', 'none');
          this.showHideHistory = "hide";
        } else {
          label = "Show Answer History";
          answer_history_elem.css('display', '');
          this.showHideHistory = "show";
        }
        answer_history_link.text(label);
        answer_history_elem.slideToggle('slow');
        if (evt != null) {
          return this.dispatchEvent('Comment.AnswerHistoryToggleRequest', {
            bubbles: true
          });
        }
      };

      View.prototype.handleDirtyComment = function(analysis) {
        var field;
        field = this.$el.find(".inline-conversation-comment-field");
        field.tooltip({
          placement: 'top',
          title: analysis.error,
          trigger: 'manual'
        });
        field.tooltip("show");
        field.prop('disabled', false);
        return this.$el.find("#conversation-submit").prop('disabled', false);
      };

      View.prototype.onConversationChange = function(evt, data) {
        return this._resetForm();
      };

      View.prototype.show = function(data) {
        return data.view.view().find(data.domId).html(this.$el[0].outerHTML);
      };

      View.prototype.onHidden = function() {
        if (!this.$el.find(".inline-conversation-comment-field").is(":focus")) {
          return this.dispatchEvent('Conversation.Closed', {});
        }
      };

      return View;

    })(BaseView);
  });

}).call(this);
