// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Input, TEP, Tooltip, defaults, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./input.html');
    Tooltip = require('tep/utils/tooltip');
    require('link!./style.css');
    /*
    Input Component
    ===============
    The Input component provides a stylized input field, with support for format
    validation and unit labels.
    
    Configuration
    =============
    The Input component supports the following configuration, provided as a single
    config object.
    */

    defaults = {
      /*
      *		label: Text for a label that appears to to the left of the input field.
      *   Use for Accessiblity along with labelVisible: false
      
      Defaults to ''.
      */

      label: "",
      /*
      *		labelVisible: Determines if the label is visible to all users; if false,
      it's only visible to screen readers
      Defaults to true.
      */

      labelVisible: true,
      /*
      *		id: An id for the input field. May be a string or a number. The id is used
      to generate the full id on the field (tei-input-[id]), as well as
      associate the label with the field.
      
      Defaults to 0.
      */

      id: 0,
      /*
      *		align: Text alignment of the field itself.
      
      Defaults to 'left'.
      */

      align: 'left',
      /*
      *		attributes: A dictionary of attributes to be applied to the input element.
      Any valid attribute of an HTML input element is acceptable here.
      
      Defaults to { type: "text", placeholder: "" }.
      */

      attributes: {
        type: 'text',
        placeholder: ''
      },
      /*
      *		units: A dictionary of unit labels to be desplayed on either side of
      the input field.
      
      Allowed keys are "left" and "right".
      
      Defaults to { left: "", right: "" }.
      */

      units: {
        left: '',
        right: ''
      },
      /*
      *		format: A regex describing the valid format of the field.
      
      Defaults to / .* /.
      */

      format: /.*/,
      /*
      *		formatDescription: A string providing the tooltip content if the user
      provides an invalid input, as determined by the format regex.
      
      Defaults to "Please enter a value".
      */

      formatDescription: 'Please enter a value',
      /*
      *		tooltipLocation: A string providing the tooltip location. (bottom,left,right,top)
      */

      tooltipLocation: 'right',
      /*
      *		customValidate: A function to run to determine validation status. This
      field provides support for any validation that cannot (or cannot easily)
      be managed via the format regex.
      
      The function should expect one argument, the current value of the field,
      and return a boolean.
      
      Note that customValidate does not replace the regex validation, and
      the field contents must pass both checks to be considered valid.
      
      Defaults to null.
      */

      customValidate: null,
      /*
      *		undecorate: Undecorate the input field on value get; used for special formatting
      */

      undecorate: function(val) {
        return val;
      },
      /*
      *		decorate: Decorate the selected field on value set; used for special formatting
      */

      decorate: function(val) {
        return val;
      },
      /*
      *		selectOnFocus: Select the text in the input field on focus
      */

      selectOnFocus: false,
      /*
      *		MaxLength: An integer that controls the maximum length of the field
      */

      maxLength: 0,
      /*
      *		enableTooltip: Enable tooltips to be displayed
      */

      enableTooltip: true,
      /*
      *		validateOnSelect: Validate value when field is selected
      */

      validateOnSelect: true,
      /*
      *		validateOnChange: Validate value when the value changes
      */

      validateOnChange: true,
      /*
      *		validateOnBlur: Validate value on field blur
      */

      validateOnBlur: false,
      /*
      *		correctTooltipText: This string will be used to generate a tooltip when
      @toggleCorrect is used and the user is correct. The text should contain an explanation
      as to why the user is correct; if not included, the tooltip will just show "Correct"
      */

      correctTooltipText: null,
      /*
      *		incorrectTooltipText: This string will be used to generate a tooltip when
      @toggleCorrect is used and the user is incorrect. The text should contain an explanation
      as to why the user is incorrect; if not included, the tooltip will just show "Incorrect"
      */

      incorrectTooltipText: null,
      /*
      autoNumeric: in case using the autoNumeric.js plugin
      */

      autoNumeric: false
    };
    return Input = (function(_super) {
      __extends(Input, _super);

      function Input(options) {
        this.onFocusOut = __bind(this.onFocusOut, this);
        this.onBlur = __bind(this.onBlur, this);
        this.onKeyUp = __bind(this.onKeyUp, this);
        this.onValueChange = __bind(this.onValueChange, this);
        this.validate = __bind(this.validate, this);
        this.selectField = __bind(this.selectField, this);
        this.view = __bind(this.view, this);
        this.displayValue = __bind(this.displayValue, this);
        this.rawValue = __bind(this.rawValue, this);
        this.val = __bind(this.val, this);
        this.value = __bind(this.value, this);
        this.disable = __bind(this.disable, this);
        this.enable = __bind(this.enable, this);
        this.toggleCorrect = __bind(this.toggleCorrect, this);
        this.buildTooltip = __bind(this.buildTooltip, this);
        this.displayTooltip = __bind(this.displayTooltip, this);
        this.updateTooltip = __bind(this.updateTooltip, this);
        this.clearTooltip = __bind(this.clearTooltip, this);
        this.hideTooltip = __bind(this.hideTooltip, this);
        this.isValid = __bind(this.isValid, this);
        var labelClass;
        this.settings = $.extend({}, defaults, options);
        this._view = $(tmpl);
        if (this.settings.label !== '') {
          labelClass = !this.settings.labelVisible ? "screen-reader-visible" : "";
          this._view.find('label').text(this.settings.label).addClass(labelClass).attr({
            "for": 'tei-input-' + this.settings.id
          });
        } else {
          this._view.find('.te-input-label').remove();
        }
        this.settings.attributes.id = 'tei-input-' + this.settings.id;
        this.field = this._view.find('input');
        this.field.attr(this.settings.attributes);
        if (this.settings.autoNumeric) {
          this.field.removeAttr('type');
        }
        this.field.css('text-align', this.settings.align);
        this.wrap = this._view.find('.te-input-wrap');
        if (this.settings.units.left !== '') {
          this._view.find('.te-input-unit-left').text(this.settings.units.left);
        } else {
          this._view.find('.te-input-unit-left').remove();
        }
        if (this.settings.units.right !== '') {
          this._view.find('.te-input-unit-right').text(this.settings.units.right);
        } else {
          this._view.find('.te-input-unit-right').remove();
        }
        this.field.bind('change', this.onValueChange);
        this.field.bind('keyup', this.onKeyUp);
        this.field.bind('focusout', this.onFocusOut);
        this.field.bind('blur', this.onBlur);
        if (this.settings.selectOnFocus) {
          this.field.bind('focus', this.selectField);
        }
        this.active = true;
      }

      /*
      
      API
      ===
      
      isValid()
      ---------
      Returns, as a boolean, whether the current value is considered valid.
      
      If the 'maxLength' setting is greater than zero, the first validation that will be run
       is a size check.
      
      If the defined format is a string instead of a regular expression
       the following options are valid:
        "numeric" - The component will ensure that the format can be converted to a number
      
      The final check is based on the format regex and, if provided, the customValidate function.
      */


      Input.prototype.isValid = function() {
        var value;
        value = this.settings.autoNumeric ? this.field.autoNumeric('get') : this.field.val();
        if (this.settings.maxLength > 0) {
          if (value.length > this.settings.maxLength) {
            this.updateTooltip("Max length of " + this.settings.maxLength);
            return false;
          } else {
            this.updateTooltip();
          }
        }
        if (typeof this.settings.format === "string") {
          if (this.settings.format.toLowerCase() === 'numeric') {
            return !isNaN(parseFloat(value)) && isFinite(value) && (this.settings.customValidate != null ? this.settings.customValidate(value, this) : true);
          }
        }
        return this.settings.format.test(value) && (this.settings.customValidate != null ? this.settings.customValidate(value, this) : true);
      };

      /*
      
      hideTooltip()
      --------
      Hides tooltip from the input wrap
      */


      Input.prototype.hideTooltip = function() {
        return Tooltip.hideTooltip(this.wrap, false);
      };

      /*
      
      clearTooltip()
      --------
      Removes tooltip from the input wrap and removes data-error
      */


      Input.prototype.clearTooltip = function() {
        this.wrap.removeData('error');
        Tooltip.destroyTooltip(this.wrap, false);
        return this.field.removeAttr('aria-describedby');
      };

      /*
      
      updateTooltip()
      --------
      Updates the tooltip value and destroys the old tooltip
      */


      Input.prototype.updateTooltip = function(description) {
        if (description == null) {
          description = this.settings.formatDescription;
        }
        if (this.settings.enableTooltip && this.settings.currentTooltip !== description && !this.evaluated) {
          this.settings.currentTooltip = description;
          this.clearTooltip();
          return this.buildTooltip();
        }
      };

      /*
      
      displayTooltip()
      --------
      Displays the tooltip
      Also checks for data-error to avoid flickering
      */


      Input.prototype.displayTooltip = function() {
        if (this.settings.enableTooltip && !this.wrap.data('error') && this.active) {
          this.buildTooltip();
          return Tooltip.showTooltip(this.wrap);
        }
      };

      /*
      
      buildTooltip()
      --------
      Builds the tooltip and sets data-error value
      */


      Input.prototype.buildTooltip = function() {
        if (this.settings.enableTooltip) {
          Tooltip.destroyTooltip(this.wrap);
          Tooltip.buildTooltip(this.wrap, "tei-input-" + this.settings.id + "-tip", this.settings.currentTooltip || this.settings.formatDescription, {
            placement: this.settings.tooltipLocation
          }, false);
          this.field.attr("aria-describedby", "tei-input-" + this.settings.id + "-tip");
          this.wrap.data('error', true);
          return this.wrap.removeAttr('tabindex');
        }
      };

      /*
      
      toggleCorrect()
      --------
      Updates field to show correct/incorrect tooltip and style appropriately
      */


      Input.prototype.toggleCorrect = function(isCorrect) {
        var tooltipMessage;
        if (isCorrect) {
          tooltipMessage = "Correct";
          if (this.settings.correctTooltipText != null) {
            tooltipMessage += " - " + this.settings.correctTooltipText;
          }
          this.field.addClass('input-correct');
        } else {
          tooltipMessage = "Incorrect";
          if (this.settings.incorrectTooltipText != null) {
            tooltipMessage += " - " + this.settings.incorrectTooltipText;
          }
          this.field.addClass('input-incorrect');
        }
        this.updateTooltip(tooltipMessage);
        return this.evaluated = true;
      };

      /*
      
      enable()
      --------
      Enables the component for user manipulation.
      */


      Input.prototype.enable = function() {
        this.active = true;
        this.field.removeAttr('readonly');
        this.clearTooltip();
        return this._view.removeClass('te-input-disabled');
      };

      /*
      disable()
      ---------
      Disables the component, preventing further user manipulation.
      */


      Input.prototype.disable = function() {
        this.active = false;
        this.clearTooltip();
        this._view.addClass('te-input-disabled');
        return this.field.attr('readonly', 'readonly');
      };

      /*
      value(val, silent)
      ----------
      Gets or sets the current value of the input field.
      If silent is provided, no event will be fired.
      */


      Input.prototype.value = function(val, silent) {
        var value;
        if (val != null) {
          if (this.settings.autoNumeric) {
            this.field.autoNumeric('set', val);
          } else {
            this.field.val(this.settings.decorate(val));
          }
          if (silent) {
            return;
          }
          return this.dispatchEvent('valuechange', {});
        } else {
          value = this.settings.autoNumeric ? this.field.autoNumeric('get') : this.settings.undecorate(this.field.val());
          return value;
        }
      };

      /*
      val(val, silent)
      ----------
      Convenience function for those used to jquery.
      TODO 3.0 replace value() with val()
      */


      Input.prototype.val = function(val, silent) {
        return this.value(val, silent);
      };

      /*
      rawValue()
      ----------
      get the raw value, with decorating or undecorating
      */


      Input.prototype.rawValue = function() {
        return this.field.val();
      };

      /*
      
      displayValue()
      --------------
      Returns the fields current value, with unit labels applied as appropriate.
      */


      Input.prototype.displayValue = function() {
        return (this.settings.units.left != null ? this.settings.units.left : '') + this.value() + (this.settings.units.right != null ? this.settings.units.right : '');
      };

      /*
      
      view()
      ------
      Returns the component's dom element (as a jQuery object).
      */


      Input.prototype.view = function() {
        return this._view;
      };

      /*
      
      selectField()
      ------
      Selects the currentTarget of the event. Useful for selecting the input text on focus.
      */


      Input.prototype.selectField = function(evt) {
        var _this = this;
        return $(evt.currentTarget).one('mouseup', function() {
          $(evt.currentTarget).select();
          if (_this.active && _this.settings.validateOnSelect) {
            _this.validate();
          }
          return false;
        }).select();
      };

      /*
      
      validate()
      ------
      Check if the field is valid and update the tooltip if necessary
      */


      Input.prototype.validate = function() {
        this.updateTooltip();
        if (this.value()) {
          if (this.isValid()) {
            this.hasError = false;
            this.clearTooltip();
          } else {
            this.hasError = true;
            if (this.settings.enableTooltip) {
              this.displayTooltip();
            }
          }
        } else {
          this.clearTooltip();
        }
        return this.field.attr("aria-invalid", this.hasError);
      };

      /*
      
      Events
      ======
      The Input component fires the following events:
      
      valuechange
      -----------
      Fires whenever the field value is set or changes.
      
      change
      -----------
      Fires only when the change event is fired (after focus out)
      
      If the change is not valid, the value is removed
      */


      Input.prototype.onValueChange = function(evt) {
        if (this.active) {
          if (this.settings.validateOnChange) {
            this.validate();
          }
          this.dispatchEvent('valuechange', {});
          if (evt.type === 'change') {
            return this.dispatchEvent('change', {});
          }
        }
      };

      Input.prototype.onKeyUp = function(evt) {
        if (evt.keyCode === 13) {
          this.dispatchEvent("Input.RequestSubmit", {});
          return;
        }
        return this.onValueChange(evt);
      };

      Input.prototype.onBlur = function(evt) {
        var value;
        if (this.settings.validateOnBlur) {
          this.validate();
        }
        value = this.field.val();
        if (value) {
          this.field.val(this.settings.decorate(value), true);
        }
        return this.dispatchEvent("Input.blur", {});
      };

      Input.prototype.onFocusOut = function(evt) {
        return this.hideTooltip();
      };

      return Input;

    })(TEP.EventDispatcher);
  });

}).call(this);
