// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, Model, Poll, SharedAnswers, TEP, Tooltip, View, defaults, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    Tooltip = require('tep/utils/tooltip');
    tmpl = require('text!./template.html');
    SharedAnswers = require('tep/components/sharedanswer/main');
    Model = require('./models/model');
    View = require('./views/view');
    require('link!./style.css');
    defaults = {
      calledFromBeforeAndAfter: false,
      graphInBeforeAndAfter: {
        show: false,
        message: ''
      },
      reflection: {
        shared: false,
        sharedInBeforeAndAfter: false,
        use: false
      }
    };
    return Poll = (function(_super) {
      __extends(Poll, _super);

      function Poll(data) {
        this.data = data;
        this.getPathLabelNumeric = __bind(this.getPathLabelNumeric, this);
        this.getPathLabelMC = __bind(this.getPathLabelMC, this);
        this._onEndRequest = __bind(this._onEndRequest, this);
        this.parseState = __bind(this.parseState, this);
        this.buildState = __bind(this.buildState, this);
        this.onReflectionChangeRequest = __bind(this.onReflectionChangeRequest, this);
        this.onResponseChangeRequest = __bind(this.onResponseChangeRequest, this);
        this.checkButtonBayMove = __bind(this.checkButtonBayMove, this);
        this.onReflectionSubmission = __bind(this.onReflectionSubmission, this);
        this.updateTeiState = __bind(this.updateTeiState, this);
        this.onResponseSubmission = __bind(this.onResponseSubmission, this);
        this.purify = __bind(this.purify, this);
        this.onBarTooltip = __bind(this.onBarTooltip, this);
        this.onStatusChange = __bind(this.onStatusChange, this);
        this.onSaveRequest = __bind(this.onSaveRequest, this);
        this.buildView = __bind(this.buildView, this);
        this.buildModel = __bind(this.buildModel, this);
        this.showSharedAnswers = __bind(this.showSharedAnswers, this);
        this._buildConversationHeader = __bind(this._buildConversationHeader, this);
        Poll.__super__.constructor.call(this, this.data, tmpl);
        this.needsTeiStateUpdate = false;
        this.model = this.buildModel();
        this.mainView = this.buildView();
        this.mainView.addEventListener("Poll.ResponseChangeRequest", this.onResponseChangeRequest);
        this.mainView.addEventListener("Poll.ReflectionChangeRequest", this.onReflectionChangeRequest);
        this.mainView.addEventListener("Poll.ResponseSubmission", this.onResponseSubmission);
        this.mainView.addEventListener("Poll.ReflectionSubmission", this.onReflectionSubmission);
        this.mainView.addEventListener("Poll.SaveState", this.onSaveRequest);
        this.mainView.addEventListener("Bar.Hover", this.onBarTooltip);
        this.mainView.handleButtonBay(this.buttonBay);
        this.mainView.handleSubState(this.model.getSubState());
        this.sharedAnswers = new SharedAnswers({
          tei: this.model._data.id,
          teiModel: this.model._data,
          calledFromBeforeAndAfter: this.model._data.calledFromBeforeAndAfter,
          beforeAndAfterId: this.model._data.beforeAndAfterId,
          type: "poll",
          conversation_header: this._buildConversationHeader
        });
        this.sharedAnswers.addEventListener("SharedAnswer.MetricRequest", this.onMetricRequest);
      }

      Poll.prototype._buildConversationHeader = function(answer) {
        return "<div class=\"poll-conversation-header\">\n  <div class=\"conversation-question te-preamble\"><p>" + this.model._data.reflection.prompt + "</p></div>\n  <div class=\"conversation-answer te-preamble\">\n    <p>\n      <div class=\"conversation-comment-byline\">\n        <span class=\"conversation-comment-author\">" + (answer.get('first_name') + '&nbsp;' + answer.get('last_name')) + "</span>\n        (<span class=\"conversation-comment-date\">" + (answer.get('answer_date')) + "</span>)\n      </div>\n      <div class=\"conversation-comment-text\">" + (answer.get('answer')) + "</div>\n    </p>\n  </div>\n</div>";
      };

      Poll.prototype.showSharedAnswers = function() {
        var $sharedContainer, calledFromBeforeAfter, displaySharedAnswers, reflectionData;
        reflectionData = this.model.get('reflection');
        calledFromBeforeAfter = this.model._data['calledFromBeforeAndAfter'];
        displaySharedAnswers = false;
        if (calledFromBeforeAfter) {
          if (reflectionData.shared) {
            displaySharedAnswers = true;
          }
        } else {
          if (reflectionData.use && reflectionData.shared && !reflectionData.sharedInBeforeAndAfter && this.$el.find('.te-poll-reflection-sharedanswers').length) {
            displaySharedAnswers = true;
          }
        }
        if (displaySharedAnswers) {
          $sharedContainer = this.$el.find('.te-poll-reflection-sharedanswers');
          $sharedContainer.show().append(this.sharedAnswers.$dom());
          this.sharedAnswers.update();
          if (calledFromBeforeAfter) {
            this.$el.find('.poll-reflection-wrap').before($sharedContainer);
            return this.$el.find('.poll-datavis').after(this.$el.find('.poll-reflection'));
          }
        }
      };

      Poll.prototype.buildModel = function() {
        this.data = new Model($.extend({}, true, defaults, this.data));
        this.data.last_tei = this.data._data.last_tei;
        return new Model(this.data._data);
      };

      Poll.prototype.buildView = function() {
        return new View(this.$el, this.model);
      };

      Poll.prototype.onSaveRequest = function() {
        Poll.__super__.onSaveRequest.call(this);
        return this.buttonBay.updateStatusMessage('save');
      };

      Poll.prototype.onStatusChange = function(evt, data) {
        Poll.__super__.onStatusChange.call(this);
        switch (this.model.getSubState()) {
          case "result":
            return this.showSharedAnswers();
        }
        switch (this.status) {
          case "unlocked":
            return this.start();
          case "complete":
            return this.mainView.removeButtons();
        }
      };

      Poll.prototype.onBarTooltip = function(evt, data) {
        return this.pushMetric({
          "user_selection": data.label
        }, "hover_histogram");
      };

      Poll.prototype.buttonBayBuildButtons = function() {
        var btns;
        btns = Poll.__super__.buttonBayBuildButtons.call(this, ['save']);
        _.extend(btns.buttons.save, {
          event: 'Poll.SaveState'
        });
        btns.buttons.response = {
          label: "Submit",
          event: "Poll.ResponseSubmission",
          "class": "alt-btn poll-respond interact-btn",
          statusMessageAction: 'Your information has been submitted.'
        };
        btns.buttons.reflection = {
          label: "Submit",
          event: "Poll.ReflectionSubmission",
          "class": "alt-btn poll-reflect interact-btn"
        };
        return btns;
      };

      Poll.prototype.purify = function(value) {
        var clean, input_answer, that,
          _this = this;
        clean = true;
        that = this;
        input_answer = this.$el.find(".poll-reflection-input");
        $.ajax('/common/web_purify_api/', {
          type: 'POST',
          async: false,
          dataType: 'json',
          data: JSON.stringify({
            'purify': value,
            'purify_warning_shown': that.purify_warning_shown,
            'cid': window.course_instance,
            'tei_id': that.data.id
          }),
          success: function(data, textStatus, jqXHR) {
            if (data.error) {
              that.purify_warning_shown = true;
              clean = false;
              Tooltip.buildTooltip(input_answer, _this.createId("reflectionError"), data.error);
              Tooltip.showTooltip(input_answer);
              return input_answer.on('click', function() {
                return Tooltip.destroyTooltip(input_answer);
              });
            } else {
              return that.purify_warning_shown = false;
            }
          }
        });
        return clean;
      };

      Poll.prototype.onResponseSubmission = function(evt, data) {
        var _this = this;
        switch (this.status) {
          case "unlocked":
          case "in-progress":
            this.pushMetric({
              "selected_answers": this.model.get('selectedAnswers')
            }, "user_selection");
            this.model.nextSubState();
            this.pushState('user', 'submit', function() {
              _this.needsTeiStateUpdate = true;
              _this.updateTeiState();
              return _this.buttonBay.updateStatusMessage('response');
            });
            return this.checkButtonBayMove();
        }
      };

      Poll.prototype.updateTeiState = function() {
        var _this = this;
        return this.pushState('tei', 'increment', function() {
          _this.needsTeiStateUpdate = false;
          return _this.pullState();
        });
      };

      Poll.prototype.onReflectionSubmission = function(evt, data) {
        var inputField, value,
          _this = this;
        inputField = this.$el.find(".poll-reflection-input");
        Tooltip.destroyTooltip(inputField);
        value = inputField.val();
        if (value) {
          if (this.purify(value)) {
            this.model.set('reflection.isSubmitted', true);
            this.pushMetric({
              "submitted": 1
            }, "reflection");
            this.model.nextSubState();
            this.pushState('user', 'set', function() {
              _this.pullState();
              return _this.showSharedAnswers();
            });
            return this.checkButtonBayMove();
          }
        }
      };

      Poll.prototype.checkButtonBayMove = function() {
        if (this.model.getSubState() === "result") {
          this.$el.find(".poll-submission-status h3").removeAttr("aria-hidden").text("Poll submitted");
          return this.moveButtonBay("end");
        }
      };

      Poll.prototype.onResponseChangeRequest = function(evt, data) {
        this.model.set('selectedAnswers', data.value);
        if (data.displayValue != null) {
          this.model.set('displayValue', data.displayValue);
        }
        return this.updateSaveButton(true);
      };

      Poll.prototype.onReflectionChangeRequest = function(evt, data) {
        this.model.set('reflection.value', data.value);
        return this.updateSaveButton(true);
      };

      Poll.prototype.buildState = function(scope, op) {
        var id, s, _i, _len, _ref;
        s = Poll.__super__.buildState.call(this, scope, op);
        switch (scope) {
          case "user":
            s.model = this.model["export"]();
            s.selectedAnswers = this.model.get('selectedAnswers');
            s.reflection = this.model.get('reflection');
            break;
          case "tei":
            if (op === "increment") {
              _ref = this.model.get('selectedAnswers');
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                id = _ref[_i];
                s[id] = 1;
              }
            }
        }
        return s;
      };

      Poll.prototype.parseState = function(data) {
        var scope, state, _ref, _ref1;
        if (this.needsTeiStateUpdate) {
          this.updateTeiState();
        }
        _ref = data.states;
        for (scope in _ref) {
          state = _ref[scope];
          switch (scope) {
            case "user":
              if (state.model != null) {
                this.model["import"](state.model);
              }
              break;
            case "tei":
              if ((state.data != null) && (((_ref1 = data.states.user) != null ? _ref1.submitCount : void 0) != null) > 0 && !data.survey) {
                this.model.importAggregateData(state);
              }
          }
        }
        return Poll.__super__.parseState.call(this, data);
      };

      Poll.prototype._onEndRequest = function(evt, data) {
        var labels, responseType;
        if (!this.data._data || $.isEmptyObject(this.data._data.pathSettings)) {
          return this.end();
        } else {
          responseType = this.data._data.response.type;
          if (responseType === "numeric") {
            labels = this.getPathLabelNumeric();
          } else {
            labels = this.getPathLabelMC();
          }
          return this.pushCourseInstanceState(labels, "role", this.end);
        }
      };

      Poll.prototype.getPathLabelMC = function() {
        var answers, labels, option, _i, _len, _ref, _ref1;
        labels = [];
        answers = this.data._data.selectedAnswers;
        _ref = this.data._data.pathSettings.options;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          option = _ref[_i];
          if (_ref1 = String(option.choiceId), __indexOf.call(answers, _ref1) >= 0) {
            labels.push(option.label);
          }
        }
        return labels;
      };

      Poll.prototype.getPathLabelNumeric = function() {
        var answer, answerRange, labels, option, range, rangeNumbers, _i, _j, _k, _len, _len1, _len2, _ref, _ref1;
        answer = parseFloat(this.data._data.selectedAnswers[0]);
        rangeNumbers = [];
        _ref = this.data._data.pathSettings.options;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          option = _ref[_i];
          rangeNumbers.push(option.rangeMax);
        }
        rangeNumbers.sort(function(a, b) {
          return a - b;
        });
        answerRange = null;
        for (_j = 0, _len1 = rangeNumbers.length; _j < _len1; _j++) {
          range = rangeNumbers[_j];
          if (answer <= range) {
            answerRange = range;
            break;
          }
        }
        labels = [];
        if (answerRange !== null) {
          _ref1 = this.data._data.pathSettings.options;
          for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
            option = _ref1[_k];
            if (option.rangeMax === answerRange) {
              labels.push(option.label);
            }
          }
        } else {
          labels.push(this.data._data.pathSettings.catchAllLabel);
        }
        return labels;
      };

      return Poll;

    })(TEP.TeachingElement);
  });

}).call(this);
