// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Graph, StateMachine;
    Graph = require('tep/utils/geom/graph/main');
    return StateMachine = (function(_super) {
      __extends(StateMachine, _super);

      function StateMachine() {
        this.forceState = __bind(this.forceState, this);
        this._setState = __bind(this._setState, this);
        this.traverse = __bind(this.traverse, this);
        this.addPath = __bind(this.addPath, this);
        this.addState = __bind(this.addState, this);
        this.currentState = __bind(this.currentState, this);
        StateMachine.__super__.constructor.call(this);
        this.createNode({
          params: 'default'
        });
        this._currentState = 'default';
      }

      StateMachine.prototype.currentState = function() {
        return this._currentState;
      };

      StateMachine.prototype.addState = function(id) {
        return this.createNode({
          params: id
        });
      };

      StateMachine.prototype.addPath = function(fromId, toId) {
        var opts;
        opts = {
          from: this.getNodeById(fromId),
          to: this.getNodeById(toId)
        };
        return this.connect(opts);
      };

      StateMachine.prototype.traverse = function(toId) {
        var allPaths, p, paths;
        allPaths = this.getEdgesFrom(this.getNodeById(this._currentState));
        if (toId != null) {
          paths = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = allPaths.length; _i < _len; _i++) {
              p = allPaths[_i];
              if (p.to.id === toId) {
                _results.push(p);
              }
            }
            return _results;
          })();
        } else {
          paths = (function() {
            var _i, _len, _results;
            _results = [];
            for (_i = 0, _len = allPaths.length; _i < _len; _i++) {
              p = allPaths[_i];
              _results.push(p);
            }
            return _results;
          })();
        }
        if (paths.length > 0) {
          return this._setState(paths[0].to.id);
        }
      };

      StateMachine.prototype._setState = function(toId) {
        var old;
        old = this._currentState;
        this._currentState = toId;
        return this.dispatchEvent('StateMachine.StateChange', {
          from: old,
          to: this._currentState
        });
      };

      StateMachine.prototype.forceState = function(id) {
        var node;
        if ((node = this.getNodeById(id))) {
          return this._setState(id);
        } else {
          throw new Error("No such state \"" + id + "\"");
        }
      };

      return StateMachine;

    })(Graph);
  });

}).call(this);
