// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, MouseTouch, Slider, TEP, Tooltip, Utils, defaults, labelDefaults, label_tmpl, tmpl;
    $ = require('jquery');
    TEP = require("tep/tep");
    tmpl = require('text!./template.html');
    label_tmpl = require('text!./label.html');
    MouseTouch = require('tep/utils/mousetouch');
    Utils = require('tep/utils/utils');
    Tooltip = require('tep/utils/tooltip');
    require('link!./style.css');
    /*
    Slider Component
    ================
    The Slider component provides a one-dimensional value selector. Internally,
    everything is managed on a [0,1] domain, but by providing minimum and maximum
    values for the range, scaled values can be easily obtained.
    
    Configuration
    =============
    The Slider component supports the following configuration, passed in as a single
    config object:
    */

    defaults = {
      /*
      *   steps: An integer describing how many "steps" are in the slider. If set to
      0, the slider performs as a free-form entry. If set to 2 or greater,
      the slider will be divided up into that many steps, and values will always
      "snap" into the nearest step.  This means that if there are only two steps,
      this is functionally equivalent to a Switch component.
      
      A step value of 1 is treated as if it were 0.
      
      Defaults to 0.
      */

      steps: 0,
      /*
      *   min: The minimum value of the slider's range.  Affects the returned value
      of scaledValue()
      
      Defaults to 0.
      */

      min: 0,
      /*
      *   max: The maximum value of the slider's range.  Affects the returned value
      of scaledValue()
      
      Defaults to 1.
      */

      max: 1,
      /*
      *   delta: The increment/decrement value of the slider's range.  Affects the
      returned value of scaledValue()
      
      Defaults to 1.
      */

      delta: 1,
      /*
      *   deltaJump: The amount to multiply delta when using the page up/down keys
      
      Defaults to 10.
      */

      deltaJump: 10,
      /*
      *   type: the type of slider, single or ranged; if ranged, accessibility attributes are added differently
      this is handled in the rangedslider component
      
      Defaults to single.
      */

      type: 'single',
      /*
      *   ariaControls: links the slider to the element it controls for accessibility
      
      Defaults to single.
      */

      ariaControls: '',
      /*
      *   axis: EXPERIMENTAL. A string indicating the orientation of the
      slider.
      
      Supported values: "x", "y"
      
      Defaults to "x".
      */

      axis: "x",
      /*
      *   currentValue: The initial value of the slider.
      
      See also: currentValueType
      
      Defaults to 0.
      */

      currentValue: 0,
      /*
      *   currentValueType: A string indicating the nature of the currentValue.
      
      Supported values:
      *   "raw": currentValue is a [0,1] percentage.
      *   "scaled": currentValue is a scaled value, falling between min and max.
      
      Defaults to "raw".
      */

      currentValueType: "raw",
      /*
      *   disabled: A boolean indicating the initial active state of the component.
      */

      disabled: false,
      /*
      *   classes: A string of classes to be applied to the component. Styles are
      provided for "large"
      
      Defaults to "large".
      */

      classes: "large",
      /*
      *   title: A string title to be displayed above the slider.
      */

      title: null,
      /*
      *   description: A string description to be added as the aria label
      */

      description: '',
      /*
      *   ariaLabeledBy: A string description to be added as the aria labeled by
      */

      ariaLabeledBy: '',
      /*
      *   showTooltips: Show tooltip on slider.
      */

      showTooltips: false,
      /*
      *   tooltipFormatter: Callback function to format tooltip value
      */

      tooltipFormatter: null,
      /*
      *   tooltipPlacement: where the tooltip should appear
      */

      tooltipPlacement: 'top',
      /*
      *   labels: A dictionary (object) of label configurations (see below).  Keys
      of the dict are used to generate the id attribute of the label for custom
      styling.
      Defaults to null.
      */

      labels: null,
      /*
      *   upFunction: function to be called after key up
      Defaults to null.
      */

      upFunction: null,
      /*
      *   metricFunction: function to be called after key up to send metrics
      Defaults to null.
      */

      metricFunction: null
    };
    /*
    
    Label Configuration
    -------------------
    Slider labels support the following configurations, provided in the labels
    field of the main configuration.
    */

    labelDefaults = {
      /*
      *   content: A string containing the text to be displayed.
      
      Defaults to "".
      */

      content: "",
      /*
      *   value: A number designating the location of the label, relative to
      values on the slider.
      
      See also: valueType.
      
      Defaults to 0.
      */

      value: 0,
      /*
      *   valueType: A string indicating the nature of the value.
      
      Supported values:
      *   "raw": value is a [0,1] percentage.
      *   "scaled": value is a scaled value, falling between min and max.
      
      Defaults to "raw".
      */

      valueType: "raw"
    };
    return Slider = (function(_super) {
      __extends(Slider, _super);

      function Slider(conf, template_override) {
        this.handleKeyUp = __bind(this.handleKeyUp, this);
        this.getMetric = __bind(this.getMetric, this);
        this.handleKeypress = __bind(this.handleKeypress, this);
        this._updateAriaValues = __bind(this._updateAriaValues, this);
        this._updatePosition = __bind(this._updatePosition, this);
        this._updateValue = __bind(this._updateValue, this);
        this._parseValueFromPosition = __bind(this._parseValueFromPosition, this);
        this.stopHover = __bind(this.stopHover, this);
        this.startHover = __bind(this.startHover, this);
        this.drag = __bind(this.drag, this);
        this.stopDrag = __bind(this.stopDrag, this);
        this.startDrag = __bind(this.startDrag, this);
        this.jump = __bind(this.jump, this);
        this._configureLabelsHeight = __bind(this._configureLabelsHeight, this);
        this.drawTooltip = __bind(this.drawTooltip, this);
        this.scale = __bind(this.scale, this);
        this._snapValue = __bind(this._snapValue, this);
        this.value = __bind(this.value, this);
        this.scaledValue = __bind(this.scaledValue, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        var $label, $labelContent, attrs, cssClasses, key, label, percentage, template, value, _ref,
          _this = this;
        template = template_override ? template_override : tmpl;
        this.config = $.extend({}, defaults, conf);
        if (this.config.currentValueType === "scaled") {
          this.currentValue = this.scale(this.config.currentValue, 'domain');
        } else {
          this.currentValue = this.config.currentValue;
        }
        this.disabled = this.config.disabled;
        this.currentPt = {
          x: 0,
          y: 0
        };
        this.$dom = $(template);
        cssClasses = this.config.classes.split(' ');
        cssClasses.push('slider-' + this.config.axis);
        this.$dom.addClass(cssClasses.join(' '));
        if (this.config.type === "single") {
          attrs = {
            'id': this.config.sliderId,
            'aria-valuemin': this.config.min,
            'aria-valuemax': this.config.max,
            'aria-valuenow': this.config.currentValue,
            'aria-label': this.config.description,
            'aria-labelledby': this.config.ariaLabeledBy
          };
          if (this.config.ariaControls) {
            attrs['aria-controls'] = this.config.ariaControls;
          }
          this.$dom.find('.component-slider-slider').attr(attrs);
        }
        this.$dom.find('.slider-rail').on('click', this.jump);
        this.$dom.find('.component-slider-handle').on('mousedown', this.startDrag);
        $(document).on('mouseup', this.stopDrag);
        $(document).on('mousemove', this.drag);
        this.$dom.find('.component-slider-handle').on('mouseenter', this.startHover);
        this.$dom.find('.component-slider-handle').on('mouseleave', this.stopHover);
        this.$dom.bind('focus', function() {
          return $(document).on('keydown', _this.handleKeypress);
        });
        this.$dom.bind('blur', function() {
          return $(document).off('keydown', _this.handleKeypress);
        });
        this.$dom.find('.component-slider-slider').on('keydown', this.handleKeypress);
        this.$dom.find('.component-slider-slider').on('keyup', this.handleKeyUp);
        this._configureLabelsHeight();
        if (this.config.labels != null) {
          _ref = this.config.labels;
          for (key in _ref) {
            value = _ref[key];
            label = $.extend({}, labelDefaults, value);
            if (label.valueType === "scaled") {
              percentage = this.scale(label.value, 'domain') * 100;
            } else {
              percentage = label.value * 100;
            }
            if (percentage <= 100 && percentage >= 0) {
              $label = $(label_tmpl);
              $label.css({
                'left': percentage + '%',
                'transform': "translateX(-" + percentage + "%)"
              });
              $labelContent = $label.find('.component-slider-label-content');
              $labelContent.html(label.content);
              if (label.id) {
                $labelContent.attr('id', label.id);
              }
              this.$dom.find('.component-slider-labels').append($label);
            }
          }
        } else {
          this.$dom.find('.component-slider-labels').remove();
        }
        if (this.config.title != null) {
          this.$dom.find('.slider-title').html(this.config.title);
        } else {
          this.$dom.find('.slider-title').remove();
        }
        if (this.config.showTooltips) {
          this.drawTooltip(false);
        }
        this._updatePosition();
      }

      /*
      API
      ===
      
      disable()
      ---------
      Disables the component from further manipulation.
      */


      Slider.prototype.disable = function() {
        return this.disabled = true;
      };

      /*
      
      enable()
      --------
      Enables the component to allow user manipulation.
      */


      Slider.prototype.enable = function() {
        return this.disabled = false;
      };

      /*
      
      scaledValue(val)
      ----------------
      Gets or sets the slider's current position in terms of the slider's range (e.g.
      between the min and max values provided in configuration).
      */


      Slider.prototype.scaledValue = function(val, silent) {
        if (silent == null) {
          silent = false;
        }
        if (val != null) {
          return this.value(this.scale(val, 'domain'), silent);
        } else {
          return this.scale(this.value(), 'range');
        }
      };

      /*
      
      value(val)
      ----------
      Gets or sets the slider's current position in terms of the slider's domain,
      [0,1].
      */


      Slider.prototype.value = function(val, silent) {
        var oldVal;
        if (silent == null) {
          silent = false;
        }
        if (val != null) {
          if (!this.disabled) {
            oldVal = this.currentValue;
            this.currentValue = this._snapValue(val);
            this.currentValue = Math.min(1, Math.max(0, this.currentValue));
            if (oldVal !== this.currentValue) {
              this._updatePosition();
              if (this.config.showTooltips != null) {
                Tooltip.destroyTooltip(this.$dom.find('.slider-handle-nubbin'));
              }
              if (silent) {
                return;
              }
              return this.dispatchEvent('Slider.ValueChange', {});
            }
          }
        } else {
          return this.currentValue;
        }
      };

      Slider.prototype._snapValue = function(val) {
        if (this.config.steps < 2) {
          return val;
        } else {
          return Math.round(val * (this.config.steps - 1)) / (this.config.steps - 1);
        }
      };

      /*
      scale(val, target = 'range')
      ----------
      */


      Slider.prototype.scale = function(val, target) {
        if (target == null) {
          target = "range";
        }
        if (target === 'domain') {
          return (val - this.config.min) / (this.config.max - this.config.min);
        } else {
          return val * (this.config.max - this.config.min) + this.config.min;
        }
      };

      /*
      drawTooltip(display)
      ----------
      */


      Slider.prototype.drawTooltip = function(display) {
        var nub, tip_value;
        if (display == null) {
          display = true;
        }
        tip_value = this.scaledValue();
        if (this.config.tooltipFormatter) {
          tip_value = this.config.tooltipFormatter(tip_value);
        }
        nub = this.$dom.find('.slider-handle-nubbin');
        Tooltip.buildTooltip(nub, "", tip_value, {
          placement: this.config.tooltipPlacement,
          trigger: "manual focus"
        }, false);
        if (display) {
          return Tooltip.showTooltip(nub);
        }
      };

      Slider.prototype._configureLabelsHeight = function() {
        var observer, that,
          _this = this;
        that = this;
        observer = new MutationObserver(function() {
          var maxHeight;
          maxHeight = that.$dom.find('.component-slider-labels').outerHeight();
          that.$dom.find('.component-slider-label-content').each(function(index, item) {
            var itemHeight;
            itemHeight = $(item).outerHeight();
            return maxHeight = maxHeight > itemHeight ? maxHeight : itemHeight;
          });
          that.$dom.find('.component-slider-labels').css('height', "" + maxHeight + "px");
          return observer.disconnect();
        });
        return observer.observe(this.$dom.find('.component-slider-labels')[0], {
          attributes: false,
          childList: true
        });
      };

      /*
      Events
      ======
      The Slider component fires the following events:
      
      Slider.ValueChange
      ------------------
      Fires whenever the slider's value changes. Note that this fires only on
      a change, not necessarily every time the value is set.
      
      Slider.Jump
      -----------
      Fires when the user clicks on the slider's rail to specify a new location.
      
      Slider.DragStart
      ----------------
      Fires when the user begins dragging the slider's handle.
      
      Slider.Drag
      -----------
      Fires when the user moves the slider's handle.
      
      Slider.Drop
      -----------
      Fires when the user stops dragging the slider's handle.
      
      Internal Event Handlers
      =======================
      */


      Slider.prototype.jump = function(jqevt) {
        if (!this.disabled) {
          this.dragging = false;
          this._updateValue(jqevt);
          if (this.config.showTooltips) {
            this.drawTooltip();
          }
          if (this.config.metricFunction) {
            this.config.metricFunction(this.getMetric('mouse'), 'slider');
          }
          this.dispatchEvent('Slider.Jump', {});
          return false;
        }
      };

      Slider.prototype.startDrag = function(jqevt) {
        if (!this.dragging && !this.disabled) {
          this.dragging = true;
          if (this.config.showTooltips) {
            Tooltip.destroyTooltip(this.$dom.find('.slider-handle-nubbin'));
          }
          this.dispatchEvent('Slider.DragStart', {});
          this.$dom.addClass('slider-dragging');
          return false;
        }
      };

      Slider.prototype.stopDrag = function(jqevt) {
        if (this.dragging && !this.disabled) {
          this.dragging = false;
          if (this.config.showTooltips) {
            this.drawTooltip();
          }
          this.$dom.removeClass('slider-dragging');
          if (this.config.metricFunction) {
            this.config.metricFunction(this.getMetric('mouse'), 'slider');
          }
          this.dispatchEvent('Slider.Drop', {});
          return false;
        }
      };

      Slider.prototype.drag = function(jqevt) {
        if (this.dragging && !this.disabled) {
          this._updateValue(jqevt);
          this.dispatchEvent('Slider.Drag', {});
          return false;
        }
      };

      Slider.prototype.startHover = function(jqevt) {
        if (this.config.showTooltips) {
          this.drawTooltip();
        }
        return true;
      };

      Slider.prototype.stopHover = function(jqevt) {
        if (this.config.showTooltips) {
          Tooltip.destroyTooltip(this.$dom.find('.slider-handle-nubbin'));
        }
        return true;
      };

      Slider.prototype._parseValueFromPosition = function(currentPt) {
        var offset, size, val;
        switch (this.config.axis) {
          case "x":
            size = this.$dom.find('.slider-rail').width();
            offset = this.$dom.find('.slider-rail').offset().left;
            val = (currentPt[this.config.axis] - offset) / size;
            break;
          case "y":
            size = this.$dom.find('.slider-rail').height();
            offset = this.$dom.find('.slider-rail').offset().top + size;
            val = (offset - currentPt[this.config.axis]) / size;
        }
        return val;
      };

      Slider.prototype._updateValue = function(jqevt) {
        var currentPt, val;
        currentPt = MouseTouch.parsePosition(jqevt.originalEvent);
        val = this._parseValueFromPosition(currentPt);
        this.value(val);
        return this._updateAriaValues();
      };

      Slider.prototype._updatePosition = function() {
        var bgParam, coords, handle, handleParam, percent;
        switch (this.config.axis) {
          case "x":
            handleParam = "left";
            bgParam = "width";
            percent = this.value() * 100;
            break;
          case "y":
            handleParam = "top";
            bgParam = "height";
            percent = (1 - this.value()) * 100;
        }
        handle = this.$dom.find('.component-slider-handle');
        handle.css(handleParam, percent + "%");
        this.$dom.find('.slider-before').css(bgParam, percent + "%");
        this.$dom.find('.slider-after').css(bgParam, (1 - percent / 100) * 100 + "%");
        coords = handle.offset();
        return this.currentPt = {
          x: coords.left,
          y: coords.top
        };
      };

      Slider.prototype._updateAriaValues = function() {
        return this.$dom.find('.component-slider-slider').attr('aria-valuenow', this.scaledValue().toFixed(2));
      };

      Slider.prototype.handleKeypress = function(jqevt) {
        var code, delta, keys, max, min, newVal;
        jqevt.stopPropagation();
        code = jqevt.keyCode ? jqevt.keyCode : jqevt.which;
        keys = Utils.getKeyMap();
        if (__indexOf.call(keys.allMovementKeys, code) >= 0) {
          jqevt.preventDefault();
          delta = this.config.delta;
          newVal = this.scaledValue();
          max = this.config.max;
          min = this.config.min;
          if (__indexOf.call(keys.decreaseKeys, code) >= 0) {
            delta *= -1;
          }
          if (__indexOf.call(keys.jumpKeys, code) >= 0) {
            delta *= this.config.deltaJump;
          }
          if (code === keys.zeroKey || code === keys.maxKey) {
            delta = 0;
            newVal = code === keys.zeroKey ? min : max;
          }
          newVal += delta;
          if (newVal > max) {
            newVal = max;
          } else if (newVal < min) {
            newVal = min;
          }
          this.scaledValue(newVal);
          return this._updateAriaValues();
        }
      };

      Slider.prototype.getMetric = function(method) {
        return {
          name: this.config.title || this.config.description,
          scaled_value: this.scaledValue().toFixed(5),
          value: this.value().toFixed(5),
          method: method
        };
      };

      Slider.prototype.handleKeyUp = function(jqevt) {
        var code, keys;
        jqevt.stopPropagation();
        jqevt.preventDefault();
        code = jqevt.keyCode ? jqevt.keyCode : jqevt.which;
        keys = Utils.getKeyMap();
        if (__indexOf.call(keys.allMovementKeys, code) >= 0) {
          this.drawTooltip();
          if (this.config.upFunction) {
            this.config.upFunction(jqevt);
          }
          if (this.config.metricFunction) {
            return this.config.metricFunction(this.getMetric('key_up'), 'slider');
          }
        }
      };

      return Slider;

    })(TEP.EventDispatcher);
  });

}).call(this);
