// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, DropContainer, TEP, defaults, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./template.html');
    require('bootstrap');
    require('jqueryui');
    require('link!./style.css');
    /*
    Droppable Component
    ===============
    
    The Droppable component provides a standard droppable element for Teaching Elements. It can be configured
    to work with the Draggable component (the two work together via the scope option to allow draggables to
    work with one or more droppable elements).
    
    Configuration
    =============
    Droppable supports the following configurations, passed in as a single config object.
    */

    defaults = {
      /*
        *   scope: used to determine what draggables (from the Draggable component) can be accepted by the droppable.
        Enter different values to create multiple droppable "buckets."
      
        Defaults to te-drop-container.
      */

      scope: 'te-drop-container',
      /*
        *   container: determines where the draggable can be dragged (i.e. do not drag outside the TEI).
      
        Defaults to .te-drag, which should be the TEI.
      */

      container: '.te-drag',
      /*
        *   hoverClass: assigned to the droppable when a draggable is hovering over the droppable. Use different
        values if you need to highlight the droppables differently (must also update style.scss if creating
        a new hover class)
      
        Defaults to te-droppable-hover.
      */

      hoverClass: 'te-droppable-hover',
      /*
        *   dropContainerElement: container to drop item into.
      
        Defaults to null.
      */

      dropContainerElement: null
    };
    return DropContainer = (function(_super) {
      __extends(DropContainer, _super);

      function DropContainer(data, options, container) {
        this.setWidth = __bind(this.setWidth, this);
        this.getWidth = __bind(this.getWidth, this);
        this.setTitleHeight = __bind(this.setTitleHeight, this);
        this.getTitleHeight = __bind(this.getTitleHeight, this);
        this.setHeight = __bind(this.setHeight, this);
        this.getHeight = __bind(this.getHeight, this);
        this.view = __bind(this.view, this);
        this.onFocus = __bind(this.onFocus, this);
        this.disable = __bind(this.disable, this);
        this.enable = __bind(this.enable, this);
        this.onItemOut = __bind(this.onItemOut, this);
        this.onItemOver = __bind(this.onItemOver, this);
        this.dropItem = __bind(this.dropItem, this);
        this.onItemDrop = __bind(this.onItemDrop, this);
        this.initialize = __bind(this.initialize, this);
        var key, val;
        for (key in defaults) {
          val = defaults[key];
          this[key] = options[key] != null ? options[key] : val;
        }
        this._view = $(container);
        if (data.content !== void 0) {
          this._view.find('.te-droppable-title').html(data.content);
        }
        if (data.id !== void 0) {
          this._view.attr('data-drop-id', data.id);
        }
        this.initialize();
        this._view.on('focus focusout', this.onFocus);
      }

      DropContainer.prototype.initialize = function() {
        return this._view.droppable({
          scope: this.scope,
          hoverClass: this.hoverClass,
          tolerance: "intersect",
          drop: this.onItemDrop,
          over: this.onItemOver,
          out: this.onItemOut
        });
      };

      DropContainer.prototype.onItemDrop = function(event, ui) {
        var container, observer, that,
          _this = this;
        that = this;
        container = this._view;
        if (this.dropContainerElement) {
          container = this.dropContainerElement;
        }
        observer = new MutationObserver(function() {
          that.dispatchEvent('Droppable.ItemReceived', {
            id: ui.draggable.attr('data-id'),
            item: ui.draggable,
            dropId: _this._view.data('drop-id')
          });
          return observer.disconnect();
        });
        observer.observe(container[0], {
          attributes: false,
          childList: true
        });
        return this.dropItem(ui, container);
      };

      DropContainer.prototype.dropItem = function(ui, container) {
        ui.draggable.parent().removeClass("item-slot-empty");
        return ui.draggable.appendTo(container);
      };

      DropContainer.prototype.onItemOver = function(event, ui) {
        return this.dispatchEvent('Droppable.ItemOver', {
          id: ui.draggable.attr('data-id'),
          item: ui.draggable
        });
      };

      DropContainer.prototype.onItemOut = function(event, ui) {
        return this.dispatchEvent('Droppable.ItemRemoved', {
          id: ui.draggable.attr('data-id'),
          item: ui.draggable
        });
      };

      DropContainer.prototype.enable = function() {
        return this._view.droppable('enable');
      };

      DropContainer.prototype.disable = function() {
        this._view.droppable('disable');
        return this._view.removeAttr('aria-dropeffect');
      };

      DropContainer.prototype.onFocus = function() {
        if (this._view.attr('tabindex')) {
          if (this._view.hasClass(this.hoverClass)) {
            return this._view.removeClass(this.hoverClass);
          } else {
            return this._view.addClass(this.hoverClass);
          }
        }
      };

      DropContainer.prototype.view = function() {
        return this._view;
      };

      DropContainer.prototype.getHeight = function() {
        var height;
        return height = this._view.outerHeight();
      };

      DropContainer.prototype.setHeight = function(newHeight) {
        return this._view.height(newHeight);
      };

      DropContainer.prototype.getTitleHeight = function() {
        var height;
        return height = this._view.find('.te-droppable-title').height();
      };

      DropContainer.prototype.setTitleHeight = function(newHeight) {
        return this._view.find('.te-droppable-title').height(newHeight);
      };

      DropContainer.prototype.getWidth = function() {
        var width;
        return width = this._view.outerWidth();
      };

      DropContainer.prototype.setWidth = function(newWidth) {
        return this._view.width(newWidth);
      };

      return DropContainer;

    })(TEP.EventDispatcher);
  });

}).call(this);
