// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Drag, DragCategorization, Drop, Lightbox, TEP, Tooltip, Utils, modulePath, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./template.html');
    Drag = require('tep/components/draggable/main');
    Drop = require('tep/components/droppable/main');
    Utils = require('tep/utils/utils');
    Tooltip = require('tep/utils/tooltip');
    require('jquery_ui_touch_punch');
    require('link!./style.css');
    modulePath = "bcore/static/te/dragCategorization/0.1/courseware/";
    Lightbox = require('tep/components/lightbox/main');
    return DragCategorization = (function(_super) {
      __extends(DragCategorization, _super);

      function DragCategorization(data) {
        var cat, cnt, colW, container, drag, dragOptions, it, maxItems, row, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2;
        this.data = data;
        this.parseState = __bind(this.parseState, this);
        this.buildSummary = __bind(this.buildSummary, this);
        this.buildState = __bind(this.buildState, this);
        this.getCurrentItems = __bind(this.getCurrentItems, this);
        this.enableItems = __bind(this.enableItems, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.checkItems = __bind(this.checkItems, this);
        this.delayCheckItems = __bind(this.delayCheckItems, this);
        this.onSpaceKey = __bind(this.onSpaceKey, this);
        this.onEnterKey = __bind(this.onEnterKey, this);
        this.onEscapeKey = __bind(this.onEscapeKey, this);
        this.clearDropItems = __bind(this.clearDropItems, this);
        this.clearDragItems = __bind(this.clearDragItems, this);
        this.keyPressed = __bind(this.keyPressed, this);
        this.buildButtons = __bind(this.buildButtons, this);
        this.checkButtons = __bind(this.checkButtons, this);
        this.submit = __bind(this.submit, this);
        this.onResetRequest = __bind(this.onResetRequest, this);
        this.updCatH = __bind(this.updCatH, this);
        this.checkSizes = __bind(this.checkSizes, this);
        this.onScreen = __bind(this.onScreen, this);
        this.onStatusChange = __bind(this.onStatusChange, this);
        this.resetClasses = __bind(this.resetClasses, this);
        this.showLightbox = __bind(this.showLightbox, this);
        DragCategorization.__super__.constructor.call(this, this.data, tmpl);
        this.retry = 0;
        this.snd = Utils.loadSound("" + modulePath + "../../../_common/media/sfx/drop");
        if (this.data.type === "image") {
          this.$el.find('.te-dragCategorization').addClass('te-drag-imgs');
        }
        row = 0;
        cnt = 0;
        if (this.data.type === "text") {
          maxItems = 5;
        } else {
          maxItems = 3;
        }
        dragOptions = {
          container: this.$el.data("tep-id", this.data.id)
        };
        this.dragItems = (function() {
          var _i, _len, _ref, _results;
          _ref = this.data.items;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            it = _ref[_i];
            _results.push(new Drag(it, dragOptions));
          }
          return _results;
        }).call(this);
        _ref = this.dragItems;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          drag = _ref[_i];
          drag.draggableItem.on('dragstart', this.resetClasses);
        }
        if (this.data.type === "image") {
          _ref1 = this.dragItems;
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            drag = _ref1[_j];
            drag.draggableItem.on('click', this.showLightbox);
          }
        }
        this.on('requestLightbox', this.onLightboxRequest);
        while (cnt < this.dragItems.length) {
          if (row === 0 || cnt === (maxItems * row)) {
            row++;
            this.$el.find('.te-drag-items').append('<div class="te-drag-item-row-' + row + ' te-drag-item-row"></div>');
          }
          this.$el.find('.te-drag-item-row-' + row).append(this.dragItems[cnt].view());
          cnt++;
        }
        container = '<div class="te-droppable te-droppable-column" tabindex="0"><div class="te-droppable-title"><div class="te-droppable-title-content"></div></div></div>';
        this.categories = (function() {
          var _k, _len2, _ref2, _results;
          _ref2 = this.data.categories;
          _results = [];
          for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
            cat = _ref2[_k];
            _results.push(new Drop(cat, {}, container));
          }
          return _results;
        }).call(this);
        colW = (100 / this.categories.length) + '%';
        _ref2 = this.categories;
        for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
          cat = _ref2[_k];
          this.$el.find('.te-droppables').append(cat.view());
          cat.setWidth(colW);
        }
        this.$el.find('.te-droppable').css('width', colW);
        this.showButton('clear');
        this.showButton('save');
        this.disableButton('save');
        this.showButton('submit');
        this.checkButtons();
        this.enableItems(1);
      }

      DragCategorization.prototype.onLightboxRequest = function(evt, data) {
        return Lightbox.display(data);
      };

      DragCategorization.prototype.showLightbox = function(jqevt) {
        jqevt.stopImmediatePropagation();
        return this.dispatchEvent('requestLightbox', {
          image: $(jqevt.currentTarget).find('img').attr('src'),
          title: $(jqevt.currentTarget).find('img').attr('alt')
        });
      };

      DragCategorization.prototype.resetClasses = function() {
        this.clearDragItems();
        return this.clearDropItems();
      };

      DragCategorization.prototype.onStatusChange = function(evt, data) {
        DragCategorization.__super__.onStatusChange.call(this);
        if (this.status === "in-progress") {
          $(document).off('keydown', this.keyPressed);
          return $(document).on('keydown', this.keyPressed);
        } else if (this.status === "complete") {
          return $(document).off('keydown', this.keyPressed);
        }
      };

      DragCategorization.prototype.onScreen = function() {
        DragCategorization.__super__.onScreen.call(this);
        return this.checkSizesInt = setInterval(this.checkSizes, 100);
      };

      DragCategorization.prototype.checkSizes = function() {
        var drag, dragH, drop, dropH, maxDragH, maxDropH, maxDropTitleH, reqMaxDragH, titleH, _i, _j, _k, _l, _len, _len1, _len2, _len3, _ref, _ref1, _ref2, _ref3;
        maxDropH = 0;
        maxDropTitleH = 0;
        _ref = this.categories;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          drop = _ref[_i];
          dropH = drop.getHeight();
          if (dropH > maxDropH) {
            maxDropH = dropH;
          }
          titleH = drop.getTitleHeight();
          if (titleH > maxDropTitleH) {
            maxDropTitleH = titleH;
          }
        }
        maxDragH = 0;
        _ref1 = this.dragItems;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          drag = _ref1[_j];
          dragH = drag.getHeight();
          if (dragH > maxDragH) {
            maxDragH = dragH;
          }
        }
        maxDropH += maxDragH / 2;
        reqMaxDragH = this.data.type === "image" ? 150 : 50;
        if (maxDropH > 40 && maxDropTitleH > 0 && maxDragH > reqMaxDragH) {
          clearInterval(this.checkSizesInt);
          _ref2 = this.categories;
          for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
            drop = _ref2[_k];
            drop.setHeight(maxDropH);
            drop.setTitleHeight(maxDropTitleH);
          }
          _ref3 = this.dragItems;
          for (_l = 0, _len3 = _ref3.length; _l < _len3; _l++) {
            drag = _ref3[_l];
            drag.setHeight(maxDragH);
          }
          return this.updCatH();
        }
      };

      DragCategorization.prototype.updCatH = function() {
        var cat, catTitleHeight, catWidth, curCatHeight, itCnt, itMargin, itcat, itemHeight, itemWidth, itsCat, newCatHeight, newPos, xVal, yVal, _i, _j, _len, _len1, _ref;
        if (this.$el.find('.te-drag-item').outerHeight() > 0) {
          clearInterval(this.catHInt);
          itemHeight = this.$el.find('.te-drag-item').outerHeight();
          itemWidth = this.$el.find('.te-drag-item').width();
          catTitleHeight = this.$el.find('.te-droppable-title').height();
          catWidth = this.$el.find('.te-droppable').width();
          itMargin = 10;
          newCatHeight = catTitleHeight + itemHeight;
          _ref = this.categories;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            cat = _ref[_i];
            cat = cat.view();
            itCnt = 0;
            itsCat = cat.find('.te-drag-item');
            for (_j = 0, _len1 = itsCat.length; _j < _len1; _j++) {
              itcat = itsCat[_j];
              yVal = cat.offset().top + catTitleHeight + itMargin + ((itemHeight + itMargin) * itCnt);
              xVal = cat.offset().left + (catWidth - itemWidth) / 2;
              newPos = {
                top: yVal,
                left: xVal
              };
              this.$el.find(itcat).offset(newPos);
              itCnt++;
            }
            curCatHeight = catTitleHeight + itemHeight + itMargin * 2 + (itCnt * (itemHeight + itMargin));
            if (curCatHeight === itMargin) {
              curCatHeight += parseInt(this.$el.find('.te-droppable').css("min-height").replace("px", ""));
            }
            if (curCatHeight > newCatHeight) {
              newCatHeight = curCatHeight;
            }
          }
          return this.$el.find('.te-droppable').css("height", newCatHeight + "px");
        }
      };

      DragCategorization.prototype.onResetRequest = function() {
        var it, item, itemsCat, left, slotDiv, top, _i, _len, _ref;
        this.$el.find('.te-drag-items').focus();
        itemsCat = this.$el.find('.te-droppables').find('.te-drag-item').length;
        this.pushMetric({
          "items_reset": itemsCat
        }, "reset");
        _ref = this.dragItems;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          it = _ref[_i];
          it.clearSelected();
          item = this.$el.find('[data-id="' + it.id + '"]');
          slotDiv = this.$el.find(it.view());
          if (slotDiv.hasClass('te-drag-item-slot-empty')) {
            slotDiv.removeClass('te-drag-item-slot-empty');
            slotDiv.append(item);
            top = slotDiv.offset().top;
            left = slotDiv.offset().left;
            item.offset({
              top: top + 1,
              left: left + 1
            });
          }
        }
        this.updCatH();
        this.checkButtons();
        this.resetClasses();
        top = this.$el.find(".te-drag-items").offset().top;
        window.scrollTo(0, top - 100);
        return this.updateSaveButton(true);
      };

      DragCategorization.prototype.submit = function() {
        DragCategorization.__super__.submit.call(this);
        return this.checkButtons();
      };

      DragCategorization.prototype.checkButtons = function(hideAll) {
        var itInBank, itInCats;
        if (hideAll == null) {
          hideAll = 0;
        }
        itInBank = this.$el.find('.te-drag-items .te-drag-item');
        itInCats = this.$el.find('.dc-categories .te-drag-item');
        if (!hideAll && itInBank.length > 0 && itInCats.length > 0) {
          this.enableButton("clear");
          return this.disableButton("submit");
        } else if (!hideAll && itInBank.length === 0) {
          if (this.retry) {
            this.disableButton("clear");
          } else {
            this.enableButton("clear");
          }
          return this.enableButton('submit');
        } else {
          this.disableButton("clear");
          return this.disableButton("submit");
        }
      };

      DragCategorization.prototype.buildButtons = function() {
        DragCategorization.__super__.buildButtons.call(this);
        return this.buttons.clear = {
          el: $("<button>").attr({
            "class": "btn"
          }).text('Clear'),
          events: {
            click: this.onResetRequest
          }
        };
      };

      DragCategorization.prototype.getItemId = function(container, str) {
        var classes, end, id, start;
        classes = container.attr('class');
        id = '';
        if (classes.indexOf(str) >= 0) {
          start = classes.indexOf(str);
          end = classes.indexOf(" ", start);
          id = classes.substr(start, end);
        }
        return id;
      };

      DragCategorization.prototype.keyPressed = function(e) {
        var kCode, keyMap, _ref;
        if ((_ref = e.target.type) !== 'textarea' && _ref !== 'input' && _ref !== 'text' && _ref !== 'number') {
          this.correctNum = this.$el.find('.te-drag-item-correct').length;
          kCode = e.keyCode ? e.keyCode : e.which;
          keyMap = Utils.getKeyMap();
          if (this.correctNum < this.dragItems.length && (kCode === keyMap.enterKey || kCode === keyMap.escapeKey || kCode === keyMap.selectKey)) {
            e.preventDefault();
            e.stopPropagation();
            this.itemsList = this.$el.find('.te-drag-item');
            this.catsList = this.$el.find('.te-droppable');
            this.curItem = this.$el.find('[aria-grabbed="true"]');
            if (!this.curItem.length) {
              this.curItem = this.$el.find('.te-drag-item-dragging');
            }
            this.curCat = this.$el.find('.te-droppable-hover');
            if (kCode === keyMap.escapeKey) {
              return this.onEscapeKey();
            } else if (kCode === keyMap.enterKey) {
              return this.onEnterKey();
            } else if (kCode === keyMap.selectKey) {
              return this.onSpaceKey();
            }
          }
        }
      };

      DragCategorization.prototype.clearDragItems = function() {
        return this.$el.find('.te-drag-item').attr({
          'aria-grabbed': 'false',
          tabindex: '0'
        }).removeClass('te-drag-item-dragging');
      };

      DragCategorization.prototype.clearDropItems = function() {
        return this.$el.find('.te-droppable').removeClass('te-droppable-hover').removeAttr('aria-dropeffect tabindex');
      };

      DragCategorization.prototype.onEscapeKey = function() {
        this.clearDropItems();
        if (this.activeItem) {
          this.activeItem.clearSelected();
          this.clearDragItems();
          this.activeItem.view().find('.te-drag-item').focus();
          return this.activeItem = null;
        }
      };

      DragCategorization.prototype.onEnterKey = function() {
        if (!this.$el.find('.te-drag-items .te-drag-item').length) {
          this.clearDragItems();
          return this.submit();
        }
      };

      DragCategorization.prototype.onSpaceKey = function() {
        var $activeItemView, $item, activeItemView, catID, catName, it, itemID, itemName, metric, _i, _len, _ref;
        if (!this.curItem.length) {
          return;
        }
        if (!this.curCat.length) {
          $item = this.$el.find('.te-drag-item-dragging');
          _ref = this.dragItems;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            it = _ref[_i];
            if (it.id === $item.data('id')) {
              it.setSelected();
              this.activeItem = it;
              break;
            }
          }
          $activeItemView = this.activeItem.view();
          $activeItemView.attr('aria-grabbed', 'true');
          this.$el.find('.te-drag-item').removeAttr('tabindex');
          this.$el.find('.dc-categories .te-droppable').attr('aria-dropeffect', 'move').attr('tabindex', '0');
          this.itParent = $activeItemView.find('.te-drag-item').parent('.te-droppable');
          if (this.itParent.length > 0) {
            return this.itParent.focus();
          } else {
            return this.$el.find('.te-droppable')[0].focus();
          }
        } else if (this.curCat.length && this.activeItem) {
          activeItemView = this.activeItem.view().find('.te-drag-item');
          this.$el.find(activeItemView).parent(".te-drag-item-slot").addClass('te-drag-item-slot-empty');
          this.$el.find(activeItemView).appendTo(this.$el.find('.te-droppable-hover'));
          this.updCatH();
          Utils.resetSound(this.snd);
          this.checkButtons();
          this.checkItems();
          itemName = $(this.curItem).text().trim();
          itemID = $(this.curItem).data('id');
          catName = $(this.curCat).first()[0].childNodes[0].firstChild.data;
          catID = $(this.curCat).data("drop-id");
          metric = {
            droppable_id: catID,
            droppable_name: catName,
            draggable_id: itemID,
            draggable_name: itemName,
            method: "keyboard"
          };
          this.pushMetric(metric, "dropped_item");
          this.activeItem.clearSelected();
          this.clearDragItems();
          this.$el.find('.te-drag-item').attr('tabindex', '0');
          this.clearDropItems();
          this.activeItem.draggableItem.focus();
          return this.activeItem = null;
        }
      };

      DragCategorization.prototype.delayCheckItems = function(event) {
        var catID, catName, itemID, itemName, metric;
        this.correct = this.$el.find('.te-drag-item-correct');
        this.incorrect = this.$el.find('.te-drag-item-incorrect');
        this.cats = this.$el.find('.te-droppables');
        this.itsCats = this.$el.find(this.cats).find('.te-drag-item');
        Utils.resetSound(this.snd);
        this.catHInt = setInterval(this.updCatH, 10);
        catID = $(event.target).data("drop-id");
        catName = $(event.target).find('.te-droppable-title').text();
        itemID = this.$el.find('.te-drag-item-dragging').data('id');
        itemName = this.$el.find('.te-drag-item-dragging .te-drag-item-content').text();
        metric = {
          droppable_id: catID,
          droppable_name: catName,
          draggable_id: itemID,
          draggable_name: itemName,
          method: "mouse"
        };
        this.pushMetric(metric, "dropped_item");
        this.checkItemsInt = setInterval(this.checkItems, 100);
        return this.updateSaveButton(true);
      };

      DragCategorization.prototype.checkItems = function() {
        if (this.$el.find('.dc-categories .te-drag-item').length > 0) {
          clearInterval(this.checkItemsInt);
          this.itemsBank = this.$el.find('.te-drag-items');
          this.itRemain = this.$el.find(this.itemsBank).find('.te-drag-item');
          return this.checkButtons();
        }
      };

      DragCategorization.prototype.disable = function() {
        DragCategorization.__super__.disable.call(this);
        return this.enableItems(0);
      };

      DragCategorization.prototype.enable = function() {
        DragCategorization.__super__.enable.call(this);
        return this.enableItems(1);
      };

      DragCategorization.prototype.enableItems = function(enable) {
        var drag, drop, _i, _j, _len, _len1, _ref, _ref1;
        _ref = this.dragItems;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          drag = _ref[_i];
          if (!enable) {
            drag.disable();
          } else {
            drag.enable();
          }
          drag.draggableItem.off('dragstart', this.resetClasses);
          if (enable) {
            drag.draggableItem.on('dragstart', this.resetClasses);
          }
        }
        _ref1 = this.categories;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          drop = _ref1[_j];
          if (!enable) {
            drop.disable();
          } else {
            drop.enable();
          }
          drop.view().off("drop", this.delayCheckItems);
          if (enable) {
            drop.view().on("drop", this.delayCheckItems);
          }
        }
        if (!this.enable) {
          return this.clearDropItems();
        }
      };

      DragCategorization.prototype.getCurrentItems = function() {
        var catid, it, itParent, item, slotDiv, submittedItems, _i, _len, _ref;
        submittedItems = "";
        _ref = this.dragItems;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          it = _ref[_i];
          item = this.$el.find('[data-id="' + it.id + '"]');
          slotDiv = this.$el.find(it.view());
          if (submittedItems !== "") {
            submittedItems += ", ";
          }
          if (slotDiv.find('.te-drag-item').length > 0) {
            catid = 'empty';
          } else {
            itParent = this.$el.find("[data-id='" + it.id + "']").parent();
            catid = itParent.attr('data-drop-id');
          }
          submittedItems += '{"itid":"' + it.id + '","cat":"' + catid + '"}';
        }
        submittedItems = '[' + submittedItems + ']';
        return submittedItems;
      };

      DragCategorization.prototype.buildState = function(scope, op) {
        var curItems, json, s;
        s = DragCategorization.__super__.buildState.call(this, scope, op);
        switch (scope) {
          case "user":
            curItems = this.getCurrentItems();
            json = JSON.parse(curItems);
            s.selectedAnswers = json;
        }
        return s;
      };

      DragCategorization.prototype.buildSummary = function(data) {
        var $currentElement, addS, correctNum, curEleId, incorrectNum, sum, tooltipContent, _i, _len, _ref;
        if ((data.summary != null) && (data.submitHistory != null)) {
          correctNum = 0;
          incorrectNum = 0;
          _ref = data.summary;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            sum = _ref[_i];
            if (sum.id !== "overall") {
              curEleId = this.createId(sum.id);
              $currentElement = this.$el.find("[data-id='" + sum.id + "']");
              if (sum.correct) {
                $currentElement.addClass("te-drag-item-correct");
                correctNum++;
                tooltipContent = "Correct";
              } else {
                $currentElement.addClass("te-drag-item-incorrect");
                incorrectNum++;
                tooltipContent = "Incorrect";
              }
              if (sum.content !== '') {
                tooltipContent = sum.content;
              }
              Tooltip.buildTooltip($currentElement, curEleId, tooltipContent);
            }
          }
          if (!data.userCorrect) {
            if (incorrectNum === 1) {
              addS = '';
            } else {
              addS = 's';
            }
            return "You have " + incorrectNum + " item" + addS + " in the wrong category.";
          }
        }
        return "";
      };

      DragCategorization.prototype.parseState = function(data) {
        var hideAll, it, scope, slot, slots, state, _i, _j, _len, _len1, _ref, _ref1, _results;
        DragCategorization.__super__.parseState.call(this, data);
        _ref = data.states;
        _results = [];
        for (scope in _ref) {
          state = _ref[scope];
          switch (scope) {
            case "user":
              if (state.selectedAnswers != null) {
                _ref1 = state.selectedAnswers;
                for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
                  it = _ref1[_i];
                  if (it.cat !== "empty") {
                    this.$el.find("[data-drop-id='" + it.cat + "']").append(this.$el.find("[data-id='" + it.itid + "']"));
                  }
                }
                slots = this.$el.find(".te-drag-item-slot");
                for (_j = 0, _len1 = slots.length; _j < _len1; _j++) {
                  slot = slots[_j];
                  if (this.$el.find(slot).find(".te-drag-item").length === 0) {
                    this.$el.find(slot).addClass("te-drag-item-slot-empty");
                  }
                }
              }
              this.checkSizes();
              if ((state != null ? state.allowRetry : void 0) === false) {
                this.hideButton("clear");
                $(document).off("keydown");
                this.clearDropItems();
              }
              this.retry = state != null ? state.allowRetry : void 0;
              hideAll = ((state != null ? state.userCorrect : void 0) != null) && state.userCorrect ? 1 : 0;
              _results.push(this.checkButtons(hideAll));
              break;
            default:
              _results.push(void 0);
          }
        }
        return _results;
      };

      return DragCategorization;

    })(TEP.Question);
  });

}).call(this);
