// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, AudioPlayer, ControlBar, KEY_MAP, PlayPauseControl, ScrubBar, Slider, Utils, View, VolumeControl, modulePath, tmpl;
    $ = require('jquery');
    View = require('tep/utils/view');
    Slider = require('tep/components/slider/main');
    tmpl = require('text!./template.html');
    Utils = require('tep/utils/utils');
    require('link!./style.css');
    require('jqueryui');
    KEY_MAP = Utils.getKeyMap();
    modulePath = "/bcore/static/tep-jsl/0.1/components/audioplayer/";
    ScrubBar = (function(_super) {
      __extends(ScrubBar, _super);

      function ScrubBar($rootEl, audio) {
        this.$rootEl = $rootEl;
        this.audio = audio;
        this.updateBar = __bind(this.updateBar, this);
        this.onClick = __bind(this.onClick, this);
        this.media = this.audio.player;
        this.audio.addEventListener('Media.TimeUpdate', this.updateBar);
        this.media.bind('progress', this.updateBar);
        this.userMaxTime = 0;
        this.$rootEl.bind('click', this.onClick);
        this.labels = {
          current: this.$rootEl.find('.audio-time-current'),
          duration: this.$rootEl.find('.audio-time-duration')
        };
        this.updateBar;
        this.audio.addEventListener('statuschange', this.onTeStatusChange);
      }

      ScrubBar.prototype.onClick = function(e) {
        var target;
        target = this.audio.duration() * (e.offsetX != null ? e.offsetX : e.originalEvent.layerX) / this.$rootEl.width();
        return this.audio.seek(target);
      };

      ScrubBar.prototype.updateBar = function(e) {
        var m, percent;
        m = this.audio.media();
        this.labels.current.text(this.timeToString(m.currentTime));
        this.labels.duration.text(this.timeToString(this.audio.duration()));
        this.userMaxTime = Math.max(this.userMaxTime, m.currentTime);
        percent = m.currentTime / m.duration;
        this.$rootEl.find('.audio-playhead').css('width', 100 * percent + "%");
        if (m.buffered.length) {
          percent = m.buffered.end(m.buffered.length - 1) / m.duration;
          return this.$rootEl.find('.audio-buffer').css('width', 100 * percent + "%");
        }
      };

      ScrubBar.prototype.timeToString = function(timeInS) {
        var seconds, t, times;
        times = [];
        times.push(Math.floor(timeInS / 60));
        seconds = Math.round(timeInS % 60);
        if (seconds === 60) {
          times[times.length - 1] += 1;
          seconds = 0;
        }
        times.push(seconds);
        return ((function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = times.length; _i < _len; _i++) {
            t = times[_i];
            _results.push((t < 10 ? '0' : '') + t.toString());
          }
          return _results;
        })()).join(':');
      };

      return ScrubBar;

    })(TEP.EventDispatcher);
    PlayPauseControl = (function(_super) {
      __extends(PlayPauseControl, _super);

      function PlayPauseControl($rootEl, audio) {
        this.$rootEl = $rootEl;
        this.audio = audio;
        this.changeState = __bind(this.changeState, this);
        this.view = __bind(this.view, this);
        this.onClick = __bind(this.onClick, this);
        this.audio.addEventListener('playing', this.changeState);
        this.audio.addEventListener('pause', this.changeState);
        this.$rootEl.bind('click', this.onClick);
        this.$rootEl.addClass('paused');
        this.$rootEl.find('img').attr('src', "" + modulePath + "img/controls/play.png");
      }

      PlayPauseControl.prototype.onClick = function(e) {
        e.preventDefault();
        return this.audio.togglePlay();
      };

      PlayPauseControl.prototype.view = function() {
        return this.$rootEl;
      };

      PlayPauseControl.prototype.changeState = function(e) {
        if (this.audio.media().paused) {
          this.$rootEl.removeClass('paused playing').addClass('paused');
          this.$rootEl.find('img').attr('src', "" + modulePath + "img/controls/play.png");
          return this.$rootEl.find('img').attr('alt', "Play Video");
        } else {
          this.$rootEl.removeClass('paused playing').addClass('playing');
          this.$rootEl.find('img').attr('src', "" + modulePath + "img/controls/pause.png");
          return this.$rootEl.find('img').attr('alt', "Pause Video");
        }
      };

      return PlayPauseControl;

    })(TEP.EventDispatcher);
    VolumeControl = (function(_super) {
      __extends(VolumeControl, _super);

      function VolumeControl($rootEl, audio) {
        var volumeId;
        this.$rootEl = $rootEl;
        this.audio = audio;
        this.changeState = __bind(this.changeState, this);
        this.view = __bind(this.view, this);
        this.value = __bind(this.value, this);
        this.onVolumeChange = __bind(this.onVolumeChange, this);
        this.handleSliderChange = __bind(this.handleSliderChange, this);
        this.updateSliderAttributes = __bind(this.updateSliderAttributes, this);
        this.handleKeypress = __bind(this.handleKeypress, this);
        this.media = this.audio.player;
        this.media.bind('volumechange', this.changeState);
        this.$rootEl.addClass('unmuted');
        this.isOn = false;
        volumeId = "" + this.audio.data.teiId + "_audio_VolumeExpand_#";
        this.$rootEl.find('audio-volume-wrap').attr('id', volumeId);
        this.$rootEl.attr('aria-controls', volumeId);
        this.slider = new Slider({
          currentValue: 0.5,
          axis: 'y',
          classes: '',
          min: 0,
          max: 100,
          description: "Change volume"
        });
        this.slider.addEventListener('Slider.ValueChange', this.onVolumeChange);
        this.slider.addEventListener('Slider.Jump', this.handleSliderChange);
        this.slider.addEventListener('Slider.Drop', this.handleSliderChange);
        this.$rootEl.bind('keydown', this.handleKeypress);
        this.$rootEl.find('.audio-volume-control').append(this.slider.$dom).find('.slider-handle-nubbin').html("<img src='" + modulePath + "img/controls/nubbin.png' alt='Adjust volume' />");
        this.$rootEl.find('> img').attr('src', "" + modulePath + "img/controls/volume.png");
      }

      VolumeControl.prototype.handleKeypress = function(e) {
        var code;
        e.stopPropagation();
        code = e.keyCode ? e.keyCode : e.which;
        if (code === KEY_MAP.selectKey || code === KEY_MAP.submitKey) {
          e.preventDefault();
          return this.updateSliderAttributes();
        }
      };

      VolumeControl.prototype.updateSliderAttributes = function() {
        this.isOn = !this.isOn;
        if (this.isOn) {
          this.$rootEl.attr('aria-expanded', 'true');
          return this.$rootEl.find('.audio-volume-wrap').css('display', 'block');
        } else {
          this.$rootEl.attr('aria-expanded', 'false');
          return this.$rootEl.find('.audio-volume-wrap').css('display', 'none');
        }
      };

      VolumeControl.prototype.handleSliderChange = function() {
        return this.audio.dispatchEvent('Audio.VolumeUpdate', this.slider.value());
      };

      VolumeControl.prototype.onVolumeChange = function() {
        return this.audio.setVolume(this.slider.value());
      };

      VolumeControl.prototype.value = function(val) {
        return this.slider.value(val);
      };

      VolumeControl.prototype.view = function() {
        return this.$rootEl;
      };

      VolumeControl.prototype.changeState = function(e) {
        if (e.currentTarget.volume === 0 || e.currentTarget.muted) {
          this.$rootEl.removeClass('muted unmuted').addClass('muted');
          return this.$rootEl.find('> img').attr({
            'src': "" + modulePath + "img/controls/muted.png",
            'alt': "Volume Muted, Change"
          });
        } else {
          this.$rootEl.removeClass('muted unmuted').addClass('unmuted');
          return this.$rootEl.find('> img').attr({
            'src': "" + modulePath + "img/controls/volume.png",
            'alt': "Change Volume"
          });
        }
      };

      return VolumeControl;

    })(TEP.EventDispatcher);
    ControlBar = (function(_super) {
      __extends(ControlBar, _super);

      function ControlBar($rootEl, audio) {
        this.$rootEl = $rootEl;
        this.audio = audio;
        this.controls = [];
        this.controls.push(new PlayPauseControl(this.$rootEl.find('.audio-playpause'), this.audio));
        if (!navigator.userAgent.match(/iPad|iPod|iPhone/g)) {
          this.controls.push(new VolumeControl(this.$rootEl.find('.audio-volume'), this.audio));
        } else {
          $rootEl.find('.audio-volume').remove();
        }
        this.controls.push(new ScrubBar(this.$rootEl.find('.audio-scrubbar'), this.audio));
      }

      return ControlBar;

    })(TEP.EventDispatcher);
    return AudioPlayer = (function(_super) {
      __extends(AudioPlayer, _super);

      function AudioPlayer(data) {
        this.data = data;
        this.onRelatedTEStatusChange = __bind(this.onRelatedTEStatusChange, this);
        this.setTEPreferences = __bind(this.setTEPreferences, this);
        this.togglePlay = __bind(this.togglePlay, this);
        this._timeUpdate = __bind(this._timeUpdate, this);
        this.pause = __bind(this.pause, this);
        this.play = __bind(this.play, this);
        this.seek = __bind(this.seek, this);
        this.toggleMute = __bind(this.toggleMute, this);
        this.getControl = __bind(this.getControl, this);
        this.setVolume = __bind(this.setVolume, this);
        this.setSources = __bind(this.setSources, this);
        this.onScreen = __bind(this.onScreen, this);
        this.buildPlayer = __bind(this.buildPlayer, this);
        this.isPaused = __bind(this.isPaused, this);
        this.currentTime = __bind(this.currentTime, this);
        this.duration = __bind(this.duration, this);
        this.media = __bind(this.media, this);
        this.showControls = __bind(this.showControls, this);
        AudioPlayer.__super__.constructor.call(this, tmpl);
        this.showControls();
        this.wrap = this.$el.find('.descriptive-audio');
        this.ready = false;
        this.buildPlayer();
        this.controlBar = new ControlBar(this.$el.find('.audio-controlbar'), this);
        this.paused = true;
        this.lastTime = 0;
        this._lastPlayheadState = 0;
        this.addEventListener('Media.TimeUpdate', this.checkTriggerPoints);
        TEP.addEventListener('TEP.RelatedTEStatusChange', this.onRelatedTEStatusChange);
      }

      AudioPlayer.prototype.showControls = function() {
        return this.$el.find('.audio').addClass("audio-controls-visible");
      };

      AudioPlayer.prototype.media = function() {
        return this.player.get(0);
      };

      AudioPlayer.prototype.duration = function() {
        if (!isNaN(this.media().duration)) {
          return this.media().duration;
        } else {
          return 0;
        }
      };

      AudioPlayer.prototype.currentTime = function() {
        if (!isNaN(this.media().currentTime)) {
          return this.media().currentTime;
        } else {
          return 0;
        }
      };

      AudioPlayer.prototype.isPaused = function() {
        return this.media().paused;
      };

      AudioPlayer.prototype.buildPlayer = function() {
        this.player = $('<audio>').attr('id', 'audio-' + this.id).attr('preload', 'auto').attr('role', 'application').attr('aria-labelledby', 'desc-audio-' + this.id).addClass('audio-player');
        this.wrap.append(this.player);
        this.setSources();
        this.$teMedia = this.$el.find('.audio');
        return this.isMobile = navigator.userAgent.match(/iPad|iPhone|iPod/g);
      };

      AudioPlayer.prototype.onScreen = function() {
        this.ready = true;
        this.dispatchEvent('ready', this);
        return this.pullState();
      };

      AudioPlayer.prototype.setSources = function() {
        return this.player.append($('<source>').attr('src', this.data.location));
      };

      AudioPlayer.prototype.setVolume = function(vol) {
        this.media().volume = vol;
        return this.$el.find('.audio-volume-control .component-slider-slider').attr("aria-valuenow", vol).attr("aria-valuetext", "" + (Math.round(vol * 100)) + " percent");
      };

      AudioPlayer.prototype.getControl = function(name) {
        switch (name) {
          case "volume":
            return this.controlBar.controls[1];
        }
      };

      AudioPlayer.prototype.toggleMute = function(mute) {
        if (mute != null) {
          return this.media().muted = mute;
        } else {
          return this.media().muted = !this.media().muted;
        }
      };

      AudioPlayer.prototype.seek = function(time) {
        if (!this.frozen) {
          this.media().currentTime = time;
          this.dispatchEvent('Media.TimeUpdate', {
            time: this.currentTime()
          });
          return this.dispatchEvent('Audio.MetricsUpdate', {
            value: {
              "dvs_audio": "scrub " + time
            },
            category: "interface"
          });
        }
      };

      AudioPlayer.prototype.play = function() {
        if (!this.frozen) {
          this.media().play();
          this.paused = false;
          this.dispatchEvent('Audio.MetricsUpdate', {
            value: {
              "dvs_audio": "play"
            },
            category: "interface"
          });
          this.dispatchEvent('playing', this);
          return setInterval(this._timeUpdate, 100);
        }
      };

      AudioPlayer.prototype.pause = function() {
        if (!this.frozen) {
          this.media().pause();
          this.paused = true;
          this.dispatchEvent('Audio.MetricsUpdate', {
            value: {
              "dvs_audio": "pause"
            },
            category: "interface"
          });
          return this.dispatchEvent('pause', this);
        }
      };

      AudioPlayer.prototype._timeUpdate = function() {
        return this.dispatchEvent('Media.TimeUpdate', {
          time: this.currentTime()
        });
      };

      AudioPlayer.prototype.togglePlay = function() {
        if (this.paused) {
          return this.play();
        } else {
          return this.pause();
        }
      };

      AudioPlayer.prototype.setTEPreferences = function(prefs) {
        if (prefs.volume != null) {
          this.setVolume(prefs.volume);
          return this.getControl('volume').value(prefs.volume);
        }
      };

      AudioPlayer.prototype.onRelatedTEStatusChange = function(evt, data) {
        if (data.source.id !== this.id) {
          return this.setTEPreferences(data);
        }
      };

      return AudioPlayer;

    })(View);
  });

}).call(this);
