// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, ButtonBay, EventDispatcher, Model, View, defaults;
    $ = require('jquery');
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    Model = require('./models/model');
    View = require('./views/view');
    require('link!./style.css');
    /*
    buttons:
      continue:
        label: "Continue"
        class: "alt-btn"
        event: "TE.EndRequest"
    */

    defaults = {
      buttons: {}
    };
    return ButtonBay = (function(_super) {
      __extends(ButtonBay, _super);

      function ButtonBay(conf, teiId) {
        this.$dom = __bind(this.$dom, this);
        this.view = __bind(this.view, this);
        this["export"] = __bind(this["export"], this);
        this["import"] = __bind(this["import"], this);
        this.updateStatusMessage = __bind(this.updateStatusMessage, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.hideAll = __bind(this.hideAll, this);
        this.showAll = __bind(this.showAll, this);
        this.enableButton = __bind(this.enableButton, this);
        this.disableButton = __bind(this.disableButton, this);
        this.hideButton = __bind(this.hideButton, this);
        this.showButton = __bind(this.showButton, this);
        this.changeLabel = __bind(this.changeLabel, this);
        this.hasButton = __bind(this.hasButton, this);
        var config;
        config = $.extend(true, {}, defaults, conf);
        this._model = new Model(config);
        this._view = new View(this._model, teiId);
      }

      ButtonBay.prototype.hasButton = function(btnId) {
        return this._model.get("buttons." + btnId) != null;
      };

      ButtonBay.prototype.changeLabel = function(btnId, label) {
        return this._model.set("buttons." + btnId + ".label", label);
      };

      ButtonBay.prototype.showButton = function(btnId) {
        if (this.hasButton(btnId)) {
          return this._model.set("buttons." + btnId + ".visible", true);
        }
      };

      ButtonBay.prototype.hideButton = function(btnId) {
        if (this.hasButton(btnId)) {
          return this._model.set("buttons." + btnId + ".visible", false);
        }
      };

      ButtonBay.prototype.disableButton = function(btnId) {
        if (this.hasButton(btnId)) {
          return this._model.set("buttons." + btnId + ".disabled", true);
        }
      };

      ButtonBay.prototype.enableButton = function(btnId) {
        if (this.hasButton(btnId)) {
          return this._model.set("buttons." + btnId + ".disabled", false);
        }
      };

      ButtonBay.prototype.showAll = function() {
        var btn, id, _ref, _results;
        _ref = this._model.get('buttons');
        _results = [];
        for (id in _ref) {
          btn = _ref[id];
          _results.push(this._model.set("buttons." + id + ".visible", true));
        }
        return _results;
      };

      ButtonBay.prototype.hideAll = function() {
        var btn, id, _ref, _results;
        _ref = this._model.get('buttons');
        _results = [];
        for (id in _ref) {
          btn = _ref[id];
          _results.push(this._model.set("buttons." + id + ".visible", false));
        }
        return _results;
      };

      ButtonBay.prototype.disable = function() {
        var btn, id, _ref, _results;
        _ref = this._model.get('buttons');
        _results = [];
        for (id in _ref) {
          btn = _ref[id];
          _results.push(this._model.set("buttons." + id + ".disabled", true));
        }
        return _results;
      };

      ButtonBay.prototype.enable = function() {
        var btn, id, _ref, _results;
        _ref = this._model.get('buttons');
        _results = [];
        for (id in _ref) {
          btn = _ref[id];
          _results.push(this._model.set("buttons." + id + ".disabled", false));
        }
        return _results;
      };

      ButtonBay.prototype.updateStatusMessage = function(btnId) {
        var button, statusMessage;
        button = this._model.get("buttons." + btnId);
        statusMessage = button.getActionStatusMessage();
        if (!statusMessage) {
          return;
        }
        return this._view.updateButtonsStatus(statusMessage);
      };

      ButtonBay.prototype["import"] = function(data) {
        return this._model["import"](data);
      };

      ButtonBay.prototype["export"] = function() {
        return this._model["export"]();
      };

      ButtonBay.prototype.view = function() {
        return this._view;
      };

      ButtonBay.prototype.$dom = function() {
        return this._view.view();
      };

      return ButtonBay;

    })(EventDispatcher);
  });

}).call(this);
