// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, ColdCall, SharedAnswers, TEP, Timer, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./template.html');
    Timer = require('tep/components/timer/main');
    SharedAnswers = require('tep/components/sharedanswer/main');
    require('link!./style.css');
    return ColdCall = (function(_super) {
      __extends(ColdCall, _super);

      function ColdCall(data) {
        this.data = data;
        this.onMetricRequest = __bind(this.onMetricRequest, this);
        this.parseState = __bind(this.parseState, this);
        this.buildState = __bind(this.buildState, this);
        this.getEntry = __bind(this.getEntry, this);
        this.getWordCount = __bind(this.getWordCount, this);
        this.showFeedback = __bind(this.showFeedback, this);
        this.showQuestion = __bind(this.showQuestion, this);
        this.showIntro = __bind(this.showIntro, this);
        this.enableButton = __bind(this.enableButton, this);
        this.disableButton = __bind(this.disableButton, this);
        this.hideButton = __bind(this.hideButton, this);
        this.showButton = __bind(this.showButton, this);
        this.triggerDisplay = __bind(this.triggerDisplay, this);
        this.clearButtons = __bind(this.clearButtons, this);
        this.onSubmitRequest = __bind(this.onSubmitRequest, this);
        this.onClearRequest = __bind(this.onClearRequest, this);
        this.onStartRequest = __bind(this.onStartRequest, this);
        this.onKeyUp = __bind(this.onKeyUp, this);
        this.showSharedAnswers = __bind(this.showSharedAnswers, this);
        this.onStatusChange = __bind(this.onStatusChange, this);
        this.buildButtons = __bind(this.buildButtons, this);
        this.loadGroup = __bind(this.loadGroup, this);
        this._buildConversationHeader = __bind(this._buildConversationHeader, this);
        ColdCall.__super__.constructor.call(this, this.data, "<div>");
        this._tmpl = $(tmpl);
        this.buildButtons();
        if (this.data.sections == null) {
          this._tmpl.find('.coldcall-label').html(this.data.title || 'Cold Call');
        } else {
          if (this.data.interactive_title) {
            this._tmpl.find('.coldcall-label').html('Cold Call: ' + this.data.interactive_title);
          } else {
            this._tmpl.find('.coldcall-label').html('Cold Call');
          }
          this.$el.find('.te-section-title').remove();
          this.$el.find('.te-section-content').remove();
        }
        this.feedback = this._tmpl.find('.coldcall-feedback');
        this.feedback.remove();
        this.timer = new Timer({
          start: this.data.timeLimit,
          rate: -1,
          classes: 'right'
        });
        this.timer.addEventListener('Timer.End', this.onSubmitRequest);
        this._tmpl.find('.coldcall-input').append(this.timer.$dom);
        if (this.data.outro != null) {
          this.feedback.find('.coldcall-feedback-message').html(this.data.outro);
        } else {
          this.feedback.find('.coldcall-feedback-message').remove();
        }
        this._tmpl.find(".te-coldCall").append(this.buttonBay.$dom());
        this.buttonBay.hideAll();
        this._triggered = false;
        this.disableButton('submit');
        this._hideForever = false;
        this.calledFromBeforeAndAfter = Boolean(this.data.calledFromBeforeAndAfter);
        this.beforeAndAfterId = "";
        if (this.calledFromBeforeAndAfter) {
          this.beforeAndAfterId = this.data.beforeAndAfterId;
        }
        this.sharedAnswers = new SharedAnswers({
          tei: this.data.id,
          type: "coldCall",
          conversation_header: this._buildConversationHeader,
          calledFromBeforeAndAfter: this.calledFromBeforeAndAfter,
          beforeAndAfterId: this.beforeAndAfterId,
          restrictResultsToTeam: this.data.restrictResultsToTeam
        });
        this.sharedAnswers.addEventListener("SharedAnswer.MetricRequest", this.onMetricRequest);
      }

      ColdCall.prototype._buildConversationHeader = function(answer) {
        return "<div class=\"coldCall-conversation-header\">\n  <div class=\"conversation-question te-preamble\">" + this.data.question + "</div>\n  <div class=\"conversation-answer te-preamble\">\n    <p>\n      <div class=\"conversation-comment-byline\">\n        <span class=\"conversation-comment-author\">" + (answer.get('first_name') + '&nbsp;' + answer.get('last_name')) + "</span>\n        (<span class=\"conversation-comment-date\">" + (answer.get('answer_date')) + "</span>)\n      </div>\n      <div class=\"conversation-comment-text\">" + (answer.get('answer')) + "</div>\n    </p>\n  </div>\n</div>";
      };

      ColdCall.prototype.loadGroup = function(groupData) {
        var clean, mem, members, reversed_id, _i, _len, _ref;
        ColdCall.__super__.loadGroup.call(this, groupData);
        members = [];
        _ref = groupData.members;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          mem = _ref[_i];
          if (mem.substring(mem.length - 1) === "/") {
            clean = mem.substring(0, mem.length - 1);
          } else {
            clean = mem;
          }
          members.push(clean.substring(clean.lastIndexOf('/') + 1));
        }
        reversed_id = window.user_id ? window.user_id.split("").reverse().join("").replace(/\D/g, '') : null;
        if (reversed_id && reversed_id % members.length !== members.indexOf(this.data.id)) {
          return this._hideForever = true;
        }
      };

      ColdCall.prototype.buildButtons = function() {
        return this.buttons = {
          start: {
            dom: $('<button>').addClass('alt-btn').text(this.data.intro.startLabel),
            callback: this.onStartRequest
          },
          clear: {
            dom: $('<button>').addClass('btn').text('Reset'),
            callback: this.onClearRequest
          },
          submit: {
            dom: $('<button>').addClass('alt-btn').text('Submit'),
            callback: this.onSubmitRequest
          }
        };
      };

      ColdCall.prototype.onStatusChange = function(evt, data) {
        ColdCall.__super__.onStatusChange.call(this);
        switch (this.status) {
          case 'unlocked':
            if (this._hideForever) {
              return this.start();
            } else {
              this._tmpl.find('.first').show();
              this.triggerDisplay();
              return this.showIntro();
            }
            break;
          case 'in-progress':
            this.triggerDisplay();
            if (this._hideForever) {
              this.showSharedAnswers();
              this.showQuestion();
              this.clearButtons();
              this.showButton('continue');
              return this._tmpl.find(".second").show();
            } else if (this._submit) {
              this.showSharedAnswers();
              this.clearButtons();
              this.showButton('continue');
              this.timer.pause();
              return this.timer.$dom.remove();
            } else {
              this._tmpl.find('.coldcall-input').show();
              this.showQuestion();
              this.timer.start();
              return this._tmpl.find('.first').show();
            }
            break;
          case 'complete':
            this.triggerDisplay();
            this.showSharedAnswers();
            if (!this._hideForever) {
              return this.showQuestion();
            } else {
              return this.clearButtons();
            }
        }
      };

      ColdCall.prototype.showSharedAnswers = function() {
        if (!$.contains(this._tmpl[0], this.sharedAnswers.$dom()[0])) {
          this._tmpl.find('.second').show().append(this.sharedAnswers.$dom());
          return this.sharedAnswers.update();
        }
      };

      ColdCall.prototype.onKeyUp = function(jqevt) {
        var that;
        that = this;
        return setTimeout(function() {
          if ($.trim(that._tmpl.find('.coldcall-user-input').val()).length) {
            return that.enableButton('submit');
          } else {
            return that.disableButton('submit');
          }
        }, 0);
      };

      ColdCall.prototype.onStartRequest = function() {
        var that;
        that = this;
        return $.ajax({
          url: "/api/v1/tep/state/" + this.data.id + '/?format=json&cohort_id=' + window.cohort_id,
          type: "GET",
          success: function(data) {
            if (data["states"]["user"]["status"] === "unlocked") {
              return that.start(function() {
                that._start = true;
                that.pushState('user');
                return that._start = false;
              });
            } else {
              that.clearButtons();
              that._tmpl.find(".first").hide();
              return that.parseState(data);
            }
          }
        });
      };

      ColdCall.prototype.onClearRequest = function() {
        this._tmpl.find(".coldcall-user-input").val('');
        return this.disableButton('submit');
      };

      ColdCall.prototype.onSubmitRequest = function() {
        var _this = this;
        this._submit = true;
        this.pushState('user', 'set', function() {
          return _this.pullState();
        });
        this.clearButtons();
        this._tmpl.find(".first").hide();
        this.showButton('continue');
        this.timer.pause();
        return this.timer.$dom.remove();
      };

      ColdCall.prototype.clearButtons = function() {
        var btn, key, _ref, _results;
        _ref = this.buttons;
        _results = [];
        for (key in _ref) {
          btn = _ref[key];
          _results.push(this.hideButton(key));
        }
        return _results;
      };

      ColdCall.prototype.triggerDisplay = function() {
        if (!this._triggered) {
          if (this._hideForever) {
            this._tmpl.find('.not-selected').show();
          }
          if (this.data.sections == null) {
            this.view().find('div').first().append(this._tmpl);
          } else {
            this.view().find('.te-interactive').first().append(this.section_title);
            this.view().find('.te-interactive').first().append(this.section_content);
            this.view().find('.te-interactive').first().append(this._tmpl);
          }
          this._tmpl.find('.coldcall-user-input').bind('paste', this.onKeyUp).bind('keyup', this.onKeyUp);
          return this._triggered = true;
        }
      };

      ColdCall.prototype.showButton = function(btn) {
        if (btn === "continue") {
          this.moveButtonBay('end');
          return this.buttonBay.showButton(btn);
        } else {
          this._tmpl.find('.coldcall-buttons').append(this.buttons[btn].dom);
          this.buttons[btn].dom.unbind('click', this.buttons[btn].callback);
          return this.buttons[btn].dom.bind('click', this.buttons[btn].callback);
        }
      };

      ColdCall.prototype.hideButton = function(btn) {
        if (btn === "continue") {
          return this.buttonBay.hideButton(btn);
        } else {
          this.buttons[btn].dom.remove();
          return this.buttons[btn].dom.unbind('click', this.buttons[btn].callback);
        }
      };

      ColdCall.prototype.disableButton = function(btn) {
        if (btn === "continue") {
          return this.buttonBay.disableButton(btn);
        } else {
          return this.buttons[btn].dom.attr('disabled', 'disabled');
        }
      };

      ColdCall.prototype.enableButton = function(btn) {
        if (btn === "continue") {
          return this.buttonBay.enableButton(btn);
        } else {
          return this.buttons[btn].dom.removeAttr('disabled');
        }
      };

      ColdCall.prototype.showIntro = function() {
        if (this.data.sections == null) {
          this._tmpl.find('.coldcall-intro').html(this.data.intro.text);
        } else {
          this._tmpl.find('.coldcall-intro').html(this.data.interactive_content);
        }
        this._tmpl.find('.coldcall-intro').removeClass('responses-question');
        this.clearButtons();
        return this.showButton('start');
      };

      ColdCall.prototype.showQuestion = function() {
        this._tmpl.find('.coldcall-intro').html(this.data.question);
        this._tmpl.find('.coldcall-intro').addClass('responses-question');
        this.hideButton('start');
        this.hideButton('clear');
        this.hideButton('submit');
        if (!this._submit) {
          this.showButton('clear');
          return this.showButton('submit');
        } else {
          this._tmpl.find('.coldcall-input').hide();
          return this.showFeedback();
        }
      };

      ColdCall.prototype.showFeedback = function() {
        return this._tmpl.find('.te-coldCall').append(this.feedback);
      };

      ColdCall.prototype.getWordCount = function() {
        return this.getEntry().replace('\s+', ' ').split('\s').length;
      };

      ColdCall.prototype.getEntry = function() {
        return this._tmpl.find('.coldcall-user-input').val();
      };

      ColdCall.prototype.buildState = function(scope, op) {
        var s;
        s = ColdCall.__super__.buildState.call(this, scope, op);
        switch (scope) {
          case 'user':
            if (!this._hideForever) {
              s.entry = this.getEntry();
              if (this._start) {
                s.start = true;
              }
              if (this._submit) {
                s.submitted = true;
              }
            }
        }
        return s;
      };

      ColdCall.prototype.parseState = function(data) {
        var scope, state, time, _ref, _ref1;
        _ref = data.states;
        for (scope in _ref) {
          state = _ref[scope];
          switch (scope) {
            case 'user':
              this.$el.find('.arrow').show();
              this._submit = state.submitted;
              if ((state.status === "in-progress" || state.status === "complete") && !this._hideForever) {
                this.$el.find('.coldcall-input').show();
              } else {
                this.$el.find('.coldcall-input').hide();
              }
              if (this._submit) {
                this.$el.find(".component-timer").hide();
              }
              if (state.entry) {
                this._tmpl.find('.coldcall-user-input').val(state.entry);
                this.enableButton('submit');
              }
              if (this._submit || ((state.status === "in-progress" || state.status === "complete") && this._hideForever)) {
                if (this._submit) {
                  this.enableButton('submit');
                }
                this.triggerDisplay();
                this.showSharedAnswers();
                this.$el.find(".te").show();
              }
              if ((_ref1 = this.status) !== "locked" && _ref1 !== "unlocked") {
                this.showQuestion();
              }
              if (state.startTime) {
                time = this.data.timeLimit - (state.now - state.startTime);
                this.timer.setTime(time);
              }
          }
        }
        return ColdCall.__super__.parseState.call(this, data);
      };

      ColdCall.prototype.onMetricRequest = function(evt, data) {
        return this.pushMetric(data.metric, data.category);
      };

      return ColdCall;

    })(TEP.TeachingElement);
  });

}).call(this);
