// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Conversation, EventDispatcher, InlineView, Model, View;
    $ = require('jquery');
    EventDispatcher = require("tep/utils/event/event_dispatcher");
    Model = require('./models/model');
    View = require('./views/view');
    InlineView = require('./views/inlineView');
    require('link!./style.css');
    Conversation = (function(_super) {
      __extends(Conversation, _super);

      function Conversation() {
        this.onAddCommentRequest = __bind(this.onAddCommentRequest, this);
        this.onConversationClosed = __bind(this.onConversationClosed, this);
        this.showConversation = __bind(this.showConversation, this);
        this.showInlineConversation = __bind(this.showInlineConversation, this);
        this.onAnswerHistoryToggleRequest = __bind(this.onAnswerHistoryToggleRequest, this);
        this.onLikeToggleRequest = __bind(this.onLikeToggleRequest, this);
        this.onCommentAccepted = __bind(this.onCommentAccepted, this);
        var prevFocusedEl,
          _this = this;
        this._model = new Model({});
        this._view = new View(this._model);
        this._inlineView = new InlineView(this._model);
        $('body').append(this._view.$el);
        prevFocusedEl = null;
        this.purify_warning_shown = false;
        this._model.set("calledFromBeforeAndAfter", false);
        this._model.set("beforeAndAfterId", "");
        this._view.addEventListener('Conversation.AddCommentRequest', this.onAddCommentRequest);
        this._view.addEventListener('Comment.LikeToggleRequest', this.onLikeToggleRequest);
        this._view.addEventListener('Comment.AnswerHistoryToggleRequest', this.onAnswerHistoryToggleRequest);
        this._view.addEventListener('Conversation.Closed', this.onConversationClosed);
        this._model.addEventListener('Conversation.CommentAccepted', this.onCommentAccepted);
        this._model.addEventListener('Conversation.MetricRequest', function(evt, data) {
          return _this.dispatchEvent(evt, data);
        });
      }

      Conversation.prototype.onCommentAccepted = function(evt, data) {
        return this.dispatchEvent("Conversation.CommentAdded", {
          comment_count: this._model.get('conversation.comments').length,
          conversation_id: this._model.get('conversation.id')
        });
      };

      Conversation.prototype.onLikeToggleRequest = function(evt, data) {
        return this._model.toggleCommentLike(data.comment_id);
      };

      Conversation.prototype.onAnswerHistoryToggleRequest = function(evt, data) {
        return this._model.answerHistoryView();
      };

      Conversation.prototype.showInlineConversation = function(data) {
        var _this = this;
        if (data.calledFromBeforeAndAfter) {
          this._model.set("calledFromBeforeAndAfter", true);
          this._model.set("beforeAndAfterId", data.beforeAndAfterId);
          this._model.set("restrictResultsToTeam", data.restrictResultsToTeam);
        }
        return this._model.loadConversation(data, function() {
          _this._inlineView.show(data);
          if (data.dispatchEvents) {
            _this.dispatchEvent('Conversation.MetricRequest', {
              metric: {
                conversation_id: data.id
              },
              category: "conversation_opened"
            });
            return _this.dispatchEvent('Conversation.ConversationReloaded', {
              conversation_id: data.id,
              comment_count: _this._model.get('conversation.comments').length
            });
          }
        });
      };

      Conversation.prototype.showConversation = function(data) {
        var _this = this;
        this.prevFocusedEl = data.focusedElement;
        if (data.calledFromBeforeAndAfter) {
          this._model.set("calledFromBeforeAndAfter", true);
          this._model.set("beforeAndAfterId", data.beforeAndAfterId);
        }
        return this._model.loadConversation(data, function() {
          _this._view.show();
          _this.dispatchEvent('Conversation.MetricRequest', {
            metric: {
              conversation_id: data.id
            },
            category: "conversation_opened"
          });
          return _this.dispatchEvent('Conversation.ConversationReloaded', {
            conversation_id: data.id,
            comment_count: _this._model.get('conversation.comments').length
          });
        });
      };

      Conversation.prototype.onConversationClosed = function(evt, data) {
        this.purify_warning_shown = false;
        this.dispatchEvent('Conversation.MetricRequest', {
          metric: {
            conversation_id: this._model.get('conversation.id')
          },
          category: "conversation_closed"
        });
        this.prevFocusedEl.focus();
        return $('.modal-backdrop').remove();
      };

      Conversation.prototype.onAddCommentRequest = function(evt, data) {
        var that,
          _this = this;
        that = this;
        return $.ajax({
          url: '/common/web_purify_api/',
          type: 'POST',
          data: JSON.stringify({
            purify: data.comment,
            purify_warning_shown: that.purify_warning_shown,
            tei_discussion: true
          }),
          success: function(analysis, textStatus, jqXHR) {
            if (analysis.error) {
              that.purify_warning_shown = true;
              return _this._view.handleDirtyComment(analysis);
            } else {
              _this._model.createComment(data, that.purify_warning_shown);
              return that.purify_warning_shown = false;
            }
          }
        });
      };

      return Conversation;

    })(EventDispatcher);
    return new Conversation;
  });

}).call(this);
