// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Edge, EventDispatcher, Graph, Node;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    Node = require('./node');
    Edge = require('./edge');
    return Graph = (function(_super) {
      __extends(Graph, _super);

      function Graph() {
        this.removeEdge = __bind(this.removeEdge, this);
        this.addEdge = __bind(this.addEdge, this);
        this.connect = __bind(this.connect, this);
        this.getEdgesTo = __bind(this.getEdgesTo, this);
        this.getEdgesFrom = __bind(this.getEdgesFrom, this);
        this.getNodeById = __bind(this.getNodeById, this);
        this.removeNode = __bind(this.removeNode, this);
        this.addNode = __bind(this.addNode, this);
        this.createNode = __bind(this.createNode, this);
        this._nodes = [];
        this._edges = [];
        this._defaultEdgeClass = Edge;
        this._defaultNodeClass = Node;
      }

      Graph.prototype.createNode = function(opts) {
        var NodeClass, node;
        NodeClass = opts["with"] != null ? opts["with"] : this._defaultNodeClass;
        node = new NodeClass(opts.params);
        return this.addNode(node);
      };

      Graph.prototype.addNode = function(node) {
        var n;
        if (this._nodes.indexOf(node) < 0 && ((function() {
          var _i, _len, _ref, _results;
          _ref = this._nodes;
          _results = [];
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            n = _ref[_i];
            if (n.id === node.id) {
              _results.push(n);
            }
          }
          return _results;
        }).call(this)).length === 0) {
          this._nodes.push(node);
          return this.dispatchEvent('Graph.NodeAdded', {
            node: node
          });
        }
      };

      Graph.prototype.removeNode = function(node) {
        var deadEnds, e, i, _i, _j, _len, _len1, _ref;
        if ((i = this._nodes.indexOf(node)) >= 0) {
          deadEnds = [];
          _ref = this._edges;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            e = _ref[_i];
            if (e.touches(node)) {
              deadEnds.push(e);
            }
          }
          for (_j = 0, _len1 = deadEnds.length; _j < _len1; _j++) {
            e = deadEnds[_j];
            this.removeEdge(e);
          }
          this._nodes.splice(i, 1);
          return this.dispatchEvent('Graph.NodeRemoved', {
            node: node
          });
        }
      };

      Graph.prototype.getNodeById = function(id) {
        var n, _i, _len, _ref;
        _ref = this._nodes;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          n = _ref[_i];
          if (n.id === id) {
            return n;
          }
        }
        return null;
      };

      Graph.prototype.getEdgesFrom = function(node) {
        var e, _i, _len, _ref, _results;
        _ref = this._edges;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          e = _ref[_i];
          if (e.from === node) {
            _results.push(e);
          }
        }
        return _results;
      };

      Graph.prototype.getEdgesTo = function(node) {
        var e, _i, _len, _ref, _results;
        _ref = this._edges;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          e = _ref[_i];
          if (e.to === node) {
            _results.push(e);
          }
        }
        return _results;
      };

      Graph.prototype.connect = function(opts) {
        var EdgeClass, from, fte, tfe, to;
        from = opts.from;
        to = opts.to;
        EdgeClass = opts["with"] != null ? opts["with"] : this._defaultEdgeClass;
        if (this._nodes.indexOf(from) >= 0 && this._nodes.indexOf(to) >= 0) {
          fte = new EdgeClass(from, to);
          this.addEdge(fte);
          if (opts.bidirectional) {
            tfe = new EdgeClass(to, from);
            return this.addEdge(tfe);
          }
        }
      };

      Graph.prototype.addEdge = function(edge) {
        this._edges.push(edge);
        return this.dispatchEvent('Graph.EdgeAdded', {
          edge: edge
        });
      };

      Graph.prototype.removeEdge = function(edge) {
        var i;
        if ((i = this._edges.indexOf(edge)) >= 0) {
          this._edges.splice(i, 1);
          return this.dispatchEvent('Graph.EdgeRemoved', {
            edge: edge
          });
        }
      };

      return Graph;

    })(EventDispatcher);
  });

}).call(this);
