// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, MathJax, MathUtils, QuestionSet, RingDisplay, TEP, count_tmpl, group_summary_tmpl, summary_tmpl, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./template.html');
    summary_tmpl = require('text!./summary.html');
    group_summary_tmpl = require('text!./group_summary.html');
    RingDisplay = require('./ring_display');
    MathUtils = require('tep/utils/math');
    MathJax = require('mathjax');
    require('link!./style.css');
    count_tmpl = '<span><span class="questionset-count-label">Question</span> <span class="questionset-count-current"></span> of <span class="questionset-count-total"></span></span>';
    return QuestionSet = (function(_super) {
      __extends(QuestionSet, _super);

      function QuestionSet(data) {
        var qsTitleElem, _ref, _ref1, _ref2;
        this.data = data;
        this.conceptFinaleAdjust = __bind(this.conceptFinaleAdjust, this);
        this._checkFinaleAutoComplete = __bind(this._checkFinaleAutoComplete, this);
        this.buildSummary = __bind(this.buildSummary, this);
        this.onSummaryRequest = __bind(this.onSummaryRequest, this);
        this.onRepeatRequest = __bind(this.onRepeatRequest, this);
        this.showButtons = __bind(this.showButtons, this);
        this.displayContent = __bind(this.displayContent, this);
        this.updateQuestionNavigation = __bind(this.updateQuestionNavigation, this);
        this.viewNextQuestion = __bind(this.viewNextQuestion, this);
        this.viewPreviousQuestion = __bind(this.viewPreviousQuestion, this);
        this.onCurrentQuestionComplete = __bind(this.onCurrentQuestionComplete, this);
        this.onCurrentQuestionReady = __bind(this.onCurrentQuestionReady, this);
        this.buildState = __bind(this.buildState, this);
        this.parseState = __bind(this.parseState, this);
        this.onStatusChange = __bind(this.onStatusChange, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.buttonBayBuildButtons = __bind(this.buttonBayBuildButtons, this);
        QuestionSet.__super__.constructor.call(this, this.data, tmpl);
        if (this.data.type === "drill") {
          this.data.questionCount = this.data.drill.groupSize;
        }
        this.$summary = $(summary_tmpl);
        this.$countLabel = $(count_tmpl);
        if (this.data.type != null) {
          this.view().find(".te-questionSet").addClass("questionset-" + this.data.type);
        }
        qsTitleElem = this.$el.find('.questionset-title');
        if (this.data.sections == null) {
          qsTitleElem.text(this.data.name || '');
        }
        if (!qsTitleElem.text()) {
          qsTitleElem.parent().remove();
        }
        this.$countLabel.find('.questionset-count-label').text('Question');
        this.$countLabel.find('.questionset-count-total').text(this.data.questionCount);
        this.$countLabel.find('.questionset-count-current').text(1);
        this.addEventListener('statuschange', this.onStatusChange);
        this.$el.find('.questionset-prev').on('click', this.viewPreviousQuestion);
        this.$el.find('.questionset-next').on('click', this.viewNextQuestion);
        this.ring = new RingDisplay({
          radius: 27,
          ringWidth: 7,
          percentStroke: this.data.type === "quiz" ? "#a41034" : "#fff"
        });
        this.$summary.find('.questionset-score .questionset-data-icon').append(this.ring.view());
        if (this.data.questionCount === 1 && this.data.type !== "drill") {
          this.$el.find('.questionset-count-wrap').remove();
          this.$el.find('.questionset-content').addClass('questionset-single');
        } else {
          this.$el.find('.questionset-content').addClass('questionset-multiple');
        }
        if ((_ref = this.buttonBay) != null) {
          _ref.hideAll();
        }
        if ((_ref1 = this.buttonBay) != null) {
          _ref1.view().addEventListener("QuestionSet.RepeatRequest", this.onRepeatRequest);
        }
        if ((_ref2 = this.buttonBay) != null) {
          _ref2.view().addEventListener("QuestionSet.ViewSummary", this.onSummaryRequest);
        }
        this.ready = false;
      }

      QuestionSet.prototype.buttonBayBuildButtons = function() {
        var btns, qc;
        btns = QuestionSet.__super__.buttonBayBuildButtons.call(this);
        qc = this.data.type === "drill" ? this.data.drill.groupSize : this.data.questionCount;
        btns.buttons.repeat = {
          label: "Try " + qc + " More",
          "class": "alt-btn btn-right",
          event: "QuestionSet.RepeatRequest"
        };
        btns.buttons.summary = {
          label: "View Summary",
          "class": "btn",
          event: "QuestionSet.ViewSummary"
        };
        return btns;
      };

      QuestionSet.prototype.disable = function() {
        var _ref, _ref1;
        QuestionSet.__super__.disable.call(this);
        if (this._currentQuestionDisableState == null) {
          this._currentQuestionDisableState = (_ref = this.currentQuestion) != null ? _ref.te.isDisabled : void 0;
        }
        if (!this._currentQuestionDisableState) {
          return (_ref1 = this.currentQuestion) != null ? _ref1.te.disable() : void 0;
        }
      };

      QuestionSet.prototype.enable = function() {
        var _ref;
        QuestionSet.__super__.enable.call(this);
        if ((this._currentQuestionDisableState != null) && !this._currentQuestionDisableState) {
          if ((_ref = this.currentQuestion) != null) {
            _ref.te.enable();
          }
        }
        return this._currentQuestionDisableState = null;
      };

      QuestionSet.prototype.onScreen = function() {
        return true;
      };

      QuestionSet.prototype.onStatusChange = function(evt, data) {
        var _ref, _ref1, _ref2;
        QuestionSet.__super__.onStatusChange.call(this);
        if (this.status !== "locked") {
          if ((_ref = this.currentQuestion) != null) {
            if ((_ref1 = _ref.te) != null) {
              _ref1.unlock();
            }
          }
        }
        if (this.status === "unlocked") {
          this.start();
        }
        if (this.status === "complete") {
          return (_ref2 = this.buttonBay) != null ? _ref2.hideAll() : void 0;
        }
      };

      QuestionSet.prototype.cleanup = function() {
        return true;
      };

      QuestionSet.prototype.parseState = function(data) {
        var questions_with_credit, scope, state, _ref, _ref1, _results;
        QuestionSet.__super__.parseState.call(this, data);
        _ref = data.states;
        _results = [];
        for (scope in _ref) {
          state = _ref[scope];
          switch (scope) {
            case "user":
              this._awaitingReset = state.reset;
              if (state.history != null) {
                this.questionHistory = state.history;
              } else {
                this.questionHistory = [];
              }
              if (state.hasQuestion) {
                if (!this.currentQuestion || this.currentQuestion.id !== state.currentQuestionId) {
                  if ((_ref1 = this.buttonBay) != null) {
                    _ref1.hideAll();
                  }
                  _results.push(this.displayContent(state.currentQuestionId));
                } else {
                  _results.push(void 0);
                }
              } else {
                if (this.status !== 'complete') {
                  this.showButtons();
                }
                if (__indexOf.call(this.questionHistory, 'summary') < 0) {
                  this.questionHistory.push('summary');
                }
                this.$summary.find('.questionset-summary-message').html(this.data.summaryMessage);
                if (state.summary != null) {
                  questions_with_credit = state.questions_with_credit != null ? state.questions_with_credit : {};
                  this.buildSummary(state.summary, questions_with_credit);
                } else {
                  this.$summary.find('.questionset-summary-overview, .questionset-summary-details').hide();
                }
                if (this.data.questionCount === 1 && this.data.type !== "drill") {
                  _results.push(this.displayContent(this.questionHistory[0]));
                } else {
                  _results.push(this.displayContent('summary'));
                }
              }
              break;
            default:
              _results.push(void 0);
          }
        }
        return _results;
      };

      QuestionSet.prototype.buildState = function(scope, op) {
        var s;
        s = QuestionSet.__super__.buildState.call(this, scope, op);
        if (scope === "user" && this._awaitingReset) {
          s.reset = true;
        }
        return s;
      };

      QuestionSet.prototype.onCurrentQuestionReady = function() {
        var continueLabel, _ref,
          _this = this;
        this.currentQuestion.removeEventListener('ready', this.onCurrentQuestionReady);
        this.addLaTeX(this.$el.find('.questionset-question .te-title')[0]);
        this.addLaTeX(this.$el.find('.questionset-question .te-preamble')[0]);
        if (this.currentQuestion.te.data.helpText != null) {
          this.currentQuestion.te.addHelpText(this.$el.find('.questionset-question .te-preamble p').last(), this.currentQuestion.te.data.helpText);
        }
        this._checkFinaleAutoComplete();
        if (this.data.type === "quiz" && __indexOf.call(this.questionHistory, 'summary') < 0) {
          if (this.data.questionCount !== 1) {
            this.currentQuestion.te.setSkipSummary(true);
          }
          this.currentQuestion.te.setAutoComplete(true);
        }
        if (this.questionHistory.length % this.data.questionCount === 0) {
          continueLabel = "View Summary";
          if (this.data.questionCount === 1 && this.data.type !== "drill") {
            continueLabel = "Continue";
            this.currentQuestion.te.setAutoComplete(true);
          }
          this.currentQuestion.te.setButtonLabel("continue", continueLabel);
        }
        if ((_ref = this.status) === "unlocked" || _ref === "in-progress" || _ref === "complete") {
          this.currentQuestion.te.unlock();
        }
        if (this.currentQuestion.te.status !== "complete") {
          this.currentQuestion.te.addEventListener('complete', this.onCurrentQuestionComplete);
        }
        if (!this.data.showTitles) {
          this.currentQuestion.te.$el.find(".te-title").remove();
        }
        return this.$el.find('.questionset-question').stop().animate({
          height: this.currentQuestion.view().outerHeight(true),
          opacity: 1
        }, {
          duration: 250,
          complete: function() {
            _this.$el.find('.questionset-question').css('height', 'auto');
            if (_this.autoScroll && _this.scrollPos) {
              $('html,body').animate({
                scrollTop: _this.scrollPos
              }, {
                duration: 250
              });
              _this.autoScroll = null;
              _this.scrollPos = null;
            }
            if (!_this.ready) {
              _this.ready = true;
              return _this.dispatchEvent('ready', _this);
            }
          }
        });
      };

      QuestionSet.prototype.onCurrentQuestionComplete = function() {
        this.currentQuestion.te.removeEventListener('complete', this.onCurrentQuestionComplete);
        return this.pullState();
      };

      QuestionSet.prototype.viewPreviousQuestion = function() {
        var target;
        target = MathUtils.posMod(this.viewQuestionIndex - 1, this.questionHistory.length);
        if (target !== this.viewQuestionIndex) {
          return this.displayContent(this.questionHistory[target]);
        }
      };

      QuestionSet.prototype.viewNextQuestion = function() {
        var target;
        target = MathUtils.posMod(this.viewQuestionIndex + 1, this.questionHistory.length);
        if (target !== this.viewQuestionIndex) {
          return this.displayContent(this.questionHistory[target]);
        }
      };

      QuestionSet.prototype.updateQuestionNavigation = function() {
        var max;
        if (__indexOf.call(this.questionHistory, 'summary') < 0 && (this.questionHistory.length === 1 || this.data.type === "quiz")) {
          this.$el.find('.questionset-prev').attr('disabled', 'disabled');
        } else {
          this.$el.find('.questionset-prev').removeAttr('disabled');
        }
        if (__indexOf.call(this.questionHistory, 'summary') < 0 && (this.viewQuestionIndex === this.questionHistory.length - 1 || this.data.type === "quiz")) {
          this.$el.find('.questionset-next').attr('disabled', 'disabled');
        } else {
          this.$el.find('.questionset-next').removeAttr('disabled');
        }
        if (this.questionHistory[this.viewQuestionIndex] === 'summary') {
          return this.$el.find('.questionset-page-label').html(this.data.summaryLabel);
        } else {
          this.$countLabel = $(count_tmpl);
          this.$el.find('.questionset-page-label').html(this.$countLabel);
          max = this.data.questionCount;
          if (this.data.type === "drill") {
            max *= Math.ceil(this.questionHistory.length / this.data.questionCount);
            if (__indexOf.call(this.questionHistory, "summary") >= 0) {
              max -= this.data.questionCount;
            }
          }
          this.$el.find('.questionset-count-total').html(max);
          return this.$el.find('.questionset-count-current').text(this.viewQuestionIndex + 1);
        }
      };

      QuestionSet.prototype.displayContent = function(id) {
        var old,
          _this = this;
        if ((this.viewQuestionIndex == null) || id !== this.questionHistory[this.viewQuestionIndex] || this._reset) {
          this._reset = false;
          if (__indexOf.call(this.questionHistory, "summary") >= 0 && id !== "summary" && this.data.questionCount > 1) {
            this.buttonBay.showButton("summary");
          }
          if (id === "summary") {
            this.buttonBay.hideButton("summary");
          }
          if (this.viewQuestionIndex != null) {
            this.autoScroll = true;
            this.scrollPos = this.$el.offset().top - $('.top-bar').height() - 10;
          }
          old = this.viewQuestionIndex;
          this.viewQuestionIndex = this.questionHistory.indexOf(id);
          if (id === 'summary') {
            return this.$el.find('.questionset-question').stop().animate({
              height: 0,
              opacity: 0
            }, {
              duration: 250,
              complete: function() {
                _this.updateQuestionNavigation();
                _this.currentQuestion = null;
                _this.$el.find('.questionset-question').html(_this.$summary);
                return setTimeout(function() {
                  return _this.$el.find('.questionset-question').stop().animate({
                    height: _this.$el.find(_this.$summary).outerHeight(true),
                    opacity: 1
                  }, {
                    duration: 250,
                    complete: function() {
                      _this.$el.find('.questionset-question').css('height', 'auto');
                      if (_this.autoScroll && _this.scrollPos) {
                        $('html,body').animate({
                          scrollTop: _this.scrollPos
                        }, {
                          duration: 250
                        });
                        _this.autoScroll = null;
                        _this.scrollPos = null;
                      }
                      if (!_this.ready) {
                        _this.ready = true;
                        return _this.dispatchEvent('ready', _this);
                      }
                    }
                  });
                }, 250);
              }
            });
          } else {
            return this.$el.find('.questionset-question').stop().animate({
              height: 0,
              opacity: 0
            }, {
              duration: 250,
              complete: function() {
                _this.updateQuestionNavigation();
                _this.currentQuestion = TEP.make(id);
                _this.currentQuestion.addEventListener('ready', _this.onCurrentQuestionReady);
                if (_this.questionHistory[old] === "summary") {
                  _this.$summary.detach();
                }
                return _this.$el.find('.questionset-question').html(_this.currentQuestion.view());
              }
            });
          }
        }
      };

      QuestionSet.prototype.showButtons = function() {
        var _ref, _ref1;
        if (this._awaitingReset) {
          return (_ref = this.buttonBay) != null ? _ref.showButton('repeat') : void 0;
        } else {
          if ((_ref1 = this.buttonBay) != null) {
            _ref1.showButton('continue');
          }
          return this.moveButtonBay('end');
        }
      };

      QuestionSet.prototype.onRepeatRequest = function() {
        var _this = this;
        return this.pushState('user', 'set', function() {
          _this._reset = true;
          return _this.pullState();
        });
      };

      QuestionSet.prototype.onSummaryRequest = function() {
        if (__indexOf.call(this.questionHistory, "summary") >= 0) {
          return this.displayContent("summary");
        }
      };

      QuestionSet.prototype.buildSummary = function(summary, questions_with_credit) {
        var creditElement, creditExplanation, creditGranted, grade, grantCreditIncluded, groupCorrect, groupCount, groupInd, groupQuestionCount, groupView, item, itemView, totalCorrect, totalCount, _i, _j, _len, _ref, _ref1, _ref2,
          _this = this;
        this.$summary.find('.questionset-summary-details').html('');
        totalCount = 0;
        totalCorrect = 0;
        groupCount = Math.ceil(summary.length / this.data.questionCount);
        for (groupInd = _i = 0, _ref = groupCount - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; groupInd = 0 <= _ref ? ++_i : --_i) {
          groupView = $(group_summary_tmpl);
          groupQuestionCount = 0;
          groupCorrect = 0;
          grantCreditIncluded = false;
          _ref1 = summary.slice(groupInd * this.data.questionCount, (groupInd + 1) * this.data.questionCount);
          for (_j = 0, _len = _ref1.length; _j < _len; _j++) {
            item = _ref1[_j];
            creditGranted = item.question_id in questions_with_credit;
            groupQuestionCount++;
            totalCount++;
            if (item.correct || creditGranted) {
              groupCorrect++;
            }
            if (item.correct || creditGranted) {
              totalCorrect++;
            }
            creditElement = "";
            if (creditGranted && !item.correct) {
              grantCreditIncluded = true;
              creditExplanation = questions_with_credit[item.question_id];
              creditElement = "<div class='questionset-summary-result-credit'>(!) You have received credit for this question" + (creditExplanation ? "<br>" + creditExplanation.replace(/[\u00A0-\u9999<>\&]/gim, function(i) {
                return '&#' + i.charCodeAt(0) + ';';
              }) : "") + "</div>";
            }
            itemView = $(("            <li data-question-index='" + (summary.indexOf(item)) + "'>            <div class='questionset-summary-result ") + (item.correct ? "correct" : "incorrect") + "'>Question " + totalCount + "<i/>            </div>" + creditElement + "</li>          ");
            itemView.on('click', function(jqevt) {
              return _this.displayContent(_this.questionHistory[$(jqevt.currentTarget).data('question-index')]);
            });
            groupView.find("ul").append(itemView);
          }
          if (this.data.type === "drill") {
            groupView.find(".questionset-group-summary-title").text("Group " + (groupInd + 1) + " (" + (Math.round(100 * groupCorrect / groupQuestionCount)) + "%)");
          } else {
            groupView.find(".questionset-group-summary-title").remove();
          }
          this.$summary.find('.questionset-summary-details').append(groupView);
        }
        grade = groupCorrect / groupQuestionCount;
        this.$summary.find('.questionset-score .questionset-data-label').text(Math.round(grade * 100) + "%");
        if (this.data.type === "drill") {
          this.$summary.find(".questionset-score .questionset-overview-label").text("Your score (Group " + groupCount + ")");
        }
        this.$summary.find('.questionset-correct .questionset-data-label').text(groupCorrect);
        this.$summary.find('.questionset-incorrect .questionset-data-label').text(groupQuestionCount - groupCorrect);
        if (grantCreditIncluded) {
          this.$summary.find('.questionset-correct .credit-granted-included').show();
          this.$summary.find('.questionset-correct .questionset-overview-label').addClass("credit-granted-in-correct");
        }
        this.ring.animate({
          from: 0,
          to: grade,
          duration: 1000
        });
        if (this._awaitingReset) {
          return this.$summary.find(".questionset-summary-tryAgain").text((_ref2 = this.data.drill) != null ? _ref2.tryAgain : void 0).show();
        } else {
          return this.$summary.find(".questionset-summary-tryAgain").text("").hide();
        }
      };

      QuestionSet.prototype._checkFinaleAutoComplete = function() {
        var _ref;
        if (this._finaleAutoComplete && (((_ref = this.currentQuestion) != null ? _ref.te : void 0) != null)) {
          return this.currentQuestion.te.setAutoComplete(true);
        }
      };

      QuestionSet.prototype.conceptFinaleAdjust = function(type) {
        var _ref;
        QuestionSet.__super__.conceptFinaleAdjust.call(this, type);
        if (this.data.questionCount === 1 && ((_ref = this.data.type) !== "drill")) {
          this._finaleAutoComplete = true;
        }
        return this._checkFinaleAutoComplete();
      };

      return QuestionSet;

    })(TEP.TeachingElement);
  });

}).call(this);
