// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, DraggableItem, TEP, Tooltip, Utils, defaults, dragContentPadding, tmpl;
    $ = require('jquery');
    TEP = require('tep/tep');
    tmpl = require('text!./template.html');
    Utils = require('tep/utils/utils');
    Tooltip = require('tep/utils/tooltip');
    require('bootstrap');
    require('jqueryui');
    require('link!./style.css');
    /*
    Draggable Component
    ===============
    
    The Draggable component provides a standard draggable element for Teaching Elements. It can be configured
    to work with the Droppable component (the two work together via the scope option to allow draggables to
    work with one or more droppable elements).
    
    Configuration
    =============
    Draggable supports the following configurations, passed in as a single config object.
    */

    defaults = {
      /*
        *   type: if type is amt a dollar sign will automatically appear in front of the amount.
        Other types may be defined over time.
      
        Defaults to empty string ('').
      */

      type: '',
      /*
        *   scope: used to determine what droppables (from the Droppable component) can accept the draggables.
        Enter different values to create multiple droppable "buckets."
      
        Defaults to te-drop-container.
      */

      scope: 'te-drop-container',
      /*
        *   container: determines where the draggable can be dragged (i.e. do not drag outside the TEI).
      
        Defaults to .te-drag, which should be the TEI.
      */

      container: '.te-drag',
      /*
        *   disableDrop: if set to 1, will disable the droppable when the draggable is dropped. Use this to
        only allow one draggable per droppable. If 0, the droppable will remain active even after a draggable
        is dropped.
      
        Defaults to 0.
      */

      disableDrop: 0,
      /*
        *   charLimit: set a character limit for the words in a draggable item. If a word goes over the limit,
        the word is hyphenated via the Utilities hyphenateWord method. Base this on the average size of the
        draggable items in the TE.
      
        Defaults to 12.
      */

      charLimit: 12
    };
    dragContentPadding = 5;
    return DraggableItem = (function(_super) {
      __extends(DraggableItem, _super);

      function DraggableItem(data, options, template) {
        var imgTag, key, val;
        if (template == null) {
          template = null;
        }
        this.setWidth = __bind(this.setWidth, this);
        this.getWidth = __bind(this.getWidth, this);
        this.setHeight = __bind(this.setHeight, this);
        this.getHeight = __bind(this.getHeight, this);
        this.view = __bind(this.view, this);
        this.outFocus = __bind(this.outFocus, this);
        this.onFocus = __bind(this.onFocus, this);
        this.clearSelected = __bind(this.clearSelected, this);
        this.setSelected = __bind(this.setSelected, this);
        this.removeTooltip = __bind(this.removeTooltip, this);
        this.addTooltip = __bind(this.addTooltip, this);
        this.disable = __bind(this.disable, this);
        this.enable = __bind(this.enable, this);
        this.initialize = __bind(this.initialize, this);
        for (key in defaults) {
          val = defaults[key];
          this[key] = options[key] != null ? options[key] : val;
        }
        this.id = data.id;
        this.content = data.content;
        if (this.type === 'amt') {
          this.content = "$" + Utils.commaNumber(this.content);
        }
        this.content = Utils.hyphenateWords(this.content, this.charLimit);
        this.$dom = template ? $(template) : $(tmpl);
        this._view = this.$dom;
        this._view.find('.te-drag-item-content').html(this.content);
        this.draggableItem = this._view.find('.te-drag-item');
        if (template) {
          this.draggableItem = this._view;
        }
        if (data.image != null) {
          imgTag = "<img src='" + data.image + "' alt='" + data.imageFile.description + "' />";
          this.draggableItem.find('.te-drag-item-content').prepend(imgTag).prepend($('<div class="image-preview"></div>'));
        }
        this.draggableItem.attr('data-id', this.id);
        this.selected = false;
        this.initialize();
      }

      DraggableItem.prototype.initialize = function() {
        this.prevPos = null;
        return this.draggableItem.draggable({
          disabled: false,
          containment: this.container,
          zIndex: 100,
          scope: this.scope,
          snap: true,
          snapMode: "inner",
          distance: 10,
          revert: "invalid",
          helper: "clone",
          start: this.startDrag,
          stop: this.stopDrag,
          drag: this.dragging
        });
      };

      DraggableItem.prototype.enable = function() {
        if (this.draggableItem.hasClass('ui-draggable-disabled')) {
          this.draggableItem.draggable('enable');
        }
        this.draggableItem.attr('aria-grabbed', 'false');
        this.draggableItem.on('dragstart', this.removeTooltip);
        this.draggableItem.on('focus', this.onFocus);
        return this.draggableItem.on('focusout', this.outFocus);
      };

      DraggableItem.prototype.disable = function() {
        this.draggableItem.draggable('disable');
        this.draggableItem.removeAttr('aria-grabbed');
        this.draggableItem.off('dragstart', this.removeTooltip);
        this.draggableItem.off('focus', this.onFocus);
        return this.draggableItem.off('focusout', this.outFocus);
      };

      DraggableItem.prototype.startDrag = function(e, ui) {
        $(this).parent(".te-drag-item-slot").addClass('te-drag-item-slot-empty');
        if (this.disableDrop) {
          $(this).parent().droppable('disable');
        }
        $('.te-drag-item').removeClass('te-drag-item-dragging');
        $(this).addClass('te-drag-item-dragging');
        $(this).addClass('te-drag-item-hide');
        $(this).removeClass("te-drag-item-incorrect te-drag-item-correct");
        return this.prevPos = null;
      };

      DraggableItem.prototype.stopDrag = function(e, ui) {
        $(this).parent(".te-drag-item-slot").removeClass('te-drag-item-slot-empty');
        $(this).removeClass('te-drag-item-dragging');
        $(this).removeClass('te-drag-item-hide');
        return this.prevPos = null;
      };

      DraggableItem.prototype.dragging = function(e, ui) {};

      DraggableItem.prototype.addTooltip = function(text) {
        return Tooltip.buildTooltip(this._view, "dragTooltip_" + this.id, text);
      };

      DraggableItem.prototype.removeTooltip = function() {
        return Tooltip.destroyTooltip(this._view);
      };

      DraggableItem.prototype.setSelected = function() {
        this.selected = true;
        this.onFocus();
        return this._view.attr("aria-grabbed", "true").removeClass("te-drag-item-incorrect te-drag-item-correct");
      };

      DraggableItem.prototype.clearSelected = function() {
        this.selected = false;
        this.outFocus();
        return this._view.attr('aria-grabbed', 'false');
      };

      DraggableItem.prototype.onFocus = function() {
        if (this.draggableItem.attr('tabindex')) {
          return this.draggableItem.addClass('te-drag-item-dragging');
        }
      };

      DraggableItem.prototype.outFocus = function() {
        return this.draggableItem.removeClass('te-drag-item-dragging');
      };

      DraggableItem.prototype.view = function() {
        return this._view;
      };

      DraggableItem.prototype.getHeight = function() {
        var height;
        return height = this.draggableItem.height();
      };

      DraggableItem.prototype.setHeight = function(newHeight) {
        var borderSize;
        this._view.css("height", newHeight + "px");
        borderSize = 4;
        if (this.draggableItem.hasClass('te-drag-item-correct') || this.draggableItem.hasClass('te-drag-item-incorrect')) {
          this.draggableItem.css("height", (newHeight + borderSize) + "px");
        } else {
          this.draggableItem.css("height", newHeight + "px");
        }
        return this.draggableItem.find('.te-drag-item-content').css("height", (newHeight - dragContentPadding * 2) + "px");
      };

      DraggableItem.prototype.getWidth = function() {
        var width;
        return width = this._view.width();
      };

      DraggableItem.prototype.setWidth = function(newWidth) {
        this._view.width(newWidth);
        this.draggableItem.width(newWidth);
        return this.draggableItem.find('.te-drag-item-content').width(newWidth);
      };

      return DraggableItem;

    })(TEP.EventDispatcher);
  });

}).call(this);
