// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Conversation, EventDispatcher, Model, SharedAnswer, View, defaults;
    $ = require("jquery");
    EventDispatcher = require("tep/utils/event/event_dispatcher");
    Model = require("./models/model");
    View = require("./views/view");
    require("link!./style.css");
    Conversation = require("tep/components/conversation/main");
    defaults = {
      tei: null,
      teiModel: null,
      type: null,
      course_instance_id: window.globals.courseInstanceId,
      current_user: window.user_id,
      items_per_page: 24,
      conversation_header: "",
      group_id: null,
      calledFromBeforeAndAfter: false,
      beforeAndAfterId: "",
      restrictResultsToTeam: false,
      focusedAnswerData: null
    };
    return SharedAnswer = (function(_super) {
      __extends(SharedAnswer, _super);

      function SharedAnswer(settings) {
        this.update = __bind(this.update, this);
        this.onConversationMetricRequest = __bind(this.onConversationMetricRequest, this);
        this.onMetricRequest = __bind(this.onMetricRequest, this);
        this.onCommentAdded = __bind(this.onCommentAdded, this);
        this.focusedAnswerRequest = __bind(this.focusedAnswerRequest, this);
        this.searchRequest = __bind(this.searchRequest, this);
        this.onTeamFilterToggle = __bind(this.onTeamFilterToggle, this);
        this.onOrderBy = __bind(this.onOrderBy, this);
        this.onConversationRequest = __bind(this.onConversationRequest, this);
        this.onAnswerHistoryRequest = __bind(this.onAnswerHistoryRequest, this);
        this.onLikeToggleRequest = __bind(this.onLikeToggleRequest, this);
        this.onAnswerScrollRequest = __bind(this.onAnswerScrollRequest, this);
        this.onAnswerSelectionRequest = __bind(this.onAnswerSelectionRequest, this);
        this.$dom = __bind(this.$dom, this);
        this.view = __bind(this.view, this);
        this._model = new Model($.extend({}, true, defaults, settings));
        this._view = new View(this._model);
        this._view.addEventListener("SharedAnswer.AnswerSelectionRequest", this.onAnswerSelectionRequest);
        this._view.addEventListener("SharedAnswer.AnswerScrollRequest", this.onAnswerScrollRequest);
        this._view.addEventListener("SharedAnswer.LikeToggleRequest", this.onLikeToggleRequest);
        this._view.addEventListener("SharedAnswer.AnswerHistoryRequest", this.onAnswerHistoryRequest);
        this._view.addEventListener("SharedAnswer.ConversationRequest", this.onConversationRequest);
        this._view.addEventListener("SharedAnswer.OrderByRequest", this.onOrderBy);
        this._view.addEventListener("SharedAnswer.ClearSearchRequest", this.searchRequest);
        this._view.addEventListener("SharedAnswer.SubmitSearch", this.searchRequest);
        this._view.addEventListener("SharedAnswer.FocusedAnswer", this.focusedAnswerRequest);
        this._view.addEventListener("SharedAnswer.OnTeamFilterToggle", this.onTeamFilterToggle);
        this._model.addEventListener("SharedAnswer.MetricRequest", this.onMetricRequest);
        this.conversation = Conversation;
        this.conversation.addEventListener("Conversation.CommentAdded", this.onCommentAdded);
        this.conversation.addEventListener("Conversation.ConversationReloaded", this.onCommentAdded);
        this.conversation.addEventListener("Conversation.MetricRequest", this.onConversationMetricRequest);
      }

      SharedAnswer.prototype.view = function() {
        return this._view;
      };

      SharedAnswer.prototype.$dom = function() {
        return this._view.view();
      };

      SharedAnswer.prototype.onAnswerSelectionRequest = function(evt, data) {
        this._model.selectAnswer(data.answer_index);
        if (window.globals.is_invisible) {
          return this._view.view().find(".sharedanswer-answer-comments-meta").remove();
        }
      };

      SharedAnswer.prototype.onAnswerScrollRequest = function(evt, data) {
        this._model.setScrollTop(data.scroll);
        return this.dispatchEvent("SharedAnswer.MetricRequest", {
          metric: {
            viewed_user_id: this._model.get("selectedAnswer.user_id")
          },
          category: "view_user_response"
        });
      };

      SharedAnswer.prototype.onLikeToggleRequest = function(evt, data) {
        return this._model.get("selectedAnswer").toggleLike();
      };

      SharedAnswer.prototype.onAnswerHistoryRequest = function(evt, data) {
        return this._model.get("selectedAnswer").toggleAnswerHistory();
      };

      SharedAnswer.prototype.onConversationRequest = function(evt, data) {
        var header;
        header = this._model.common.get("conversation_header");
        if (typeof header === "function") {
          header = header(this._model.get("selectedAnswer"));
        }
        return this.conversation.showConversation({
          id: this._model.get("selectedAnswer.conversation_id"),
          title: "Discussion",
          preamble: header,
          calledFromBeforeAndAfter: this._model.common.get("calledFromBeforeAndAfter"),
          beforeAndAfterId: this._model.common.get("beforeAndAfterId"),
          restrictResultsToTeam: this._model.common.get("restrictResultsToTeam"),
          focusedElement: data.focusedElement
        });
      };

      SharedAnswer.prototype.onOrderBy = function(evt, data) {
        var metric;
        metric = {
          metric: {
            order_by: data.orderBy,
            is_on: data.onOff
          },
          category: "reorder_responses"
        };
        this.dispatchEvent("SharedAnswer.MetricRequest", metric);
        return this._model.updateOrderBy(data.orderBy);
      };

      SharedAnswer.prototype.onTeamFilterToggle = function(evt, data) {
        var metric;
        metric = {
          metric: {
            value: data.value,
            key: "filter_answers"
          },
          category: "interface"
        };
        return this.dispatchEvent("SharedAnswer.MetricRequest", metric);
      };

      SharedAnswer.prototype.searchRequest = function(evt, data) {
        var category, metric, search;
        search = data.search;
        category = data.category;
        metric = {
          metric: {
            search: search
          },
          category: category
        };
        this.dispatchEvent("SharedAnswer.MetricRequest", metric);
        if (category !== "search_results") {
          search = "";
        }
        this._model.set("search", search);
        return this._model.loadResponses();
      };

      SharedAnswer.prototype.focusedAnswerRequest = function(evt, data) {
        return this._model.loadResponses();
      };

      SharedAnswer.prototype.onCommentAdded = function(evt, data) {
        var answer, answers, _i, _len, _results;
        answers = this._model.get("answers");
        if (answers) {
          _results = [];
          for (_i = 0, _len = answers.length; _i < _len; _i++) {
            answer = answers[_i];
            if (answer.get("conversation_id") === data.conversation_id) {
              answer.set("comments", data.comment_count);
              break;
            } else {
              _results.push(void 0);
            }
          }
          return _results;
        }
      };

      SharedAnswer.prototype.onMetricRequest = function(evt, data) {
        return this.dispatchEvent(evt, data);
      };

      SharedAnswer.prototype.onConversationMetricRequest = function(evt, data) {
        var answer, answers, _i, _len, _results;
        answers = this._model.get("answers");
        if (answers) {
          _results = [];
          for (_i = 0, _len = answers.length; _i < _len; _i++) {
            answer = answers[_i];
            if (answer.get("conversation_id") === data.metric.conversation_id) {
              this.dispatchEvent("SharedAnswer.MetricRequest", data);
              break;
            } else {
              _results.push(void 0);
            }
          }
          return _results;
        }
      };

      SharedAnswer.prototype.update = function() {
        return this._model.loadResponses();
      };

      return SharedAnswer;

    })(EventDispatcher);
  });

}).call(this);
