// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Switch, TEP, defaults, tmpl;
    TEP = require('tep/tep');
    $ = require('jquery');
    tmpl = require('text!./template.html');
    require('link!./style.css');
    /*
    Switch Component
    ================
    The Switch component provides a simple, stylized on/off switch.
    
    Configuration
    =============
    The Switch component supports the following configuration, passed in as a single config object:
    */

    defaults = {
      /*
      *   currentValue: A string indicating the initial value of the switch. Acceptable values are "on" or "off".
      
      Defaults to "off".
      */

      currentValue: "off",
      /*
      *   disabled: A boolean indicating whether the switch starts disabled or enabled.
      
      Defaults to false.
      */

      disabled: false,
      /*
      *   class: A string of classes that should be applied to the component. Styles are provided for both "small" and "light".
      
      Defaults to ''.
      */

      "class": '',
      /*
      *   onLabel: Label for the "on" position.
      */

      onLabel: "on",
      /*
      *   offLabel: Label for the "off" position.
      */

      offLabel: "off"
    };
    return Switch = (function(_super) {
      __extends(Switch, _super);

      function Switch(options) {
        this._updateDisplay = __bind(this._updateDisplay, this);
        this.toggleSwitch = __bind(this.toggleSwitch, this);
        this.toggleValue = __bind(this.toggleValue, this);
        this.value = __bind(this.value, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.isOn = __bind(this.isOn, this);
        this.view = __bind(this.view, this);
        var key, _i, _len, _ref;
        this.config = $.extend({}, defaults, options);
        this.currentValue = this.config.currentValue;
        this.disabled = this.config.disabled;
        this.$dom = $(tmpl);
        this.$dom.find('.switch').on('keydown', this.toggleSwitch);
        this.$dom.find('.switch').on('click', this.toggleValue);
        _ref = ["on", "off"];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          key = _ref[_i];
          this.$dom.find(".switch-" + key + " .switch-label").html(this.config["" + key + "Label"]);
        }
        this.$dom.addClass(this.config["class"]);
        this._updateDisplay();
      }

      /*
      API
      ===
      
      view()
      ------
      Returns the dom element of the component (as a jQuery object).
      */


      Switch.prototype.view = function() {
        return this.$dom;
      };

      /*
      isOn()
      ------
      Returns the current status of the switch, as a boolean.
      */


      Switch.prototype.isOn = function() {
        return this.currentValue === "on";
      };

      /*
      disable()
      ---------
      Disables the component from further manipulation.
      */


      Switch.prototype.disable = function() {
        this.disabled = true;
        return this._updateDisplay();
      };

      /*
      enable()
      --------
      Enables the component to allow user manipulation.
      */


      Switch.prototype.enable = function() {
        this.disabled = false;
        return this._updateDisplay();
      };

      /*
      value(val)
      ----------
      If a value (on|off string) is provided and appropriate, this sets the value.
      Otherwise, it returns the current value as an on|off string.
      */


      Switch.prototype.value = function(val) {
        if (val != null) {
          if (!this.disabled && ["on", "off"].indexOf(val) >= 0 && val !== this.currentValue) {
            this.currentValue = val;
            this._updateDisplay();
            return this.dispatchEvent('Switch.ValueChange', {});
          }
        } else {
          return this.currentValue;
        }
      };

      /*
      toggleValue()
      -------------
      Alternates the value between "on" and "off".
      */


      Switch.prototype.toggleValue = function() {
        if (!this.disabled) {
          return this.value(this.isOn() ? "off" : "on");
        }
      };

      /*
      toggleSwitch()
      -------------
      Trigger the click event of switch for spacebar and enter
      */


      Switch.prototype.toggleSwitch = function(evt) {
        if (evt.keyCode === 13 || evt.keyCode === 32) {
          evt.preventDefault();
          evt.stopPropagation();
          return $(evt.target).trigger('click');
        }
      };

      /*
      
      Events
      ======
      The Switch component fires the following events:
      
      Switch.ValueChange
      ------------------
      Fires when the value of the switch changes. Note that this does not fire if you call value(val)
      but it does not result in a change.
      */


      Switch.prototype._updateDisplay = function() {
        this.$dom.find('.switch').removeClass('on off').addClass(this.isOn() ? "on" : "off");
        if (this.disabled) {
          return this.$dom.addClass('disabled');
        } else {
          return this.$dom.removeClass('disabled');
        }
      };

      return Switch;

    })(TEP.EventDispatcher);
  });

}).call(this);
