// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, AudioPLayer, ClosedCaptionControl, ControlBar, FullScreenControl, KALTURA_PARTNER_ID, KALTURA_PLAYER_ID, KALTURA_PLAYER_LOW_QUALITY_ID, KALTURA_PLAYER_RTMP_ID, KEY_MAP, KalturaMediaPlayer, KalturaPlayerPromise, PlayPauseControl, STATE_FREQUENCY, ScrubBar, Slider, SpeedControl, Switch, TEP, TPPreview, Tooltip, TranscriptControl, TranscriptPanel, Utils, VolumeControl, captionator, dvsTmpl, fs, modulePath, tmpl;
    $ = require("jquery");
    KalturaPlayerPromise = require("tep/components/kaltura3rdPartyCode/main");
    TEP = require("tep/tep");
    AudioPLayer = require('tep/components/audioplayer/main');
    Slider = require("tep/components/slider/main");
    Switch = require("tep/components/switch/main");
    tmpl = require("text!./template.html");
    dvsTmpl = require('text!./dvs.html');
    fs = require("./fullscreen");
    Utils = require("tep/utils/utils");
    Tooltip = require('tep/utils/tooltip');
    require("link!./style.css");
    captionator = require("../../../media/0.1/courseware/captionator");
    /*
    
    Kaltura player notes:
    - the "playback speed" plugin must be enabled in the Kaltura video player in order for the playback speed functionality to work
    - the "show captions" option in the captions plugin must also be enabled in order for captions to display
    */

    STATE_FREQUENCY = 10;
    KEY_MAP = Utils.getKeyMap();
    KALTURA_PARTNER_ID = 2011081;
    KALTURA_PLAYER_LOW_QUALITY_ID = 31854781;
    KALTURA_PLAYER_RTMP_ID = 40278101;
    KALTURA_PLAYER_ID = window.default_media_bandwidth === "high" ? KALTURA_PLAYER_RTMP_ID : KALTURA_PLAYER_LOW_QUALITY_ID;
    modulePath = "/bcore/static/te/kalturaMediaPlayer/0.1/courseware/";
    if (!('kalturaGlobalOptions' in window)) {
      window.kalturaGlobalOptions = {
        speed: null,
        volume: null,
        captionIsOn: null,
        transcriptIsOn: null,
        players: {},
        updateSpeedForOtherPlayers: function(id, speed) {
          var player, prop;
          for (prop in this.players) {
            if (id !== prop) {
              player = this.players[prop];
              player.setSpeed(speed, false, false);
              player.controlBar.controls.speed.value(speed);
              player.controlBar.controls.speed.updateSpeedSlider(speed);
              player.pushState("user/te");
            }
          }
        },
        updateVolumeForOtherPlayers: function(id, volume) {
          var player, prop;
          for (prop in this.players) {
            if (id !== prop) {
              player = this.players[prop];
              player.setVolume(volume, false, false);
              player.controlBar.controls.volume.value(volume);
              player.pushState("user/te");
            }
          }
        },
        updateCaptionForOtherPlayers: function(id, isOn) {
          var player, prop;
          for (prop in this.players) {
            if (id !== prop) {
              player = this.players[prop];
              if (player.controlBar.controls.closedcaption.isOn !== isOn) {
                player.captionisOn = isOn;
                player.controlBar.controls.closedcaption._updateDisplay();
                player.pushState("user/te");
                if (player.captionisOn) {
                  player.kalturaSendNotification('showClosedCaptions');
                } else {
                  player.kalturaSendNotification('hideClosedCaptions');
                }
              }
            }
          }
        },
        updateTranscriptForOtherPlayers: function(id, isOn) {
          var player, prop;
          for (prop in this.players) {
            if (id !== prop) {
              player = this.players[prop];
              player.transcriptisOn = isOn;
              player.controlBar.controls.transcript.isOn = isOn;
              player.controlBar.controls.transcript._updateDisplay(false);
              player.pushState("user/te");
            }
          }
        }
      };
    }
    TPPreview = (function(_super) {
      __extends(TPPreview, _super);

      function TPPreview(tp) {
        this.view = __bind(this.view, this);
        this.setStatus = __bind(this.setStatus, this);
        var _ref,
          _this = this;
        this.id = tp.id;
        this.timestamp = (_ref = tp.triggerSequence[0]) != null ? _ref.value : void 0;
        this._view = $("<div>").addClass("media-ippreview-wrap");
        this._view.append($("<div>").addClass("media-ippreview locked"));
        this._view.find(".media-ippreview").bind("click", function() {
          if (_this.status === "complete") {
            _this.dispatchEvent("requestTPDisplay", _this);
          }
          return false;
        });
        if (tp.status != null) {
          this.setStatus(tp.status);
        } else {
          this.status = "locked";
        }
      }

      TPPreview.prototype.setStatus = function(status) {
        var prev;
        this.status = status;
        prev = this._view.find(".media-ippreview");
        return prev.removeClass("locked in-progress complete").addClass(status);
      };

      TPPreview.prototype.view = function() {
        return this._view;
      };

      return TPPreview;

    })(TEP.EventDispatcher);
    ScrubBar = (function(_super) {
      __extends(ScrubBar, _super);

      function ScrubBar(root, te) {
        var _this = this;
        this.root = root;
        this.te = te;
        this.updateBar = __bind(this.updateBar, this);
        this.canAccessTime = __bind(this.canAccessTime, this);
        this.onClick = __bind(this.onClick, this);
        this.addTriggerPoints = __bind(this.addTriggerPoints, this);
        this.te.addEventListener("KalturaMediaPlayer.TimeUpdate", function(evt, data) {
          return _this.updateBar(evt, data.time);
        });
        this.root.bind("click", this.onClick);
        this.labels = {
          current: this.root.find(".media-time-current"),
          duration: this.root.find(".media-time-duration")
        };
      }

      ScrubBar.prototype.addTriggerPoints = function() {
        var id, ip, v, _ref, _results;
        _ref = this.te.interrupts;
        _results = [];
        for (id in _ref) {
          ip = _ref[id];
          v = ip.view();
          v.css({
            left: (100 * ip.timestamp / this.te.duration) + "%"
          });
          _results.push(this.root.find(".media-ip").append(v));
        }
        return _results;
      };

      ScrubBar.prototype.onClick = function(e) {
        var target;
        target = this.te.duration * (e.offsetX != null ? e.offsetX : e.originalEvent.layerX) / this.root.width();
        if (this.canAccessTime(target)) {
          return this.te.seek(target);
        }
      };

      ScrubBar.prototype.canAccessTime = function(time) {
        return time <= this.te.state.user.maxTime;
      };

      ScrubBar.prototype.updateBar = function(e, time) {
        var bufferedPercent;
        if (time == null) {
          time = 0;
        }
        if (!time && this.te.state.user.timestamp) {
          time = this.te.state.user.timestamp;
        }
        this.labels.current.text(this.timeToString(time));
        this.labels.duration.text(this.timeToString(this.te.duration));
        this.root.find(".media-playhead").css("width", 100 * (time / this.te.duration) + "%");
        bufferedPercent = 100 * this.te.kalturaEvaluate("video.buffer.percent");
        if (isNaN(bufferedPercent)) {
          bufferedPercent = 0;
        }
        if (this.te.duration) {
          return this.root.find('.media-buffer').css('width', bufferedPercent + "%");
        }
      };

      ScrubBar.prototype.timeToString = function(timeInS) {
        var hours, seconds, t, times;
        times = [];
        if (hours = Math.floor(timeInS / (60 * 60))) {
          times.push(hours);
        }
        times.push(Math.floor((timeInS / 60) % 60));
        seconds = Math.round(timeInS % 60);
        if (seconds === 60) {
          times[times.length - 1] += 1;
          seconds = 0;
        }
        times.push(seconds);
        return ((function() {
          var _i, _len, _results;
          _results = [];
          for (_i = 0, _len = times.length; _i < _len; _i++) {
            t = times[_i];
            _results.push((t < 10 ? "0" : "") + t.toString());
          }
          return _results;
        })()).join(":");
      };

      return ScrubBar;

    })(TEP.EventDispatcher);
    PlayPauseControl = (function(_super) {
      __extends(PlayPauseControl, _super);

      function PlayPauseControl(_view, te) {
        this._view = _view;
        this.te = te;
        this.updateImage = __bind(this.updateImage, this);
        this.changeState = __bind(this.changeState, this);
        this.view = __bind(this.view, this);
        this.onClick = __bind(this.onClick, this);
        this.te.addEventListener("playing", this.changeState);
        this.te.addEventListener("pause", this.changeState);
        this._view.bind("click", this.onClick);
        this._view.addClass("paused");
        this.updateImage("play", "Play Video");
      }

      PlayPauseControl.prototype.onClick = function(e) {
        e.preventDefault();
        return this.te.togglePlay();
      };

      PlayPauseControl.prototype.view = function() {
        return this._view;
      };

      PlayPauseControl.prototype.changeState = function(e) {
        if (this.te.paused) {
          this._view.removeClass("paused playing").addClass("paused");
          return this.updateImage("play", "Play Video");
        } else {
          this._view.removeClass("paused playing").addClass("playing");
          return this.updateImage("pause", "Pause Video");
        }
      };

      PlayPauseControl.prototype.updateImage = function(imgName, altText) {
        return this._view.find("img").attr({
          "src": "" + modulePath + "img/controls/" + imgName + ".png",
          "alt": altText
        });
      };

      return PlayPauseControl;

    })(TEP.EventDispatcher);
    VolumeControl = (function(_super) {
      __extends(VolumeControl, _super);

      function VolumeControl(_view, te) {
        var volumeId;
        this._view = _view;
        this.te = te;
        this.changeState = __bind(this.changeState, this);
        this.view = __bind(this.view, this);
        this.getVolume = __bind(this.getVolume, this);
        this.value = __bind(this.value, this);
        this.onVolumeChange = __bind(this.onVolumeChange, this);
        this.handleSliderChange = __bind(this.handleSliderChange, this);
        this.updateSliderAttributes = __bind(this.updateSliderAttributes, this);
        this.handleKeypress = __bind(this.handleKeypress, this);
        this.te.addEventListener("volumechange", this.changeState);
        this._view.addClass("unmuted");
        this.isOn = false;
        volumeId = "" + this.te.data.te + "_VolumeExpand_" + this.te.data.id;
        this._view.find("media-volume-wrap").attr("id", volumeId);
        this._view.attr("aria-controls", volumeId);
        this.slider = new Slider({
          currentValue: 0.5,
          axis: "y",
          classes: "",
          min: 0,
          max: 100,
          description: "Change volume",
          metricFunction: this.te.pushMetric,
          upFunction: this.handleSliderChange
        });
        this.slider.addEventListener("Slider.Jump", this.handleSliderChange);
        this.slider.addEventListener("Slider.Drop", this.handleSliderChange);
        this._view.bind("keydown", this.handleKeypress);
        this._view.find(".media-volume-control").append(this.slider.$dom).find(".slider-handle-nubbin").html("<img src='" + modulePath + "img/controls/nubbin.png' alt='Adjust volume' />");
        this._view.find("> img").attr("src", "" + modulePath + "img/icons-on/1x/volume-icon.png");
      }

      VolumeControl.prototype.handleKeypress = function(e) {
        var code;
        e.stopPropagation();
        code = e.keyCode ? e.keyCode : e.which;
        if (code === KEY_MAP.selectKey || code === KEY_MAP.submitKey) {
          e.preventDefault();
          return this.updateSliderAttributes();
        }
      };

      VolumeControl.prototype.updateSliderAttributes = function() {
        this.isOn = !this.isOn;
        if (this.isOn) {
          this._view.attr("aria-expanded", "true");
          return this._view.find(".media-volume-wrap").css("display", "block");
        } else {
          this._view.attr("aria-expanded", "false");
          return this._view.find(".media-volume-wrap").css("display", "none");
        }
      };

      VolumeControl.prototype.handleSliderChange = function() {
        this.te.setVolume(this.slider.value());
        return this.te.pushState("user/te");
      };

      VolumeControl.prototype.onVolumeChange = function() {
        return this.te.setVolume(this.slider.value());
      };

      VolumeControl.prototype.value = function(val) {
        return this.slider.value(val);
      };

      VolumeControl.prototype.getVolume = function() {
        return this.slider.value();
      };

      VolumeControl.prototype.view = function() {
        return this._view;
      };

      VolumeControl.prototype.changeState = function(e) {
        if (e.currentTarget.volume === 0 || e.currentTarget.muted) {
          this._view.removeClass("muted unmuted").addClass("muted");
          return this._view.find("> img").attr({
            "src": "" + modulePath + "img/icons-on/1x/volume-icon.png",
            "alt": "Volume Muted, Change"
          });
        } else {
          this._view.removeClass("muted unmuted").addClass("unmuted");
          return this._view.find("> img").attr({
            "src": "" + modulePath + "img/icons-on/1x/volume-icon.png",
            "alt": "Change Volume"
          });
        }
      };

      return VolumeControl;

    })(TEP.EventDispatcher);
    FullScreenControl = (function(_super) {
      __extends(FullScreenControl, _super);

      function FullScreenControl(_view, te) {
        this._view = _view;
        this.te = te;
        this.view = __bind(this.view, this);
        this.onClick = __bind(this.onClick, this);
        this.checkState = __bind(this.checkState, this);
        this._view.bind("click", this.onClick);
        this._view.addClass("fullscreen");
        fs.bind(this.checkState);
        this.isFS = false;
        this._view.find("img").attr("src", "" + modulePath + "img/icons-off/1x/full-screen-icon.png");
      }

      FullScreenControl.prototype.checkState = function(e) {
        if (fs.isFullScreen()) {
          return this._view.removeClass("fullscreen normalscreen").addClass("normalscreen");
        } else {
          return this._view.removeClass("fullscreen normalscreen").addClass("fullscreen");
        }
      };

      FullScreenControl.prototype.onClick = function(e) {
        e.preventDefault();
        return this.te.toggleFullscreen();
      };

      FullScreenControl.prototype.view = function() {
        return this._view;
      };

      return FullScreenControl;

    })(TEP.EventDispatcher);
    SpeedControl = (function(_super) {
      __extends(SpeedControl, _super);

      function SpeedControl(_view, te) {
        var k, v, _ref;
        this._view = _view;
        this.te = te;
        this.view = __bind(this.view, this);
        this.value = __bind(this.value, this);
        this.onSpeedChange = __bind(this.onSpeedChange, this);
        this.updateSpeedSlider = __bind(this.updateSpeedSlider, this);
        this.getSpeed = __bind(this.getSpeed, this);
        this.slider = new Slider({
          axis: "y",
          steps: 7,
          delta: 0.5,
          currentValue: 1,
          currentValueType: "scaled",
          min: 0.5,
          max: 2,
          classes: "",
          description: "Adjust video playback speed",
          metricFunction: this.te.pushMetric,
          upFunction: this.onSpeedChange
        });
        this.scaledSliderValues = {
          1: 0.5,
          2: 0.75,
          3: 1,
          4: 1.25,
          5: 1.5,
          6: 1.75,
          7: 2
        };
        this.unscaledSliderValues = {};
        _ref = this.scaledSliderValues;
        for (k in _ref) {
          v = _ref[k];
          this.unscaledSliderValues[v] = k;
        }
        this.slider.addEventListener("Slider.Jump", this.onSpeedChange);
        this.slider.addEventListener("Slider.Drop", this.onSpeedChange);
        this._view.find(".media-speed-control").append(this.slider.$dom).find(".slider-handle-nubbin").html("<img src='" + modulePath + "img/controls/nubbin.png' alt='Adjust playback speed' />");
        this.updateSpeedSlider(this.getSpeed());
      }

      SpeedControl.prototype.getSpeed = function() {
        return this.slider.scaledValue();
      };

      SpeedControl.prototype.updateSpeedSlider = function(speed) {
        this._view.find("> img").attr("src", ("" + modulePath + "img/icons-off/1x/speed-") + speed + "x.png");
        return this._view.find(".media-speed-control .component-slider-slider").attr({
          "aria-valuenow": this.slider.scaledValue(),
          "aria-valuetext": "" + speed + " times speed"
        });
      };

      SpeedControl.prototype.onSpeedChange = function() {
        var speed;
        speed = this.getSpeed();
        this.updateSpeedSlider(speed);
        this.te.setSpeed(speed);
        return this.te.pushState("user/te");
      };

      SpeedControl.prototype.value = function(val) {
        return this.slider.scaledValue(val);
      };

      SpeedControl.prototype.view = function() {
        return this._view;
      };

      return SpeedControl;

    })(TEP.EventDispatcher);
    TranscriptControl = (function(_super) {
      __extends(TranscriptControl, _super);

      function TranscriptControl(_view, te) {
        this._view = _view;
        this.te = te;
        this.view = __bind(this.view, this);
        this._updateDisplay = __bind(this._updateDisplay, this);
        this.disable = __bind(this.disable, this);
        this.enable = __bind(this.enable, this);
        this.onToggle = __bind(this.onToggle, this);
        this.onClick = __bind(this.onClick, this);
        this.buildTooltip = __bind(this.buildTooltip, this);
        this.handleKeypress = __bind(this.handleKeypress, this);
        this.isOn = false;
        this._view.on("click", this.onClick);
        this._view.on("keydown", this.handleKeypress);
        this._updateDisplay();
        this.buildTooltip();
        Tooltip.hideTooltip(this._view);
      }

      TranscriptControl.prototype.handleKeypress = function(e) {
        var code;
        e.stopPropagation();
        code = e.keyCode ? e.keyCode : e.which;
        if (code === KEY_MAP.selectKey || code === KEY_MAP.submitKey) {
          e.preventDefault();
          this.onClick();
          return this._view.focus();
        }
      };

      TranscriptControl.prototype.buildTooltip = function() {
        var $selector;
        $selector = this._view;
        Tooltip.buildTooltip($selector, Math.random().toString().substring(8), "Transcript", {
          trigger: 'hover'
        });
        return Tooltip.showTooltip($selector);
      };

      TranscriptControl.prototype.onClick = function() {
        var isOn, metricValue;
        this.te.transcriptisOn = !this.te.transcriptisOn;
        isOn = this.te.transcriptisOn;
        window.kalturaGlobalOptions.transcriptIsOn = this.te.transcriptisOn;
        window.kalturaGlobalOptions.updateTranscriptForOtherPlayers(this.te.mediaElementId, this.te.transcriptisOn);
        if (this.te.transcriptisOn) {
          metricValue = "on";
        } else {
          metricValue = "off";
        }
        this.te.pushState('user');
        this.te.pushMetric({
          "video_transcript": metricValue
        }, 'interface');
        return this._updateDisplay();
      };

      TranscriptControl.prototype.onToggle = function(evt, data) {
        this.te.transcript.toggle();
        this.isOn = !this.isOn;
        window.kalturaGlobalOptions.transcriptIsOn = this.isOn;
        window.kalturaGlobalOptions.updateTranscriptForOtherPlayers(this.te.mediaElementId, this.isOn);
        return this.te.pushState('user');
      };

      TranscriptControl.prototype.enable = function() {
        return this._view.addClass("enabled");
      };

      TranscriptControl.prototype.disable = function() {
        return this._view.addClass("disabled");
      };

      TranscriptControl.prototype._updateDisplay = function(doScrollFocus) {
        if (doScrollFocus == null) {
          doScrollFocus = true;
        }
        this._view.removeClass("on off").addClass(this.te.transcriptisOn ? "on" : "off");
        this._view.find("img").attr({
          "src": this.te.transcriptisOn ? "" + modulePath + "img/icons-on/1x/transcript-icon.png" : "" + modulePath + "img/icons-off/1x/transcript-icon.png",
          "alt": this.te.transcriptisOn ? "Turn off transcript" : "Turn on transcript"
        });
        this.isOn = this.te.transcriptisOn;
        if (this.te.transcript) {
          if (this.te.transcriptisOn) {
            return this.te.transcript.open(doScrollFocus);
          } else {
            return this.te.transcript.close();
          }
        }
      };

      TranscriptControl.prototype.view = function() {
        return this._view;
      };

      return TranscriptControl;

    })(TEP.EventDispatcher);
    TranscriptPanel = (function(_super) {
      __extends(TranscriptPanel, _super);

      function TranscriptPanel(_view, te) {
        var _this = this;
        this._view = _view;
        this.te = te;
        this.view = __bind(this.view, this);
        this.close = __bind(this.close, this);
        this.open = __bind(this.open, this);
        this.$findTeMediaContainer = __bind(this.$findTeMediaContainer, this);
        this.toggle = __bind(this.toggle, this);
        this.handleCueClick = __bind(this.handleCueClick, this);
        this.scrollToCue = __bind(this.scrollToCue, this);
        this.unlockToTime = __bind(this.unlockToTime, this);
        this.getCurrentCueId = __bind(this.getCurrentCueId, this);
        this.handleCueChange = __bind(this.handleCueChange, this);
        this.setTextTrack = __bind(this.setTextTrack, this);
        this.checkCueChange = __bind(this.checkCueChange, this);
        this.renderTriggerPoint = __bind(this.renderTriggerPoint, this);
        this.enabled = false;
        this.isOpen = false;
        this.currentCue = null;
        this.renderedTriggerPoints = [];
        this.textTrack = null;
        this.autoScrollSwitch = new Switch({
          currentValue: "on",
          disabled: false
        });
        this.autoScrollSwitch.view().find('.switch').on('click', function() {
          return _this.te.pushMetric({
            "transcript_auto-scroll": _this.autoScrollSwitch.currentValue
          }, 'interface');
        });
        this._view.find(".media-transcript-autoscroll-control").append(this.autoScrollSwitch.$dom);
        this.$content = this._view.find(".media-transcript-content ul");
      }

      TranscriptPanel.prototype.renderTriggerPoint = function(cue) {
        var i, j, time, tp, tpKey, _i, _len, _ref, _results;
        _ref = this.te.triggerPoints;
        _results = [];
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          tp = _ref[i];
          _results.push((function() {
            var _j, _len1, _ref1, _results1;
            _ref1 = tp.triggerSequence;
            _results1 = [];
            for (j = _j = 0, _len1 = _ref1.length; _j < _len1; j = ++_j) {
              time = _ref1[j];
              tpKey = "" + i + "." + j;
              if (__indexOf.call(this.renderedTriggerPoints, tpKey) < 0 && Number(time.value) <= cue.startTime) {
                this.$content.append("<li class='media-cue media-transcript-tp' data-cue-start='" + time.value + "'><div class='line-through'></div><div><span>" + tp.displayName + "</span></div><div class='lock-screen'></div></li></div>");
                _results1.push(this.renderedTriggerPoints.push(tpKey));
              } else {
                _results1.push(void 0);
              }
            }
            return _results1;
          }).call(this));
        }
        return _results;
      };

      TranscriptPanel.prototype.checkCueChange = function() {
        var currentCue;
        if (!this.textTrack) {
          this.addTranscriptTrack();
        }
        if (this.textTrack && this.textTrack.activeCues && this.textTrack.activeCues.length) {
          currentCue = this.textTrack.activeCues[0];
          if (currentCue !== this.currentCue) {
            return this.handleCueChange(currentCue);
          }
        }
      };

      TranscriptPanel.prototype.setTextTrack = function() {
        var cue, cueId, i, _i, _len, _ref;
        _ref = this.textTrack.cues;
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          cue = _ref[i];
          cueId = "cue-" + this.te.id + "-" + i;
          this.renderTriggerPoint(cue);
          this.$content.append("<li id='" + cueId + "' data-cue-start='" + cue.startTime + "' class='media-cue'><div><span>" + cue.text + "</span></div><div class='lock-screen'></div></li>");
        }
        this.unlockToTime(this.te.kalturaCurrentTime());
        this.checkCueChange();
        this.$content.find("span").click(this.handleCueClick);
        return this.te.addEventListener("KalturaMediaPlayer.TimeUpdate", this.checkCueChange);
      };

      TranscriptPanel.prototype.handleCueChange = function(newCue) {
        var $cue;
        this.currentCue = newCue;
        this._view.find(".media-cue.active").removeClass("active");
        $cue = this._view.find("#" + this.getCurrentCueId()).addClass("unlocked active");
        $cue.find(".lock-screen").remove();
        if (this.autoScrollSwitch.currentValue === "on") {
          return this.scrollToCue($cue);
        }
      };

      TranscriptPanel.prototype.getCurrentCueId = function() {
        var cue, i, _i, _len, _ref;
        _ref = this.textTrack.cues;
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          cue = _ref[i];
          if (cue === this.currentCue) {
            return "cue-" + this.te.id + "-" + i;
          }
        }
      };

      TranscriptPanel.prototype.unlockToTime = function(time) {
        return this._view.find(".media-cue").each(function(index, item) {
          if ($(item).data("cue-start") <= time) {
            return $(item).addClass("unlocked");
          }
        });
      };

      TranscriptPanel.prototype.scrollToCue = function($cue) {
        return this.$content.animate({
          scrollTop: $cue.position().top + this.$content.scrollTop() - (this.$content.height() * .25),
          duration: 500
        });
      };

      TranscriptPanel.prototype.handleCueClick = function(e) {
        return this.te.seek(Number($(e.currentTarget).closest("li").data("cue-start")));
      };

      TranscriptPanel.prototype.toggle = function() {
        var metricValue;
        if (this.isOpen) {
          this.close();
          metricValue = 'off';
        } else {
          this.open();
          metricValue = 'on';
        }
        return this.te.pushMetric({
          "video_transcript": metricValue
        }, 'interface');
      };

      TranscriptPanel.prototype.$findTeMediaContainer = function() {
        if (!this.$teMediaContainer) {
          this.$teMediaContainer = this.te.$el.find(".te-media").first();
        }
        return this.$teMediaContainer;
      };

      TranscriptPanel.prototype.open = function(doScrollFocus) {
        var $currentCue;
        if (doScrollFocus == null) {
          doScrollFocus = true;
        }
        this.isOpen = true;
        this.te.transcriptisOn = true;
        this.$findTeMediaContainer().addClass("transcript-on");
        if (!this.te.isFullscreen) {
          this.$findTeMediaContainer().addClass("fullscreen-off");
        }
        this._view.show("slide", {
          direction: "right"
        });
        if (doScrollFocus) {
          this._view.find(".media-transcript-autoscroll-control").find(".switch").focus();
        }
        if (this.currentCue) {
          $currentCue = this._view.find("#" + this.getCurrentCueId());
          return this.scrollToCue($currentCue);
        }
      };

      TranscriptPanel.prototype.close = function() {
        var _this = this;
        this.isOpen = false;
        this.te.transcriptisOn = false;
        return this._view.hide("slide", {
          direction: "right"
        }, function() {
          return _this.$findTeMediaContainer().removeClass("transcript-on").removeClass("fullscreen-off");
        });
      };

      TranscriptPanel.prototype.view = function() {
        return this._view;
      };

      return TranscriptPanel;

    })(TEP.EventDispatcher);
    ClosedCaptionControl = (function(_super) {
      __extends(ClosedCaptionControl, _super);

      function ClosedCaptionControl(_view, te) {
        this._view = _view;
        this.te = te;
        this._updateDisplay = __bind(this._updateDisplay, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.view = __bind(this.view, this);
        this.buildTooltip = __bind(this.buildTooltip, this);
        this.onClick = __bind(this.onClick, this);
        this.handleKeypress = __bind(this.handleKeypress, this);
        this.disabled = false;
        this._view.on("click", this.onClick);
        this._view.bind("keydown", this.handleKeypress);
        this._updateDisplay();
        this.buildTooltip();
        Tooltip.hideTooltip(this._view);
      }

      ClosedCaptionControl.prototype.handleKeypress = function(e) {
        var code;
        e.stopPropagation();
        code = e.keyCode ? e.keyCode : e.which;
        if (code === KEY_MAP.selectKey || code === KEY_MAP.submitKey) {
          e.preventDefault();
          return this.onClick();
        }
      };

      ClosedCaptionControl.prototype.onClick = function() {
        var metricValue;
        this.te.captionisOn = !this.te.captionisOn;
        window.kalturaGlobalOptions.captionIsOn = this.te.captionisOn;
        window.kalturaGlobalOptions.updateCaptionForOtherPlayers(this.te.mediaElementId, this.te.captionisOn);
        if (this.te.captionisOn) {
          this.te.kalturaSendNotification("showClosedCaptions");
          metricValue = "on";
        } else {
          this.te.kalturaSendNotification("hideClosedCaptions");
          metricValue = "off";
        }
        this.te.pushState('user');
        this.te.pushMetric({
          "closed_caption": metricValue
        }, 'interface');
        return this._updateDisplay();
      };

      ClosedCaptionControl.prototype.buildTooltip = function() {
        var $selector;
        $selector = this._view;
        Tooltip.buildTooltip($selector, Math.random().toString().substring(8), "Closed Captioning", {
          trigger: 'hover'
        });
        return Tooltip.showTooltip($selector);
      };

      ClosedCaptionControl.prototype.view = function() {
        return this._view;
      };

      ClosedCaptionControl.prototype.disable = function() {
        this.disabled = true;
        return this._updateDisplay();
      };

      ClosedCaptionControl.prototype.enable = function() {
        this.disabled = false;
        return this._updateDisplay();
      };

      ClosedCaptionControl.prototype._updateDisplay = function() {
        this._view.removeClass("on off").addClass(this.te.captionisOn ? "on" : "off");
        this._view.find("img").attr({
          "src": this.te.captionisOn ? "" + modulePath + "img/icons-on/1x/caption-icon.png" : "" + modulePath + "img/icons-off/1x/caption-icon.png",
          "alt": this.te.captionisOn ? "Turn off closed captions" : "Turn on closed captions"
        });
        if (this.disabled) {
          return this._view.addClass("disabled");
        } else {
          return this._view.removeClass("disabled");
        }
      };

      return ClosedCaptionControl;

    })(TEP.EventDispatcher);
    ControlBar = (function(_super) {
      __extends(ControlBar, _super);

      function ControlBar(root, te) {
        this.root = root;
        this.te = te;
        this.disable = __bind(this.disable, this);
        this.hide = __bind(this.hide, this);
        this.show = __bind(this.show, this);
        this.controls = {
          "playpause": new PlayPauseControl(this.root.find(".media-playpause"), this.te),
          "volume": new VolumeControl(this.root.find(".media-volume"), this.te),
          "closedcaption": new ClosedCaptionControl(this.root.find(".media-cc"), this.te),
          "speed": new SpeedControl(this.root.find(".media-speed"), this.te),
          "fullscreen": new FullScreenControl(this.root.find(".media-fullscreen"), this.te),
          "scrubbar": new ScrubBar(this.root.find(".media-scrubbar"), this.te),
          "transcript": new TranscriptControl(this.root.find('.media-tr'), this.te)
        };
      }

      ControlBar.prototype.show = function() {
        return this.root.show();
      };

      ControlBar.prototype.hide = function() {
        if (!this.te.paused) {
          return this.root.hide();
        }
      };

      ControlBar.prototype.disable = function() {
        return this.root.hide();
      };

      return ControlBar;

    })(TEP.EventDispatcher);
    return KalturaMediaPlayer = (function(_super) {
      __extends(KalturaMediaPlayer, _super);

      function KalturaMediaPlayer(data) {
        this.data = data;
        this.onSidebarSearchChange = __bind(this.onSidebarSearchChange, this);
        this.highlightAndScroll = __bind(this.highlightAndScroll, this);
        this.populateTranscriptPanel = __bind(this.populateTranscriptPanel, this);
        this.parseState = __bind(this.parseState, this);
        this.buildState = __bind(this.buildState, this);
        this.onRelatedTEStatusChange = __bind(this.onRelatedTEStatusChange, this);
        this.setTEPreferences = __bind(this.setTEPreferences, this);
        this.toggleFullscreen = __bind(this.toggleFullscreen, this);
        this.buildFullscreenTooltip = __bind(this.buildFullscreenTooltip, this);
        this.fsHandleState = __bind(this.fsHandleState, this);
        this.togglePlay = __bind(this.togglePlay, this);
        this._timeUpdate = __bind(this._timeUpdate, this);
        this._endTimeUpdateInterval = __bind(this._endTimeUpdateInterval, this);
        this._startTimeUpdateInterval = __bind(this._startTimeUpdateInterval, this);
        this.pause = __bind(this.pause, this);
        this.sendPauseEvent = __bind(this.sendPauseEvent, this);
        this.play = __bind(this.play, this);
        this.seek = __bind(this.seek, this);
        this.setTranscript = __bind(this.setTranscript, this);
        this.setClosedCaption = __bind(this.setClosedCaption, this);
        this.setSpeed = __bind(this.setSpeed, this);
        this.setVolume = __bind(this.setVolume, this);
        this.addTranscriptTrack = __bind(this.addTranscriptTrack, this);
        this.kalturaEvaluate = __bind(this.kalturaEvaluate, this);
        this.kalturaSendNotification = __bind(this.kalturaSendNotification, this);
        this.embedKalturaVideo = __bind(this.embedKalturaVideo, this);
        this.addKalturaEventListeners = __bind(this.addKalturaEventListeners, this);
        this.mediaReady = __bind(this.mediaReady, this);
        this.onScreen = __bind(this.onScreen, this);
        this.kalturaCurrentTime = __bind(this.kalturaCurrentTime, this);
        this.media = __bind(this.media, this);
        this.checkEndState = __bind(this.checkEndState, this);
        this.handleTriggerComplete = __bind(this.handleTriggerComplete, this);
        this.handleTriggerState = __bind(this.handleTriggerState, this);
        this.handleTPDisplayRequest = __bind(this.handleTPDisplayRequest, this);
        this.buildDvsView = __bind(this.buildDvsView, this);
        this.checkTriggerPoints = __bind(this.checkTriggerPoints, this);
        this.loadTriggerPoints = __bind(this.loadTriggerPoints, this);
        this.checkTriggerPointCompletion = __bind(this.checkTriggerPointCompletion, this);
        this.pushPlayState = __bind(this.pushPlayState, this);
        this.cleanup = __bind(this.cleanup, this);
        KalturaMediaPlayer.__super__.constructor.call(this, this.data, tmpl);
        this.mediaElementId = this.createId("Kaltura");
        this.$el.find(".media-element").attr("id", this.mediaElementId);
        this.fsWrap = this.$el.find(".te-media");
        this.fsCache = {};
        this.isFullscreen = false;
        this.paused = true;
        this.captionisOn = false;
        this.transcriptisOn = false;
        this.initialized = false;
        this.state = {
          user: {
            maxTime: 0
          },
          te: null
        };
        this._lastPlayheadState = 0;
        this.frozen = false;
        this.ready = false;
        this.allTpComplete = false;
        this._timeUpdateInterval = null;
        this.interrupts = {};
        this.inProgressInterrupt = false;
        this.buildFullscreenTooltip();
        Tooltip.hideTooltip(this._view.find(".media-fullscreen img"));
        if (this.data.descriptiveAudio || this.data.descriptiveContent) {
          this.buildDvsView();
        }
        if ("kalturaDuration" in this.data) {
          this.duration = Math.round(this.data.kalturaDuration / 1000);
        }
        if (this.status !== "complete") {
          this.addEventListener("KalturaMediaPlayer.TimeUpdate", this.pushPlayState);
        }
        fs.bind(this.fsHandleState);
        TEP.addEventListener("TEP.RelatedTEStatusChange", this.onRelatedTEStatusChange);
      }

      KalturaMediaPlayer.prototype.buttonBayBuildButtons = function() {
        return null;
      };

      KalturaMediaPlayer.prototype.cleanup = function() {
        return fs.unbind(this.fsHandleState);
      };

      KalturaMediaPlayer.prototype.pushPlayState = function(e, data) {
        var currentTime;
        currentTime = data.time;
        if ((currentTime - this._lastPlayheadState >= STATE_FREQUENCY) || this.checkTriggerPoints()) {
          this._lastPlayheadState = currentTime;
          return this.pushState("user");
        }
      };

      KalturaMediaPlayer.prototype.checkTriggerPointCompletion = function() {
        var allTpComplete, id, intrrpt, _ref;
        allTpComplete = true;
        this.inProgressInterrupt = false;
        _ref = this.interrupts;
        for (id in _ref) {
          intrrpt = _ref[id];
          if (intrrpt.status !== "complete") {
            if (intrrpt.status === "in-progress") {
              this.inProgressInterrupt = id;
            }
            allTpComplete = false;
            break;
          }
        }
        return this.allTpComplete = allTpComplete;
      };

      KalturaMediaPlayer.prototype.loadTriggerPoints = function(triggerPointData) {
        var tp, tpPreview, triggerPointLinkId, _i, _len, _ref;
        KalturaMediaPlayer.__super__.loadTriggerPoints.call(this, triggerPointData);
        this.interrupts = {};
        if ((this.triggerPoints != null) && this.triggerPoints.length > 0) {
          _ref = this.triggerPoints;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            tp = _ref[_i];
            tpPreview = new TPPreview(tp);
            tpPreview.on("requestTPDisplay", this.handleTPDisplayRequest);
            this.interrupts[tp.id] = tpPreview;
            this.$el.find(".trigger-point-data").append("<tr><td>" + tp.data.display_name + "</td><td>at " + tp.data.trigger_sequence[0].value + " seconds</td></tr>");
          }
          this.checkTriggerPointCompletion();
          triggerPointLinkId = this.createId("triggerPointLink");
          this.triggerPointBay._view.attr("id", triggerPointLinkId);
          this.$el.find(".trigger-point-link").attr("href", "#" + triggerPointLinkId);
        } else {
          this.$el.find(".trigger-point-data").remove();
        }
        this.controlBar = new ControlBar(this.$el.find(".media-controlbar"), this);
        return this.transcript = new TranscriptPanel(this.$el.find('.media-transcript-panel'), this);
      };

      KalturaMediaPlayer.prototype.checkTriggerPoints = function(e) {
        var id, incompleteTriggerPointReached, ip, _ref;
        this.kalturaCurrentTime();
        incompleteTriggerPointReached = false;
        _ref = this.interrupts;
        for (id in _ref) {
          ip = _ref[id];
          if (ip.timestamp <= this.state.user.maxTime && ip.status !== "complete") {
            incompleteTriggerPointReached = true;
            this.transcript.unlockToTime(ip.timestamp);
            this.pause(false, false);
            if (this.isFullscreen) {
              this.toggleFullscreen();
            }
            this.$el.find(".media-tp-screen").stop().css({
              "display": "table",
              "opacity": 0
            }).animate({
              opacity: 0.01
            }, {
              duration: 250
            });
            if (!this.frozen) {
              this.raiseTriggerPoint(ip.id);
              ip.setStatus("in-progress");
              this.inProgressInterrupt = ip.id;
              this.frozen = true;
            }
          }
        }
        return incompleteTriggerPointReached;
      };

      KalturaMediaPlayer.prototype.buildDvsView = function() {
        var dvsCheckboxClick,
          _this = this;
        dvsCheckboxClick = function(evt) {
          var metricValue;
          _this.dvs_open = !_this.dvs_open;
          metricValue = _this.dvs_open ? {
            dvs: 'open'
          } : {
            dvs: 'close'
          };
          return _this.pushMetric(metricValue, 'interface');
        };
        this.dvs_open = false;
        this.$el.find('.descriptive-content').append($(_.template(dvsTmpl)({
          text: this.data.descriptiveContent,
          showAudioIcon: this.data.descriptiveAudio ? true : false
        })));
        this.$el.find("input:checkbox").on('click', dvsCheckboxClick);
        if (this.data.descriptiveAudio) {
          this.audioDescription = new AudioPLayer(this.data.descriptiveAudio);
          this.audioDescription.addEventListener('Audio.MetricsUpdate', function(evt, metricData) {
            return _this.pushMetric(metricData.value, metricData.category);
          });
          this.audioDescription.addEventListener('Audio.VolumeUpdate', function(evt, value) {
            _this.setVolume(value, false);
            return _this.controlBar.controls.volume.value(value);
          });
          return this.$el.find('.descriptive-audio').append(this.audioDescription.$el);
        }
      };

      KalturaMediaPlayer.prototype.handleTPDisplayRequest = function(evt, data) {
        return this.displayTriggerPoint(data.id);
      };

      KalturaMediaPlayer.prototype.handleTriggerState = function(tp) {
        var id, ip, _ref, _results;
        _ref = this.interrupts;
        _results = [];
        for (id in _ref) {
          ip = _ref[id];
          if (id === tp.id) {
            _results.push(ip.setStatus(tp.status));
          }
        }
        return _results;
      };

      KalturaMediaPlayer.prototype.handleTriggerComplete = function(tp) {
        var _this = this;
        this.frozen = false;
        this.$el.find(".media-tp-screen").stop().animate({
          opacity: 0
        }, {
          duration: 250,
          complete: function() {
            return _this.$el.find(".media-tp-screen").css("display", "none");
          }
        });
        this.$el.find(".media-playpause").focus();
        $(window).scrollTop(this.$el.find(".media").offset().top + 200);
        this.inProgressInterrupt = false;
        return this.checkEndState();
      };

      KalturaMediaPlayer.prototype.checkEndState = function() {
        var delta;
        delta = 5;
        if (this.status === "complete") {
          return false;
        }
        this.checkTriggerPointCompletion();
        if ((this.playbackEnded || this.duration < this.state.user.maxTime + delta) && this.allTpComplete) {
          this.pause(false, false);
          return this.end();
        }
      };

      KalturaMediaPlayer.prototype.media = function() {
        return this.kalturaPlayer;
      };

      KalturaMediaPlayer.prototype.kalturaCurrentTime = function() {
        var playerTime;
        playerTime = this.kalturaEvaluate("video.player.currentTime");
        this.state.user.maxTime = Math.max(this.state.user.maxTime, playerTime || 0);
        return playerTime;
      };

      KalturaMediaPlayer.prototype.onScreen = function() {
        var _this = this;
        this.populateTranscriptPanel();
        if (window.globals.searchPhrase && this.data.kalturaCaption) {
          this.highlightAndScroll(true);
        }
        KalturaMediaPlayer.__super__.onScreen.apply(this, arguments);
        this.pullState();
        return KalturaPlayerPromise.then(function() {
          _this.addKalturaEventListeners();
          _this.mediaReady();
          return _this.checkTriggerPoints();
        });
      };

      KalturaMediaPlayer.prototype.mediaReady = function() {
        var scrubbar;
        this.duration = this.duration || this.kalturaEvaluate("duration");
        if (!this.duration) {
          return;
        }
        $($("#" + this.mediaElementId + "_ifp").contents().find(".mwEmbedPlayer")[0]).css("cursor", "default");
        scrubbar = this.controlBar.controls.scrubbar;
        scrubbar.updateBar("playerReady");
        scrubbar.addTriggerPoints();
        return this.$el.find(".media-center-wrap").attr("class", "media-center-wrap");
      };

      KalturaMediaPlayer.prototype.addKalturaEventListeners = function() {
        var _this = this;
        if (this.ready) {
          return;
        }
        kWidget.addReadyCallback(function(playerId) {
          if (playerId !== _this.mediaElementId) {
            return;
          }
          _this.kalturaPlayer = document.getElementById(playerId);
          _this.kalturaPlayer.kBind("doPlay.hbxKalturaPlugins", function() {
            _this.paused = false;
            return _this.dispatchEvent("playing", _this);
          });
          _this.kalturaPlayer.kBind('doPlay.hbxInitialPlay', function() {
            _this.kalturaPlayer.kUnbind('doPlay.hbxInitialPlay');
            _this.setVolume(_this.controlBar.controls.volume.getVolume(), false);
            if ((_this.seekTime != null) && _this.seekTime > 0) {
              return _this.seek(_this.seekTime, false);
            }
          });
          _this.kalturaPlayer.kBind("mediaReady.hbxKalturaPlugins", function() {
            _this.kalturaPlayer.kUnbind("mediaReady.hbxKalturaPlugins");
            _this.mediaReady();
            _this._startTimeUpdateInterval();
            if (_this.status === 'unlocked') {
              _this.start();
            }
            return _this.checkEndState();
          });
          _this.kalturaPlayer.kBind("bufferProgress", function() {
            if (location.href.indexOf("?__QASpeedIt") > -1) {
              _this.setSpeed(15, false);
            } else {
              _this.setSpeed(_this.controlBar.controls.speed.getSpeed(), false);
            }
            return _this.kalturaPlayer.kUnbind("bufferProgress");
          });
          _this.kalturaPlayer.kBind("bytesTotalChange", function() {
            if (!_this.captionisOn) {
              _this.kalturaSendNotification("hideClosedCaptions");
            }
            return _this.kalturaPlayer.kUnbind("bytesTotalChange");
          });
          _this.kalturaPlayer.kBind("ccDataLoaded.hbxKalturaPlugins", function(data) {
            _this.transcriptTrackId = data[0].id;
            if (!_this.seekTime) {
              return _this.addTranscriptTrack();
            }
          });
          _this.kalturaPlayer.kBind("playerSeekEnd.hbxKalturaPlugins", function() {
            if (_this.seekTime != null) {
              _this.addTranscriptTrack();
              _this._timeUpdate(_this.seekTime);
              _this.seekTime = null;
            }
            if (_this.paused) {
              return _this.pause(false);
            }
          });
          return _this.kalturaPlayer.kBind("playerPlayEnd.hbxKalturaPlugins", function() {
            _this.playbackEnded = true;
            _this._lastPlayheadState = _this.duration;
            _this.state.user.maxTime = _this.duration;
            _this.checkEndState();
            _this.controlBar.controls.scrubbar.updateBar("playerPlayEnd", _this.duration);
            return _this.sendPauseEvent();
          });
        });
        return this.embedKalturaVideo();
      };

      KalturaMediaPlayer.prototype.embedKalturaVideo = function() {
        var doThumbEmbed,
          _this = this;
        doThumbEmbed = function() {
          _this.controlBar.controls.scrubbar.updateBar("init");
          if (_this.preferences) {
            if (_this.preferences.closedcaption) {
              _this.captionisOn = true;
              _this.controlBar.controls.closedcaption._updateDisplay();
            }
            if (_this.preferences.transcript) {
              _this.transcriptisOn = true;
              _this.controlBar.controls.transcript._updateDisplay();
            }
            if (_this.preferences.volume >= 0) {
              _this.volume = _this.preferences.volume;
              _this.setVolume(_this.preferences.volume, false, false);
              _this.controlBar.controls.volume.value(_this.preferences.volume);
            }
            if (_this.preferences.speed) {
              _this.setSpeed(_this.preferences.speed, false, false);
              _this.controlBar.controls.speed.value(_this.preferences.speed);
              _this.controlBar.controls.speed.updateSpeedSlider(_this.preferences.speed);
            }
          }
          _this.ready = true;
          _this.dispatchEvent("ready", _this);
          return kWidget.thumbEmbed({
            "targetId": _this.mediaElementId,
            "wid": "_" + KALTURA_PARTNER_ID,
            "uiconf_id": KALTURA_PLAYER_ID,
            "entry_id": _this.data.kalturaId,
            "flashvars": {
              "autoPlay": false,
              "disableOnScreenClick": true,
              "controlBarContainer.plugin": false,
              "largePlayBtn.plugin": false,
              "loadingSpinner.plugin": true
            },
            "params": {
              "wmode": "transparent"
            }
          });
        };
        window.kalturaGlobalOptions.players[this.mediaElementId] = this;
        return doThumbEmbed();
      };

      KalturaMediaPlayer.prototype.kalturaSendNotification = function(event, val) {
        if (val == null) {
          val = null;
        }
        try {
          if (val != null) {
            return this.media().sendNotification(event, val);
          } else {
            return this.media().sendNotification(event);
          }
        } catch (_error) {

        }
      };

      KalturaMediaPlayer.prototype.kalturaEvaluate = function(item) {
        if (this.media()) {
          return this.media().evaluate("{" + item + "}");
        }
      };

      KalturaMediaPlayer.prototype.addTranscriptTrack = function() {
        var cue, _i, _len, _ref,
          _this = this;
        if (this.transcript.textTrack) {
          this.transcript.unlockToTime(this.seekTime ? this.seekTime : this.te.kalturaCurrentTime());
          this.transcript.checkCueChange();
          return;
        } else if (!this.transcriptTrackId) {
          return;
        }
        this.video = $($("#" + this.mediaElementId + "_ifp").contents().find("video")[0]);
        this.video.attr("crossorigin", "Anonymous");
        this.video.find('track[kind=metadata]').each(function(item) {
          var track;
          track = item.prop('track');
          return track.mode = "disabled";
        }).remove();
        this.transcript.textTrack = this.video[0].addTextTrack("metadata", "English", "en-us");
        this.transcript.textTrack.mode = "hidden";
        this.transcript.$content.empty();
        _ref = captionator.parseCaptions(this.data.kalturaCaption);
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          cue = _ref[_i];
          this.transcript.textTrack.addCue(new VTTCue(cue.startTime, cue.endTime, cue.text));
        }
        return this.transcript.setTextTrack();
      };

      KalturaMediaPlayer.prototype.setVolume = function(vol, sendMetric, updateOtherPlayers) {
        if (sendMetric == null) {
          sendMetric = true;
        }
        if (updateOtherPlayers == null) {
          updateOtherPlayers = true;
        }
        this.kalturaSendNotification("changeVolume", vol);
        this.$el.find(".media-volume-control .component-slider-slider").attr({
          "aria-valuenow": vol,
          "aria-valuetext": "" + (Math.round(vol * 100)) + " percent"
        });
        if (sendMetric) {
          this.pushMetric({
            "volume_change": vol
          }, "interface");
        }
        if (updateOtherPlayers) {
          window.kalturaGlobalOptions.volume = vol;
          return window.kalturaGlobalOptions.updateVolumeForOtherPlayers(this.mediaElementId, vol);
        }
      };

      KalturaMediaPlayer.prototype.setSpeed = function(spd, sendMetric, updateOtherPlayers) {
        if (sendMetric == null) {
          sendMetric = true;
        }
        if (updateOtherPlayers == null) {
          updateOtherPlayers = true;
        }
        this._endTimeUpdateInterval();
        if (sendMetric) {
          this.pushMetric({
            "speed_change": spd
          }, "interface");
        }
        if (!this.paused) {
          this._startTimeUpdateInterval();
        }
        this.kalturaSendNotification("playbackRateChangeSpeed", spd);
        if (updateOtherPlayers) {
          window.kalturaGlobalOptions.speed = spd;
          return window.kalturaGlobalOptions.updateSpeedForOtherPlayers(this.mediaElementId, spd);
        }
      };

      KalturaMediaPlayer.prototype.setClosedCaption = function(cc) {
        return this.media().closedCaption = cc;
      };

      KalturaMediaPlayer.prototype.setTranscript = function(tr) {
        return this.media().transcript = tr;
      };

      KalturaMediaPlayer.prototype.seek = function(time, sendMetric) {
        if (sendMetric == null) {
          sendMetric = true;
        }
        if (this.frozen) {
          return;
        }
        this.seekTime = time;
        this.transcript.unlockToTime(this.seekTime);
        this.controlBar.controls.scrubbar.updateBar("seek", this.seekTime);
        if (sendMetric) {
          this.pushMetric({
            "seek": this.seekTime
          }, "interface");
        }
        return this.kalturaSendNotification("doSeek", this.seekTime);
      };

      KalturaMediaPlayer.prototype.play = function() {
        if (this.frozen) {
          return;
        }
        this.paused = false;
        this.pushMetric({
          "play": this.kalturaCurrentTime()
        }, "interface");
        this.dispatchEvent("playing", this);
        this._startTimeUpdateInterval();
        this.pushState("user");
        if (location.href.indexOf("?__QASpeedIt") > -1) {
          this.setSpeed(15, false);
        }
        return this.kalturaSendNotification("doPlay");
      };

      KalturaMediaPlayer.prototype.sendPauseEvent = function() {
        this.paused = true;
        this._endTimeUpdateInterval();
        return this.dispatchEvent("pause", this);
      };

      KalturaMediaPlayer.prototype.pause = function(sendMetric, pushState) {
        var _ref;
        if (sendMetric == null) {
          sendMetric = true;
        }
        if (pushState == null) {
          pushState = true;
        }
        if (this.frozen) {
          return;
        }
        this.sendPauseEvent();
        if (sendMetric) {
          this.pushMetric({
            "pause": this.kalturaCurrentTime()
          }, "interface");
        }
        if (pushState && ((_ref = this.status) === "in-progress" || _ref === "complete")) {
          this.pushState("user");
        }
        return this.kalturaSendNotification("doPause");
      };

      KalturaMediaPlayer.prototype._startTimeUpdateInterval = function() {
        clearInterval(this._timeUpdateInterval);
        if (!this.frozen) {
          return this._timeUpdateInterval = setInterval(this._timeUpdate, 100 / this.controlBar.controls.speed.getSpeed());
        }
      };

      KalturaMediaPlayer.prototype._endTimeUpdateInterval = function() {
        return clearInterval(this._timeUpdateInterval);
      };

      KalturaMediaPlayer.prototype._timeUpdate = function(time) {
        if (time == null) {
          time = this.kalturaCurrentTime();
        }
        return this.dispatchEvent("KalturaMediaPlayer.TimeUpdate", {
          time: time
        });
      };

      KalturaMediaPlayer.prototype.togglePlay = function() {
        var playBtnId;
        if (this.inProgressInterrupt) {
          return this.raiseTriggerPoint(this.inProgressInterrupt);
        }
        if (!this.initialized) {
          this.initialized = true;
          playBtnId = this.mediaElementId + "_playBtn";
          return this.$el.find("#" + playBtnId).click();
        }
        if (this.paused) {
          return this.play();
        } else {
          return this.pause();
        }
      };

      KalturaMediaPlayer.prototype.fsPreventScroll = function() {
        return $("html, body").css({
          height: $(window).height(),
          padding: 0,
          margin: 0,
          overflow: "hidden"
        });
      };

      KalturaMediaPlayer.prototype.fsFreeScroll = function() {
        return $("html, body").css({
          height: "",
          padding: "",
          margin: "",
          overflow: ""
        });
      };

      KalturaMediaPlayer.prototype.fsHandleState = function(e) {
        if (fs.isFullScreen()) {
          this.fsWrap.addClass("fullscreen").removeClass("fullscreen-off").css("padding", "0");
          this._view.find(".media-fullscreen img").attr("src", "" + modulePath + "img/icons-on/1x/full-screen-close.png");
          return $("body").css("background", "#000");
        } else {
          this.fsWrap.removeClass("fullscreen").addClass("fullscreen-off");
          this._view.find(".media-fullscreen img").attr("src", "" + modulePath + "img/icons-off/1x/full-screen-icon.png");
          return $("body").css("background", "");
        }
      };

      KalturaMediaPlayer.prototype.buildFullscreenTooltip = function() {
        var $selector;
        $selector = this._view.find(".media-fullscreen img");
        Tooltip.buildTooltip($selector, Math.random().toString().substring(8), "Fullscreen", {
          trigger: 'hover'
        });
        return Tooltip.showTooltip($selector);
      };

      KalturaMediaPlayer.prototype.toggleFullscreen = function() {
        var isPlaying;
        if (this.isFullscreen) {
          if (fs.fullscreenEnabled()) {
            fs.cancelFullScreen();
          } else {
            this.fsFreeScroll();
            isPlaying = !this.media().paused;
            this.$el.prepend($(".te-media.pseudo-fullscreen"));
            if (isPlaying) {
              this.play();
            }
            $(".media-controlbar").removeClass("fullscreen-manual");
            this.fsWrap.removeClass("pseudo-fullscreen");
            $(window).scrollTop(this.fsCache.scrollTop);
          }
          this.isFullscreen = false;
        } else {
          if (fs.fullscreenEnabled()) {
            fs.requestFullScreen(this.fsWrap.get(0));
          } else {
            this.fsCache.scrollTop = $(window).scrollTop();
            $(window).scrollTop(0);
            this.fsWrap.addClass("pseudo-fullscreen");
            isPlaying = !this.media().paused;
            $("body").prepend(this.fsWrap);
            $(".media-controlbar").addClass("fullscreen-manual");
            if (isPlaying) {
              this.play();
            }
            this.fsPreventScroll();
          }
          this.isFullscreen = true;
        }
        return this.pushMetric({
          "fullscreen": this.isFullscreen
        }, "interface");
      };

      KalturaMediaPlayer.prototype.setTEPreferences = function(prefs) {
        var speed, vol;
        if (this.audioDescription) {
          this.audioDescription.setTEPreferences(prefs);
        }
        if (window.kalturaGlobalOptions.volume != null) {
          prefs.volume = window.kalturaGlobalOptions.volume;
        }
        if (window.kalturaGlobalOptions.speed != null) {
          prefs.speed = window.kalturaGlobalOptions.speed;
        }
        if (window.kalturaGlobalOptions.captionIsOn != null) {
          prefs.closedcaption = window.kalturaGlobalOptions.captionIsOn;
        }
        if (window.kalturaGlobalOptions.transcriptIsOn != null) {
          prefs.transcript = window.kalturaGlobalOptions.transcriptIsOn;
        }
        if (prefs.volume != null) {
          vol = prefs.volume;
          this.controlBar.controls.volume.value(vol);
          this.setVolume(vol, false);
        }
        if (prefs.speed != null) {
          speed = prefs.speed;
          this.controlBar.controls.speed.value(speed);
          this.setSpeed(speed, false);
        }
        if (prefs.closedcaption != null) {
          this.controlBar.controls.closedcaption.te.captionisOn = prefs.closedcaption;
          this.controlBar.controls.closedcaption._updateDisplay();
        }
        if (prefs.transcript != null) {
          this.controlBar.controls.transcript.te.transcriptisOn = prefs.transcript;
          this.controlBar.controls.transcript._updateDisplay();
          if (prefs.transcript) {
            return this.transcript.open();
          } else {
            return this.transcript.close();
          }
        }
      };

      KalturaMediaPlayer.prototype.onRelatedTEStatusChange = function(evt, data) {
        if (data.source.id !== this.id) {
          return this.setTEPreferences(data);
        }
      };

      KalturaMediaPlayer.prototype.buildState = function(scope, op) {
        var s;
        s = KalturaMediaPlayer.__super__.buildState.call(this, scope, op);
        if (window.kalturaGlobalOptions.volume != null) {
          s.volume = window.kalturaGlobalOptions.volume;
        } else {
          s.volume = this.controlBar.controls.volume.getVolume();
        }
        if (window.kalturaGlobalOptions.volume != null) {
          s.speed = window.kalturaGlobalOptions.speed;
        } else {
          s.speed = this.controlBar.controls.speed.getSpeed();
        }
        if (window.kalturaGlobalOptions.captionIsOn != null) {
          s.closedcaption = window.kalturaGlobalOptions.captionIsOn;
        } else {
          s.closedcaption = this.controlBar.controls.closedcaption.te.captionisOn;
        }
        if (window.kalturaGlobalOptions.transcriptIsOn != null) {
          s.transcript = window.kalturaGlobalOptions.transcriptIsOn;
        } else {
          s.transcript = this.controlBar.controls.transcript.isOn;
        }
        switch (scope) {
          case "user":
            s.timestamp = this.kalturaCurrentTime() ? this.kalturaCurrentTime() : this._lastPlayheadState;
            s.maxTime = this.state.user.maxTime;
            s.duration = this.duration;
        }
        return s;
      };

      KalturaMediaPlayer.prototype.parseState = function(data) {
        var scope, state, _ref, _results;
        KalturaMediaPlayer.__super__.parseState.call(this, data);
        _ref = data.states;
        _results = [];
        for (scope in _ref) {
          state = _ref[scope];
          if (window.kalturaGlobalOptions.volume != null) {
            state.volume = window.kalturaGlobalOptions.volume;
          }
          if (window.kalturaGlobalOptions.speed != null) {
            state.speed = window.kalturaGlobalOptions.speed;
          }
          if (window.kalturaGlobalOptions.captionIsOn != null) {
            state.closedcaption = window.kalturaGlobalOptions.captionIsOn;
          }
          if (window.kalturaGlobalOptions.transcriptIsOn != null) {
            state.transcript = window.kalturaGlobalOptions.transcriptIsOn;
          }
          switch (scope) {
            case "user":
              this.duration = this.duration || state.duration || 0;
              this.state.user = state;
              this.state.user.maxTime = this.state.user.maxTime || 0;
              if (state.timestamp != null) {
                _results.push(this.seekTime = state.timestamp);
              } else {
                _results.push(void 0);
              }
              break;
            case "user/te":
              if (this.preferences != null) {
                if (!('closedcaption' in this.preferences) && ('closedcaption' in state)) {
                  this.preferences.closedcaption = state.closedcaption;
                }
                if (!('transcript' in this.preferences) && ('transcript' in state)) {
                  this.preferences.transcript = state.transcript;
                }
                if (!('volume' in this.preferences) && ('volume' in state)) {
                  this.preferences.volume = state.volume;
                }
                if (!('speed' in this.preferences) && ('speed' in state)) {
                  _results.push(this.preferences.speed = state.speed);
                } else {
                  _results.push(void 0);
                }
              } else {
                _results.push(this.preferences = state);
              }
              break;
            default:
              _results.push(void 0);
          }
        }
        return _results;
      };

      KalturaMediaPlayer.prototype.populateTranscriptPanel = function() {
        var $cueDiv, $cueLi, $cueSpan, cue, i, _i, _len, _ref;
        if (!this.data.kalturaCaption) {
          return;
        }
        _ref = captionator.parseCaptions(this.data.kalturaCaption);
        for (i = _i = 0, _len = _ref.length; _i < _len; i = ++_i) {
          cue = _ref[i];
          this.transcript.renderTriggerPoint(cue);
          $cueSpan = $('<span>', {
            'html': cue.text.getPlain()
          });
          $cueDiv = $('<div>').append($cueSpan);
          $cueLi = $('<li>', {
            'id': "cue-" + this.id + "-" + i,
            'data-cue-start': cue.startTime,
            'class': 'media-cue'
          }).append($cueDiv);
          if (cue.startTime <= (this.state.user.timestamp || 0)) {
            $cueLi.addClass('unlocked');
          } else {
            $cueLi.append($('<div>', {
              'class': 'lock-screen'
            }));
          }
          this.transcript.$content.append($cueLi);
        }
        return this.transcript.renderedTriggerPoints = [];
      };

      KalturaMediaPlayer.prototype.highlightAndScroll = function(isFirstLoad) {
        var $firstHighlight, $firstHighlightParentLi, $transcriptContentDiv, $transcriptHighlights, scrollFunc, scrollTop,
          _this = this;
        if (isFirstLoad == null) {
          isFirstLoad = false;
        }
        if (isFirstLoad) {
          TEP.addHighlights(this.transcript.$content);
        }
        $transcriptHighlights = $(this.transcript.$content.selector + ' ' + this.getHighlights().selector);
        if ($transcriptHighlights.length) {
          if (!this.transcript.isOpen) {
            this.transcript.open(false);
          }
          $firstHighlight = $transcriptHighlights.eq(0);
          $firstHighlightParentLi = $firstHighlight.parents('li').eq(0);
          $transcriptContentDiv = $(this.transcript.$content.parent());
          scrollTop = $firstHighlightParentLi.position().top + this.transcript.$content.scrollTop() - ($transcriptContentDiv.height() * .25);
          scrollFunc = function() {
            return _this.transcript.$content.animate({
              scrollTop: scrollTop,
              duration: 500
            });
          };
          if (isFirstLoad) {
            return this.addEventListener("ready", scrollFunc);
          } else {
            return scrollFunc();
          }
        }
      };

      KalturaMediaPlayer.prototype.onSidebarSearchChange = function(searchPhrase) {
        KalturaMediaPlayer.__super__.onSidebarSearchChange.call(this, searchPhrase);
        if (this.getHighlights().length) {
          return this.highlightAndScroll();
        }
      };

      return KalturaMediaPlayer;

    })(TEP.TeachingElement);
  });

}).call(this);
