// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var BaseModel, Model, Option;
    BaseModel = require('tep/utils/model');
    Option = require('./option');
    return Model = (function(_super) {
      __extends(Model, _super);

      function Model(data) {
        this.getSelection = __bind(this.getSelection, this);
        this["export"] = __bind(this["export"], this);
        this["import"] = __bind(this["import"], this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.toggleSelection = __bind(this.toggleSelection, this);
        var keys, o, options, _i, _len, _ref;
        Model.__super__.constructor.call(this, data);
        options = {};
        keys = [];
        _ref = this.get('options');
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          o = _ref[_i];
          options[o.id] = new Option(o);
          keys.push(o.id);
        }
        this.set('options', options);
        this.set('optionKeys', keys);
      }

      Model.prototype.toggleSelection = function(optId) {
        var change, id, opt, _ref;
        if (!this.get("disabled")) {
          change = false;
          if (this.get("singleResponse")) {
            if (!this.get("options." + optId + ".selected")) {
              _ref = this.get("options");
              for (id in _ref) {
                opt = _ref[id];
                opt.set("selected", id === optId);
              }
              change = true;
            }
          } else {
            this.set("options." + optId + ".selected", !this.get("options." + optId + ".selected"));
            change = true;
          }
          if (change) {
            return this.dispatchEvent('Multiselect.SelectionChange', {
              selection: this.getSelection()
            });
          }
        }
      };

      Model.prototype.disable = function() {
        return this.set("disabled", true);
      };

      Model.prototype.enable = function() {
        return this.set("disabled", false);
      };

      Model.prototype["import"] = function(data) {
        var id, _i, _len, _ref, _results;
        _ref = data.selection;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          id = _ref[_i];
          _results.push(this.set("options." + id + ".selected", true));
        }
        return _results;
      };

      Model.prototype["export"] = function() {
        return {
          selection: this.getSelection()
        };
      };

      Model.prototype.getSelection = function() {
        var id, opt, _ref, _results;
        _ref = this.get("options");
        _results = [];
        for (id in _ref) {
          opt = _ref[id];
          if (opt.get("selected")) {
            _results.push(id);
          }
        }
        return _results;
      };

      return Model;

    })(BaseModel);
  });

}).call(this);
