// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, BaseModel, Comment, Model, Utils;
    $ = require('jquery');
    BaseModel = require('tep/utils/model');
    Utils = require('tep/utils/utils');
    Comment = require('./comment');
    return Model = (function(_super) {
      __extends(Model, _super);

      function Model(data) {
        this.answerHistoryView = __bind(this.answerHistoryView, this);
        this.toggleCommentLike = __bind(this.toggleCommentLike, this);
        this.createComment = __bind(this.createComment, this);
        this.bubbleMetric = __bind(this.bubbleMetric, this);
        this._handleConversationData = __bind(this._handleConversationData, this);
        this._loadConversationData = __bind(this._loadConversationData, this);
        this.loadConversation = __bind(this.loadConversation, this);
        Model.__super__.constructor.call(this, data);
      }

      Model.prototype.loadConversation = function(data, callback) {
        this.set('title', data.title);
        this.set('preamble', data.preamble);
        return this._loadConversationData(data.id, callback);
      };

      Model.prototype._loadConversationData = function(id, callback) {
        var _this = this;
        return $.ajax({
          url: Utils.normalizeUrl("/conversation/" + id),
          success: function(data) {
            _this._handleConversationData(data);
            if (callback != null) {
              return callback();
            }
          }
        });
      };

      Model.prototype._handleConversationData = function(data) {
        var c, cd, comments, oldId, _i, _j, _len, _len1, _ref, _ref1;
        if (this.get('conversation.comments')) {
          _ref = this.get('conversation.comments');
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            c = _ref[_i];
            c.removeEventListener('Conversation.MetricRequest', this.bubbleMetric);
          }
        }
        comments = [];
        _ref1 = data.comments;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          cd = _ref1[_j];
          cd.calledFromBeforeAndAfter = this._data.calledFromBeforeAndAfter;
          cd.beforeAndAfterId = this._data.beforeAndAfterId;
          c = new Comment(cd);
          c.addEventListener('Conversation.MetricRequest', this.bubbleMetric);
          comments.push(c);
        }
        oldId = this.get('conversation.id');
        this.set('conversation', {
          id: data.id,
          comments: comments,
          disabled: data.disabled
        });
        if (oldId !== data.id) {
          return this.dispatchEvent('Conversation.ConversationChanged', {});
        }
      };

      Model.prototype.bubbleMetric = function(evt, data) {
        data.metric.conversation_id = this.get('conversation.id');
        return this.dispatchEvent(evt, data);
      };

      Model.prototype.createComment = function(data, purify_warning_shown) {
        var current_tei_id,
          _this = this;
        current_tei_id = null;
        if (this._data.calledFromBeforeAndAfter) {
          current_tei_id = this._data.beforeAndAfterId;
        }
        if (!this.get('conversation.disabled')) {
          return $.ajax({
            url: Utils.normalizeUrl("/conversation/" + (this.get('conversation.id')) + "/comment", "POST"),
            type: "POST",
            data: JSON.stringify({
              comment: data.comment,
              purify_warning_shown: purify_warning_shown,
              current_tei_id: current_tei_id
            }),
            success: function(data) {
              $(".tooltip").hide();
              return _this._loadConversationData(_this.get('conversation.id'), function() {
                return _this.dispatchEvent('Conversation.CommentAccepted', {});
              });
            }
          });
        }
      };

      Model.prototype.toggleCommentLike = function(comment_id) {
        var comment, _i, _len, _ref;
        _ref = this.get('conversation.comments');
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          comment = _ref[_i];
          if (comment.get('id') === comment_id) {
            comment.toggleLike(this.get('conversation.id'));
            return;
          }
        }
      };

      Model.prototype.answerHistoryView = function() {
        var disp, metric;
        metric = {
          "conversation_id": this.get('conversation.id')
        };
        disp = this.get('display_history') != null ? this.get('display_history') : "hide";
        metric.display_history = disp === "hide" ? "show" : "hide";
        this.set('display_history', metric.display);
        return this.dispatchEvent('Conversation.MetricRequest', {
          bubbles: true,
          metric: metric,
          category: 'show_hide_answer_history'
        });
      };

      return Model;

    })(BaseModel);
  });

}).call(this);
