// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var BaseModel, Model, SubstateMachine;
    BaseModel = require('tep/utils/model');
    SubstateMachine = require('./ssm');
    return Model = (function(_super) {
      __extends(Model, _super);

      function Model(data) {
        this.createCssId = __bind(this.createCssId, this);
        this.onStateChange = __bind(this.onStateChange, this);
        this["export"] = __bind(this["export"], this);
        this.importAggregateData = __bind(this.importAggregateData, this);
        this["import"] = __bind(this["import"], this);
        this.nextSubState = __bind(this.nextSubState, this);
        this.getSubState = __bind(this.getSubState, this);
        this.onDataChange = __bind(this.onDataChange, this);
        var sliderDefaultValue, sliderInput;
        Model.__super__.constructor.call(this, data);
        this.set('selectedAnswers', []);
        this.ssm = new SubstateMachine(this.get('reflection.use'));
        this.ssm.traverse();
        this.ssm.addEventListener("StateMachine.StateChange", this.onStateChange);
        if (data.response.numeric && data.response.numeric.sliderInput) {
          sliderInput = data.response.numeric.sliderInput;
          sliderDefaultValue = data.response.numeric.sliderDefault;
          if (sliderInput) {
            this.set('selectedAnswers', [sliderDefaultValue.toString()]);
            this.ssm.traverse();
          }
        }
        this.addEventListener('Model.Change', this.onDataChange);
      }

      Model.prototype.onDataChange = function(evt, data) {
        switch (data.path) {
          case "selectedAnswers":
            if (data.value.length === 0 || data.value[0] === "") {
              return this.ssm.cancel();
            } else if (this.getSubState() === "response") {
              return this.ssm.traverse();
            }
            break;
          case "reflection.value":
            if (data.value === "") {
              return this.ssm.cancel();
            } else if (this.getSubState() === "reflection") {
              return this.ssm.traverse();
            }
        }
      };

      Model.prototype.getSubState = function() {
        return this.ssm.currentState();
      };

      Model.prototype.nextSubState = function() {
        return this.ssm.confirm();
      };

      Model.prototype["import"] = function(data) {
        if (data.ssm != null) {
          this.ssm.forceState(data.ssm);
        }
        if (data.selectedAnswers != null) {
          this.set('selectedAnswers', data.selectedAnswers);
        }
        if (data.reflection != null) {
          this.set('reflection.value', data.reflection);
        }
        if (data.displayValue != null) {
          return this.set('displayValue', data.displayValue);
        }
      };

      Model.prototype.importAggregateData = function(data) {
        return this.set('aggregate', data);
      };

      Model.prototype["export"] = function() {
        return {
          ssm: this.ssm.currentState(),
          selectedAnswers: this.get('selectedAnswers'),
          reflection: this.get('reflection.value'),
          displayValue: this.get('displayValue')
        };
      };

      Model.prototype.onStateChange = function(evt, data) {
        return this.dispatchEvent(evt, data);
      };

      Model.prototype.createCssId = function(extra) {
        return "" + extra + "_" + (this.get('id'));
      };

      return Model;

    })(BaseModel);
  });

}).call(this);
