// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var EventDispatcher, Model;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    return Model = (function(_super) {
      __extends(Model, _super);

      function Model(_data) {
        this._data = _data;
        this.bubbleEvent = __bind(this.bubbleEvent, this);
        this.set = __bind(this.set, this);
        this.get = __bind(this.get, this);
      }

      Model.prototype.get = function(path) {
        var part, paths, target, _i, _len;
        paths = path.split('.');
        target = this._data;
        for (_i = 0, _len = paths.length; _i < _len; _i++) {
          part = paths[_i];
          if ((target.get != null) && target.get(part)) {
            target = target.get(part);
          } else if (target[part] != null) {
            target = target[part];
          } else {
            return null;
          }
        }
        return target;
      };

      Model.prototype.set = function(path, value) {
        var i, old, part, paths, target, _i, _len, _results;
        if (value !== this.get(path)) {
          paths = path.split('.');
          target = this._data;
          _results = [];
          for (i = _i = 0, _len = paths.length; _i < _len; i = ++_i) {
            part = paths[i];
            if (i === paths.length - 1) {
              if (target.set != null) {
                old = target.get(part);
                target.set(part, value);
              } else {
                old = target[part];
                if (value === null) {
                  target[part] = null;
                  delete target[part];
                } else {
                  target[part] = value;
                }
              }
              if ((old != null ? old.removeEventListener : void 0) != null) {
                old.removeEventListener('*', this.bubbleEvent);
              }
              if ((value != null ? value.addEventListener : void 0) != null) {
                value.addEventListener('*', this.bubbleEvent);
              }
              _results.push(this.dispatchEvent('Model.Change', {
                path: path,
                value: value,
                old: old,
                bubbles: true
              }));
            } else {
              if (target.get != null) {
                if (!target.get(part)) {
                  target.set(part, {});
                }
                _results.push(target = target.get(part));
              } else {
                if (target[part] == null) {
                  target[part] = {};
                }
                _results.push(target = target[part]);
              }
            }
          }
          return _results;
        } else {
          return this.dispatchEvent('Model.SetSame', {
            path: path,
            value: value,
            old: old,
            bubbles: true
          });
        }
      };

      Model.prototype.bubbleEvent = function(evt, data) {
        if (data.bubbles) {
          return this.dispatchEvent(evt, data);
        }
      };

      return Model;

    })(EventDispatcher);
  });

}).call(this);
