// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, Color, EventDispatcher, GraphModel, d3;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    d3 = require('common/js/vendor/d3_v3.2.8');
    $ = require('jquery');
    Color = require('./color');
    return GraphModel = (function(_super) {
      __extends(GraphModel, _super);

      function GraphModel(config) {
        var c, id, _i, _j, _len, _len1, _ref, _ref1;
        this.config = config;
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.onObjectDeselected = __bind(this.onObjectDeselected, this);
        this.onObjectSelected = __bind(this.onObjectSelected, this);
        this.getCurrentObject = __bind(this.getCurrentObject, this);
        this.getObjectsInLayer = __bind(this.getObjectsInLayer, this);
        this.clearLayer = __bind(this.clearLayer, this);
        this._removeObjectFromLayer = __bind(this._removeObjectFromLayer, this);
        this.removeObject = __bind(this.removeObject, this);
        this.addObjectToLayer = __bind(this.addObjectToLayer, this);
        this.addObject = __bind(this.addObject, this);
        this.setCurrentLayer = __bind(this.setCurrentLayer, this);
        this.setCurrentTool = __bind(this.setCurrentTool, this);
        this.getColorById = __bind(this.getColorById, this);
        this.addTool = __bind(this.addTool, this);
        this.setCurrentColorTool = __bind(this.setCurrentColorTool, this);
        this._toolsLoaded = __bind(this._toolsLoaded, this);
        this.areToolsLoaded = __bind(this.areToolsLoaded, this);
        this.buildToolFactory = __bind(this.buildToolFactory, this);
        this.loadTools = __bind(this.loadTools, this);
        this._active = true;
        this.objects = {};
        this.objects['default'] = [];
        _ref = this.config.layers;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          id = _ref[_i];
          this.objects[id] = [];
        }
        this._currentLayer = this.config.layers[this.config.layers.length - 1];
        this.colors = {
          "default": new Color('default')
        };
        _ref1 = this.config.colors;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          c = _ref1[_j];
          this.colors[c] = new Color(c);
        }
      }

      GraphModel.prototype.loadTools = function() {
        var tool, _i, _len, _ref;
        this.tools = {};
        this._toolAudit = {
          total: 0,
          loaded: 0
        };
        _ref = this.config.tools;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tool = _ref[_i];
          this._toolAudit.total++;
          if (tool.data == null) {
            tool.data = {};
          }
          require(['../tools/' + tool.type + '/tool'], this.buildToolFactory(tool));
        }
        if (this._toolAudit.total === 0) {
          return this._toolsLoaded();
        }
      };

      GraphModel.prototype.buildToolFactory = function(conf) {
        var _this = this;
        return function(ToolClass) {
          var tool;
          tool = new ToolClass(conf.data);
          _this.addTool(tool, true);
          _this._toolAudit.loaded++;
          if (_this.areToolsLoaded()) {
            return _this._toolsLoaded();
          }
        };
      };

      GraphModel.prototype.areToolsLoaded = function() {
        return this._toolAudit.loaded === this._toolAudit.total;
      };

      GraphModel.prototype._toolsLoaded = function() {
        var g, k, _ref;
        if (this.tools.color != null) {
          this.setCurrentColorTool(this.tools.color[0]);
        }
        if (this.tools.create != null) {
          this.setCurrentTool(this.tools.create[0]);
        } else {
          _ref = this.tools;
          for (k in _ref) {
            g = _ref[k];
            this.setCurrentTool(g[0]);
            break;
          }
        }
        return this.dispatchEvent('Graph.ToolsLoaded', {});
      };

      GraphModel.prototype.setCurrentColorTool = function(colorTool) {
        if (this.currentColorTool != null) {
          this.currentColorTool.deactivate();
        }
        this.currentColorTool = colorTool;
        if (this._active) {
          this.currentColorTool.activate();
          return this.dispatchEvent('Graph.ColorSelectionChanged', {
            color: this.currentColorTool
          });
        }
      };

      GraphModel.prototype.addTool = function(tool, silent) {
        var color;
        if (silent == null) {
          silent = false;
        }
        if (this.tools[tool.group()] == null) {
          this.tools[tool.group()] = [];
        }
        this.tools[tool.group()].push(tool);
        this.tools[tool.group()].sort(function(a, b) {
          return a.groupWeight() - b.groupWeight();
        });
        if (tool.group() === 'color') {
          color = tool.color();
          this.colors[color.id] = color;
        }
        if (this.currentTool == null) {
          this.setCurrentTool(tool);
        }
        if (!silent) {
          return this.dispatchEvent('Graph.ToolAdded', {
            tool: tool
          });
        }
      };

      GraphModel.prototype.getColorById = function(id) {
        return this.colors[id];
      };

      GraphModel.prototype.setCurrentTool = function(tool) {
        if (this.currentTool != null) {
          this.currentTool.deactivate();
        }
        this.currentTool = tool;
        if (this._active) {
          this.currentTool.activate();
          return this.dispatchEvent('Graph.ToolSelectionChanged', {
            tool: tool
          });
        }
      };

      GraphModel.prototype.setCurrentLayer = function(layer) {
        return this._currentLayer = layer;
      };

      GraphModel.prototype.addObject = function(obj) {
        return this.addObjectToLayer(obj, this._currentLayer);
      };

      GraphModel.prototype.addObjectToLayer = function(obj, layer) {
        if (obj.color == null) {
          obj.setColor(this.currentColorTool.color());
        }
        this.objects[layer].push(obj);
        obj.addEventListener('GraphObject.Selected', this.onObjectSelected);
        obj.addEventListener('GraphObject.Deselected', this.onObjectDeselected);
        return this.dispatchEvent('Graph.ObjectAdded', {
          newObject: obj,
          layer: layer
        });
      };

      GraphModel.prototype.removeObject = function(obj, layer) {
        var list, _ref, _results;
        if (layer != null) {
          return this._removeObjectFromLayer(obj, layer);
        } else {
          _ref = this.objects;
          _results = [];
          for (layer in _ref) {
            list = _ref[layer];
            if (__indexOf.call(list, obj) >= 0) {
              this._removeObjectFromLayer(obj, layer);
              break;
            } else {
              _results.push(void 0);
            }
          }
          return _results;
        }
      };

      GraphModel.prototype._removeObjectFromLayer = function(obj, layer) {
        if ((this.objects[layer] != null) && __indexOf.call(this.objects[layer], obj) >= 0) {
          this.objects[layer].splice(this.objects[layer].indexOf(obj), 1);
          if (this.selectedObject === obj) {
            this.selectedObject = null;
          }
          return this.dispatchEvent('Graph.ObjectRemoved', {
            obj: obj,
            layer: layer
          });
        }
      };

      GraphModel.prototype.clearLayer = function(l) {
        var _results;
        if (this.objects[l] != null) {
          _results = [];
          while (this.objects[l].length > 0) {
            _results.push(this.removeObject(this.objects[l].pop(), l));
          }
          return _results;
        }
      };

      GraphModel.prototype.getObjectsInLayer = function(layer) {
        return this.objects[layer];
      };

      GraphModel.prototype.getCurrentObject = function() {
        if (this.selectedObject != null) {
          return this.selectedObject;
        } else {
          return this.objects.user[this.objects.user.length - 1];
        }
      };

      GraphModel.prototype.onObjectSelected = function(evt, data) {
        return this.selectedObject = data.currentTarget;
      };

      GraphModel.prototype.onObjectDeselected = function() {
        return this.selectedObject = null;
      };

      GraphModel.prototype.disable = function() {
        var g, k, t, _i, _len, _ref;
        this._active = false;
        _ref = this.tools;
        for (k in _ref) {
          g = _ref[k];
          for (_i = 0, _len = g.length; _i < _len; _i++) {
            t = g[_i];
            t.disable();
          }
        }
        this.dispatchEvent('Graph.ToolSelectionChanged', {
          tool: null
        });
        return this.dispatchEvent('Graph.ColorSelectionChanged', {
          color: null
        });
      };

      GraphModel.prototype.enable = function() {
        var g, k, t, _i, _len, _ref;
        this._active = true;
        _ref = this.tools;
        for (k in _ref) {
          g = _ref[k];
          for (_i = 0, _len = g.length; _i < _len; _i++) {
            t = g[_i];
            t.enable();
          }
        }
        if (this.currentColorTool != null) {
          this.currentColorTool.activate();
        }
        if (this.currentTool != null) {
          this.currentTool.activate();
        }
        this.dispatchEvent('Graph.ToolSelectionChanged', {
          tool: this.currentTool
        });
        return this.dispatchEvent('Graph.ColorSelectionChanged', {
          color: this.currentColorTool
        });
      };

      return GraphModel;

    })(EventDispatcher);
  });

}).call(this);
