// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, Answer, BaseModel, Model;
    $ = require("jquery");
    BaseModel = require("tep/utils/model");
    Answer = require("./answer");
    return Model = (function(_super) {
      __extends(Model, _super);

      function Model(settings) {
        this.pushStudentLog = __bind(this.pushStudentLog, this);
        this.updateOrderBy = __bind(this.updateOrderBy, this);
        this.setScrollTop = __bind(this.setScrollTop, this);
        this.selectAnswer = __bind(this.selectAnswer, this);
        this.resetAnswers = __bind(this.resetAnswers, this);
        this.randomizeAnswers = __bind(this.randomizeAnswers, this);
        this.orderAnswers = __bind(this.orderAnswers, this);
        this._parseResponses = __bind(this._parseResponses, this);
        this.loadResponses = __bind(this.loadResponses, this);
        Model.__super__.constructor.call(this, {});
        this.common = new BaseModel(settings);
        this.setScrollTop(0);
        this.set("orderBy", []);
      }

      Model.prototype.loadResponses = function() {
        var data, focusedAnswer, negotiationTEI, orderBy, search, te_type, tei;
        tei = this.common.get("tei");
        te_type = this.common.get("type");
        negotiationTEI = this.common.get("negotiationTEI");
        data = {
          course_instance_id: this.common.get("course_instance_id"),
          cohort: window.cohort_id,
          negotiationTEI: negotiationTEI,
          tei: tei,
          te_type: te_type,
          group_id: this.common.get("group_id"),
          assignment: tei,
          type: "te",
          subtype: te_type
        };
        search = this.get("search");
        if (search) {
          data.search = search;
        }
        orderBy = this.get("orderBy");
        if (orderBy.length) {
          data.order = orderBy;
        }
        focusedAnswer = this.get("focusedAnswer");
        if (focusedAnswer) {
          data.focusedAnswer = focusedAnswer;
        }
        return $.ajax("/api/v1/tep/te/get_responses", {
          type: "POST",
          dataType: "json",
          contentType: "application/json; charset=utf-8",
          data: JSON.stringify(data),
          success: this._parseResponses
        });
      };

      Model.prototype._parseResponses = function(data) {
        var allAns, answer, response, _i, _j, _len, _len1, _ref;
        if (this.get("answers")) {
          _ref = this.get("answers");
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            answer = _ref[_i];
            answer.removeEventListener("*", this.bubbleEvent);
          }
        }
        allAns = [];
        for (_j = 0, _len1 = data.length; _j < _len1; _j++) {
          response = data[_j];
          delete response.current_user;
          answer = new Answer(response, this.common);
          answer.addEventListener("*", this.bubbleEvent);
          allAns.push(answer);
        }
        return this.orderAnswers(allAns);
      };

      Model.prototype.orderAnswers = function(answers) {
        var ans, order;
        if (answers == null) {
          answers = null;
        }
        ans = answers != null ? answers : this.get("answers");
        order = _.intersection(this.get("orderBy"), ['likes', 'comments']);
        if (order.length) {
          ans.sort(function(a, b) {
            var sortAValue, sortBValue;
            sortAValue = order.reduce((function(total, value) {
              return total + a.get(value);
            }), 0);
            sortBValue = order.reduce((function(total, value) {
              return total + b.get(value);
            }), 0);
            return sortBValue - sortAValue;
          });
        } else {
          ans = this.randomizeAnswers(ans);
        }
        return this.resetAnswers(ans);
      };

      Model.prototype.randomizeAnswers = function(oldAns) {
        var ans, answer, curr, _i, _len;
        ans = [];
        curr = null;
        for (_i = 0, _len = oldAns.length; _i < _len; _i++) {
          answer = oldAns[_i];
          if (this.common.get("current_user") === answer.get("user_id")) {
            curr = answer;
          } else {
            ans.push(answer);
          }
        }
        ans.sort(function(a, b) {
          return Math.random() - 0.5;
        });
        if (curr != null) {
          ans.unshift(curr);
        }
        return ans;
      };

      Model.prototype.resetAnswers = function(ans) {
        var answer, i, _i, _len;
        this.setScrollTop(0);
        for (i = _i = 0, _len = ans.length; _i < _len; i = ++_i) {
          answer = ans[i];
          answer.set("index", i);
        }
        return this.set("answers", ans);
      };

      Model.prototype.selectAnswer = function(ind) {
        var old, selection;
        if (old = this.get("selectedAnswer")) {
          old.set("isSelected", false);
        }
        selection = this.get("answers." + ind);
        selection.set("isSelected", true);
        selection.loadLikeStatus();
        this.set("selectedAnswer", selection);
        return this.pushStudentLog(selection.get("user_id"), this.common.get("tei"));
      };

      Model.prototype.setScrollTop = function(ind) {
        return this.set("scrollTop", ind);
      };

      Model.prototype.updateOrderBy = function(item) {
        var loc, order;
        order = this.get("orderBy");
        loc = order.indexOf(item);
        if (loc > -1) {
          order.splice(loc, 1);
        } else {
          order.push(item);
        }
        this.set("orderBy", order);
        return this.loadResponses();
      };

      Model.prototype.pushStudentLog = function(user_id, tei_id) {
        var studentLog;
        studentLog = {
          user_id: window.user_id,
          target_id: user_id,
          action: 'Expand_CW',
          data: {
            course_instance_id: window.globals.courseInstanceId,
            tei_id: tei_id
          }
        };
        return $.ajax({
          url: '/api/v1/student_log/',
          data: JSON.stringify(studentLog),
          type: 'POST',
          contentType: 'application/json'
        });
      };

      return Model;

    })(BaseModel);
  });

}).call(this);
