// Generated by CoffeeScript 1.6.3
(function() {
  define(function(require) {
    /*
    Mouse Touch Utility
    ===================
    Singleton object that provides utility methods for abstracting mouse and touch
    events.
    */

    var MouseTouch;
    MouseTouch = (function() {
      function MouseTouch() {}

      /*
      
      parsePosition(evt)
      ------------------
      Given a JavaScript event object (or jQuery event object), returns the x/y
      coordinates of the event, relative to the page. If there are multiple touches,
      this returns the location of only the first touch.
      */


      MouseTouch.prototype.parsePosition = function(evt) {
        var currentPt;
        if (evt.pageX) {
          currentPt = {
            x: evt.pageX,
            y: evt.pageY
          };
        } else if (evt.type.match(/^touch/)) {
          currentPt = {
            x: evt.touches[0].pageX,
            y: evt.touches[0].pageY
          };
        } else {
          currentPt = {
            x: 0,
            y: 0
          };
        }
        return currentPt;
      };

      return MouseTouch;

    })();
    return new MouseTouch;
  });

}).call(this);
