// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, BarChart, PollMultipleChoiceBarChart, Utils, d3, tmpl;
    $ = require('jquery');
    BarChart = require('tep/components/datavis/bar/bar');
    tmpl = require('text!./template.html');
    d3 = require('common/js/vendor/d3_v3.2.8');
    require('bootstrap');
    Utils = require('tep/utils/utils');
    return PollMultipleChoiceBarChart = (function(_super) {
      var CONTAINER_WIDTH, FONT, X_AXIS_TICK_LABEL_HEIGHT, X_AXIS_TICK_PADDING;

      __extends(PollMultipleChoiceBarChart, _super);

      CONTAINER_WIDTH = 700;

      X_AXIS_TICK_PADDING = 10;

      X_AXIS_TICK_LABEL_HEIGHT = 12;

      FONT = "12px sans-serif";

      function PollMultipleChoiceBarChart(opts) {
        this.opts = opts;
        this.addGraphDescription = __bind(this.addGraphDescription, this);
        this.sendHoverMetric = __bind(this.sendHoverMetric, this);
        this.wrapLabels = __bind(this.wrapLabels, this);
        this.handleData = __bind(this.handleData, this);
        this.view = __bind(this.view, this);
        this._view = $(tmpl);
        PollMultipleChoiceBarChart.__super__.constructor.call(this, this._view.find('.dv'), {
          width: (this.opts.numberOfOptions * this.opts.optionWidth) + 4 * this.opts.numberOfOptions,
          height: 400,
          xAxisTickLabels: this.opts.options.map(function(item) {
            if (item.label) {
              return item.label;
            } else {
              return item.content;
            }
          }),
          label: {
            yAxis: this.opts.yAxis.toUpperCase(),
            xAxis: this.opts.xAxis.toUpperCase()
          }
        });
        this.yAxis.tickFormat(d3.format("d"));
        if (this.totalWidth > CONTAINER_WIDTH) {
          this._view.find('.dv').css({
            "overflow-x": "scroll"
          });
        }
      }

      PollMultipleChoiceBarChart.prototype.defaultClass = function(d) {
        return 'bar' + (d.isUserSelection ? ' userSelection' : '');
      };

      PollMultipleChoiceBarChart.prototype.view = function() {
        return this._view;
      };

      PollMultipleChoiceBarChart.prototype.handleData = function(data) {
        var circ, rect, tempBarG, wrap, wrap2,
          _this = this;
        PollMultipleChoiceBarChart.__super__.handleData.call(this, data);
        tempBarG = this.barG;
        wrap2 = this.barG.append('g').attr('transform', function(d) {
          return 'translate(' + ((_this.x.rangeBand() / 2) - (_this.x.rangeBand() / 2)) + ',' + (_this.config.height - _this.y(d.value)) + ') rotate(-90)';
        });
        rect = wrap2.append('rect').attr('class', 'star-bg').attr('width', function(d, i) {
          return tempBarG[0][i].children[0].attributes.height.value;
        }).attr('height', function(d, i) {
          return tempBarG[0][i].children[0].attributes.width.value;
        });
        wrap = this.barG.append('g').attr('transform', function(d) {
          return 'translate(' + (_this.x.rangeBand() / 2) + ',' + ((_this.config.height - _this.y(d.value)) / 2) + ') rotate(-90)';
        });
        circ = wrap.append('circle').attr('class', 'star-bg').attr('r', function(d) {
          if (d.value === 0) {
            return 0;
          } else {
            return 4;
          }
        });
        wrap.append('path').attr('d', this.buildStar).attr('class', 'star');
        wrap2.on('mouseover', this.sendHoverMetric);
        return this.wrapLabels();
      };

      PollMultipleChoiceBarChart.prototype.wrapLabels = function() {
        var wordWrapper;
        wordWrapper = function(text, width) {
          return text.each(function() {
            var dy, line, lineHeight, lineNumber, tspan, word, words, x, y, _results;
            text = d3.select(this);
            words = text.text().split(/\s+/).reverse();
            word;
            line = [];
            lineNumber = 0;
            lineHeight = 1.1;
            x = text.attr('x');
            y = text.attr('y');
            dy = 0;
            tspan = text.text(null).append('tspan').attr('x', x).attr('y', y).attr('dy', dy + 'em');
            _results = [];
            while ((word = words.pop())) {
              line.push(word);
              tspan.text(line.join(' '));
              if (Utils.measureText(tspan.text(), FONT) > width) {
                line.pop();
                tspan.text(line.join(' '));
                line = [word];
                _results.push(tspan = text.append('tspan').attr('x', x).attr('y', y).attr('dy', ++lineNumber * lineHeight + dy + 'em').text(word));
              } else {
                _results.push(void 0);
              }
            }
            return _results;
          });
        };
        return this.gx.selectAll('.tick text').call(wordWrapper, this.opts.optionWidth - X_AXIS_TICK_PADDING);
      };

      PollMultipleChoiceBarChart.prototype.buildStar = function(d) {
        var angle, i, innerRadius, outerRadius, path, points, r, stops, x, y, _i;
        outerRadius = 4;
        innerRadius = 2;
        points = 5;
        stops = points * 2;
        path = ['M', '0 0'];
        for (i = _i = 0; 0 <= stops ? _i <= stops : _i >= stops; i = 0 <= stops ? ++_i : --_i) {
          angle = i * 2 * Math.PI / stops;
          r = i % 2 === 1 ? innerRadius : outerRadius;
          x = Math.cos(angle) * r;
          y = Math.sin(angle) * r;
          path.push('L', x + ' ' + y);
        }
        path.push('z');
        return path.join('');
      };

      PollMultipleChoiceBarChart.prototype.sendHoverMetric = function(d, i) {
        return this.dispatchEvent('Bar.Hover', {
          label: d.label,
          bubbles: true
        });
      };

      PollMultipleChoiceBarChart.prototype.addGraphDescription = function(model, $content) {
        this.svg.attr("aria-labelledby", "graph-desc-" + (model.get("id"))).append("g").html("<desc id=graph-desc-" + (model.get("id")) + "></desc>");
        return this.view().find("#graph-desc-" + (model.get("id"))).empty().append($content.prop('outerHTML'));
      };

      return PollMultipleChoiceBarChart;

    })(BarChart);
  });

}).call(this);
