// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Input, NumericResponseView, View;
    View = require('tep/utils/view');
    Input = require('tep/components/input/input');
    require('common/js/vendor/jquery_plugins/autoNumeric-min');
    return NumericResponseView = (function(_super) {
      __extends(NumericResponseView, _super);

      function NumericResponseView(data) {
        this.update = __bind(this.update, this);
        this.disable = __bind(this.disable, this);
        this.onSubmitRequest = __bind(this.onSubmitRequest, this);
        this.onValueChange = __bind(this.onValueChange, this);
        this._customValidate = __bind(this._customValidate, this);
        this.setValidationMessage = __bind(this.setValidationMessage, this);
        var autoNumericConfig;
        NumericResponseView.__super__.constructor.call(this, "<div></div>");
        this.$el.addClass("poll-response-numeric");
        if (data.attributes == null) {
          data.attributes = {};
        }
        if (data.format === "^\\d+(\\.\\d{2})?$") {
          autoNumericConfig = {
            aSep: ',',
            aPad: true,
            lZero: 'keep'
          };
        } else {
          autoNumericConfig = {
            aSep: ',',
            aPad: false,
            lZero: 'keep'
          };
        }
        data.format = new RegExp(data.format);
        data.selectOnFocus = true;
        data.autoNumeric = true;
        this.setValidationMessage(data);
        data.customValidate = this._customValidate;
        this.input = new Input(data);
        this.input.addEventListener('valuechange', this.onValueChange);
        this.input.addEventListener('Input.RequestSubmit', this.onSubmitRequest);
        this.input.field.autoNumeric('init', autoNumericConfig);
        this.$el.append(this.input.view());
      }

      NumericResponseView.prototype.setValidationMessage = function(data) {
        if ((data.attributes.min != null) && (data.attributes.max != null)) {
          return data.formatDescription = "Please enter a number between " + data.attributes.min + " and " + data.attributes.max;
        } else if (data.attributes.min != null) {
          return data.formatDescription = "Please enter a number greater than or equal to " + data.attributes.min;
        } else if (data.attributes.max != null) {
          return data.formatDescription = "Please enter a number less than or equal to " + data.attributes.max;
        } else {
          return data.formatDescription = "Please enter positive number with two decimal places.";
        }
      };

      NumericResponseView.prototype._customValidate = function(value) {
        var val;
        val = parseFloat(value);
        if (isNaN(val) || ((this.input.settings.attributes.min != null) && val < this.input.settings.attributes.min) || ((this.input.settings.attributes.max != null) && val > this.input.settings.attributes.max)) {
          return false;
        }
        return true;
      };

      NumericResponseView.prototype.onValueChange = function(evt, data) {
        if (this.input.isValid()) {
          return this.dispatchEvent("Poll.ResponseChangeRequest", {
            value: [this.input.value()],
            displayValue: this.input.field.val(),
            bubbles: true
          });
        } else {
          return this.dispatchEvent("Poll.ResponseChangeRequest", {
            value: [],
            displayValue: this.input.field.val(),
            bubbles: true
          });
        }
      };

      NumericResponseView.prototype.onSubmitRequest = function(evt, data) {
        return this.dispatchEvent("Poll.ResponseSubmission", {
          bubbles: true
        });
      };

      NumericResponseView.prototype.disable = function() {
        return this.input.disable();
      };

      NumericResponseView.prototype.update = function(values) {
        if (!this.modelInitialized) {
          this.modelInitialized = true;
          return this.input.value(values[0], true);
        }
      };

      return NumericResponseView;

    })(View);
  });

}).call(this);
