// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, BarChart, PollNumericBarChart, Tooltip, d3, tmpl;
    $ = require('jquery');
    BarChart = require('tep/components/datavis/bar/bar');
    tmpl = require('text!./template.html');
    d3 = require('common/js/vendor/d3_v3.2.8');
    Tooltip = require('tep/utils/tooltip');
    require('bootstrap');
    return PollNumericBarChart = (function(_super) {
      __extends(PollNumericBarChart, _super);

      function PollNumericBarChart(opts) {
        this.opts = opts;
        this.setUserSelection = __bind(this.setUserSelection, this);
        this.hideBarTooltip = __bind(this.hideBarTooltip, this);
        this.showBarTooltip = __bind(this.showBarTooltip, this);
        this.sendHoverMetric = __bind(this.sendHoverMetric, this);
        this.hideUserSelectionTT = __bind(this.hideUserSelectionTT, this);
        this.showUserSelectionTT = __bind(this.showUserSelectionTT, this);
        this.handleData = __bind(this.handleData, this);
        this.view = __bind(this.view, this);
        this.buildTicks = __bind(this.buildTicks, this);
        this._view = $(tmpl);
        PollNumericBarChart.__super__.constructor.call(this, this._view.find('.dv'), {
          width: 680,
          height: 400,
          label: {
            width: 20,
            yAxis: this.opts.labels.yAxis.toUpperCase(),
            xAxis: this.opts.labels.xAxis.toUpperCase()
          }
        });
        Tooltip.buildTooltip(this._view, "results", this.opts.mouseover, {}, false);
        this.yAxis.tickFormat(d3.format("d"));
        this.ticks = [];
        if (this.opts.binCount >= 5 || ((this.opts.bins != null) && this.opts.bins.length >= 5)) {
          this.svg.selectAll('.x .tick').remove();
          if (this.opts.ticks != null) {
            this.buildTicks();
          } else {
            this.svg.append('text').attr('x', 340).attr('y', 385).attr('text-anchor', 'middle');
          }
        }
      }

      PollNumericBarChart.prototype.buildTicks = function() {
        var t, text, tick, _i, _len, _ref, _results;
        _ref = this.opts.ticks;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          t = _ref[_i];
          tick = this.svg.select('.x').append('g').attr('class', 'customTick major');
          this.ticks.push(tick);
          tick.hbxData = t;
          _results.push(text = tick.append('text').attr('x', 0).attr('y', 14).attr('dy', ".71em").attr('style', 'text-anchor: middle;').text(t.position));
        }
        return _results;
      };

      PollNumericBarChart.prototype.defaultClass = function(d) {
        return 'bar' + (d.isUserSelection ? ' userSelection' : '');
      };

      PollNumericBarChart.prototype.view = function() {
        return this._view;
      };

      PollNumericBarChart.prototype.handleData = function(data) {
        var bar, circ, i, partial, rect, start, tempBarG, tick, tickWidth, wrap, wrap2, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _results,
          _this = this;
        PollNumericBarChart.__super__.handleData.call(this, data);
        tickWidth = this.config.width / data.length;
        _ref = this.ticks;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tick = _ref[_i];
          for (i = _j = 0, _len1 = data.length; _j < _len1; i = ++_j) {
            bar = data[i];
            if (((bar.min == null) && tick.hbxData.position < bar.max) || ((bar.max == null) && tick.hbxData.position >= bar.min) || ((bar.min <= (_ref1 = tick.hbxData.position) && _ref1 < bar.max))) {
              break;
            }
          }
          start = i * tickWidth;
          partial = tickWidth * (bar.min == null ? 0 : (!bar.max ? 0.1 : (tick.hbxData.position - bar.min) / (bar.max - bar.min)));
          tick.attr('transform', "translate(" + (start + partial) + ", 0)");
        }
        tempBarG = this.barG;
        wrap2 = this.barG.append('g').attr('transform', function(d) {
          return 'translate(' + ((_this.x.rangeBand() / 2) - (_this.x.rangeBand() / 2)) + ',' + (_this.config.height - _this.y(d.value)) + ') rotate(-90)';
        });
        rect = wrap2.append('rect').attr('class', 'star-bg').attr('width', function(d, i) {
          return tempBarG[0][i].children[0].attributes.height.value;
        }).attr('height', function(d, i) {
          return tempBarG[0][i].children[0].attributes.width.value;
        });
        wrap = this.barG.append('g').attr('transform', function(d) {
          return 'translate(' + (_this.x.rangeBand() / 2) + ',' + ((_this.config.height - _this.y(d.value)) / 2) + ') rotate(-90)';
        });
        circ = wrap.append('circle').attr('class', 'star-bg').attr('r', function(d) {
          if (d.value === 0) {
            return 0;
          } else {
            return 4;
          }
        });
        wrap.append('path').attr('d', this.buildStar).attr('class', 'star');
        wrap.on('mouseover', this.showUserSelectionTT).on('mouseout', this.hideUserSelectionTT);
        if (this.svg.selectAll('.bar')[0].length >= 5) {
          this.svg.selectAll('.x .tick').remove();
          return wrap2.on('mouseover', this.showBarTooltip).on('mouseout', this.hideBarTooltip);
        } else {
          _results = [];
          for (i = _k = 0, _len2 = data.length; _k < _len2; i = ++_k) {
            bar = data[i];
            if (bar.hidden) {
              _results.push(this.svg.selectAll(".x .tick").each(function(d, j) {
                if (d === bar.label) {
                  return d3.select(this).classed("hidden", true);
                }
              }));
            } else {
              _results.push(void 0);
            }
          }
          return _results;
        }
      };

      PollNumericBarChart.prototype.showUserSelectionTT = function(d, i) {
        var objOff, vOff;
        if (d.isUserSelection) {
          vOff = this._view.offset();
          objOff = $(this.svg.selectAll('path.star')[0][i]).offset();
          this._view.find('.userSelection-tooltip').css({
            top: objOff.top - vOff.top,
            left: objOff.left - vOff.left + 4
          }).show();
          this._view.find('.label-userSelection').text(this.opts.labels.userSelection);
          this._view.find('.value-userSelection').text(this.userSelection);
          return this._view.find('.userSelection-wrap').css({
            left: -this._view.find(".userSelection-wrap").width() / 2 - 5
          });
        }
      };

      PollNumericBarChart.prototype.hideUserSelectionTT = function() {
        return this._view.find('.userSelection-tooltip').hide();
      };

      PollNumericBarChart.prototype.buildStar = function(d) {
        var angle, i, innerRadius, outerRadius, path, points, r, stops, x, y, _i;
        outerRadius = 4;
        innerRadius = 2;
        points = 5;
        stops = points * 2;
        path = ['M', '0 0'];
        for (i = _i = 0; 0 <= stops ? _i <= stops : _i >= stops; i = 0 <= stops ? ++_i : --_i) {
          angle = i * 2 * Math.PI / stops;
          r = i % 2 === 1 ? innerRadius : outerRadius;
          x = Math.cos(angle) * r;
          y = Math.sin(angle) * r;
          path.push('L', x + ' ' + y);
        }
        path.push('z');
        return path.join('');
      };

      PollNumericBarChart.prototype.sendHoverMetric = function(d, i) {
        return this.dispatchEvent('Bar.Hover', {
          label: d.label,
          bubbles: true
        });
      };

      PollNumericBarChart.prototype.showBarTooltip = function(d, i) {
        var objOff, vOff;
        vOff = this._view.offset();
        objOff = $(this.svg.selectAll('.bar')[0][i]).offset();
        this._view.find('.userSelection-tooltip').css({
          top: objOff.top - vOff.top,
          left: (objOff.left - vOff.left) + ($(this.svg.selectAll('.bar')[0][i]).children()[0].attributes.width.value / 2)
        }).show();
        this._view.find('.value-userSelection').text(d.label);
        this._view.find('.userSelection-wrap').css({
          left: -this._view.find(".userSelection-wrap").width() / 2 - 5
        });
        return this.sendHoverMetric(d, i);
      };

      PollNumericBarChart.prototype.hideBarTooltip = function() {
        return this._view.find('.userSelection-tooltip').hide();
      };

      PollNumericBarChart.prototype.setUserSelection = function(userSelection) {
        this.userSelection = userSelection;
      };

      return PollNumericBarChart;

    })(BarChart);
  });

}).call(this);
