// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, GraphObject, MathUtils, Model, PieSliceObject, View, defaults;
    $ = require('jquery');
    GraphObject = require('../graph_object');
    Model = require('tep/utils/model');
    View = require('./view');
    MathUtils = require('tep/utils/math');
    /*
    PieSliceObject
    ==========
    Represents a slice for use in pie chart style graphs.
    
    Configuration
    =============
    PieSliceObject supports the following configuration, passed in as a single
    config object.
    */

    defaults = {
      /*
      *   radius: The base radius of the pie.
      
      Defaults to 1
      */

      radius: 1,
      /*
      *   origin: The center point of the pie, provided in { x: 0, y: 0 } format.
      */

      origin: {
        x: 0,
        y: 0
      },
      /*
      *   percent: The percentage of the pie, expressed in the [0,1] range.
        
      Defaults to 1.
      */

      percent: 1,
      /*
      *   label: Label displayed beneath the bar
      
      Defaults to null.
      */

      label: null,
      /*
      *   rotation: The initial rotation of the object in radians.
      
      Defaults to 0.
      */

      rotation: 0
    };
    return PieSliceObject = (function(_super) {
      __extends(PieSliceObject, _super);

      function PieSliceObject(conf) {
        this.exportData = __bind(this.exportData, this);
        this.setScale = __bind(this.setScale, this);
        this.getScale = __bind(this.getScale, this);
        this.setRotation = __bind(this.setRotation, this);
        this.getRotation = __bind(this.getRotation, this);
        this.setReferencePoint = __bind(this.setReferencePoint, this);
        this.getReferencePoint = __bind(this.getReferencePoint, this);
        this.registerSvgObject = __bind(this.registerSvgObject, this);
        this.buildView = __bind(this.buildView, this);
        var config;
        config = $.extend(true, {}, defaults, conf);
        config.originalRadius = config.radius;
        this.model = new Model(config);
        this._name = "slice";
        PieSliceObject.__super__.constructor.call(this, config);
      }

      PieSliceObject.prototype.buildView = function() {
        var v;
        v = new View(this.model);
        if (this.colorTag) {
          v.setColorTag(this.colorTag);
        }
        return v;
      };

      PieSliceObject.prototype.registerSvgObject = function(obj, config) {
        return this.view.registerSvgObject(obj, config);
      };

      PieSliceObject.prototype.getReferencePoint = function() {
        return this.model.get('origin');
      };

      PieSliceObject.prototype.setReferencePoint = function(pt) {
        return this.model.set('origin', pt);
      };

      PieSliceObject.prototype.getRotation = function() {
        return this.model.get('rotation');
      };

      PieSliceObject.prototype.setRotation = function(theta) {
        return this.model.set('rotation', MathUtils.posMod(theta));
      };

      PieSliceObject.prototype.getScale = function() {
        return this.model.get('radius') / this.model.get('originalRadius');
      };

      PieSliceObject.prototype.setScale = function(scale) {
        return this.model.set('radius', this.model.get('originalRadius') * scale);
      };

      PieSliceObject.prototype.exportData = function() {
        var e;
        return e = {
          ordinal: this.model.ordinal,
          heights: this.model.heights,
          label: this.model.label,
          columnWidth: this.model.columnWidth
        };
      };

      return PieSliceObject;

    })(GraphObject);
  });

}).call(this);
