// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Lightbox, OptionView, Template, View;
    View = require('tep/utils/view');
    Template = require('text!../templates/option.html');
    Lightbox = require('tep/components/lightbox/main');
    return OptionView = (function(_super) {
      __extends(OptionView, _super);

      function OptionView(model) {
        this.handleKeypress = __bind(this.handleKeypress, this);
        this.onClick = __bind(this.onClick, this);
        this.onDataChange = __bind(this.onDataChange, this);
        this.showLightbox = __bind(this.showLightbox, this);
        var dataAtr, dataValue, file, style, _ref,
          _this = this;
        OptionView.__super__.constructor.call(this, Template);
        this._optionId = model.get('id');
        if (file = model.get('imageFile')) {
          style = "image";
          this._lightboxData = {
            image: file.location,
            title: model.get('imageFile.description')
          };
          this.$el.find('.multiselect-option-image').attr({
            src: file.location,
            alt: model.get('imageFile.description')
          });
          this.$el.find('.multiselect-image-preview').on('click', this.showLightbox);
        } else {
          style = "list-item";
        }
        this.$el.addClass("multiselect-" + style);
        this.$el.find(".multiselect-option-content").html(model.get('content'));
        _ref = model.get('dataAttributes');
        for (dataAtr in _ref) {
          dataValue = _ref[dataAtr];
          this.$el.data(dataAtr, dataValue);
        }
        this.$el.on('click', this.onClick);
        this.$el.bind('focus', function() {
          return $(document).on('keydown', _this.handleKeypress);
        });
        this.$el.bind('blur', function() {
          return $(document).off('keydown', _this.handleKeypress);
        });
        this.$el.on('mousemove touchend', this.handleMousemove);
        model.addEventListener('Model.Change', this.onDataChange);
      }

      OptionView.prototype.showLightbox = function(jqevt) {
        jqevt.stopImmediatePropagation();
        return Lightbox.display(this._lightboxData);
      };

      OptionView.prototype.onDataChange = function(evt, data) {
        if (data.path === "selected") {
          this.$el.toggleClass("multiselect-selected", data.value);
          return this.$el.find('input').prop('checked', data.value);
        }
      };

      OptionView.prototype.onClick = function(jqevt) {
        return this.dispatchEvent('Option.RequestSelectionToggle', {
          optionId: this._optionId,
          bubbles: true
        });
      };

      OptionView.prototype.handleMousemove = function(jqevt) {
        jqevt.stopPropagation();
        return $(document.activeElement).trigger('blur');
      };

      OptionView.prototype.handleKeypress = function(jqevt) {
        var code;
        jqevt.stopPropagation();
        code = jqevt.keyCode ? jqevt.keyCode : jqevt.which;
        if (code === 13 || code === 32) {
          jqevt.preventDefault();
        }
        if (code === 32 || code === 13) {
          this.onClick(jqevt);
        }
        if (code === 13) {
          return this.dispatchEvent('Option.RequestSelectionSubmit', {
            bubbles: true
          });
        }
      };

      return OptionView;

    })(View);
  });

}).call(this);
