// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Graph, PercentageView, Template, View;
    View = require('tep/utils/view');
    Template = require('text!../../templates/results/percentage.html');
    Graph = require('tep/components/drawgraph/graph');
    return PercentageView = (function(_super) {
      __extends(PercentageView, _super);

      function PercentageView(model) {
        this.onModelChange = __bind(this.onModelChange, this);
        var _this = this;
        PercentageView.__super__.constructor.call(this, Template);
        this.graph = new Graph({
          label: "Results Graph",
          height: 300,
          axes: {
            xAxis: {
              min: -3,
              max: 3,
              tickSize: 1,
              label: ""
            },
            yAxis: {
              min: -1,
              max: 1,
              tickSize: 1,
              label: ""
            }
          },
          layers: ['pie'],
          colors: ['pie']
        });
        this.graph.disable();
        this.graph._buildObjectFactory = function(settings) {
          return function(ObjectClass) {
            var imp, obj, translation;
            if (_this.lastPosition) {
              settings.data.lastY = _this.lastPosition.y;
              settings.data.lastX = _this.lastPosition.x;
            }
            obj = new ObjectClass(settings.data);
            obj.setColor(_this.graph.model.getColorById(settings.color));
            _this.graph.model.addObjectToLayer(obj, settings.layer);
            imp = _this.graph._imports[settings.importGroup];
            _this.lastPosition = obj.view.labelPosition;
            imp.loaded++;
            if (imp.loaded === imp.total) {
              _this.dispatchEvent('Graph.ImportComplete', {
                group: settings.importGroup
              });
              if (_this.lastPosition && _this.lastPosition.y < -160) {
                translation = Math.abs(_this.lastPosition.y + 160);
                d3.select(_this.$el.find('svg').get(0)).attr('height', 380 + translation);
                return d3.select(_this.$el.find('.pie').get(0)).attr("transform", "translate(0 " + translation + ")");
              }
            }
          };
        };
        this.$el.find(".poll-percentage").append(this.graph.$dom());
        model.addEventListener('Model.Change', this.onModelChange);
      }

      PercentageView.prototype.onModelChange = function(evt, data) {
        var datum, existingSlices, graphData, importData, label, listDom, obj, optionListDom, percent, running, runningPercent, slice, total, z, zeroList, _i, _j, _k, _l, _len, _len1, _len2, _len3, _ref, _results;
        if (data.path === "aggregate") {
          graphData = data.value.data.slice(0);
          graphData.sort(function(a, b) {
            return b.value - a.value;
          });
          total = 0;
          for (_i = 0, _len = graphData.length; _i < _len; _i++) {
            datum = graphData[_i];
            total += datum.value;
          }
          existingSlices = this.graph.getObjectsInLayer("pie").slice(0);
          for (_j = 0, _len1 = existingSlices.length; _j < _len1; _j++) {
            obj = existingSlices[_j];
            this.graph.removeObject(obj);
          }
          importData = [];
          running = 0;
          runningPercent = 0;
          zeroList = [];
          optionListDom = this.$el.find(".poll-percentage ul");
          for (_k = 0, _len2 = graphData.length; _k < _len2; _k++) {
            datum = graphData[_k];
            if (datum.value > 0) {
              percent = Number((datum.value / total).toFixed(3));
              if ((1.001 >= (_ref = (runningPercent + percent).toFixed(3)) && _ref >= 0.999)) {
                percent = 1 - runningPercent;
              }
              runningPercent += percent;
              label = datum.label;
              optionListDom.append("<li>" + (percent * 100) + " percent selected " + label + "</li>");
              slice = {
                type: "pieslice",
                data: {
                  rotation: Math.PI * (2 * (running / total) - 0.5),
                  percent: percent,
                  label: label,
                  classes: datum.isUserSelection ? "poll-userSelection" : null
                },
                color: "pie",
                layer: "pie"
              };
              running += datum.value;
              importData.push(slice);
            } else {
              zeroList.push(datum);
            }
          }
          this.graph["import"](importData);
          listDom = this.$el.find(".poll-percentage-zeroList");
          if (zeroList.length) {
            listDom.show();
            listDom.find("ul li").remove();
            _results = [];
            for (_l = 0, _len3 = zeroList.length; _l < _len3; _l++) {
              z = zeroList[_l];
              _results.push(listDom.find("ul").append("<li>" + z.label + "</li>"));
            }
            return _results;
          } else {
            return listDom.hide();
          }
        }
      };

      return PercentageView;

    })(View);
  });

}).call(this);
