// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, EventDispatcher, SearchModel, TEProxy, TeachingElementPlatform, Utils, defaultMarkJsHighlighterOptions,
      _this = this;
    EventDispatcher = require("tep/utils/event/event_dispatcher");
    $ = require("jquery");
    Utils = require("tep/utils/utils");
    TEProxy = require("./proxy");
    SearchModel = require("sidebar/search/models/SearchModel");
    defaultMarkJsHighlighterOptions = {
      accuracy: "partially",
      diacritics: true,
      ignorePunctuation: ":;.,-–—‒_(){}[]!'\"+=".split(""),
      exclude: [".MathJax", ".math", ".MathJax_Preview", ".MJX_Assistive_MathML"],
      filter: function(node, term) {
        var t;
        t = term.toLowerCase();
        if (t.length < 3) {
          return false;
        }
        if (t === "the" || t === "and" || t === "for" || t === "not" || t === "that" || t === "with") {
          return false;
        }
        return true;
      }
    };
    /*
    Teaching Element Platform
    =========================
    The Platform is the main driver of the TEP-JSL on concept pages, handling
    the loading and instantiation of TEIs, as well as the basic interplay between
    TEIs on the page.
    
    TEI Lifecycle Management
    ========================
    See the TeachingElement class for details on the TEI Lifecycle itself.
    
    Each concept page contains a collection of Teaching Element Instances (TEIs)
    in a specific order.
    As each TEI is completed, a new TEI is getting requested.
    This one-by-one process is the primary way root TEIs interact with each other.
    */

    TeachingElementPlatform = (function(_super) {
      __extends(TeachingElementPlatform, _super);

      /*
      constructor()
      -----
      Global platform settings.
      If required keep general event listeners here to prevent callbacks being called multiple times.
      */


      function TeachingElementPlatform() {
        this.removeHighlights = __bind(this.removeHighlights, this);
        this.addHighlights = __bind(this.addHighlights, this);
        this.sendSidebarDisabledComponents = __bind(this.sendSidebarDisabledComponents, this);
        this.conceptPreviewSnapshot = __bind(this.conceptPreviewSnapshot, this);
        this.snapshotCheckOnTeiComplete = __bind(this.snapshotCheckOnTeiComplete, this);
        this.lastCheckAndNavigate = __bind(this.lastCheckAndNavigate, this);
        this.allReadyEventCallback = __bind(this.allReadyEventCallback, this);
        this.displayPathOutlines = __bind(this.displayPathOutlines, this);
        this.hideTepLoader = __bind(this.hideTepLoader, this);
        this.showTepLoader = __bind(this.showTepLoader, this);
        this.clearHtmlContainer = __bind(this.clearHtmlContainer, this);
        this.getToNextTei = __bind(this.getToNextTei, this);
        this.positionToTei = __bind(this.positionToTei, this);
        this.handleNextCoursewareContainer = __bind(this.handleNextCoursewareContainer, this);
        this.unlockNext = __bind(this.unlockNext, this);
        this.onRootTeiReady = __bind(this.onRootTeiReady, this);
        this.checkGlossary = __bind(this.checkGlossary, this);
        this.onTeiCompleteActions = __bind(this.onTeiCompleteActions, this);
        this.shedProxy = __bind(this.shedProxy, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.cleanup = __bind(this.cleanup, this);
        this.onTeiProxyLoaded = __bind(this.onTeiProxyLoaded, this);
        this.run = __bind(this.run, this);
        this.metricsActive = true;
        this.teachingElementsContainerId = "#hbx_teaching_elements";
        this.courseSearchModel = new SearchModel();
        this.courseSearchModel.addSearchWasHiddenListener(this.removeHighlights);
        this.highlightsActivated = false;
      }

      /*
      run()
      -----
      Ask the TEP for the teaching elements to initially load.
      These elements are considered "root" elements within the JS platform.
      */


      TeachingElementPlatform.prototype.run = function() {
        this._loadedCount = 0;
        this.activeCount = 0;
        this.rootElements = [];
        this.rootElementsIds = [];
        this.rootElementsCount = 0;
        this.rootReadyTeiIds = [];
        this.hiddenTeiIds = [];
        this.allReadyEventDispatched = false;
        this.pathOutlinesSet = false;
        this.conceptPreview = window.globals.conceptPreview;
        this.loadNextTeiUrl = window.globals.loadNextTeiUrl;
        this.conceptId = window.globals.concept;
        this.courseInstanceId = window.globals.courseInstanceId;
        this.cohortId = window.cohort_id;
        this.waveId = window.wave_id;
        this.courseDashboardUrl = window.user_course_dashboard_url;
        this.kalturaSessionKey = null;
        this.pathsWithTeis = null;
        this.SnapshotManager = null;
        this.snapshotModeFirstLast = "FIRST_LAST";
        this.snapshotModeEvery = "EVERY";
        this.snapshotModeConceptCompletion = "CONCEPT_COMPLETION";
        this.snapshotUserScope = "user/image";
        this.snapshotConceptScope = "concept/image";
        this.snapshotCurrentMode = window.globals.takeConceptSnapshots;
        this.snapshotInProgress = false;
        this.clearHtmlContainer();
        this.tepLoaderElement = $("#spinnerConcept");
        return this.getNextTeiId();
      };

      /*
      getNextTeiId(current_tei)
      -----
      Get the id of the next TEi we are supposed to show
      */


      TeachingElementPlatform.prototype.getNextTeiId = function(current_tei) {
        if (current_tei == null) {
          current_tei = null;
        }
        this.showTepLoader();
        _this = this;
        return $.ajax({
          url: this.loadNextTeiUrl,
          type: "POST",
          data: {
            "concept": this.conceptId,
            "course_instance": this.courseInstanceId,
            "cohort": this.cohortId,
            "wave": this.waveId,
            "current": current_tei,
            "preview": this.conceptPreview
          },
          success: function(data) {
            var initializationTeisEventList, tei, tei_id, tei_temp, _i, _j, _len, _len1, _ref, _ref1, _results;
            _this.kalturaSessionKey = $.cookie('kalturaSessionKey');
            if (!_this.pathsWithTeis) {
              _this.pathsWithTeis = data.paths_with_teis;
            }
            _this.sendSidebarDisabledComponents(data.s_comps_d);
            if (data.tei_completed_while_unlocked_mode) {
              if (data.unlocked_mode_page_complete) {
                _this.dispatchEvent('TEP.NoActionPageDone', {});
              }
              _this.dispatchEvent('TEP.TeiInitializationStarted', {
                teis: _this.rootElementsIds
              });
              _this.hideTepLoader();
              return;
            }
            if ((!data.teis.length || data.next_concept) && !_this.conceptPreview) {
              _this.handleNextCoursewareContainer(data.next_concept, data.next_module, data.prevent_auto_navigation);
            }
            initializationTeisEventList = data.teis;
            if (!initializationTeisEventList.length) {
              initializationTeisEventList = _this.rootElementsIds;
              _this.hideTepLoader();
            }
            _this.dispatchEvent('TEP.TeiInitializationStarted', {
              teis: initializationTeisEventList
            });
            _ref = data.teis;
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              tei_temp = _ref[_i];
              if (__indexOf.call(_this.rootElementsIds, tei_temp) >= 0) {
                data.teis = data.teis.filter(function(e) {
                  return e !== tei_temp;
                });
              }
            }
            if (data.teis) {
              _this.rootElementsCount += data.teis.length;
            }
            _ref1 = data.teis;
            _results = [];
            for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
              tei_id = _ref1[_j];
              _this.rootElementsIds.push(tei_id);
              tei = _this.make(tei_id, null, true, true);
              tei.domElem.addClass("teaching-element");
              $(_this.teachingElementsContainerId).append(tei.domElem);
              tei.setParent(null);
              tei.addEventListener("TEProxy.DataLoaded", _this.onTeiProxyLoaded);
              _results.push(tei.addEventListener("ready", _this.onRootTeiReady));
            }
            return _results;
          }
        });
      };

      /*
      onTeiProxyLoaded(evt, data)
      -----
      Callback method called when tei proxy ajax request gets completed. Returns proxy source data.
      */


      TeachingElementPlatform.prototype.onTeiProxyLoaded = function(evt, data) {
        var elem;
        this._loadedCount += 1;
        elem = data.currentTarget;
        if (elem.sourceData) {
          return elem.initTEI();
        }
      };

      /*
      make(teiId, domElem, autoload)
      ------------------------------
      Starts the TEI instantiation process for a single TEI. Generally speaking, this
      entails creating a TEProxy instance with the passed settings and listening for
      the 'ready' event.
      See the TEProxy class for more details.
      */


      TeachingElementPlatform.prototype.make = function(tepId, domElem, autoload, loadOnState) {
        var delay, tei, _ref;
        if (Utils.isGUID(tepId)) {
          if (domElem == null) {
            domElem = $("<div>").addClass('te').attr('data-tep-id', tepId);
          }
          tei = new TEProxy(domElem, tepId, autoload, loadOnState);
        } else {
          if (domElem == null) {
            domElem = $("<div>").addClass('te');
          }
          tei = new TEProxy(domElem, "anonymousText", false);
          delay = function() {
            return tei.onDataLoad({
              tei: {
                input: {
                  id: "anonymousText",
                  te: "html",
                  version: "0.1",
                  text: tepId
                }
              }
            }, 200, null);
          };
          setTimeout(delay, 100);
        }
        tei.on('ready', this.shedProxy);
        if (_ref = tei.$el.data("tep-id"), __indexOf.call(this.rootElementsIds, _ref) >= 0) {
          this.rootElements.push(tei);
        }
        return tei;
      };

      /*
      cleanup()
      ---------
      A utility method that calls cleanup() on all TEIs.
      This method is expected to be called right before the user leaves the concept
      page, if possible.
      */


      TeachingElementPlatform.prototype.cleanup = function() {
        var element, _i, _len, _ref, _results;
        _ref = this.rootElements;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          element = _ref[_i];
          if (element.hasOwnProperty('cleanup')) {
            _results.push(element.cleanup());
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };

      /*
      getState(id, callback)
      ----------------------
      Loads the current state for any given TEI id. This is decoupled from the TEI
      itself so that simple state checks may be done without a full instantiation.
      */


      TeachingElementPlatform.prototype.getState = function(id, callback) {
        return $.ajax({
          url: Utils.normalizeUrl('/state/' + id + '/'),
          success: callback,
          dataType: 'json',
          type: 'GET'
        });
      };

      TeachingElementPlatform.prototype.disable = function() {
        var tei, _i, _len, _ref, _results;
        _ref = this.rootElements;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tei = _ref[_i];
          if (tei.status !== "locked" && (tei.disable != null)) {
            _results.push(tei.disable());
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };

      TeachingElementPlatform.prototype.enable = function() {
        var tei, _i, _len, _ref, _results;
        _ref = this.rootElements;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tei = _ref[_i];
          if (tei.status !== "locked" && (tei.enable != null)) {
            _results.push(tei.enable());
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };

      /*
      Events
      ======
      The Platform fires the following events:
      
      TEI.Ready
      ---------
      Fired as each TEI on the page declares itself fully loaded and ready.
      
      TEI.Complete
      ------------
      Fired as each TEI on the page declares itself complete.
      
      TEP.AllTEIReady
      ---------------
      Fired once all root TEIs on the page have been fully loaded and are on the page.
      
      TEP.AllTEIComplete
      ------------------
      Fired once all root TEIs on the page have reached their "complete" state.
      
      TEP.TeiInitializationStarted
      ------------------
      Fired after getNextTeiId method returns next set of tei ids and before they start their initialization.
      Sends a list of ids that are going to get loaded before they actually load, which can be useful for prepare operations.
      NOTE: In case of no action (unlocked wave mode), event is fired and sends all the teaching elements on the page as a list of ids.
      
      TEP.NoActionPageDone
      ------------------
      Fired when server signals that in no action page, usually unlockAll mode, user is done with all the teaching elements available.
      Also fired when we reached the end of the page, there is no next concept page, and course dashboard url is not available (admin preview).
      */


      /*
      Private Methods
      ================
      */


      /*
      shedProxy()
      -----------
      An event handler for the Proxy 'ready' event. It swaps out the proxy object.
      for the actual TEI it holds, binds event listeners to the TEI.
      */


      TeachingElementPlatform.prototype.shedProxy = function(evt, data) {
        var i, proxy, rootProxyIndex,
          _this = this;
        proxy = data.currentTarget;
        i = this.rootElements.indexOf(proxy);
        proxy.te.on('statuschange', this.checkGlossary);
        proxy.te.on('TEI.RequestSnapshot', function(evt, data) {
          return _this.dispatchEvent(evt, data);
        });
        this.courseSearchModel.addSearchChangeListener(proxy.te.onSidebarSearchChange);
        if (proxy.te.autoCompleted && proxy.te.status === 'complete') {
          data = {
            index: this.rootElements.indexOf(proxy.te),
            total: this.rootElements.length
          };
          this.onTeiCompleteActions(data);
        }
        proxy.te.on('complete', function(evt, te) {
          data = {
            index: _this.rootElements.indexOf(te),
            total: _this.rootElements.length
          };
          return _this.onTeiCompleteActions(data);
        });
        rootProxyIndex = this.rootElements.indexOf(proxy);
        if (rootProxyIndex > -1) {
          this.rootElements.splice(i, 1, proxy.te);
          if (proxy.te.autoCompleted && proxy.te.status === 'complete') {
            this.unlockNext('complete', proxy.te);
          }
          proxy.te.on('complete', this.unlockNext);
        }
        return this.dispatchEvent('TEI.Ready', {
          tei_id: proxy.te.id
        });
      };

      /*
      onTeiCompleteActions()
      -----------
      Set of actions to do when a teaching element gets completed.
      */


      TeachingElementPlatform.prototype.onTeiCompleteActions = function(data) {
        this.dispatchEvent('TEI.Complete', data);
        return this.snapshotCheckOnTeiComplete(data);
      };

      /*
      checkGlossary()
      -----------------------
      Dispatches events based on whether the glossary should be enabled or disabled.
      This is controlled by the teaching element glossary_enabled attribute.
      The Teaching Element must be in-progress for it to have an effect on the glossary.
      */


      TeachingElementPlatform.prototype.checkGlossary = function(evt, data) {
        var elem, next, _i, _len, _ref;
        next = null;
        _ref = this.rootElements;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          elem = _ref[_i];
          switch (elem.status) {
            case 'locked':
              if (next == null) {
                next = elem;
              }
              break;
            case 'in-progress':
              if (elem.glossary_enabled) {
                return this.dispatchEvent('TEP.GlossaryEnable', {});
              } else {
                return this.dispatchEvent('TEP.GlossaryDisable', {});
              }
              break;
            default:
              break;
          }
        }
        if (next == null) {
          return this.dispatchEvent('TEP.GlossaryEnable', {});
        }
      };

      /*
      onRootTeiReady(evt, data)
      -----------------------
      Internal event handler to be fired once a root TEI is ready
      If all root teis are ready it fires the TEP.AllTEIReady event
      */


      TeachingElementPlatform.prototype.onRootTeiReady = function(evt, data) {
        var allComplete, allReady, roles, rootElem, _i, _len, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
        if (_ref = data.id, __indexOf.call(this.rootReadyTeiIds, _ref) >= 0) {
          return;
        }
        if (this.allReadyEventDispatched) {
          this.positionToTei(data.id);
        }
        allReady = true;
        allComplete = true;
        _ref1 = this.rootElements;
        for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
          rootElem = _ref1[_i];
          if (this.conceptPreview) {
            roles = ((_ref2 = rootElem.sourceData) != null ? (_ref3 = _ref2.teaching_element_type) != null ? _ref3.roles : void 0 : void 0) != null ? rootElem.sourceData.teaching_element_type.roles : false;
            if (roles && __indexOf.call(roles, "hidden") >= 0 && (_ref4 = rootElem.id, __indexOf.call(this.hiddenTeiIds, _ref4) < 0)) {
              this.hiddenTeiIds.push(rootElem.id);
            }
            if ((_ref5 = rootElem.buttonBay) != null ? _ref5.hasButton("continue") : void 0) {
              rootElem.buttonBay.hideButton("continue");
            }
          }
          if (!rootElem.ready) {
            allReady = false;
          }
          if (rootElem.ready && (_ref6 = rootElem.id, __indexOf.call(this.rootReadyTeiIds, _ref6) < 0)) {
            this.rootReadyTeiIds.push(rootElem.id);
          }
          if (rootElem.status !== "complete") {
            allComplete = false;
          }
        }
        this.hideTepLoader();
        this._conceptReview = allComplete;
        if (allReady && this.rootReadyTeiIds.length === this.rootElementsCount) {
          this.allReadyEventCallback();
          return this.checkGlossary(null, null);
        }
      };

      /*
      unlockNext()
      ------------
      Sends a request to load the next TEI if the previous one is in complete state.
      */


      TeachingElementPlatform.prototype.unlockNext = function(status, current_tei) {
        if (status === "complete") {
          return this.getNextTeiId(current_tei.id);
        }
      };

      /*
      handleNextCoursewareContainer(next_concept, next_module)
      -----
      Handle navigation to next courseware container - concept page.
      In case it exists update & display the navigation links and automatically redirect to it.
      If the next concept is locked or we hit the end of the course then automatically redirect to course dashboard.
      */


      TeachingElementPlatform.prototype.handleNextCoursewareContainer = function(next_concept, next_module, prevent_auto_navigation) {
        var nextConceptNav, nextConceptNavTitle;
        if (next_concept) {
          nextConceptNavTitle = $("#next_concept_nav_title");
          nextConceptNav = $("#next_concept_nav");
          nextConceptNav.removeClass("disabled");
          nextConceptNav.attr("href", next_concept.url);
          if (!next_module.open) {
            nextConceptNavTitle.attr("data-original-title", next_module.release_msg);
            nextConceptNavTitle.removeClass("fa-chevron-right");
            nextConceptNav.removeAttr("href");
            if (!prevent_auto_navigation) {
              if (this.courseDashboardUrl) {
                this.lastCheckAndNavigate(this.courseDashboardUrl);
              }
              return;
            }
          } else {
            nextConceptNavTitle.attr("data-original-title", next_concept.display_name);
          }
          nextConceptNavTitle.tooltip();
          nextConceptNav.attr("style", "visibility: visible");
          if (!prevent_auto_navigation) {
            return this.lastCheckAndNavigate(window.sidebarApp.processConceptUrl(next_concept.url));
          }
        } else {
          if (this.courseDashboardUrl) {
            return this.lastCheckAndNavigate(this.courseDashboardUrl);
          } else {
            return this.dispatchEvent("TEP.NoActionPageDone", {});
          }
        }
      };

      /*
      positionToTei(tei_id)
      -----------------------
      Scroll to specific teaching element with tei_id provided. Take header height as 50.
      This can be called only when teaching element reported to be ready either himself or by TEP.AllTEIReady event.
      First check does this element exist before attempting to scroll to it.
      We don't do tei jumping on concept preview in the course creator.
      */


      TeachingElementPlatform.prototype.positionToTei = function(tei_id) {
        var tei_element;
        if (this.conceptPreview) {
          return;
        }
        tei_element = $("[data-tep-id=" + tei_id + "]");
        if (tei_element.length) {
          return $("html, body").animate({
            scrollTop: tei_element.offset().top - 50
          }, 1000);
        }
      };

      /*
      getToNextTei(current_tei_id)
      -----------------------
      Give current tei_id to find the next tei_id in the list of root teaching element instances on this concept page and then navigate to it.
      Before navigation attempt we check does the next tei actually exist.
      This is to provide means for navigation when all the teaching elements are already loaded.
      */


      TeachingElementPlatform.prototype.getToNextTei = function(current_tei_id) {
        var current_tei_index, next_tei_id, next_tei_index;
        current_tei_index = this.rootElementsIds.indexOf(current_tei_id);
        next_tei_index = current_tei_index + 1;
        if (this.rootElementsIds[next_tei_index] !== void 0) {
          next_tei_id = this.rootElementsIds[next_tei_index];
          return this.positionToTei(next_tei_id);
        }
      };

      /*
      clearHtmlContainer()
      -----------------------
      Delete content of TEP html container for the teaching element instances on the page.
      This is usually used when re-running the platform to make sure no duplicate data exists in the html.
      In combination with run() it can also be used for testing without having to refresh the page.
      */


      TeachingElementPlatform.prototype.clearHtmlContainer = function() {
        return $(this.teachingElementsContainerId).html("");
      };

      /*
      showTepLoader()
      -----------------------
      Display the loader element to inform the user that a loading process is happening in the background.
      Loader should stay displayed from the moment user requested next content to the point all teaching elements loaded report they are ready to be used.
      */


      TeachingElementPlatform.prototype.showTepLoader = function() {
        return this.tepLoaderElement.show();
      };

      /*
      hideTepLoader()
      -----------------------
      Hide the loader element.
      We want to make sure all teaching elements currently on the page report they are ready before we do this.
      Since this method is called when everything on page regarding TEP is ready also call the path outline method.
      */


      TeachingElementPlatform.prototype.hideTepLoader = function() {
        if (this.rootElementsCount === this.rootReadyTeiIds.length) {
          this.tepLoaderElement.hide();
          return this.displayPathOutlines();
        }
      };

      /*
      displayPathOutlines()
      -----------------------
      Display a border around teaching elements that belong to the same path in the path container and put a name above them for easier clarification.
      This only works for internal users and unlocked mode, we check did the server send data and if so we do our stuff.
      We only want to do this operation once.
      */


      TeachingElementPlatform.prototype.displayPathOutlines = function() {
        var jquery_selector, name_content, outline_content, path, path_container, t, temp_selectors, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2;
        if (this.pathsWithTeis && !this.pathOutlinesSet) {
          _ref = this.pathsWithTeis;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            path_container = _ref[_i];
            _ref1 = path_container.paths;
            for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
              path = _ref1[_j];
              temp_selectors = [];
              _ref2 = path.teis;
              for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
                t = _ref2[_k];
                temp_selectors.push('[data-tep-id="' + t + '"]');
              }
              jquery_selector = temp_selectors.join();
              outline_content = '<div class="teaching-element-path-outline" data-path-container-id="' + path_container.id + '" data-path-id="' + path.id + '"></div>';
              name_content = '<div class="teaching-element-path-outline-name">' + path.name + '</div>';
              $(jquery_selector).wrapAll(outline_content).parent().prepend(name_content);
            }
          }
          return this.pathOutlinesSet = true;
        }
      };

      /*
      allReadyEventCallback()
      -----------------------
      Handles tasks which are supposed to happen after initial load of teaching element is done and they are all ready to be used.
      Sets allReadyEventDispatched variable, loads snapshot capabilities etc.
      */


      TeachingElementPlatform.prototype.allReadyEventCallback = function() {
        if (this.allReadyEventDispatched) {
          return;
        }
        this.allReadyEventDispatched = true;
        this.dispatchEvent("TEP.AllTEIReady", {});
        this.SnapshotManager = require("common/js/app/screenshot_manager");
        if (window.SkipToConfig) {
          window.skipToMenuInit();
        }
        return this.conceptPreviewSnapshot();
      };

      /*
      lastCheckAndNavigate()
      -----------------------
      Do last operations required before page exit, snapshot, and then navigate to the url specified..
      */


      TeachingElementPlatform.prototype.lastCheckAndNavigate = function(url_to_navigate) {
        var _this = this;
        if (this.snapshotCurrentMode === this.snapshotModeConceptCompletion || this.snapshotCurrentMode === this.snapshotModeFirstLast) {
          this.snapshotInProgress = true;
          this.SnapshotManager.queueSnapshot(this.conceptId, this.snapshotUserScope);
        }
        if (this.snapshotInProgress) {
          return document.addEventListener("ScreenshotEvent", function() {
            return window.location = url_to_navigate;
          });
        } else {
          return window.location = url_to_navigate;
        }
      };

      /*
      snapshotCheckOnTeiComplete()
      -----------------------
      Check are we supposed to take the snapshot and if so take it.
      */


      TeachingElementPlatform.prototype.snapshotCheckOnTeiComplete = function(data) {
        var _this = this;
        if (this.snapshotCurrentMode === this.snapshotModeFirstLast && data.index === 0) {
          this.snapshotInProgress = true;
          this.SnapshotManager.queueSnapshot(this.conceptId, this.snapshotUserScope);
        }
        if (this.snapshotCurrentMode === this.snapshotModeEvery && data.index >= 0) {
          this.snapshotInProgress = true;
          this.SnapshotManager.queueSnapshot(this.conceptId, this.snapshotUserScope);
        }
        _this = this;
        return document.addEventListener("ScreenshotEvent", function() {
          return _this.snapshotInProgress = false;
        });
      };

      /*
      conceptPreviewSnapshotStart()
      -----------------------
      Prepares concept preview snapshot html structure and handles concept preview snapshot taking.
      Gets prepaid to snapshot event so once its done html structure of the page can be returned to original state.
      This is used to make sure path containers are displayed as greyed out html box structures, and snapshot hidden teaching elements are removed out of sight.
      All paths inside path container need to be displayed as part of one box with fixed size, independent of the path container size.
      */


      TeachingElementPlatform.prototype.conceptPreviewSnapshot = function() {
        var brackets_content, hidden_tei_id, jquery_selector, outline_content, path_container, _i, _j, _len, _len1, _ref, _ref1,
          _this = this;
        if (!this.conceptPreview) {
          return;
        }
        if (this.pathsWithTeis) {
          _ref = this.pathsWithTeis;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            path_container = _ref[_i];
            jquery_selector = "[data-path-container-id='" + path_container.id + "']";
            outline_content = '<div class="teaching-element-path-outline-snapshot-block"></div>';
            brackets_content = '<div class="bracket-content">[ - ]</div>';
            $(jquery_selector).wrapAll(outline_content).parent().prepend(brackets_content);
          }
          $(".teaching-element-path-outline-snapshot-block").find(".teaching-element-path-outline").hide();
        }
        _ref1 = this.hiddenTeiIds;
        for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
          hidden_tei_id = _ref1[_j];
          $("[data-tep-id='" + hidden_tei_id + "']").hide();
        }
        this.snapshotInProgress = true;
        this.SnapshotManager.queueSnapshot(this.conceptId, this.snapshotConceptScope);
        _this = this;
        return document.addEventListener("ScreenshotEvent", function() {
          var _k, _l, _len2, _len3, _ref2, _ref3;
          _this.snapshotInProgress = false;
          if (_this.pathsWithTeis) {
            _ref2 = _this.pathsWithTeis;
            for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
              path_container = _ref2[_k];
              jquery_selector = "[data-path-container-id='" + path_container.id + "']";
              $(jquery_selector).unwrap();
            }
            $(".teaching-element-path-outline").show();
            _ref3 = _this.hiddenTeiIds;
            for (_l = 0, _len3 = _ref3.length; _l < _len3; _l++) {
              hidden_tei_id = _ref3[_l];
              $("[data-tep-id='" + hidden_tei_id + "']").show();
            }
            return $(".bracket-content").remove();
          }
        });
      };

      /*
      sendSidebarDisabledComponents()
      -----------------------
      Send a list of sidebar disabled components to the sidebar application.
      We don't do this in the concept preview since sidebar is not available there.
      */


      TeachingElementPlatform.prototype.sendSidebarDisabledComponents = function(disabled_components) {
        if (!this.conceptPreview) {
          return window.sidebarApp.disabledComponentsCheck(disabled_components);
        }
      };

      /*
      Search Result Highlighting: addHighlights
      ===============================================
      given `elem`, a dom element, highlight `searchPhrase`. If `searchPhrase`
      is not provided, use `window.globals.searchPhrase`. Called from
      TeachingElement.onSidebarSearchChange and TeachingElement.constructor.
      returns a Promise that resolves with the number of search results found.
      See the "done" option at https://markjs.io/.
      */


      TeachingElementPlatform.prototype.addHighlights = function(elem, searchPhrase) {
        var _this = this;
        if (searchPhrase == null) {
          searchPhrase = window.globals.searchPhrase;
        }
        return new Promise(function(resolve, reject) {
          var Mark, e, markContext, markJsParams;
          if (searchPhrase) {
            try {
              Mark = require('markjs');
              if (Mark) {
                markContext = new Mark(elem);
                markContext.unmark();
                markJsParams = $.extend(defaultMarkJsHighlighterOptions, {
                  done: resolve
                });
                markContext.mark(searchPhrase, markJsParams);
                return _this.highlightsActivated = true;
              }
            } catch (_error) {
              e = _error;
              console.error(e);
              return reject(e);
            }
          } else {
            return resolve(0);
          }
        });
      };

      /*
      Search Result Highlighting: removeHighlights
      ===============================================
      Iterate through TEIs, calling MarkJs.unmark() on each
      https://markjs.io/#unmark
      */


      TeachingElementPlatform.prototype.removeHighlights = function() {
        var Mark, markContext, tei, _i, _len, _ref, _results;
        if (this.highlightsActivated) {
          Mark = require('markjs');
          if (Mark) {
            _ref = this.rootElements;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              tei = _ref[_i];
              markContext = new Mark(tei.view());
              _results.push(markContext.unmark());
            }
            return _results;
          }
        }
      };

      return TeachingElementPlatform;

    })(EventDispatcher);
    return new TeachingElementPlatform();
  });

}).call(this);
