// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var FreeEntryTableView, Lightbox, ListView, PollAnswerBaseView, RespondentView, TRANSITION_TIME, Utils, View, moment, moment_timezone, tmpl;
    View = require("tep/utils/view");
    tmpl = require("text!../templates/respondent.html");
    PollAnswerBaseView = require("./pollAnswer/mainView");
    ListView = require("./listView");
    FreeEntryTableView = require('./freeEntryTable');
    Utils = require("tep/utils/utils");
    Lightbox = require('tep/components/lightbox/main');
    moment = require('moment');
    moment_timezone = require('moment_timezone');
    TRANSITION_TIME = 500;
    return RespondentView = (function(_super) {
      __extends(RespondentView, _super);

      function RespondentView(model) {
        this.onPostCommentKeydown = __bind(this.onPostCommentKeydown, this);
        this.onPostCommentClick = __bind(this.onPostCommentClick, this);
        this.onAnswerHistoryKeydown = __bind(this.onAnswerHistoryKeydown, this);
        this.onAnswerHistoryClick = __bind(this.onAnswerHistoryClick, this);
        this.onLikeKeydown = __bind(this.onLikeKeydown, this);
        this.onLikeClick = __bind(this.onLikeClick, this);
        this.handleHistoryDisplay = __bind(this.handleHistoryDisplay, this);
        this.displayUserData = __bind(this.displayUserData, this);
        this.toggleAnswer = __bind(this.toggleAnswer, this);
        this.onRespondentKeydown = __bind(this.onRespondentKeydown, this);
        this.onRespondentSelected = __bind(this.onRespondentSelected, this);
        this._handleModel = __bind(this._handleModel, this);
        this._buildPhotoHtml = __bind(this._buildPhotoHtml, this);
        this.createId = __bind(this.createId, this);
        this.onEyeIconClick = __bind(this.onEyeIconClick, this);
        this.showEyeIcon = __bind(this.showEyeIcon, this);
        this.hideEyeIcon = __bind(this.hideEyeIcon, this);
        this.initializeModel = __bind(this.initializeModel, this);
        this.getAnswerType = __bind(this.getAnswerType, this);
        this.onChange = __bind(this.onChange, this);
        this.setAnswerHeight = __bind(this.setAnswerHeight, this);
        this.showLightbox = __bind(this.showLightbox, this);
        this.showLightboxEvent = __bind(this.showLightboxEvent, this);
        RespondentView.__super__.constructor.call(this, tmpl);
        this.conversation_id = model.get("conversation_id");
        this.answer_index = model.get("index");
        this._img = "" + (model.get("photo")) + "_75x75.png";
        this._displayed = false;
        this._answer_showing = false;
        this.on('requestLightbox', this.onLightboxRequest);
        this.$el.find(".sharedanswer-profile-section").bind({
          click: this.onRespondentSelected,
          keydown: this.onRespondentKeydown
        });
        if (!model.isCurrentUser()) {
          this.$el.find(".sharedanswer-answer-text-footer-star-icon").addClass("sharedanswer-answer-text-footer-star-icon-pointer");
        }
        this.$el.find(".sharedanswer-answer-text-comments").attr("id", this.conversation_id + "_comments");
        this.answerView = this.$el.find(".sharedanswer-answer");
        if (!window.globals.is_invisible) {
          this.answerView.find(".sharedanswer-answer-likes .sharedanswer-meta-icon").bind({
            click: this.onLikeClick,
            keydown: this.onLikeKeydown
          });
          this.answerView.find(".sharedanswer-answer-text-footer-star-icon").bind({
            click: this.onLikeClick,
            keydown: this.onLikeKeydown
          });
          this.answerView.find(".sharedanswer-answer-comments-meta").bind({
            click: this.onPostCommentClick,
            keydown: this.onPostCommentKeydown
          });
        }
        this.setAnswerHeight();
        this._model = model;
        this.initializeModel();
        this._model.addEventListener("Model.Change", this.onChange);
      }

      RespondentView.prototype.onLightboxRequest = function(evt, data) {
        return Lightbox.display(data);
      };

      RespondentView.prototype.showLightboxEvent = function(jqevt) {
        var mainImg, validInput;
        validInput = true;
        if (jqevt.type === "keypress") {
          validInput = Utils.isTypeOfKey('selectKey', jqevt);
        }
        if (validInput) {
          jqevt.stopImmediatePropagation();
          mainImg = $(jqevt.currentTarget);
          return this.showLightbox(mainImg.attr('src'), mainImg.attr('title'));
        }
      };

      RespondentView.prototype.showLightbox = function(src, title) {
        return this.dispatchEvent('requestLightbox', {
          image: src,
          title: title
        });
      };

      RespondentView.prototype.setAnswerHeight = function() {
        this._answer_height = this.answerView.outerHeight(true);
        if (this._answer_height < 45) {
          return setTimeout(this.setAnswerHeight, 500);
        } else {
          this.answerView.css("visibility", "visible");
          return this.answerView.hide();
        }
      };

      RespondentView.prototype.onChange = function() {
        return this._handleModel();
      };

      RespondentView.prototype.getAnswerType = function(ans) {
        return typeof ans;
      };

      RespondentView.prototype.initializeModel = function() {
        var $listContainer, $pollAnswersContainer, ans, ans_data_type, ans_photo, ans_type, freeEntryTableView, is_multi_reflection, listView, name, newId, pollAnswerView, reflection_prompt, short_name, _ref, _ref1;
        name = this._model.get("display_name");
        short_name = name;
        if (name.length > 30) {
          short_name = name.substring(0, 30) + "...";
        }
        $pollAnswersContainer = this.$el.find(".poll-answers");
        $listContainer = this.$el.find(".list");
        this.$el.find(".sharedanswer-respondent-name").text(short_name);
        this.$el.find(".sharedanswer-respondent-name").attr("title", name);
        this.$el.find(".sharedanswer-respondent-image").attr("alt", name);
        ans = this._model.get("answer");
        ans_photo = this._model.get("answer_photo");
        reflection_prompt = this._model.get("reflection_prompt");
        is_multi_reflection = this._model.get("is_multi_reflection");
        ans_type = this._model.get("answer_type");
        ans_data_type = this.getAnswerType(ans);
        switch (ans_type) {
          case "dstratGoals":
            ans = this._model.get("answer_desanitized");
            if (ans_data_type === "object") {
              ans = this.createObjectAnswer(ans);
            }
            break;
          case "list":
            listView = new ListView(this._model);
            $listContainer.append(listView.view());
            break;
          case "freeEntryTable":
            freeEntryTableView = new FreeEntryTableView(this.$el, this._model);
            freeEntryTableView.render();
            break;
          default:
            $listContainer.hide();
        }
        newId = this.createId("sharedanswer-answer");
        this.answerView.find(".sharedanswer-answer-text").attr("id", newId);
        if (is_multi_reflection) {
          this.answerView.find(".sharedanswer-answer-prompt-content").text(reflection_prompt);
        }
        this.answerView.find(".sharedanswer-answer-text-content").html(ans);
        if (ans_photo && "location" in ans_photo && ans_photo.location) {
          this.answerView.find(".sharedanswer-answer-photo").html(this._buildPhotoHtml(newId, ans_photo));
          this.answerView.find(".sharedanswer-answer-photo img").on('mouseover', this.showEyeIcon);
          this.answerView.find(".sharedanswer-answer-photo img").on('mouseout', this.hideEyeIcon);
          this.answerView.find(".sharedanswer-answer-photo .user-magnifying-icon").on('click', this.onEyeIconClick);
          this.answerView.find(".sharedanswer-answer-text-content").addClass("sharedanswer-answer-photo-min-height");
          this.answerView.find(".sharedanswer-answer-text").addClass("sharedanswer-answer-text-width-with-photo");
        } else {
          this.answerView.find(".sharedanswer-answer-text-content").removeClass("sharedanswer-answer-photo-min-height");
          this.answerView.find(".sharedanswer-answer-text").addClass("sharedanswer-answer-text-width-with-no-photo");
        }
        if (ans_data_type === "object") {
          this.answerView.find(".previous_answer_history_container .previous_answer_show_hide_history").bind({
            click: this.onAnswerHistoryClick,
            keydown: this.onAnswerHistoryKeydown
          });
        }
        if (((_ref = this._model.common.get("teiModel")) != null ? (_ref1 = _ref.reflection) != null ? _ref1.pollResponseInSharedReflection : void 0 : void 0) && this._model.get("poll_answers")) {
          pollAnswerView = new PollAnswerBaseView(this._model);
          return $pollAnswersContainer.append(pollAnswerView.view());
        } else {
          return $pollAnswersContainer.hide();
        }
      };

      RespondentView.prototype.hideEyeIcon = function() {
        return this.answerView.find(".sharedanswer-answer-photo .user-magnifying-icon").delay(5000).hide(1);
      };

      RespondentView.prototype.showEyeIcon = function() {
        return this.answerView.find(".sharedanswer-answer-photo .user-magnifying-icon").show();
      };

      RespondentView.prototype.onEyeIconClick = function() {
        var img;
        img = this.answerView.find(".sharedanswer-answer-photo img");
        return this.showLightbox(img.attr('src'), img.attr('title'));
      };

      RespondentView.prototype.createId = function(extra) {
        if (extra == null) {
          extra = "";
        }
        return "" + extra + "_" + (this._model.get('conversation_id'));
      };

      RespondentView.prototype._buildPhotoHtml = function(newId, ans_photo) {
        return "<img src='" + ans_photo.location + "' aria-describedby='" + newId + "'>\n<div class='user-magnifying-icon'></div>";
      };

      RespondentView.prototype._handleModel = function() {
        var commentNumber, likeNumber, liked, likesIcon;
        if (this._model.get("isSelected") != null) {
          this.$el.toggleClass("sharedanswer-selected", this._model.get("isSelected"));
          if (this._model.get("isSelected")) {
            this.$el.find(".sharedanswer-answer-comments").find("img").attr('src', '/bcore/static/te/_common/icons/2/conversation_white.png');
            this.$el.find(".sharedanswer-answer-likes").find("img").attr('src', '/bcore/static/te/_common/icons/2/star_white.png');
          } else {
            this.$el.find(".sharedanswer-answer-comments").find("img").attr('src', '/bcore/static/te/_common/icons/2/conversation_grey.png');
            this.$el.find(".sharedanswer-answer-likes").find("img").attr('src', '/bcore/static/te/_common/icons/2/star_grey.png');
          }
        }
        likesIcon = this.answerView.find(".sharedanswer-answer-likes .sharedanswer-meta-icon");
        likesIcon.toggleClass("sharedanswer-meta-active", !this._model.isCurrentUser());
        if (likesIcon.hasClass("sharedanswer-meta-active")) {
          likesIcon.attr({
            role: "button",
            tabindex: "0"
          });
        } else {
          likesIcon.removeAttr("role").removeAttr("tabindex");
        }
        if (this._model.get("conversation_id") == null) {
          this.$el.find(".sharedanswer-answer-comments").remove();
        }
        if (this._model.get("likes") != null) {
          likeNumber = this._model.get("likes");
          if (likeNumber > 999) {
            likeNumber = "1k+";
          }
          this.$el.find(".sharedanswer-likes-meta-count").text(likeNumber);
        }
        if ((this._model.get("liked_by_user") != null) && this._model.get("liked_by_user")) {
          liked = true;
        } else {
          liked = false;
        }
        this.$el.toggleClass("sharedanswer-meta-liked", liked);
        if (this._model.get("comments") != null) {
          commentNumber = this._model.get("comments");
          if (commentNumber > 999) {
            commentNumber = "1k+";
          }
          this.$el.find(".sharedanswer-comments-meta-count").text(commentNumber);
        }
        this.$el.find(".sharedanswer-answer-time-meta").text(this._model.get("answer_date"));
        if (this.getAnswerType(this._model.get("answer")) === "object") {
          return this.handleHistoryDisplay();
        }
      };

      RespondentView.prototype.onRespondentSelected = function() {
        if (this._answer_showing) {
          return this.toggleAnswer(true);
        } else {
          return this.dispatchEvent("SharedAnswer.AnswerSelectionRequest", {
            answer_index: this.answer_index,
            bubbles: true
          });
        }
      };

      RespondentView.prototype.isSelectKey = function(evt) {
        var code, keys;
        code = evt.keyCode ? evt.keyCode : evt.which;
        keys = Utils.getKeyMap();
        if (code === keys.selectKey) {
          evt.stopPropagation();
          evt.preventDefault();
          return true;
        }
        return false;
      };

      RespondentView.prototype.onRespondentKeydown = function(jqevt) {
        if (this.isSelectKey(jqevt)) {
          return this.onRespondentSelected();
        }
      };

      RespondentView.prototype.toggleAnswer = function(forceHide) {
        var _this = this;
        if (forceHide == null) {
          forceHide = false;
        }
        if (forceHide) {
          this._answer_showing = false;
        } else {
          this._answer_showing = !this._answer_showing;
        }
        if (this._answer_showing) {
          $(this.$el[0]).animate({
            marginBottom: this._answer_height + "px"
          }, TRANSITION_TIME);
          return this.answerView.slideDown(TRANSITION_TIME, function() {
            var curTop, newTop;
            curTop = _this.$el.closest("ul").offset().top;
            newTop = _this.$el.offset().top - parseInt(_this.$el.css("margin-top"));
            return _this.dispatchEvent("SharedAnswer.AnswerScrollRequest", {
              scroll: newTop - curTop,
              bubbles: true
            });
          });
        } else {
          this._model.set("isSelected", false);
          this.answerView.slideUp(TRANSITION_TIME);
          return $(this.$el[0]).animate({
            marginBottom: "0px"
          }, TRANSITION_TIME);
        }
      };

      RespondentView.prototype.displayUserData = function() {
        if (!this._displayed) {
          this.$el.find(".sharedanswer-respondent-image").attr({
            "src": "" + this._img
          });
          this._displayed = true;
          return this._handleModel();
        }
      };

      RespondentView.prototype.createObjectAnswer = function(ans) {
        var answers, curAnswer, i, _i, _ref;
        answers = ans;
        curAnswer = answers[answers.length - 1];
        ans = "<ul><li>" + (curAnswer['answer'].join('</li><li>')) + "</li></ul>";
        if (answers.length > 1) {
          ans += "<div class='previous_answer_history_container'><button class='alt-btn-grey previous_answer_show_hide_history'>Show Answer History</button>                <div class='previous_answer_history' style='display:none'><h4>Goals History</h4><ul>";
          for (i = _i = _ref = answers.length - 2; _ref <= 0 ? _i <= 0 : _i >= 0; i = _ref <= 0 ? ++_i : --_i) {
            if (answers[i]["submitTime"] != null) {
              ans += "<li>" + answers[i]['submitTime'] + " ET<ul><li>" + (answers[i]['answer'].join('</li><li>')) + "</li></ul></li>";
            }
          }
          ans += "</ul></div>";
        }
        return ans;
      };

      RespondentView.prototype.handleHistoryDisplay = function() {
        var answer_history_elem, answer_history_link, label;
        if (this._model.get("display_history") != null) {
          answer_history_link = this.$el.find(".previous_answer_history_container .previous_answer_show_hide_history");
          answer_history_elem = this.$el.find(".previous_answer_history_container .previous_answer_history");
          if (this._model.get("display_history") === "show") {
            label = "Hide Answer History";
            answer_history_elem.css("display", "none");
          } else {
            label = "Show Answer History";
            answer_history_elem.css("display", "");
          }
          answer_history_link.text(label);
          answer_history_elem.slideToggle('slow', function() {
            var answer_history_elem_height, sharedanswer_height;
            sharedanswer_height = $(".sharedanswer-selected").find(".sharedanswer-answer-text ul").outerHeight() + 100;
            if (this.style.display === "none") {
              return $(".sharedanswer-selected").animate({
                marginBottom: sharedanswer_height
              }, TRANSITION_TIME);
            } else {
              answer_history_elem_height = this.offsetHeight;
              return $(".sharedanswer-selected").animate({
                marginBottom: sharedanswer_height + answer_history_elem_height
              }, TRANSITION_TIME);
            }
          });
        }
      };

      RespondentView.prototype.onLikeClick = function() {
        if (!this._model.isCurrentUser()) {
          return this.dispatchEvent("SharedAnswer.LikeToggleRequest", {
            bubbles: true
          });
        }
      };

      RespondentView.prototype.onLikeKeydown = function(jqevt) {
        if (this.isSelectKey(jqevt)) {
          return this.onLikeClick();
        }
      };

      RespondentView.prototype.onAnswerHistoryClick = function() {
        return this.dispatchEvent("SharedAnswer.AnswerHistoryRequest", {
          bubbles: true
        });
      };

      RespondentView.prototype.onAnswerHistoryKeydown = function(jqevt) {
        if (this.isSelectKey(jqevt)) {
          return this.onAnswerHistoryClick();
        }
      };

      RespondentView.prototype.onPostCommentClick = function() {
        var focusedElement;
        focusedElement = document.activeElement;
        return this.dispatchEvent("SharedAnswer.ConversationRequest", {
          bubbles: true,
          focusedElement: focusedElement
        });
      };

      RespondentView.prototype.onPostCommentKeydown = function(jqevt) {
        if (this.isSelectKey(jqevt)) {
          return this.onPostCommentClick();
        }
      };

      return RespondentView;

    })(View);
  });

}).call(this);
