// Generated by CoffeeScript 1.6.3
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var ResultView, ResultViews, Template, View;
    View = require('tep/utils/view');
    Template = require('text!../templates/result.html');
    ResultViews = {
      histogram: require('./results/numeric_histogram'),
      multipleChoiceHistogram: require('./results/multiple_choice_histogram'),
      participation: require('./results/participation'),
      average: require('./results/mean'),
      percentage: require('./results/percentage'),
      survey: require('./results/survey'),
      complete_message: require('./results/complete_message')
    };
    return ResultView = (function(_super) {
      __extends(ResultView, _super);

      function ResultView(model) {
        var beforeAndAfterGraphData, isSurvey, multipleChoiceGraphType, res, resView, results, type, _base, _i, _len;
        ResultView.__super__.constructor.call(this, Template);
        type = model.get('response.type');
        isSurvey = model.get('survey');
        beforeAndAfterGraphData = model.get('graphInBeforeAndAfter');
        if (beforeAndAfterGraphData && beforeAndAfterGraphData['show'] && !model.get('calledFromBeforeAndAfter')) {
          results = ['complete_message'];
        } else {
          switch (type) {
            case "numeric":
              results = model.get("result.numeric.type").split("_");
              break;
            case "semantic":
              results = ["percentage"];
              break;
            case "multipleChoice":
              multipleChoiceGraphType = (_base = model.get("result").multipleChoice).graphType != null ? (_base = model.get("result").multipleChoice).graphType : _base.graphType = "pie";
              if (multipleChoiceGraphType === "pie") {
                results = ["percentage"];
              } else {
                results = ["multipleChoiceHistogram"];
              }
          }
          if (!isSurvey) {
            results.push('participation');
          } else {
            results = ['survey'];
          }
        }
        for (_i = 0, _len = results.length; _i < _len; _i++) {
          res = results[_i];
          resView = new ResultViews[res](model);
          this.addChild(resView);
        }
      }

      return ResultView;

    })(View);
  });

}).call(this);
