// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  define(function(require) {
    var $, RingDisplay;
    $ = require('jquery');
    return RingDisplay = (function() {
      function RingDisplay(options) {
        this.draw = __bind(this.draw, this);
        this.animate = __bind(this.animate, this);
        this.view = __bind(this.view, this);
        var defaults, k, v;
        defaults = {
          radius: 64,
          ringWidth: 8,
          baseColor: '#dfe0e3',
          percentColor: '#8a8f99',
          percentStroke: '#ffffff'
        };
        this.settings = {};
        for (k in defaults) {
          v = defaults[k];
          this.settings[k] = options.hasOwnProperty(k) ? options[k] : v;
        }
        this._view = $("<canvas>").attr({
          width: this.settings.radius * 2,
          height: this.settings.radius * 2
        });
        this.ctx = this._view.get(0).getContext('2d');
      }

      RingDisplay.prototype.view = function() {
        return this._view;
      };

      RingDisplay.prototype.animate = function(options) {
        var defaults, k, position, settings, startTime, v,
          _this = this;
        defaults = {
          from: 0,
          to: 1,
          duration: 1000,
          fps: 60
        };
        settings = {};
        for (k in defaults) {
          v = defaults[k];
          settings[k] = options.hasOwnProperty(k) ? options[k] : v;
        }
        position = settings.from;
        startTime = Date.now();
        this.draw(position);
        return this.animInterval = setInterval(function() {
          var delta, n;
          n = Date.now();
          delta = n - startTime;
          position = settings.from + (settings.to - settings.from) * delta / settings.duration;
          _this.draw(position);
          if (delta >= settings.duration) {
            return clearInterval(_this.animInterval);
          }
        }, settings.duration / settings.fps);
      };

      RingDisplay.prototype.draw = function(percent) {
        percent = Math.min(1, Math.max(0, percent));
        this.ctx.clearRect(0, 0, 2 * this.settings.radius, 2 * this.settings.radius);
        this.ctx.save();
        this.ctx.save();
        this.ctx.fillStyle = this.settings.baseColor;
        this.ctx.fillRect(0, 0, 2 * this.settings.radius, 2 * this.settings.radius);
        this.ctx.restore();
        this.ctx.save();
        this.ctx.shadowColor = 'rgba(0,0,0, 0.8)';
        this.ctx.shadowBlur = 8;
        this.ctx.lineWidth = 1;
        this.ctx.strokeStyle = 'black';
        this.ctx.beginPath();
        this.ctx.arc(this.settings.radius, this.settings.radius, this.settings.radius + 1, 0, Math.PI * 2, false);
        this.ctx.closePath();
        this.ctx.stroke();
        this.ctx.beginPath();
        this.ctx.arc(this.settings.radius, this.settings.radius, this.settings.radius - this.settings.ringWidth - 1, 0, Math.PI * 2, false);
        this.ctx.closePath();
        this.ctx.stroke();
        this.ctx.restore();
        this.ctx.save();
        this.ctx.fillStyle = this.settings.percentColor;
        this.ctx.strokeStyle = this.settings.percentStroke;
        if (percent === 1) {
          this.ctx.fillRect(0, 0, 2 * this.settings.radius, 2 * this.settings.radius);
        } else {
          this.ctx.beginPath();
          this.ctx.arc(this.settings.radius, this.settings.radius, this.settings.radius + 1, -Math.PI / 2, -Math.PI / 2 - percent * Math.PI * 2, true);
          this.ctx.lineTo(this.settings.radius, this.settings.radius);
          this.ctx.closePath();
          this.ctx.fill();
        }
        this.ctx.stroke();
        this.ctx.restore();
        this.ctx.globalCompositeOperation = "destination-in";
        this.ctx.beginPath();
        this.ctx.arc(this.settings.radius, this.settings.radius, this.settings.radius, 0, Math.PI * 2, false);
        this.ctx.closePath();
        this.ctx.fill();
        this.ctx.globalCompositeOperation = 'xor';
        this.ctx.beginPath();
        this.ctx.arc(this.settings.radius, this.settings.radius, this.settings.radius - this.settings.ringWidth, 0, Math.PI * 2, false);
        this.ctx.closePath();
        this.ctx.fill();
        return this.ctx.restore();
      };

      return RingDisplay;

    })();
  });

}).call(this);
