// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var Slider, SliderView, Template, View;
    View = require('tep/utils/view');
    Template = require('text!te/poll/0.2/courseware/templates/slider.html');
    Slider = require("tep/components/slider/main");
    require('common/js/vendor/jquery_plugins/autoNumeric-min');
    return SliderView = (function(_super) {
      var JS_FLOATING_POINT_ROUNDING_CORRECTION;

      __extends(SliderView, _super);

      JS_FLOATING_POINT_ROUNDING_CORRECTION = 0.0000001;

      function SliderView(data) {
        var maximumLabel, minimumLabel, sliderOptions,
          _this = this;
        this.data = data;
        this.update = __bind(this.update, this);
        this.disable = __bind(this.disable, this);
        this.onSubmitSelection = __bind(this.onSubmitSelection, this);
        this.onValueChange = __bind(this.onValueChange, this);
        this.formatNumber = __bind(this.formatNumber, this);
        this.buildSteps = __bind(this.buildSteps, this);
        this.$el = $(_.template(Template)());
        this.range = this.data.attributes.max - this.data.attributes.min;
        this["default"] = 100 * (this.data.sliderDefault - this.data.attributes.min);
        this.step = 100 * this.data.sliderStep;
        minimumLabel = this.data.minimumOptionLabel ? this.data.minimumOptionLabel : '';
        maximumLabel = this.data.maximumOptionLabel ? this.data.maximumOptionLabel : '';
        this.USDformat = _.isEqual(new RegExp(this.data.format), /^\-?\d+(\.\d+)?$/);
        this.buildSteps();
        sliderOptions = {
          title: this.data.label,
          description: 'Pick Valuer',
          min: this.data.attributes.min,
          max: this.data.attributes.max,
          currentValue: this.data.sliderDefault,
          currentValueType: 'scaled',
          delta: this.data.sliderStep,
          showTooltips: true,
          tooltipFormatter: function(currentValue) {
            return _this.formatNumber(Math.round(currentValue * 100) / 100);
          },
          labels: {
            'min': {
              content: "" + (this.formatNumber(this.data.attributes.min)) + " </br> " + minimumLabel,
              value: 0,
              valueType: 'raw'
            },
            'max': {
              content: "" + (this.formatNumber(this.data.attributes.max)) + " </br> " + maximumLabel,
              value: 1,
              valueType: 'raw'
            }
          }
        };
        this.slider = new Slider(sliderOptions);
        this.$el.append(this.slider.$dom);
        this.slider.addEventListener('Slider.ValueChange', this.onValueChange);
        this.onValueChange();
        this.slider._snapValue = function(percentage) {
          var snapPercentage, snapValue, value;
          value = percentage * _this.range + _this.data.attributes.min;
          snapValue = _this.steps.reduce(function(x, y) {
            if (Math.abs(value - x) < Math.abs(value - y)) {
              return x;
            } else {
              return y;
            }
          });
          snapPercentage = (snapValue - _this.data.attributes.min) / _this.range;
          return snapPercentage;
        };
      }

      SliderView.prototype.buildSteps = function() {
        var higherSteps, lowerSteps, x;
        lowerSteps = ((function() {
          var _i, _ref, _ref1, _ref2, _results;
          _results = [];
          for (x = _i = _ref = this.data.sliderDefault, _ref1 = this.data.attributes.min - JS_FLOATING_POINT_ROUNDING_CORRECTION, _ref2 = -this.data.sliderStep; _ref2 > 0 ? _i < _ref1 : _i > _ref1; x = _i += _ref2) {
            _results.push(x);
          }
          return _results;
        }).call(this)).reverse();
        higherSteps = (function() {
          var _i, _ref, _ref1, _ref2, _results;
          _results = [];
          for (x = _i = _ref = this.data.sliderDefault, _ref1 = this.data.attributes.max + JS_FLOATING_POINT_ROUNDING_CORRECTION, _ref2 = this.data.sliderStep; _ref2 > 0 ? _i < _ref1 : _i > _ref1; x = _i += _ref2) {
            _results.push(x);
          }
          return _results;
        }).call(this);
        return this.steps = (lowerSteps.concat(higherSteps)).map(function(value) {
          return Math.round(value * 100) / 100;
        });
      };

      SliderView.prototype.formatNumber = function(number) {
        var string;
        if (this.USDformat) {
          string = number.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        } else {
          string = number.toFixed(2).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }
        if (this.data.units.left) {
          string = this.data.units.left + string;
        }
        if (this.data.units.right) {
          string = string + this.data.units.right;
        }
        return string;
      };

      SliderView.prototype.onValueChange = function(evt, data) {
        return this.dispatchEvent("Poll.ResponseChangeRequest", {
          value: [this.slider.scaledValue().toString()],
          displayValue: this.formatNumber(this.slider.scaledValue()),
          bubbles: true
        });
      };

      SliderView.prototype.onSubmitSelection = function(evt, data) {
        this.dispatchEvent("Poll.ResponseSubmission", {
          bubbles: true
        });
        return this.slider.disable();
      };

      SliderView.prototype.disable = function() {
        return this.disabled = true;
      };

      SliderView.prototype.update = function(values) {
        this.slider.scaledValue(values[0]);
        if (this.disabled) {
          return this.slider.disable();
        }
      };

      return SliderView;

    })(View);
  });

}).call(this);
