// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice,
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, BaseTmpl, ButtonBay, DebugConsole, DropBar, DropBarBay, EventDispatcher, MathJax, TEP, TeachingElement, Tooltip, TriggerPoint, TriggerPointBay, Utils, defaultButtons, helpIcon_tmpl, _;
    $ = require('jquery');
    _ = require('underscore');
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    TriggerPoint = require('tep/lib/triggerpoint/trigger_point');
    TriggerPointBay = require('tep/lib/triggerpoint/trigger_point_bay');
    DebugConsole = require('tep/lib/debug/debug_console');
    DropBarBay = require('tep/lib/dropbar/drop_bar_bay');
    DropBar = require('tep/lib/dropbar/drop_bar');
    Utils = require('tep/utils/utils');
    Tooltip = require('tep/utils/tooltip');
    TEP = require('./platform');
    BaseTmpl = require('text!./teaching_element_section.html');
    MathJax = require('mathjax');
    ButtonBay = require('tep/components/buttonbay/main');
    helpIcon_tmpl = '<div style="cursor:pointer" role="button" tabindex="0" class="content-info">';
    /*
    Teaching Element
    ================
    Teaching Elements are the base units of course content. Every Teaching Element
    has multiple manifestations in the BCORe system. This class provides the basis
    for the courseware (student-facing) manifestation.
    
    Events
    ======
    All TeachingElements by default fire the following events:
    
    ready
    -----
    Fired whenever the TEI considers itself fully loaded and ready for display
    and use.
    
    statuschange
    ------------
    Fired whenever the status of the TEI changes.
    
    complete
    --------
    Similar to statuschange, except it is only fired when the TEI is completed.
    
    registerTriggerPoint
    --------------------
    For internal use. Fired when the TEI needs to bubble a Trigger Point
    registration.
    
    raiseTriggerPoint
    -----------------
    For internal use. Fired when the TEI needs to notify a parent that
    a Trigger Point needs to be raised.
    
    displayTriggerPoint
    -------------------
    For internal use. Fired when the TEI needs to request to a parent that
    a Trigger Point be displayed.
    */

    /*
      In order to make buttons consistent, here are the default labels, action messages and classes for common buttons
    */

    defaultButtons = {
      save: {
        label: 'Save',
        "class": 'btn btn-save',
        statusMessageAction: 'Your information has been saved.'
      },
      submit: {
        label: 'Submit',
        "class": 'alt-btn btn-submit',
        statusMessageAction: 'Your information has been submitted.'
      },
      reset: {
        label: 'Reset',
        "class": 'btn btn-reset',
        statusMessageAction: 'Your information has been cleared.'
      },
      "continue": {
        label: 'Continue',
        event: 'TE.EndRequest',
        "class": 'alt-btn btn-continue'
      }
    };
    return TeachingElement = (function(_super) {
      __extends(TeachingElement, _super);

      function TeachingElement(data, Template) {
        var btns, section, _i, _j, _len, _len1, _ref, _ref1;
        this.data = data;
        this.getHighlights = __bind(this.getHighlights, this);
        this.onSidebarSearchChange = __bind(this.onSidebarSearchChange, this);
        this.onDropBarChange = __bind(this.onDropBarChange, this);
        this.loadDropBars = __bind(this.loadDropBars, this);
        this.handleTriggerClosed = __bind(this.handleTriggerClosed, this);
        this.handleTriggerOpen = __bind(this.handleTriggerOpen, this);
        this.displayTriggerPoint = __bind(this.displayTriggerPoint, this);
        this.raiseTriggerPoint = __bind(this.raiseTriggerPoint, this);
        this.registerTriggerPoint = __bind(this.registerTriggerPoint, this);
        this.loadTriggerPoints = __bind(this.loadTriggerPoints, this);
        this.attachPingRateLimiters = __bind(this.attachPingRateLimiters, this);
        this.pushMetric = __bind(this.pushMetric, this);
        this.conceptFinaleAdjust = __bind(this.conceptFinaleAdjust, this);
        this.autoEnd = __bind(this.autoEnd, this);
        this.end = __bind(this.end, this);
        this.start = __bind(this.start, this);
        this.unlock = __bind(this.unlock, this);
        this.setStatus = __bind(this.setStatus, this);
        this.parseState = __bind(this.parseState, this);
        this.buildState = __bind(this.buildState, this);
        this.pushCourseInstanceState = __bind(this.pushCourseInstanceState, this);
        this.handleCantSubmit = __bind(this.handleCantSubmit, this);
        this.pushState = __bind(this.pushState, this);
        this.getState = __bind(this.getState, this);
        this.pullState = __bind(this.pullState, this);
        this.silence = __bind(this.silence, this);
        this.log = __bind(this.log, this);
        this.label = __bind(this.label, this);
        this.toString = __bind(this.toString, this);
        this.enable = __bind(this.enable, this);
        this.disable = __bind(this.disable, this);
        this.cleanup = __bind(this.cleanup, this);
        this.onScreen = __bind(this.onScreen, this);
        this.view = __bind(this.view, this);
        this.setParent = __bind(this.setParent, this);
        this.buildButton = __bind(this.buildButton, this);
        this.buildSection = __bind(this.buildSection, this);
        this.buildContinue = __bind(this.buildContinue, this);
        this._onEndRequest = __bind(this._onEndRequest, this);
        this.onSaveRequest = __bind(this.onSaveRequest, this);
        this.updateSaveButton = __bind(this.updateSaveButton, this);
        this.moveButtonBay = __bind(this.moveButtonBay, this);
        this.createId = __bind(this.createId, this);
        this.addHelpText = __bind(this.addHelpText, this);
        this.checkForSearchResults = __bind(this.checkForSearchResults, this);
        this.onStatusChange = __bind(this.onStatusChange, this);
        this.id = this.data.id;
        this.type = this.data.te;
        if (this.triggerPoints == null) {
          this.triggerPoints = [];
        }
        this.purify_warning_shown = false;
        this.autoCompleted = false;
        this.triggerPointBay = new TriggerPointBay;
        this.dropBarBay = new DropBarBay;
        this.dropBarBay.addEventListener('dropBarOpen', this.onDropBarChange);
        this.dropBarBay.addEventListener('dropBarClosed', this.onDropBarChange);
        this.debugConsole = new DebugConsole(this);
        this.sectionIcon = 'interactive';
        if (this.data.sections != null) {
          if (this.data.sections.length === 0) {
            delete this.data.sections;
          } else {
            this.sections = this.data.sections;
          }
          this.$el = $("<div class='container te-container-" + this.type + "'>");
          if (Template !== null) {
            this.data['interactive_additional_content'] = Template;
          }
          _ref = this.sections;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            section = _ref[_i];
            this.buildSection(section);
          }
          _ref1 = this.sections;
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            section = _ref1[_j];
            this.addLaTeX(this.view().find(".te-" + section + " .te-section-title")[0]);
            this.addLaTeX(this.view().find(".te-" + section + " .te-section-content")[0]);
          }
          if (this.data.interactive_help) {
            this.addHelpText(this.$el.find('.te-interactive .te-section-content p').last(), this.data.interactive_help);
          }
        } else {
          if (Template != null) {
            this.$el = $(Template);
            this.$el.addClass("te-container-" + this.type);
          } else {
            if (this.tag == null) {
              this.tag = "div";
            }
            this.$el = $("<" + this.tag + " class='te-container-" + this.type + "'>");
          }
        }
        MathJax.Hub.Queue([this.checkForSearchResults]);
        if (btns = this.buttonBayBuildButtons()) {
          this.buttonBay = new ButtonBay(btns, this.id);
          this.moveButtonBay('end');
          this.buttonBay.view().addEventListener("TE.EndRequest", this._onEndRequest);
        }
        if (this.debug) {
          this.view().append(this.debugConsole.view());
        }
        this.status = "";
        this.pingOn = true;
        this.attachPingRateLimiters();
        this.ready = true;
        this.addEventListener('statuschange', this.onStatusChange);
      }

      TeachingElement.prototype.onStatusChange = function() {
        if (this.status === "complete" && (this.buttonBay != null)) {
          return this.buttonBay.hideButton('continue');
        }
      };

      TeachingElement.prototype.addLaTeX = function(elem) {
        return MathJax.Hub.Queue(["Typeset", MathJax.Hub, elem]);
      };

      /*
      Called from TeachingElement.constructor after the view DOM is ready,
      this method checks the TE's DOM for search results. If any are found,
      it dispatches EventDispatcher.INITIAL_SEARCH_RESULT_FOUND so that drop bars
      and trigger points can listen for the event and open or fire as needed.
      */


      TeachingElement.prototype.checkForSearchResults = function() {
        var _this = this;
        return TEP.addHighlights(this.view()).then(function(numResults) {
          if (numResults) {
            return _this.dispatchEvent(EventDispatcher.INITIAL_SEARCH_RESULT_FOUND, _this);
          }
        });
      };

      TeachingElement.prototype.addHelpText = function($elem, content, defaultPos) {
        var _this = this;
        if (defaultPos == null) {
          defaultPos = "right";
        }
        this.helpIcon = $(helpIcon_tmpl);
        $elem.append(this.helpIcon);
        Tooltip.buildTooltip(this.helpIcon, "instructions-" + this.id + "-tip", content, {
          placement: Tooltip.getTooltipPlacement(defaultPos, 300, 600)
        });
        return this.helpIcon.on("mouseenter", function() {
          return _this.pushMetric({
            viewed: 1
          }, "view_help_text");
        });
      };

      TeachingElement.prototype.createId = function(extra) {
        if (extra == null) {
          extra = "";
        }
        return "" + this.type + "_" + extra + "_" + this.id;
      };

      /*
      moveButtonBay()
      -----------------------
      Move the button bay to a specific location within a TEI
      */


      TeachingElement.prototype.moveButtonBay = function(location) {
        var btnBay;
        if (this.buttonBay != null) {
          if (this.buttonBay.$dom != null) {
            btnBay = this.buttonBay.$dom();
          } else {
            btnBay = this.buttonBay;
          }
        }
        switch (location) {
          case 'interactive':
            return this.view().find('.te-interactive').append(btnBay);
          case 'end':
            return this.view().append(btnBay);
        }
      };

      /*
      updateSaveButton()
      -----------------------
      Enable/disable save button and change text
      */


      TeachingElement.prototype.updateSaveButton = function(enable, saved) {
        var btn;
        if (saved == null) {
          saved = true;
        }
        if ((this.buttons != null) && (this.buttons.save != null)) {
          btn = this.buttons.save;
          if (enable) {
            btn.el.text("Save");
            return this.enableButton('save');
          } else {
            this.disableButton('save');
            if (saved) {
              return btn.el.text("Saved");
            }
          }
        } else if ((this.buttonBay != null) && (this.buttonBay.hasButton('save') != null)) {
          btn = this.buttonBay;
          if (enable) {
            btn.changeLabel('save', 'Save');
            return btn.enableButton('save');
          } else {
            btn.disableButton('save');
            if (saved) {
              return btn.changeLabel('save', 'Saved');
            }
          }
        }
      };

      /*
      onSaveRequest()
      -----------------
      Handles clicks to the save button by calling this.pushState('user)
      */


      TeachingElement.prototype.onSaveRequest = function() {
        this.pushState('user');
        this.updateSaveButton(false);
        return this.pushMetric({
          'savedData': 1
        }, 'save');
      };

      /*
      buttonBayBuildButtons()
      -----------------------
      Method will build continue button by default and additional buttons sent by
      the TE itself if they are in the list (like save, submit and reset)
      */


      TeachingElement.prototype.buttonBayBuildButtons = function(btnIds) {
        var btnId, buttons, cleanBtnId, _i, _len;
        if (btnIds == null) {
          btnIds = [];
        }
        buttons = {};
        for (_i = 0, _len = btnIds.length; _i < _len; _i++) {
          btnId = btnIds[_i];
          cleanBtnId = btnId.toLowerCase().trim();
          if (typeof defaultButtons[cleanBtnId] !== 'undefined') {
            buttons[cleanBtnId] = defaultButtons[cleanBtnId];
          }
        }
        buttons["continue"] = defaultButtons["continue"];
        return {
          buttons: buttons
        };
      };

      /*
      _onEndRequest()
      ------
      Sets a function for clicking on continue button that should end the TE.
      */


      TeachingElement.prototype._onEndRequest = function(evt, data) {
        return this.end();
      };

      /*
      buildContinue()
      ------
      Build the continue button and place at the bottom of the Teaching Element
      */


      TeachingElement.prototype.buildContinue = function() {
        return this.buildButton({
          name: 'continue',
          btnClass: 'alt-btn btn-right',
          disabled: false,
          hidden: false,
          text: 'Continue'
        }, this.$el);
      };

      /*
      buildSection(section_name)
      ------
      Add section to the html. If section is conclusion we are not adding in to @el. This fixes error when rendering tei which has DropBar tei
      of same type.
      */


      TeachingElement.prototype.buildSection = function(section_name) {
        var tmpl;
        if (this.data[section_name + '_title'] || this.data[section_name + '_content'] || this.data[section_name + '_additional_content']) {
          tmpl = _.template(BaseTmpl)({
            title: this.data[section_name + '_title'],
            title_type: this.data[section_name + '_title_type'] || 'h2',
            content: this.data[section_name + '_content'],
            section: section_name,
            additional_content: this.data[section_name + '_additional_content'],
            te_title: section_name === this.sectionIcon,
            te_name: this.data.te
          });
          if (section_name === 'conclusion') {
            $(tmpl).insertBefore(this.view().find('.lock-screen'));
            return;
          }
          return this.$el.append(tmpl);
        }
      };

      /*
      buildButton(config, button_bay)
      ------
      Creates a button and adds it to the button_bay as well as this.buttons[<button_name>]
      */


      TeachingElement.prototype.buildButton = function(config, $container) {
        var $button;
        $button = $('<button class="' + config.btnClass + '">' + config.text + '</button>');
        if (config.hidden) {
          $button.hide();
        }
        if (config.disabled) {
          $button.prop('disabled', true);
        }
        $button.addClass('te-' + this.type);
        if (!(config.name in this.buttons)) {
          this.buttons[config.name] = $button;
        }
        return $container.append(this.buttons[config.name]);
      };

      /*
      External API
      ============
      
      The following methods support access and commands from outside the TEI itself,
      most likely from the TEP-JSL (specifically, the TeachingElementPlatform class).
      
      setParent(parent)
      -----------------
      Establishes the parent of the current TEI. Parents are expected to be other
      TEIs. If the parent is null, then the TEI can assume that it is a "root" TEI.
      */


      TeachingElement.prototype.setParent = function(par) {
        var tp, _i, _len, _ref, _results;
        this.parent = par;
        _ref = this.triggerPoints;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          tp = _ref[_i];
          _results.push(this.registerTriggerPoint(tp, this));
        }
        return _results;
      };

      /*
      view()
      ------
      Provides the TEI's dom (as a jQuery object).
      
      This method lazily wraps the TEI's content in a .tei class and sets up a lock
      screen div.
      */


      TeachingElement.prototype.view = function() {
        if (this._view == null) {
          this._view = $("<div>").addClass('tei');
          this._view.append(this.$el);
          this._view.append($("<div>").addClass('lock-screen'));
        }
        return this._view;
      };

      /*
      onScreen()
      ----------
      Method to be called once the TEI's dom has been entered into the page dom.
      
      By default, this method fires the 'ready' event (see below), which triggers
      a number of processes, including the thumbnail snapshot, so if the TEI wishes
      to delay these processes, they should override onScreen and fire the 'ready'
      event as appropriate.
      */


      TeachingElement.prototype.onScreen = function() {
        return this.dispatchEvent('ready', this);
      };

      /*
      cleanup()
      ---------
      Method to be called before a TEI is removed from the page/window.
      
      By default, this saves the user state for the TEI. This may be overridden
      of different or additional functionality is desired.
      */


      TeachingElement.prototype.cleanup = function() {
        return this.pushState('user');
      };

      /*
      disable()
      ---------
      Method to be overridden by individual TEs. When called, the TE should no longer
      accept user input.
      */


      TeachingElement.prototype.disable = function() {
        this.isDisabled = true;
        if (this.buttonBay != null) {
          this._bbCache = this.buttonBay["export"]();
          return this.buttonBay.disable();
        }
      };

      TeachingElement.prototype.enable = function() {
        this.isDisabled = false;
        if ((this.buttonBay != null) && this._bbCache) {
          this.buttonBay["import"](this._bbCache);
          return this._bbCache = null;
        }
      };

      /*
      toString()
      ----------
      Provides a string representation of the TEI for logging/debugging purposes.
      
      By default, it defers to the label() method, but it may be overridden to
      provide more detailed information.
      */


      TeachingElement.prototype.toString = function() {
        return this.label();
      };

      /*
      label()
      -------
      Provides a single-line string to represent the TEI.
      */


      TeachingElement.prototype.label = function() {
        return "TE." + Utils.ucfirst(this.type) + " #" + this.id;
      };

      /*
      Debug Console API
      ============
      
      log(log[, ...])
      -------------
      If the debug console is activated, writes each provided entry to the debug
      console.
      */


      TeachingElement.prototype.log = function() {
        var logs, obj, _i, _len, _results;
        logs = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
        if (this.debug) {
          _results = [];
          for (_i = 0, _len = logs.length; _i < _len; _i++) {
            obj = logs[_i];
            _results.push(this.debugConsole.log(obj));
          }
          return _results;
        }
      };

      TeachingElement.prototype.silence = function() {
        return this._silent = true;
      };

      /*
      Group Management
      ================
      
      loadGroup(groupData)
      --------------------
      Provides an overridable hook for TEIs to respond to group membership.
      */


      TeachingElement.prototype.loadGroup = function(groupData) {};

      /*
      State API
      =========
      
      Each TEI has the option of maintaining a state object, which is stored and
      provided by the state facility on the server.
      
      State is broken up into multiple scopes:
      
      *   user: The user scope maintains each user's state across multiple visits and
          page loads.
      *   tei: The tei scope maintains state data for the TEI itself. This can be
          aggregate data
      
      pullState()
      -----------
      Grabs the TEI's state from the server, and calls parseState with the returned
      payload.
      */


      TeachingElement.prototype.pullState = function() {
        return TEP.getState(this.id, this.parseState);
      };

      /*
      getState()
      -----------
      Grabs the TEI's state from the server, with custom callback. Used when we need to check
      state of TEI before updating, so there are no logic in parseState method.
      */


      TeachingElement.prototype.getState = function(callback) {
        return TEP.getState(this.id, callback);
      };

      /*
      pushState(scope, operation = 'set', callback = null)
      -------------------------------------
      Sends the state, with the appropriate scope and operation, to the server. The
      object to send is generated by the buildState method. If a callback is
      provided, then it is called after the server responds.
      
      The allowed operations are:
      
      *   __set__: (default) Server saves/updates only the provided fields.
      *   __store__: Server overwrites the existing state object with the one provided.
      *   __increment__: Expects the provided state to be a flat dictionary of keys and
          numeric values. The value of each key will be incremented by the provided
          amount.
      *   __decrement__: Same as increment, except values are decreased by the provided
          amount.
      *   __submit__: Used by question_provider TEs. Submits a user's answer to
          a question. This will increment the attempt count and evaluate the answer.
          Since this will alter the state of the TEI, it is always recommended to
          pullState() in the callback.
      */


      TeachingElement.prototype.pushState = function(scope, op, callback) {
        var data;
        if (op == null) {
          op = "set";
        }
        if (callback == null) {
          callback = null;
        }
        if (!this._silent) {
          data = {
            id: this.id,
            scope: scope === "status" ? "user" : scope,
            operation: op,
            state: this.buildState(scope, op),
            course_instance_id: window.globals.courseInstanceId,
            request_timestamp: this.getUTCtimestamp(),
            cohort_id: window.cohort_id
          };
          this.log("Pushing state:", data);
          return $.ajax({
            url: Utils.normalizeUrl('/state/', "POST"),
            data: JSON.stringify(data),
            success: callback,
            type: 'POST',
            error: this.handleCantSubmit,
            contentType: 'application/json'
          });
        } else if (callback != null) {
          return callback();
        }
      };

      TeachingElement.prototype.handleCantSubmit = function(request, status_text, error) {
        if (request.status === 422) {
          return this.pullState();
        }
      };

      /*
      Participant Context API - User Course Instance State
      ====================================================
      Push values to User Course Instance State.
      Name needs to be in sync with the TE Configurator Class, method course_version_vars.
      Values is a list of labels. In case of a single label send a list with one element.
      Callback method provided is called once ajax request is completed (usually end method to finish teaching element).
      */


      TeachingElement.prototype.pushCourseInstanceState = function(values, name, callback) {
        var data;
        if (callback == null) {
          callback = null;
        }
        data = {
          tei: this.id,
          course_instance_id: window.globals.courseInstanceId,
          concept_id: window.globals.concept,
          values: values,
          name: name
        };
        return $.ajax({
          url: Utils.normalizeParticipantContextURL("set_user_course_instance_state/", "POST"),
          data: JSON.stringify(data),
          success: callback,
          type: "POST",
          contentType: "application/json"
        });
      };

      /*
      buildState(scope, operation)
      ----------------------------
      Called by pushState(), this method exists to be overridden by individiual TEs.
      Given a scope and operation, this method should return the contents of
      the state object appropriate for that scope/operation.
      */


      TeachingElement.prototype.buildState = function(scope, op) {
        var state;
        if (op == null) {
          op = "set";
        }
        state = {};
        switch (scope) {
          case "status":
            state.status = this.status;
        }
        return state;
      };

      /*
      parseState(data)
      ----------------
      Used as a callback for pullState(), this method exists to be overridden by
      individual TEs. The provided data object contains a field named 'states', which
      is a dictionary of states keyed by scope.
      
      parseState should update the TEI with state data as appropriate.
      */


      TeachingElement.prototype.parseState = function(data) {
        var scope, state, _ref, _results;
        _ref = data.states;
        _results = [];
        for (scope in _ref) {
          state = _ref[scope];
          switch (scope) {
            case "user":
              _results.push(this.setStatus(state.status, this.status === ""));
              break;
            default:
              _results.push(void 0);
          }
        }
        return _results;
      };

      /*
      setStatus(status)
      -----------------
      Internal utility method to set the status of the TEI.
      
      Every TeachingElement instance has a 'status', an overarching state of the
      instance. This field can be one of four values:
      
      *   __locked__: The TEI is inaccessible, and should be disabled. A lock screen
          is also placed in front of the TEI as a first line defense against prevent
          casual manipulation.
      *   __unlocked__: The TEI is available for manipulation, but the interaction
          has not yet begun.
      *   __in-progress__: The user has begun interacting with the TEI, and it is in
          an active state of use.
      *   __complete__: The user has completed the requirements of the TEI. In some
          cases, this implies the TEI should be disabled. In others, the TEI should
          remain available to the user.
      
      In the normal course of events, a TEI's status can only move down this list, and
      should not skip a step. This process is generally called the __TEI lifecycle__.
      */


      TeachingElement.prototype.setStatus = function(status, silent, callback) {
        var _this = this;
        if (silent == null) {
          silent = false;
        }
        if (callback == null) {
          callback = null;
        }
        if (this.status !== status && Utils.stases.indexOf(status) > Utils.stases.indexOf(this.status)) {
          this.status = status;
          this.view().removeClass('status-locked status-unlocked status-in-progress status-complete').addClass('status-' + this.status);
          if (silent || window.globals.conceptPreview) {
            this.dispatchEvent('statuschange', this);
            if (this.status === 'complete') {
              this.dispatchEvent('complete', this);
            }
            if (typeof callback === "function") {
              callback();
            }
          } else {
            this.pushState('status', 'set', function() {
              _this.dispatchEvent('statuschange', _this);
              if (_this.status === 'complete') {
                _this.dispatchEvent('complete', _this);
              }
              if (typeof callback === "function") {
                return callback();
              }
            });
            this.pushMetric({
              "statusChange": this.status
            }, "status");
          }
          if (this.status === "in-progress" && TEP.pingRate > 0 && (this.interactionTimeInterval == null)) {
            this.interactionTimeInterval = setInterval(function() {
              if (TEP.pingRate) {
                return _this.pushMetric({
                  "interaction_time": TEP.pingRate
                }, "timespan");
              }
            }, TEP.requestedPingRate * 1000);
          }
          if (this.status === "complete" && (this.interactionTimeInterval != null)) {
            return clearInterval(this.interactionTimeInterval);
          }
        }
      };

      /*
      lock()
      ------
      Utility method to lock the TEI. Called by the TeachingElementPlatform.
      */


      TeachingElement.prototype.lock = function(callback) {};

      /*
      unlock()
      --------
      Utility method to unlock the TEI. Called by the TeachingElementPlatform.
      */


      TeachingElement.prototype.unlock = function(callback) {
        return this.setStatus('unlocked', false, callback);
      };

      /*
      start()
      -------
      Utility method to set the TEI status to in-progress. Each TE should determine
      for itself when to call this method. Frequently, it should be called as soon
      as the TEI is unlocked (see the 'statuschange' event).
      Make sure status is not already in progress before triggering the status change
      and sending the initial interaction time metric
      */


      TeachingElement.prototype.start = function(callback) {
        if (this.status !== 'in-progress') {
          this.setStatus('in-progress', false, callback);
          return this.pushMetric({
            "interaction_time": TEP.pingRate
          }, "timespan");
        }
      };

      /*
      end()
      -----
      Utility function to register the TEI as complete. Each TE should determine for
      itself when to call this method.
      */


      TeachingElement.prototype.end = function(callback) {
        return this.setStatus('complete', false, callback);
      };

      /*
      autoEnd()
      -----
      Automatically complete the teaching element. Mark it as such so we can check it later on.
      */


      TeachingElement.prototype.autoEnd = function(callback) {
        this.autoCompleted = true;
        return this.end(callback);
      };

      /*
      conceptFinaleAdjust()
      ---------------------
      Intended to be called explicitly by the TEP on the last TEI on a concept page.
      Handles any conditional changes related to being last.
      */


      TeachingElement.prototype.conceptFinaleAdjust = function(type) {
        if (type == null) {
          type = "concept";
        }
        if (this.buttonBay != null) {
          return this.buttonBay.changeLabel('continue', type === "course" ? "Finish" : 'Continue to Next Concept');
        }
      };

      /*
      getUTCtimestamp()
      ------
      Utility method to get Unix timestamp of the current UTC time.
      Called by the pushState function to provide client time of sending the state.
      Will be logged to catch the difference between server final time and client send time.
      */


      TeachingElement.prototype.getUTCtimestamp = function() {
        return new Date().getTime();
      };

      /*
      Metrics
      =======
      In addition to saving state to the server, TEIs may also push metrics to the
      metric service. Unlike state, metrics do not (except in rare cases) overwrite
      existing save data, and are never retreived by the TEI.
      
      pushMetric(data, category, callback = null)
      -------------------------------------------
      Sends metric data to the server. The data should be an object containing the
      relevant data. Category should be a string label that distinguishes the metric
      data from other metrics. Generally speaking, there are no pre-defined
      categories, but there is the implication that any metric data that are in
      the same category have the same structure to the data. The callback,
      if provided, is called upon a successful response from the server.
      */


      TeachingElement.prototype.pushMetric = function(data, category, callback) {
        var error, metric;
        if (callback == null) {
          callback = null;
        }
        if (TEP.metricsActive && !this._silent) {
          if ($.isEmptyObject(data)) {
            try {
              throw new Error('Attempted to send an empty metric payload.');
            } catch (_error) {
              error = _error;
              return window.onerror(error.message, '', 0, 0, error);
            }
          } else {
            metric = {
              id: this.id,
              category: category,
              metric: data,
              course_instance_id: window.globals.courseInstanceId
            };
            $.ajax({
              url: Utils.normalizeUrl('/metric/', 'POST'),
              data: JSON.stringify(metric),
              success: callback,
              type: 'POST',
              contentType: 'application/json'
            });
            if (this.debug && !((this.debug.metrics != null) && this.debug.metrics === false)) {
              return this.log("Pushing metric:", metric);
            }
          }
        } else if (this._silent && (callback != null)) {
          return callback();
        }
      };

      /*
      attachPingRateLimiters()
      ------------------------
      Set event handlers, using visibility API if possible
      */


      TeachingElement.prototype.attachPingRateLimiters = function() {
        var hidden, state, visibilityChange,
          _this = this;
        hidden = null;
        state = null;
        visibilityChange = null;
        if ("hidden" in document && (document.hidden != null)) {
          hidden = "hidden";
          visibilityChange = "visibilitychange";
          state = "visibilityState";
        } else if ("mozHidden" in document && (document.mozHidden != null)) {
          hidden = "mozHidden";
          visibilityChange = "mozvisibilitychange";
          state = "mozVisibilityState";
        } else if ("msHidden" in document && (document.msHidden != null)) {
          hidden = "msHidden";
          visibilityChange = "msvisibilitychange";
          state = "msVisibilityState";
        } else if ("webkitHidden" in document && (document.webkitHidden != null)) {
          hidden = "webkitHidden";
          visibilityChange = "webkitvisibilitychange";
          state = "webkitVisibilityState";
        }
        if (visibilityChange == null) {
          return;
        }
        return document.addEventListener(visibilityChange, function() {
          return _this.togglePingRate("visible" === document[state]);
        }, false);
      };

      /*
      togglePingRate(boolean doPing)
      -----------------------------
      Turn ping on and off based on doPing. Passing true
      sets the pingRate to the value of requestedPingRate which
      doesn't necessarily turn it back on (if the requested rate was 0).
      Used in conjuction with window focus/blur to prevent sending pings
      when user is not focused on tab
      */


      TeachingElement.prototype.togglePingRate = function(doPing) {
        if (doPing && TEP.pingRate === 0) {
          TEP.pingRate = TEP.requestedPingRate;
        }
        if (!doPing) {
          return TEP.pingRate = 0;
        }
      };

      /*
      Trigger Points
      ==============
      Every TEI has the capability of supporting Trigger Points. Trigger Points
      are themselves TEIs that are meant to interrupt the normal flow of the parent
      TEI and are required to complete before proceeding with the parent content.
      
      Trigger points should only be displayed for "root" TEIs, so if the current TEI
      has a parent, then the trigger points need to bubble up to the root.
      
      loadTriggerPoints(triggerPointData)
      -----------------------------------
      Creates TriggerPoint wrappers around each item in the data array. Called by the TeachingElementPlatform.
      */


      TeachingElement.prototype.loadTriggerPoints = function(triggerPointData) {
        var data, _i, _len, _results;
        _results = [];
        for (_i = 0, _len = triggerPointData.length; _i < _len; _i++) {
          data = triggerPointData[_i];
          _results.push(this.triggerPoints.push(new TriggerPoint(data, this)));
        }
        return _results;
      };

      /*
      registerTriggerPoint(triggerPoint, source)
      ------------------------------------------
      Registers a trigger point to the containing root TEI's trigger point bay.
      */


      TeachingElement.prototype.registerTriggerPoint = function(tp, source) {
        if (this.parent != null) {
          return this.dispatchEvent('registerTriggerPoint', {
            tp: tp,
            source: source,
            bubbles: true
          });
        } else {
          this.triggerPointBay.register(tp, source);
          return this.view().append(this.triggerPointBay.view());
        }
      };

      /*
      raiseTriggerPoint(tpid)
      -----------------------
      Raises the specified trigger point. Raising a trigger point means that the
      TP should be opened and the calling TEI is waiting for it to complete before
      continuing on.
      */


      TeachingElement.prototype.raiseTriggerPoint = function(id) {
        if (this.parent != null) {
          return this.dispatchEvent('raiseTriggerPoint', {
            id: id
          });
        } else {
          return this.triggerPointBay.show(id);
        }
      };

      /*
      displayTriggerPoint(tpid)
      -------------------------
      Requests the display of a trigger point. The primary difference between
      this method and raiseTriggerPoint() is that this method is a request, rather
      than a requirement. It should be primarily used for displaying TPs that
      have already been completed.
      */


      TeachingElement.prototype.displayTriggerPoint = function(id) {
        if (this.parent != null) {
          return this.dispatchEvent('displayTriggerPoint', {
            id: id
          });
        } else {
          return this.triggerPointBay.handleDisplayRequest(id);
        }
      };

      /*
      handleTriggerState(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source changes state.
      */


      TeachingElement.prototype.handleTriggerState = function(tp) {};

      /*
      handleTriggerReady(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source is fully loaded and ready.
      */


      TeachingElement.prototype.handleTriggerReady = function(tp) {};

      /*
      handleTriggerStart(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source has started.
      */


      TeachingElement.prototype.handleTriggerStart = function(tp) {};

      /*
      handleTriggerComplete(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source is complete. The use of this method may be preferable to
      handleTriggerState as it is limited to the complete status.
      */


      TeachingElement.prototype.handleTriggerComplete = function(tp) {};

      /*
      handleTriggerOpen(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source has been opened.
      */


      TeachingElement.prototype.handleTriggerOpen = function(tp) {
        return this.pushMetric({
          'triggerPointOpen': tp.id
        }, "interface");
      };

      /*
      handleTriggerClosed(triggerPoint)
      --------------------------------
      Callback method that is invoked when a trigger point with the current TEI
      as its source has been closed.
      */


      TeachingElement.prototype.handleTriggerClosed = function(tp) {
        return this.pushMetric({
          'triggerPointClosed': (tp != null ? tp.id : void 0) != null
        }, "interface");
      };

      /*
      Drop Bars
      =========
      Every TEI is capable of supporting Drop Bars. Drop Bars are themselves TEIs
      that are meant to provide additional, but completely optional, content and
      experiences to bolster the educational points of their parent TEI. Unlike
      Trigger Points, Drop Bars do not stop the normal flow of a TEI, and they are
      not required. They also are displayed alongside the TEI they are associated
      with, and as such do not "bubble" in the same way trigger points do.
      
      loadDropBars(dropBarList)
      -------------------------
      Accepts an array of DropBar data and registers it with the DropBarBay.
      */


      TeachingElement.prototype.loadDropBars = function(db_list) {
        this.dropBarBay.registerAll(db_list);
        if (this.sections != null) {
          if (__indexOf.call(this.sections != null, "conclusion") >= 0) {
            if (this.dropBarBay.items.length > 0) {
              this.dropBarBay.view().insertBefore(this.view().find('.te-conclusion'));
            }
            return;
          }
        }
        if (this.dropBarBay.items.length > 0) {
          return this.view().append(this.dropBarBay.view());
        }
      };

      /*
      onDropBarChange(evt, data)
      --------------------------
      Internal handler for the 'dropBarOpen' and 'dropBarClosed' events.
      */


      TeachingElement.prototype.onDropBarChange = function(evt, data) {
        if (evt === 'dropBarOpen') {
          return this.pushMetric({
            "id": data.dropBar.id,
            "name": data.dropBar.view().find('.drop-bar-title').text()
          }, "dropbar_open");
        }
      };

      /*
      onSidebarSearchChange()
      --------------------------
      Event handler for when sidebar search input box is changed.
      This handler was configured in platform.coffee inside the shedProxy method.
      */


      TeachingElement.prototype.onSidebarSearchChange = function(searchPhrase) {
        var dropBar, _i, _len, _ref, _results;
        if (searchPhrase) {
          TEP.addHighlights(this.view(), searchPhrase);
          if (this.dropBarBay.items.length > 0) {
            _ref = this.dropBarBay.items;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              dropBar = _ref[_i];
              _results.push(dropBar.onSidebarSearchChange(searchPhrase));
            }
            return _results;
          }
        }
      };

      /*
      getHighlights()
      -------------------
      if highlights have been applied to this teaching element's view, then return them
      */


      TeachingElement.prototype.getHighlights = function() {
        return this.view().find("mark[data-markjs]");
      };

      return TeachingElement;

    })(EventDispatcher);
  });

}).call(this);
