// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, EventDispatcher, TEP, TriggerPoint, Utils;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    $ = require('jquery');
    TEP = require('tep/lib/te/platform');
    Utils = require('tep/utils/utils');
    return TriggerPoint = (function(_super) {
      __extends(TriggerPoint, _super);

      function TriggerPoint(data, source) {
        var teiUserState, _ref, _ref1, _ref2, _ref3;
        this.data = data;
        this.source = source;
        this.onStateChange = __bind(this.onStateChange, this);
        this.handleComplete = __bind(this.handleComplete, this);
        this.view = __bind(this.view, this);
        this.shedProxy = __bind(this.shedProxy, this);
        this.detach = __bind(this.detach, this);
        this.close = __bind(this.close, this);
        this.open = __bind(this.open, this);
        this.onScreen = __bind(this.onScreen, this);
        this.bindLabel = __bind(this.bindLabel, this);
        this.getLabel = __bind(this.getLabel, this);
        this.id = this.data.id;
        this.teiId = (_ref = this.data.teaching_element_instances[0]) != null ? _ref.id : void 0;
        this.displayName = this.data.display_name;
        this.triggerSequence = this.data.trigger_sequence;
        this.tei = TEP.make(this.teiId, null, false);
        this.loaded = false;
        this.tei.on('ready', this.shedProxy);
        this.label = $('<li>').attr({
          'data-tab-id': this.id,
          "class": 'disabled'
        }).append($('<a tabindex="-1">').attr('href', '#').append(this.displayName + "<i></i>"));
        this._view = $('<li>').append(this.tei.view());
        teiUserState = (_ref1 = this.data.teaching_element_instances[0]) != null ? (_ref2 = _ref1.states) != null ? (_ref3 = _ref2.user) != null ? _ref3.status : void 0 : void 0 : void 0;
        if (teiUserState != null) {
          this.status = teiUserState;
          if (this.status === Utils.stases[Utils.stases.length - 1]) {
            this.label.removeClass('completed disabled').addClass('completed').find('a').removeAttr('tabindex');
            this.label.find('a .screen-reader-visible').remove();
            this.label.find('a').append("<span class='screen-reader-visible'> completed</span>");
          }
          this.source.handleTriggerState(this);
        }
      }

      TriggerPoint.prototype.getLabel = function() {
        return this.label;
      };

      TriggerPoint.prototype.bindLabel = function() {
        var _this = this;
        this.label.unbind('click');
        return this.label.bind('click', function() {
          if (_this.status === "complete") {
            _this.dispatchEvent('tpDisplayToggleRequest', _this);
          }
          return false;
        });
      };

      TriggerPoint.prototype.onScreen = function() {
        if (!this.tei.ready) {
          return this.tei.onDataLoad(this.data.teaching_element_instances[0]);
        } else {
          this.tei.onScreen();
          this.tei.unlock();
          return this.source.handleTriggerStart(this);
        }
      };

      TriggerPoint.prototype.open = function() {
        this.source.handleTriggerOpen(this);
        this.label.addClass('open');
        if (this.status !== "complete") {
          return this.label.find('a').append("<span class='screen-reader-visible'> current step</span>");
        }
      };

      TriggerPoint.prototype.close = function() {
        this.label.removeClass('open');
        return this.source.handleTriggerClosed(this);
      };

      TriggerPoint.prototype.detach = function() {
        return this._view.detach();
      };

      TriggerPoint.prototype.shedProxy = function() {
        var prox;
        prox = this.tei;
        prox.off('ready', this.shedProxy);
        this.tei = this.tei.te;
        this.tei.$el = prox.view();
        this.tei.addEventListener('complete', this.handleComplete);
        this.tei.addEventListener('statuschange', this.onStateChange);
        this.loaded = true;
        this.tei.unlock();
        this.source.handleTriggerStart(this);
        return this.dispatchEvent('proxyShed', this);
      };

      TriggerPoint.prototype.view = function() {
        return this._view;
      };

      TriggerPoint.prototype.handleComplete = function(evt, data) {
        this.source.handleTriggerComplete(this);
        return this.dispatchEvent('complete', this);
      };

      TriggerPoint.prototype.onStateChange = function(evt, data) {
        if (Utils.stases.indexOf(this.tei.status) > Utils.stases.indexOf(this.status)) {
          this.status = this.tei.status;
          this.label.removeClass('completed disabled').find('a').removeAttr('tabindex');
          switch (this.status) {
            case "locked":
            case "in-progress":
              this.label.addClass('disabled').find('a').attr('tabindex', '-1');
              break;
            case "complete":
              this.label.addClass('completed');
          }
          return this.source.handleTriggerState(this);
        }
      };

      return TriggerPoint;

    })(EventDispatcher);
  });

}).call(this);
