// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var $, EventDispatcher, TriggerPoint, TriggerPointBay, Utils, tmpl;
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    $ = require('jquery');
    tmpl = require('text!./template.html');
    TriggerPoint = require('./trigger_point');
    Utils = require('tep/utils/utils');
    return TriggerPointBay = (function(_super) {
      __extends(TriggerPointBay, _super);

      function TriggerPointBay() {
        this.hide = __bind(this.hide, this);
        this.onTPComplete = __bind(this.onTPComplete, this);
        this.adjustHeight = __bind(this.adjustHeight, this);
        this._openAndScroll = __bind(this._openAndScroll, this);
        this._scrollHeight = __bind(this._scrollHeight, this);
        this.onMutation = __bind(this.onMutation, this);
        this.show = __bind(this.show, this);
        this.handleDisplayRequest = __bind(this.handleDisplayRequest, this);
        this.register = __bind(this.register, this);
        this.view = __bind(this.view, this);
        this.points = {};
        this._view = $(tmpl);
        if (window.MutationObserver) {
          this.useObserver = true;
          this.observer = new MutationObserver(this.onMutation);
          this.observer.observe(this._view.find('.interaction-container')[0], {
            childList: true,
            subtree: true
          });
        } else {
          this.useObserver = false;
        }
      }

      TriggerPointBay.prototype.view = function() {
        return this._view;
      };

      TriggerPointBay.prototype.register = function(triggerPoint, source) {
        var id,
          _this = this;
        id = triggerPoint.id;
        this.points[id] = triggerPoint;
        this.points[id].on('complete', this.onTPComplete);
        this.points[id].on('proxyShed', this.adjustHeight);
        this.points[id].on('tpDisplayToggleRequest', function(evt, tp) {
          return _this.handleDisplayRequest(tp.id);
        });
        this._view.find('.int-toggle').append(this.points[id].getLabel());
        return this.points[id].bindLabel();
      };

      TriggerPointBay.prototype.handleDisplayRequest = function(id) {
        var tp;
        tp = this.points[id];
        if (this.currentTP != null) {
          if (this.currentTP.status === Utils.stases[Utils.stases.length - 1]) {
            if (this.currentTP === tp) {
              return this.hide();
            } else {
              return this.show(tp.id);
            }
          }
        } else {
          return this.show(tp.id);
        }
      };

      TriggerPointBay.prototype.show = function(id) {
        if (this.currentTP != null) {
          this.currentTP.close();
        }
        this._view.find(".int-toggle > li a").attr("tabindex", "-1");
        this._view.find(".interaction-container li").detach();
        this._view.find('.interaction-container').css({
          height: 0
        }).append(this.points[id].view());
        this.points[id].view().css('display', 'block');
        this._scrollCache = $(window).scrollTop();
        this._openAndScroll(id);
        this.points[id].onScreen();
        this.currentTP = this.points[id];
        return this.currentTP.open();
      };

      TriggerPointBay.prototype.onMutation = function(recordList) {
        var record;
        record = recordList[0];
        if (recordList.length > 1 || !(record.target === this._view.find('.interaction-container')[0] && record.removedNodes.length > 0)) {
          return this._scrollHeight();
        }
      };

      TriggerPointBay.prototype._scrollHeight = function() {
        var h, rate,
          _this = this;
        if (this.currentTP) {
          h = this.currentTP.view().outerHeight(true);
          rate = 500;
          return this._view.find('.interaction-container').stop().animate({
            height: h
          }, {
            duration: 1000 * h / rate,
            complete: function() {
              return _this._view.find(".interaction-container").css({
                height: ''
              });
            }
          });
        }
      };

      TriggerPointBay.prototype._openAndScroll = function(id) {
        if (!this.useObserver) {
          this._view.find('.interaction-container').css('height', 'auto');
        }
        return $('html,body').stop().animate({
          scrollTop: this._view.offset().top
        }, {
          duration: 500
        });
      };

      TriggerPointBay.prototype.adjustHeight = function(evt, tp) {
        return this._openAndScroll(tp.id);
      };

      TriggerPointBay.prototype.onTPComplete = function(e, data) {
        this._view.find(".int-toggle > li.completed a").removeAttr("tabindex");
        return this.hide();
      };

      TriggerPointBay.prototype.hide = function() {
        var _ref,
          _this = this;
        this._view.find('.interaction-container').stop().animate({
          height: 0
        }, {
          duration: 500,
          complete: function() {
            return _this._view.find('.interaction-container li').detach();
          }
        });
        $('html, body').stop().animate({
          scrollTop: this._scrollCache
        }, {
          duration: 500
        });
        if ((_ref = this.currentTP) != null) {
          _ref.close();
        }
        return this.currentTP = null;
      };

      return TriggerPointBay;

    })(EventDispatcher);
  });

}).call(this);
