// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  define(function(require) {
    var $, EventDispatcher, GraphView, Utils, d3, tmpl;
    $ = require('jquery');
    tmpl = require('text!./graph.html');
    EventDispatcher = require('tep/utils/event/event_dispatcher');
    d3 = require('common/js/vendor/d3_v3.2.8');
    Utils = require('tep/utils/utils');
    require('link!./style.css');
    return GraphView = (function(_super) {
      __extends(GraphView, _super);

      function GraphView(config, model) {
        var axisLabel, fullHeight, l, _i, _len, _ref;
        this.config = config;
        this.model = model;
        this.onToolSelectionChanged = __bind(this.onToolSelectionChanged, this);
        this.onToolSelectionRequest = __bind(this.onToolSelectionRequest, this);
        this.addTool = __bind(this.addTool, this);
        this.buildToolBar = __bind(this.buildToolBar, this);
        this.onToolAdded = __bind(this.onToolAdded, this);
        this.onToolsLoaded = __bind(this.onToolsLoaded, this);
        this.onNewObject = __bind(this.onNewObject, this);
        this.buildGrid = __bind(this.buildGrid, this);
        this.getPositionOffset = __bind(this.getPositionOffset, this);
        this._getActionPosition = __bind(this._getActionPosition, this);
        this.onActionEnd = __bind(this.onActionEnd, this);
        this.onActionMove = __bind(this.onActionMove, this);
        this.onActionStart = __bind(this.onActionStart, this);
        this.buildSvg = __bind(this.buildSvg, this);
        this.buildLegend = __bind(this.buildLegend, this);
        this.updateDescription = __bind(this.updateDescription, this);
        this.buildDescription = __bind(this.buildDescription, this);
        this.updateTitle = __bind(this.updateTitle, this);
        this.$dom = $(tmpl);
        if (this.config.title != null) {
          this.updateTitle(this.config.title);
        } else {
          this.$dom.find('.graph-title').remove();
        }
        this.buildLegend();
        if (!((this.config.title != null) || (this.config.legend != null))) {
          this.$dom.find('.graph-header').remove();
        }
        if (this.config.describedBy) {
          this.$dom.find('.component-drawgraph-description').attr('id', this.config.describedBy);
          this.updateDescription(this.config.description);
        }
        this.scales = {
          x: d3.scale.linear().range([0, this.config.width]).domain([this.config.axes.xAxis.min, this.config.axes.xAxis.max]),
          y: d3.scale.linear().range([this.config.height, 0]).domain([this.config.axes.yAxis.min, this.config.axes.yAxis.max])
        };
        fullHeight = this.config.height + this.config.margin.top + this.config.margin.bottom;
        axisLabel = this.config.axes.xAxis.label;
        if (axisLabel) {
          this.$dom.find('.graph-label-x').html(axisLabel).css({
            top: fullHeight + 2
          });
        } else {
          this.$dom.find('.graph-label-x').remove();
        }
        axisLabel = this.config.axes.yAxis.label;
        if (axisLabel) {
          this.$dom.find('.graph-label-y').html(this.config.axes.yAxis.label).css({
            width: fullHeight,
            top: fullHeight
          });
        } else {
          this.$dom.find('.graph-label-y').remove();
        }
        this.$dom.find('.graph-grid').on('mousedown', this.onActionStart).on('mousemove', this.onActionMove);
        $(document).on('mouseup', this.onActionEnd);
        this.svg = this.buildSvg();
        this.layers = {};
        if (__indexOf.call(config.layers, 'zebra') < 0) {
          this.layers.zebra = this.svg.append('g').attr('class', 'zebra-stripes');
        }
        if (__indexOf.call(config.layers, 'grid') < 0) {
          this.layers.grid = this.svg.append('g').attr('class', 'grid');
        }
        _ref = config.layers;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          l = _ref[_i];
          this.layers[l] = this.svg.append('g').attr('class', l);
        }
        this.buildGrid();
        model.addEventListener('Graph.ToolSelectionChanged', this.onToolSelectionChanged);
        model.addEventListener('Graph.ObjectAdded', this.onNewObject);
        model.addEventListener('Graph.ObjectRemoved', this.onObjectRemoved);
        model.addEventListener('Graph.ToolsLoaded', this.onToolsLoaded);
        model.addEventListener('Graph.ToolAdded', this.onToolAdded);
      }

      GraphView.prototype.updateTitle = function(title) {
        return this.$dom.find('.graph-title').html(title);
      };

      GraphView.prototype.buildDescription = function(extra) {
        var desc, xLabel, yLabel;
        if (extra == null) {
          extra = '';
        }
        xLabel = this.config.axes.xAxis.label;
        yLabel = this.config.axes.yAxis.label;
        if (!xLabel && !yLabel) {
          desc = "<p>Graph with unlabeled axes.</p>";
        } else {
          desc = "<p>Graph showing";
          if (xLabel) {
            desc += " " + xLabel + " on the x-axis";
            if (yLabel) {
              desc += " and";
            }
          }
          if (yLabel) {
            desc += " " + yLabel + " on the y-axis.";
          }
          desc += "</p>";
        }
        if (extra) {
          desc += "<p role='status' aria-live='polite'>" + extra + "</p>";
        }
        return desc;
      };

      GraphView.prototype.updateDescription = function(desc) {
        return this.$dom.find('.component-drawgraph-description').html(this.buildDescription(desc));
      };

      GraphView.prototype.buildLegend = function() {
        var itemTmpl, k, v, _ref;
        if (this.config.legend != null) {
          _ref = this.config.legend;
          for (k in _ref) {
            v = _ref[k];
            itemTmpl = $($.parseHTML('<div class="graph-legend-item"><div class="graph-legend-icon"></div><div class="graph-legend-label"></div></div>'));
            itemTmpl.addClass("graph-legend-" + k);
            itemTmpl.find('.graph-legend-label').html(v);
            this.$dom.find('.graph-legend-list').append(itemTmpl);
          }
          return this.$dom.find('.graph-legend-header').bind('click keypress', function(jqevt) {
            var code, keys, toggle;
            toggle = true;
            if (jqevt.type === 'keypress') {
              jqevt.stopPropagation();
              code = jqevt.keyCode ? jqevt.keyCode : jqevt.which;
              keys = Utils.getKeyMap();
              if (code === keys.selectKey) {
                jqevt.preventDefault();
              } else {
                toggle = false;
              }
            }
            if (toggle) {
              return $(jqevt.currentTarget).parents('.graph-legend').toggleClass('open');
            }
          });
        } else {
          return this.$dom.find('.graph-legend').remove();
        }
      };

      GraphView.prototype.buildSvg = function() {
        return d3.select(this.$dom.find('.graph-grid').get(0)).append('svg').attr({
          role: 'img',
          width: this.config.width + this.config.margin.left + this.config.margin.right,
          height: this.config.height + this.config.margin.top + this.config.margin.bottom,
          'aria-label': this.config.label ? this.config.label : void 0,
          'aria-describedby': this.config.describedBy ? this.config.describedBy : void 0
        }).append('g').attr('transform', 'translate(' + this.config.margin.left + ',' + this.config.margin.top + ')');
      };

      GraphView.prototype.onActionStart = function(jqevt) {
        jqevt.preventDefault();
        this._inAction = true;
        return this.dispatchEvent('Graph.ActionStart', {
          pos: this._getActionPosition(jqevt)
        });
      };

      GraphView.prototype.onActionMove = function(jqevt) {
        if (this._inAction) {
          jqevt.preventDefault();
          return this.dispatchEvent('Graph.ActionMove', {
            pos: this._getActionPosition(jqevt)
          });
        }
      };

      GraphView.prototype.onActionEnd = function() {
        if (this._inAction) {
          this._inAction = false;
          return this.dispatchEvent('Graph.ActionEnd', {});
        }
      };

      GraphView.prototype._getActionPosition = function(jqevt) {
        var offset, pos, relPos;
        pos = Utils.normalizeEventPosition(jqevt);
        offset = $(jqevt.currentTarget).offset();
        relPos = {
          x: pos.x - offset.left - this.config.margin.left,
          y: pos.y - offset.top - this.config.margin.top
        };
        return {
          x: this.scales.x.invert(relPos.x),
          y: this.scales.y.invert(relPos.y)
        };
      };

      GraphView.prototype._zeroOrClosest = function(axis, stripeCount) {
        var i, values;
        values = (function() {
          var _i, _results;
          _results = [];
          for (i = _i = 0; 0 <= stripeCount ? _i <= stripeCount : _i >= stripeCount; i = 0 <= stripeCount ? ++_i : --_i) {
            _results.push(i * axis.tickSize + axis.min);
          }
          return _results;
        })();
        values.sort(function(a, b) {
          return Math.abs(a) - Math.abs(b);
        });
        return values[0];
      };

      GraphView.prototype.getPositionOffset = function(pos) {
        return {
          x: this.scales.x(pos.x) + this.config.margin.left,
          y: this.scales.y(pos.y) + this.config.margin.top
        };
      };

      GraphView.prototype.buildGrid = function() {
        var h, i, tickG, val, w, xAxis, xPos, xStripeCount, xZero, yAxis, yPos, yStripeCount, yZero, z, zeros, _i, _j, _k, _len, _ref, _results;
        xAxis = this.config.axes.xAxis;
        yAxis = this.config.axes.yAxis;
        xStripeCount = Math.ceil((xAxis.max - xAxis.min) / xAxis.tickSize);
        yStripeCount = Math.ceil((yAxis.max - yAxis.min) / yAxis.tickSize);
        h = this.config.height + this.config.margin.bottom + this.config.margin.top;
        w = this.config.width + this.config.margin.left + this.config.margin.right;
        xZero = this._zeroOrClosest(xAxis, xStripeCount);
        yZero = this._zeroOrClosest(yAxis, yStripeCount);
        for (i = _i = 0; 0 <= xStripeCount ? _i <= xStripeCount : _i >= xStripeCount; i = 0 <= xStripeCount ? ++_i : --_i) {
          val = i * xAxis.tickSize + xAxis.min;
          xPos = this.scales.x(val);
          yPos = this.scales.y(yZero);
          this.layers.zebra.append('rect').attr('class', 'zebra ' + (Math.pow(-1, i) > 0 ? 'even' : 'odd')).attr('x', xPos).attr('y', -this.config.margin.top).attr('width', this.scales.x(xAxis.min + xAxis.tickSize)).attr('height', h);
          tickG = this.layers.grid.append('g').attr('class', 'x-axis-tick axis-tick' + (val === xZero ? ' axis-zero' : '')).attr('transform', 'translate(' + xPos + ',' + (-this.config.margin.top) + ')');
          tickG.append('line').attr('y2', h);
          if (val !== xZero) {
            tickG.append('text').attr('text-anchor', 'middle').attr('x', 0).attr('y', yPos + this.config.margin.top + (Math.round(yPos) >= this.config.height / 2 ? 20 : -4)).text(Math.round(val * 1000) / 1000);
          }
        }
        for (i = _j = 0; 0 <= yStripeCount ? _j <= yStripeCount : _j >= yStripeCount; i = 0 <= yStripeCount ? ++_j : --_j) {
          val = i * yAxis.tickSize + yAxis.min;
          xPos = this.scales.x(xZero);
          yPos = this.scales.y(val);
          tickG = this.layers.grid.append('g').attr('class', 'y-axis-tick axis-tick' + (val === yZero ? ' axis-zero' : '')).attr('transform', 'translate(' + (-this.config.margin.left) + ',' + yPos + ')');
          tickG.append('line').attr('x2', w);
          if (val !== yZero) {
            tickG.append('text').attr('text-anchor', Math.round(xPos) > this.config.width / 2 ? 'start' : 'end').attr('x', xPos + this.config.margin.left + (Math.round(xPos) > this.config.width / 2 ? 4 : -12)).attr('y', 4).text(Math.round(val * 1000) / 1000);
          }
        }
        zeros = this.layers.grid.selectAll('.axis-zero').remove();
        _ref = zeros[0];
        _results = [];
        for (_k = 0, _len = _ref.length; _k < _len; _k++) {
          z = _ref[_k];
          _results.push(this.layers.grid.append(function() {
            return z;
          }));
        }
        return _results;
      };

      GraphView.prototype.onNewObject = function(evt, data) {
        var obj;
        obj = this.layers[data.layer].append(data.newObject.svgType);
        return data.newObject.registerSvgObject(obj, $.extend({}, this.config, {
          xScale: this.scales.x,
          yScale: this.scales.y
        }));
      };

      GraphView.prototype.onObjectRemoved = function(evt, data) {
        return data.obj.clearView();
      };

      GraphView.prototype.onToolsLoaded = function(evt, data) {
        var model;
        model = data.currentTarget;
        if (model.tools != null) {
          this.buildToolBar(model.tools);
          if (model._active) {
            return this.$dom.find('.graph-grid').css({
              cursor: model.currentTool.cursor()
            });
          }
        } else {
          return this.$dom.find('.graph-toolbar-wrap').hide();
        }
      };

      GraphView.prototype.onToolAdded = function(evt, data) {
        return this.addTool(data.tool);
      };

      GraphView.prototype.buildToolBar = function(tools) {
        var group, key, tool, _i, _len, _results;
        _results = [];
        for (key in tools) {
          group = tools[key];
          for (_i = 0, _len = group.length; _i < _len; _i++) {
            tool = group[_i];
            this.addTool(tool);
          }
          _results.push(tool.view().addClass('last'));
        }
        return _results;
      };

      GraphView.prototype.addTool = function(tool) {
        var groupKey, grp;
        groupKey = tool.group();
        if (this.$dom.find('.graph-toolbar-wrap .graph-toolbar-' + groupKey).length === 0) {
          grp = $('<div>').addClass('graph-toolbar graph-toolbar-' + groupKey);
          this.$dom.find('.graph-toolbar-wrap').append(grp);
        } else {
          grp = this.$dom.find('.graph-toolbar-wrap .graph-toolbar-' + groupKey);
        }
        grp.append(tool.view());
        return tool.addEventListener('Graph.ToolSelectionRequest', this.onToolSelectionRequest);
      };

      GraphView.prototype.onToolSelectionRequest = function(evt, data) {
        return this.dispatchEvent(evt, data);
      };

      GraphView.prototype.onToolSelectionChanged = function(evt, data) {
        if (this.lastToolName != null) {
          this.$dom.find('.graph-grid').removeClass(this.lastToolName);
        }
        if (this.lastToolGroup != null) {
          this.$dom.find('.graph-grid').removeClass(this.lastToolGroup);
        }
        if (data.tool != null) {
          this.$dom.find('.graph-grid').addClass('graph-' + data.tool.name()).addClass('graph-' + data.tool.group());
          this.$dom.find('.graph-grid').css({
            cursor: data.tool.cursor()
          });
          this.lastToolName = data.tool.name();
          return this.lastToolGroup = data.tool.group();
        } else {
          return this.$dom.find('.graph-grid').css({
            cursor: 'auto'
          });
        }
      };

      return GraphView;

    })(EventDispatcher);
  });

}).call(this);
