// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var BaseView, Input, RESPONDENT_HEIGHT, ROW_LIMIT, RespondentView, SCROLL_LIMIT, Switch, Utils, View, tmpl;
    BaseView = require("tep/utils/view");
    tmpl = require("text!../templates/view.html");
    RespondentView = require("./respondent");
    Switch = require('tep/components/switch/main');
    Utils = require("tep/utils/utils");
    Input = require('tep/components/input/input');
    require("jqueryui");
    ROW_LIMIT = 6;
    SCROLL_LIMIT = ROW_LIMIT * 3;
    RESPONDENT_HEIGHT = 120;
    return View = (function(_super) {
      __extends(View, _super);

      function View(model) {
        this.scrollTo = __bind(this.scrollTo, this);
        this.clearSearch = __bind(this.clearSearch, this);
        this.clearSearchKey = __bind(this.clearSearchKey, this);
        this.searchKeyRequest = __bind(this.searchKeyRequest, this);
        this.addRespondentRow = __bind(this.addRespondentRow, this);
        this.buildAnswerViews = __bind(this.buildAnswerViews, this);
        this.resetVariables = __bind(this.resetVariables, this);
        this.removeNotices = __bind(this.removeNotices, this);
        this.showAnswer = __bind(this.showAnswer, this);
        this._orderBy = __bind(this._orderBy, this);
        this.onTeamToggle = __bind(this.onTeamToggle, this);
        this.onLikeToggle = __bind(this.onLikeToggle, this);
        this.onCommentToggle = __bind(this.onCommentToggle, this);
        this._onScroll = __bind(this._onScroll, this);
        this.onChange = __bind(this.onChange, this);
        var $focusedAnswerSelect, focusedAnswerData, id, inputSection, option, restrictResultsToTeam, searchSection, searchSectionButton, tei, _i, _len, _ref,
          _this = this;
        View.__super__.constructor.call(this, tmpl);
        this.model = model;
        this.resetVariables();
        this.model.addEventListener("Model.Change", this.onChange);
        this.model.addEventListener("Model.SetSame", this.onChange);
        this.initial = true;
        this.notices = {
          none: this.$el.find(".sharedanswer-no-response-notice"),
          search: this.$el.find(".sharedanswer-no-search-notice"),
          scroll: this.$el.find(".sharedanswer-scroll-notice")
        };
        this.removeNotices();
        this.commentsSwitch = new Switch({
          currentValue: "off",
          disabled: false
        });
        this.commentsSwitch.addEventListener("Switch.ValueChange", this.onCommentToggle);
        this.$el.find(".sharedanswer-respondent-control-comments").append(this.commentsSwitch.$dom);
        this.likesSwitch = new Switch({
          currentValue: "off",
          disabled: false
        });
        this.likesSwitch.addEventListener("Switch.ValueChange", this.onLikeToggle);
        this.$el.find(".sharedanswer-respondent-control-likes").append(this.likesSwitch.$dom);
        focusedAnswerData = this.model.common.get('focusedAnswerData');
        if (focusedAnswerData) {
          this.$el.find('.sharedanswer-respondent-control-focused-answer').show();
          $focusedAnswerSelect = this.$el.find('.focused-answer-select');
          $focusedAnswerSelect.on('change', function(jqevt) {
            _this.model.set('focusedAnswer', jqevt.currentTarget.value);
            return _this.dispatchEvent("SharedAnswer.FocusedAnswer", {
              bubbles: true
            });
          });
          _ref = focusedAnswerData.options;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            option = _ref[_i];
            $focusedAnswerSelect.append(new Option(option.label, option.id));
          }
          if (focusedAnswerData.isEnabled) {
            $focusedAnswerSelect.val(focusedAnswerData.selectedFocusedAnswer);
            this.model.set('focusedAnswer', focusedAnswerData.selectedFocusedAnswer);
          } else {
            $focusedAnswerSelect.val('');
            this.model.set('focusedAnswer', '');
          }
        }
        restrictResultsToTeam = this.model.common.get("restrictResultsToTeam");
        if (restrictResultsToTeam) {
          this.$el.find(".sharedanswer-respondents-header-team-appendix").html("Results are from your " + window.globals.wave_team_label);
        }
        if (window.globals.teams_set_up) {
          searchSection = this.$el.find(".sharedanswer-respondent-control-search");
          searchSection.addClass("sharedanswer-respondent-team-control-search");
          if (!restrictResultsToTeam) {
            this.teamsSwitch = new Switch({
              currentValue: "off",
              disabled: false,
              onLabel: window.globals.wave_team_label,
              offLabel: 'Cohort'
            });
            this.teamsSwitch.addEventListener("Switch.ValueChange", this.onTeamToggle);
            this.$el.find(".sharedanswer-respondent-control-team").append(this.teamsSwitch.$dom);
            inputSection = this.$el.find(".sharedanswer-respondents-controls");
            inputSection.addClass("team-control-displayed");
          }
        }
        tei = this.model.common.get('tei');
        this.inputField = new Input({
          attributes: {
            type: "search",
            placeholder: "Search"
          },
          label: "Search student submissions",
          labelVisible: false,
          selectOnFocus: true,
          enableTooltip: false,
          id: "shared-search-" + tei
        });
        this.$el.find(".sharedanswer-respondent-control-search").prepend(this.inputField.view());
        id = "sharedanswers_" + tei;
        this.$el.find("ul").attr("id", id);
        this.$el.find(".sharedanswer-respondent-control .switch").attr("aria-controls", id);
        this.$el.find(".sharedanswer-respondents-controls input").attr("aria-controls", id);
        searchSection = this.$el.find(".sharedanswer-respondent-control-search");
        searchSectionButton = searchSection.find("button");
        searchSectionButton.bind({
          click: this.clearSearch,
          keydown: this.clearSearchKey
        });
        searchSection.find("input").bind({
          keyup: this.searchKeyRequest
        });
        searchSectionButton.hide();
        this.$el.find(".sharedanswer-respondents-content").bind("scroll", this._onScroll);
        this._respondents = [];
        this._itemsPerPage = model.common.get("items_per_page");
      }

      View.prototype.onChange = function(evt, data) {
        switch (data.path) {
          case "selectedAnswer":
            return this.showAnswer(data.value);
          case "answers":
            return this.buildAnswerViews(data.value);
          case "scrollTop":
            return this.scrollTo(data.value);
        }
      };

      View.prototype._onScroll = function(evt) {
        if ($(evt.target).scrollTop() / RESPONDENT_HEIGHT > this.currentRow) {
          return this.addRespondentRow();
        }
      };

      View.prototype.onCommentToggle = function() {
        return this._orderBy("comments", this.commentsSwitch.isOn());
      };

      View.prototype.onLikeToggle = function() {
        return this._orderBy("likes", this.likesSwitch.isOn());
      };

      View.prototype.onTeamToggle = function() {
        this.dispatchEvent("SharedAnswer.OnTeamFilterToggle", {
          value: this.teamsSwitch.isOn() ? "team" : "cohort"
        });
        return this._orderBy("team", this.teamsSwitch.isOn());
      };

      View.prototype._orderBy = function(type, onOff) {
        var r, _i, _len, _ref;
        _ref = this._respondents;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          r = _ref[_i];
          if (r._answer_showing) {
            r.toggleAnswer();
          }
        }
        return this.dispatchEvent("SharedAnswer.OrderByRequest", {
          bubbles: true,
          orderBy: type,
          onOff: onOff
        });
      };

      View.prototype.showAnswer = function(answer) {
        var r, _i, _len, _ref, _results;
        _ref = this._respondents;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          r = _ref[_i];
          if (r.answer_index === answer.get("index") || r._answer_showing) {
            _results.push(r.toggleAnswer());
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      };

      View.prototype.removeNotices = function() {
        var id, notice, _ref, _results;
        _ref = this.notices;
        _results = [];
        for (id in _ref) {
          notice = _ref[id];
          _results.push(notice.remove());
        }
        return _results;
      };

      View.prototype.resetVariables = function() {
        this._respondents = [];
        return this.currentRow = 0;
      };

      View.prototype.buildAnswerViews = function(answers) {
        var cName, ele, notice, rv, _i, _len, _ref;
        _ref = this._respondents;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          rv = _ref[_i];
          this.removeChild(rv);
        }
        this.resetVariables();
        this.removeNotices();
        this.$el.find(".sharedanswer-respondents-wrap").removeClass("sharedanswer-respondents-wrap-large                                                               sharedanswer-respondents-wrap-medium                                                               sharedanswer-respondents-wrap-small");
        if (answers.length) {
          if (answers.length <= ROW_LIMIT) {
            this.$el.find(".sharedanswer-respondents-wrap").addClass("sharedanswer-respondents-wrap-medium");
          } else if (answers.length > SCROLL_LIMIT) {
            this.$el.find(".sharedanswer-respondents-wrap").addClass("sharedanswer-respondents-wrap-large");
            this.$el.find(".sharedanswer-respondents").append(this.notices.scroll);
          }
          this.$el.find(".sharedanswer-respondents").show();
          this.addRespondentRow();
        } else {
          if (this.initial && !this.model.get("focusedAnswer")) {
            notice = this.notices.none;
            ele = "sharedanswer-respondents-wrap";
            cName = "small";
            this.$el.find(".sharedanswer-respondents").remove();
          } else {
            notice = this.notices.search;
            ele = "sharedanswer-respondents-content";
            cName = "medium";
          }
          this.$el.find(".sharedanswer-respondents-wrap").addClass("sharedanswer-respondents-wrap-" + cName);
          this.$el.find("." + ele).append(notice);
        }
        return this.initial = false;
      };

      View.prototype.addRespondentRow = function() {
        var answer, answers, i, limit, newAnswers, rLength, rv, _i, _len;
        this.currentRow++;
        answers = this.model.get("answers");
        rLength = this._respondents.length;
        if (rLength < this._itemsPerPage) {
          limit = this._itemsPerPage;
        } else {
          limit = ROW_LIMIT;
        }
        newAnswers = answers.slice(0).splice(rLength, limit);
        for (i = _i = 0, _len = newAnswers.length; _i < _len; i = ++_i) {
          answer = newAnswers[i];
          rv = new RespondentView(answer);
          rv.displayUserData();
          this._respondents.push(rv);
          this.addChild(rv, ".sharedanswer-respondents-content > ul");
        }
        if (rLength > SCROLL_LIMIT && rLength >= answers.length) {
          return this.notices.scroll.remove();
        }
      };

      View.prototype.searchKeyRequest = function(evt) {
        var category, code, inputSection, inputVal, keyMap, sendEvt;
        code = evt.keyCode ? evt.keyCode : evt.which;
        sendEvt = false;
        inputSection = this.$el.find(".sharedanswer-respondents-controls");
        category = "key_event";
        keyMap = Utils.getKeyMap();
        inputVal = inputSection.find("input").val();
        if (inputVal) {
          if (code === keyMap.submitKey) {
            evt.stopPropagation();
            evt.preventDefault();
            sendEvt = true;
            category = "search_results";
          } else {
            inputSection.find("button").show();
          }
        } else if (!inputVal && code !== keyMap.submitKey) {
          inputSection.find("button").hide();
          sendEvt = true;
          category = "search_cleared";
        }
        if (sendEvt) {
          return this.dispatchEvent("SharedAnswer.SubmitSearch", {
            bubbles: true,
            search: inputVal,
            category: category
          });
        }
      };

      View.prototype.clearSearchKey = function(evt) {
        var code, keyMap;
        code = evt.keyCode ? evt.keyCode : evt.which;
        keyMap = Utils.getKeyMap();
        if (code === keyMap.selectKey || code === keyMap.submitKey) {
          evt.stopPropagation();
          evt.preventDefault();
          return this.clearSearch();
        }
      };

      View.prototype.clearSearch = function() {
        var input, inputVal;
        input = this.$el.find(".sharedanswer-respondents-controls input");
        inputVal = input.val();
        if (inputVal) {
          this.dispatchEvent("SharedAnswer.ClearSearchRequest", {
            bubbles: true,
            search: inputVal,
            category: "clear_search"
          });
          input.val("").focus();
          return this.$el.find(".sharedanswer-respondent-control-search button").hide();
        }
      };

      View.prototype.scrollTo = function(pos) {
        return this.$el.find(".sharedanswer-respondents-content").animate({
          scrollTop: pos
        }, 500);
      };

      return View;

    })(BaseView);
  });

}).call(this);
