// Generated by CoffeeScript 1.6.3
(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  define(function(require) {
    var GraphObjectView, MathUtils, PieSliceView, labelExtension, labelHeight;
    GraphObjectView = require('../graph_object_view');
    MathUtils = require('tep/utils/math');
    labelExtension = 35;
    labelHeight = 40;
    return PieSliceView = (function(_super) {
      __extends(PieSliceView, _super);

      function PieSliceView(model) {
        this.model = model;
        this.render = __bind(this.render, this);
        this.onDataChange = __bind(this.onDataChange, this);
        this.registerSvgObject = __bind(this.registerSvgObject, this);
        this.model.addEventListener('Model.Change', this.onDataChange);
      }

      PieSliceView.prototype.registerSvgObject = function(svgObject, config) {
        this.svgObject = svgObject;
        this.config = config;
        PieSliceView.__super__.registerSvgObject.call(this, this.svgObject, this.config);
        this.svgObject.classed('graph-object graph-slice', true);
        if (this.model.get('classes') != null) {
          this.svgObject.classed(this.model.get('classes'), true);
        }
        this.content = this.svgObject.append('g');
        this.slice = this.content.append('path').classed('graph-slice-slice', true);
        this.full = this.content.append('circle').classed('graph-slice-slice', true);
        this.labelBar = this.content.append('g').attr('class', 'graph-slice-bar');
        this.labelBar.append('line').attr('class', 'graph-slice-bar-line').attr('x1', this.config.xScale(this.model.get('radius')) - this.config.xScale(0)).attr('y1', 1).attr('y2', 1);
        this.labelBar.append('circle').attr('class', 'graph-slice-bar-nub').attr('r', 4).attr('cy', 1);
        this.label = this.svgObject.append('g').attr('class', 'graph-slice-label-wrap');
        this.label.append('text').attr('class', 'graph-slice-percent').attr('y', 10);
        this.label.append('text').attr('class', 'graph-slice-label').attr('y', 25).text(this.model.get('label'));
        return this.render();
      };

      PieSliceView.prototype.onDataChange = function(evt, data) {
        if (this.svgObject != null) {
          return this.render();
        }
      };

      PieSliceView.prototype.render = function() {
        var extension, labelRot, largeArc, maximumY, pathData, radians, radius, sweep, y;
        radius = this.config.xScale(this.model.get('radius')) - this.config.xScale(0);
        radians = Math.PI * 2 * this.model.get('percent');
        if (this.model.get('percent') < 1) {
          largeArc = this.model.get('percent') > 0.5 ? 1 : 0;
          sweep = 1;
          pathData = ["M 0 0", "L " + radius + " 0", "A " + radius + " " + radius + " 0 " + largeArc + " " + sweep + " " + (radius * Math.cos(radians)) + " " + (radius * Math.sin(radians)), "Z"];
          this.slice.attr('d', pathData.join(' '));
          this.full.style('display', 'none');
        } else {
          this.slice.style('display', 'none');
          this.full.attr('r', radius);
        }
        extension = 1;
        y = (radius + labelExtension) * Math.sin(this.model.get('rotation') + radians / 2);
        maximumY = parseFloat(this.model.get('lastY')) - labelHeight;
        if (parseFloat(y) < 0 && parseFloat(this.model.get('lastX')) < 0 && parseFloat(y) > maximumY) {
          extension = maximumY / y;
        }
        this.labelBar.select('line').attr('x2', extension * (radius + labelExtension));
        this.labelBar.select('circle').attr('cx', extension * (radius + labelExtension));
        this.svgObject.attr("transform", "translate(" + (this.config.xScale(0)) + " " + (this.config.yScale(0)) + ")");
        this.content.attr("transform", "rotate(" + (MathUtils.radiansToDegrees(this.model.get('rotation'))) + ")");
        this.labelBar.attr("transform", "rotate(" + (MathUtils.radiansToDegrees(radians / 2)) + ")");
        this.label.select(".graph-slice-percent").text(this.config.percentageDisplayType === 'decimal' ? (this.model.get('percent') * 100).toFixed(1) + "%" : (this.model.get('percent') * 100) + "%");
        this.labelPosition = {
          x: extension * (radius + labelExtension) * Math.cos(this.model.get('rotation') + radians / 2),
          y: extension * (radius + labelExtension) * Math.sin(this.model.get('rotation') + radians / 2)
        };
        labelRot = MathUtils.posMod(this.model.get('rotation') + radians / 2, Math.PI * 2);
        if ((Math.PI / 2 <= labelRot && labelRot < Math.PI * 3 / 2)) {
          this.labelPosition.x -= 10;
          this.label.classed('graph-slice-right', false);
          this.label.classed('graph-slice-left', true);
        } else {
          this.labelPosition.x += 10;
          this.label.classed('graph-slice-right', true);
          this.label.classed('graph-slice-left', false);
        }
        return this.label.attr("transform", "translate(" + this.labelPosition.x + " " + this.labelPosition.y + ")");
      };

      return PieSliceView;

    })(GraphObjectView);
  });

}).call(this);
